/*
 * (C) Copyright 2002-2006
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Marius Groeger <mgroeger@sysgo.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * To match the U-Boot user interface on ARM platforms to the U-Boot
 * standard (as on PPC platforms), some messages with debug character
 * are removed from the default U-Boot build.
 *
 * Define DEBUG here if you want additional info as shown below
 * printed upon startup:
 *
 * U-Boot code: 00F00000 -> 00F3C774  BSS: -> 00FC3274
 * IRQ Stack: 00ebff7c
 * FIQ Stack: 00ebef7c
 */

#include <common.h>
#include <command.h>
#include <malloc.h>
#include <stdio_dev.h>
#include <version.h>
#include <net.h>
#include <serial.h>
#include <coproc.h>
#if defined(CONFIG_SYS_RTK_NAND_FLASH)
#include <nand.h>
#endif
#include <onenand_uboot.h>
#include <mmc.h>
#include <libfdt.h>
#include <fdtdec.h>
#include <post.h>
#include <logbuff.h>
#include <platform_lib/board/pcb_mgr.h>
#ifndef IS_FPGA
#include <platform_lib/board/pcb.h>
#endif
#include <system.h>
#include <fw_info.h>
#include <logo_disp/logo_disp_api.h>
#include <asm/arch/factorylib.h>
#include <asm/arch/factorylib_ro.h>
#ifdef Config_EXT4_Load_TvConfigs_TRUE
#include <asm/arch/tvconfiglib_ext4.h>
#endif
#ifdef Config_EXT4_Load_Takeover_TRUE
#include <asm/arch/takeoverlib_ext4.h>
#endif
#include <asm/arch/bootparam.h>
#include <rbus/sb2_reg.h>
#include <watchdog.h>
#ifdef Config_Module_Test_Boot_TRUE
#include<module_test.h>
#endif
#if defined(CONFIG_SYS_RTK_NAND_FLASH)
 #include <linux/mtd/nand.h>		//surport nand flash
 #include <nand.h>
#elif defined(CONFIG_SYS_RTK_SPI_FLASH)
 #include <flashdev_s.h>
#endif

#ifdef CONFIG_BITBANGMII
#include <miiphy.h>
#endif

#ifdef CONFIG_DRIVER_SMC91111
#include "../drivers/net/smc91111.h"
#endif
#ifdef CONFIG_DRIVER_LAN91C96
#include "../drivers/net/lan91c96.h"
#endif

#ifdef CONFIG_SYS_PANEL_SUPPORT
#include "panel.h"
#endif
#ifdef CONFIG_SYS_SUPPORT_MULTITHREAD
#include <asm/thread.h>
#endif

gd_t *gd = (gd_t *)0xbabebabe;
//DECLARE_GLOBAL_DATA_PTR;
#define REG_BOOT_STAGE 0x18060130
#define UBOOT_STAGE 4
ulong monitor_flash_len;
#include "smp.h"
#ifdef CONFIG_SYS_SUPPORT_MULTICORE
extern unsigned int cpu_id_list[];
extern volatile unsigned int GlobalActive_Area[5];
extern volatile CoreWakeupFunc ActiveFuncPointer[5];
#ifdef CONFIG_SYS_SUPPORT_MULTITHREAD
extern void thread_start(void);
#endif
#endif

uchar boot_ac_on = 0;
bool boot_on_fast_install_detect = 0;
_BOARD_VERSION board_version = BOARD_UNDEFINED;

#ifdef CONFIG_HAS_DATAFLASH
extern int  AT91F_DataflashInit(void);
extern void dataflash_print_info(void);
#endif
extern int init_customize_func(void);
extern int bringup_mmc_driver( void );

extern int otp_program_with_bitmap_with_verify(void);
extern int otp_is_ever_programed(void);
extern int otp_check_and_program_special_regions(void);
unsigned int guipanel_init_done =0;

extern unsigned int smp_magic_tag(unsigned int cpu_id);
extern int otp_read_bits(unsigned long ofst, unsigned char msb, unsigned char lsb, unsigned long* pval);
extern int otp_write_bits(unsigned long ofst, unsigned char msb, unsigned char lsb, unsigned long val);
#ifdef CONFIG_CMD_MISC
extern void set_uart2rbus_status(void);
#endif
#ifndef CONFIG_SYS_SUPPORT_MULTITHREAD
extern void Core_Wakeup(CoreWakeupFunc __Addr, u32 CoreID);
#endif

#ifdef CONFIG_SYS_VIDDQ
extern int board_viddq_cal(void);
#endif

#if defined(CONFIG_HARD_I2C) || \
    defined(CONFIG_SOFT_I2C)
#include <i2c.h>
#endif

#if defined(CONFIG_OTP_UTIL)
#include <drivers/otp/rtk_otp_region_api.h>
#endif

#include <pinmux_reg.h>
//#if defined(CONFIG_CMD_KEY_BURNING)
//int set_pin_mux_burn();
//#endif

/************************************************************************
 *  External variables
 ************************************************************************/
extern int _f_exc_redirect_img, _e_exc_redirect_img;
extern int _f_exc_redirect_opt_img, _e_exc_redirect_opt_img;
extern int _f_exc_dispatch_img, _e_exc_dispatch_img;
extern int _f_av_reset_img, _e_av_reset_img;
extern int _f_a_entry_img, _e_a_entry_img;
extern int _f_v_entry_img, _e_v_entry_img;
extern int _f_v_ddr_cal_img, _e_v_ddr_cal_img;
extern int _f_v_ddr_cal_c_img, _e_v_ddr_cal_c_img;
extern int _f_isrvideo_img, _e_isrvideo_img;
extern int _f_rosbootvector_img, _e_rosbootvector_img;
extern int boot_power_on_mode;
extern int prev_power_on_status;

/************************************************************************
 * Coloured LED functionality
 ************************************************************************
 * May be supplied by boards if desired
 */
static inline void __coloured_LED_init(void) {}
void coloured_LED_init(void)
	__attribute__((weak, alias("__coloured_LED_init")));
static inline void __red_led_on(void) {}
void red_led_on(void) __attribute__((weak, alias("__red_led_on")));
static inline void __red_led_off(void) {}
void red_led_off(void) __attribute__((weak, alias("__red_led_off")));
static inline void __green_led_on(void) {}
void green_led_on(void) __attribute__((weak, alias("__green_led_on")));
static inline void __green_led_off(void) {}
void green_led_off(void) __attribute__((weak, alias("__green_led_off")));
static inline void __yellow_led_on(void) {}
void yellow_led_on(void) __attribute__((weak, alias("__yellow_led_on")));
static inline void __yellow_led_off(void) {}
void yellow_led_off(void) __attribute__((weak, alias("__yellow_led_off")));
static inline void __blue_led_on(void) {}
void blue_led_on(void) __attribute__((weak, alias("__blue_led_on")));
static inline void __blue_led_off(void) {}
void blue_led_off(void) __attribute__((weak, alias("__blue_led_off")));

/*
 ************************************************************************
 * Init Utilities							*
 ************************************************************************
 * Some of this code should be moved into the core functions,
 * or dropped completely,
 * but let's get it working (again) first...
 */

#if defined(CONFIG_ARM_DCC) && !defined(CONFIG_BAUDRATE)
#define CONFIG_BAUDRATE 115200
#endif

static int init_baudrate(void)
{
	gd->baudrate = getenv_ulong("baudrate", 10, CONFIG_BAUDRATE);
	return 0;
}

static int display_banner(void)
{
	debug("U-Boot code: %08lX -> %08lX  BSS: -> %08lX\n",
	       _TEXT_BASE,
	       _bss_start_ofs + _TEXT_BASE, _bss_end_ofs + _TEXT_BASE);
#ifdef CONFIG_MODEM_SUPPORT
	debug("Modem Support enabled\n");
#endif
#ifdef CONFIG_USE_IRQ
	debug("IRQ Stack: %08lx\n", IRQ_STACK_START);
	debug("FIQ Stack: %08lx\n", FIQ_STACK_START);
#endif

	return (0);
}

/*
 * WARNING: this code looks "cleaner" than the PowerPC version, but
 * has the disadvantage that you either get nothing, or everything.
 * On PowerPC, you might see "DRAM: " before the system hangs - which
 * gives a simple yet clear indication which part of the
 * initialization if failing.
 */
static int display_dram_config(void)
{
	int i;

#ifdef DEBUG
	puts("RAM Configuration:\n");

	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++) {
		printf("Bank #%d: %08lx ", i, gd->bd->bi_dram[i].start);
		print_size(gd->bd->bi_dram[i].size, "\n");
	}
#else
	ulong size = 0;

	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++)
		size += gd->bd->bi_dram[i].size;

	puts("DRAM:  ");
	print_size(size, "\n");
#endif

	return (0);
}

#if defined(CONFIG_HARD_I2C) || defined(CONFIG_SOFT_I2C)
static int init_func_i2c(void)
{
	puts("I2C:   ");
	i2c_init(CONFIG_SYS_I2C_SPEED, CONFIG_SYS_I2C_SLAVE);
	puts("ready\n");
	return (0);
}
#endif
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013) || defined(CONFIG_REALTEK_AMP_ACL1310) || defined(CONFIG_REALTEK_AMP_RT9107B) || defined(CONFIG_REALTEK_AMP_BM28723MUV) || defined(CONFIG_REALTEK_AMP_ALC1311) || defined(CONFIG_AMP_RT9119)
extern void AudioAmp_InitAudioOut2I2S_1st(void);
extern void AudioAmp_InitAudioOut2I2S_2nd(void);

static int init_amp_prepare(void)
{

#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_ACL1310) || defined(CONFIG_REALTEK_AMP_RT9107B) || defined(CONFIG_REALTEK_AMP_BM28723MUV) || defined(CONFIG_REALTEK_AMP_ALC1311) || defined(CONFIG_AMP_RT9119)
#if 0
printf("PIN_A7: 0xB800085C[23:20]; GPIO121   \t 0xB800085C=((xxf0xxxx))\n");
printf("PIN_A5: 0xB8000860[7:4]; GPIO127       \t 0xB8000860=((f0xxxxf0))\n");
printf("PIN_D7: 0xB8000860[31:28]; GPIO124\n");
printf("MIS_GP3DIR	((volatile int)0xb801bc0c)\n");
printf("MIS_GP3DATO	((volatile int)0xb801bc24)\n");
printf("MIS_GP3DATI	((volatile int)0xb801bc3c)\n");
printf("0xB800085C=((0x%08x))\n", rtd_inl(0xB800085C));
printf("0xB8000860=((0x%08x))\n", rtd_inl(0xB8000860));
printf("0xb801bc0c=((0x%08x))\n", rtd_inl(0xb801bc0c));
printf("0xb801bc24=((0x%08x))\n", rtd_inl(0xb801bc24));
printf("0xb801bc3c=((0x%08x))\n", rtd_inl(0xb801bc3c));
//EMMC
printf("0xb8000814 bit[23:20] & [15:12]set 1 \t 0xb8000814=((xx1010xx))\n");
printf("0xb8000814=((0x%08x))\n", rtd_inl(0xb8000814));
#endif

#ifndef CONFIG_LESS_CONSOLE
	printf("init_amp_prepare\n");
#endif

#ifdef CONFIG_REALTEK_AMP
	AudioAmp_InitAudioOut2I2S_1st();
#endif

	return 0;
#endif
}

#ifdef CONFIG_REALTEK_AMP
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013) || defined(CONFIG_REALTEK_AMP_RT9107B) || defined(CONFIG_AMP_RT9119)
static int init_amp(void)
{
	if(boot_power_on_mode != POWER_OFF)
	{
		printf("init_amp\n");
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_ACL1310) || defined(CONFIG_REALTEK_AMP_RT9107B) || defined(CONFIG_AMP_RT9119)
#if !defined(BOOTLOGO_INIT_FIRST)
		AudioAmp_InitAudioOut2I2S_2nd();
#endif
		//AudioAmp_InitAudioOut2I2S_2nd();  //move to panel.c to speedup
#else
		AudioAmp_InitAudioOut2I2S_1st();
		AudioAmp_InitAudioOut2I2S_2nd();
#endif
	}
	return 0;
}
#endif
#endif
#endif

#if defined(CONFIG_CMD_PCI) || defined (CONFIG_PCI)
#include <pci.h>
static int arm_pci_init(void)
{
	pci_init();
	return 0;
}
#endif /* CONFIG_CMD_PCI || CONFIG_PCI */

/*
 * Breathe some life into the board...
 *
 * Initialize a serial port as console, and carry out some hardware
 * tests.
 *
 * The first part of initialization is running from Flash memory;
 * its main purpose is to initialize the RAM so that we
 * can relocate the monitor code to RAM.
 */

/*
 * All attempts to come up with a "common" initialization sequence
 * that works for all boards and architectures failed: some of the
 * requirements are just _too_ different. To get rid of the resulting
 * mess of board dependent #ifdef'ed code we now make the whole
 * initialization sequence configurable to the user.
 *
 * The requirements for any new initalization function is simple: it
 * receives a pointer to the "global data" structure as it's only
 * argument, and returns an integer return code, where 0 means
 * "continue" and != 0 means "fatal error, hang the system".
 */
typedef int (init_fnc_t) (void);

int rtk_misc_init(void);
int rtk_scpu1_bisr(void);
int rtk_scpu2_bisr(void);
int do_cp42k_bisr(void);
int print_cpuinfo(void);
int rtk_memory_info_init(void);
int rtk_package_init(void);
int rtk_auto_program_otp(void);
int rtk_rbus_timeout_thr_init(void);
int init_rtd_logbuf(void);
int rtk_box_init(void);
int rtc_init(void);
#ifdef CONFIG_SVT_CLK_RMA
int rtk_svt_cpu_clock_check(void);
#endif

void __dram_init_banksize(void)
{
	gd->bd->bi_dram[0].start = CONFIG_SYS_SDRAM_BASE;
	gd->bd->bi_dram[0].size =  gd->ram_size;
}
void dram_init_banksize(void)
	__attribute__((weak, alias("__dram_init_banksize")));

int __arch_cpu_init(void)
{
	return 0;
}

int arch_cpu_init(void)
	__attribute__((weak, alias("__arch_cpu_init")));

init_fnc_t *init_sequence[] = {
	arch_cpu_init,		/* basic arch cpu dependent setup */
#if defined(CONFIG_BOARD_EARLY_INIT_F)
	board_early_init_f,
#endif
#ifdef CONFIG_OF_CONTROL
	//fdtdec_check_fdt, //Need to be fixed
#endif
	timer_init,		/* initialize timer */
#ifndef IS_FPGA
	clock_init, 		/* init clock, pll related */
#endif
#ifdef CONFIG_FSL_ESDHC
	get_clocks,
#endif
	env_init,		/* initialize environment */
	init_baudrate,		/* initialze baudrate settings */
	serial_init,		/* serial communications setup */
	console_init_f,		/* stage 1 init of console */
	display_banner,		/* say that we are here */
#ifdef CONFIG_USE_RTK_RTC
	rtc_init,
#endif
	rtk_rbus_timeout_thr_init,
#if defined(CONFIG_DISPLAY_CPUINFO)
	print_cpuinfo,		/* display cpu info (and speed) */
#endif
//	rtk_misc_init,
#ifndef CONFIG_BSP_REALTEK
	dram_init,		/* configure available RAM banks */
#endif
	rtk_memory_info_init,		/* init memory info */
	rtk_package_init,	/* used for package */
#ifdef CONFIG_SVT_CLK_RMA
	rtk_svt_cpu_clock_check,
#endif
	NULL,
};

int patch_for_low_temperature_boot(void);

init_fnc_t *init_sequence_r[] = {
#ifdef CONFIG_SYS_SUPPORT_MULTICORE
	smp_init,
#endif
#ifdef CONFIG_PATCH_FOR_LOW_TEMPERATURE_BOOT
	patch_for_low_temperature_boot,
#endif
#if defined(CONFIG_CUSTOMIZE_FUNC_REGISTER)
	init_customize_func,	/* init customize func feature */
#endif
#if defined(CONFIG_SYS_PCB_MANAGER) && !defined(CONFIG_SVT_CLK_RMA)
	pcb_mgr_init,	/* initialize pinmux*/
#endif

//#if defined(CONFIG_CMD_KEY_BURNING)
//	set_pin_mux_burn,	/* initialize pinmux for burn*/
//#endif
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013) || defined(CONFIG_REALTEK_AMP_ACL1310) || defined(CONFIG_REALTEK_AMP_RT9107B) || defined(CONFIG_REALTEK_AMP_BM28723MUV) || defined(CONFIG_REALTEK_AMP_ALC1311)  || defined(CONFIG_AMP_RT9119)
	init_amp_prepare,
#endif
#if defined(CONFIG_DISPLAY_BOARDINFO)
	checkboard,		/* display board info */
#endif
#if defined(CONFIG_HARD_I2C) || defined(CONFIG_SOFT_I2C)
	init_func_i2c,
#endif
	NULL,
};

#ifdef IS_FPGA
#ifdef IS_FPGA_RUN_ON_DISRAM
void dram_simple_test_for_fpga(char *func, uint line)
{
	return;
}
#else
void dram_simple_test_for_fpga(char *func, uint line)
{
#define TEST_ARRAY_SIZE 40960
#define TEST_ARRAY_ADDR 0x0a000000
#define TEST_LOOPS 2

	int cnt = 0;
	uint sum1 = 0;
	uint sum2 = 0;
	uint loops = TEST_LOOPS;
	char *test_array = (char *)TEST_ARRAY_ADDR;
	char pattern[] = {0xa5, 0x5a, 0xaa, 0x55};
	int pattern_idx = 0;

	printf("[dram_test] at %s:%d\n", func, line);

	while (loops--) {

		sum1 = 0;
		pattern_idx = loops % 4;
		test_array += 0x00100000;

		for(cnt = 0;cnt < TEST_ARRAY_SIZE;cnt++)
		{
			test_array[cnt] = pattern[pattern_idx];
			sum1 += pattern[pattern_idx];
		}

		sum2 = get_checksum(test_array, TEST_ARRAY_SIZE);

		if (sum1 != sum2)
			printf("[%d][test %x %d bytes] ddr checksum error %x %x\n", loops, test_array, TEST_ARRAY_SIZE, sum1, sum2);
		else
			printf("[%d][test %x %d bytes] ddr checksum ok\n", loops, test_array, TEST_ARRAY_SIZE);
	}
}
#endif
#endif


void board_init_f(ulong bootflag)
{
	init_fnc_t **init_fnc_ptr;

	strboot_init_f();

#ifndef CONFIG_NO_RELOCATION
	bd_t *bd;
	gd_t *id;
	ulong addr_sp;
#endif
	ulong addr; /*, addr_heap; */
#ifdef CONFIG_PRAM
	ulong reg;
#endif

	bootstage_mark_name(BOOTSTAGE_ID_START_UBOOT_F, "board_init_f");

	/* Pointer is writable since we allocated a register for it */
#ifdef CONFIG_NO_RELOCATION
	gd = (gd_t *) _irq_stack_start;
#else
	gd = (gd_t *) ((CONFIG_SYS_INIT_SP_ADDR) & ~0x07);
#endif

	/* compiler optimization barrier needed for GCC >= 3.4 */
	__asm__ __volatile__("": : :"memory");

	memset((void *)gd, 0, sizeof(gd_t));

	gd->mon_len = _bss_end_ofs;
#ifdef CONFIG_OF_EMBED
	/* Get a pointer to the FDT */
	gd->fdt_blob = _binary_dt_dtb_start;
#elif defined CONFIG_OF_SEPARATE
	/* FDT is at end of image */
	gd->fdt_blob = (void *)(_end_ofs + _TEXT_BASE);
#else
	//we do here
#endif
	/* Allow the early environment to override the fdt address */
	gd->fdt_blob = (void *)getenv_ulong("fdtcontroladdr", 16,
						(uintptr_t)gd->fdt_blob);

	for (init_fnc_ptr = init_sequence; *init_fnc_ptr; ++init_fnc_ptr) {
		if ((*init_fnc_ptr)() != 0) {
			hang ();
		}
	}

#ifdef CONFIG_REALTEK_WATCHDOG
	WATCHDOG_ENABLE();
#endif

	gd->ram_size = get_ddr_size();

#ifdef CONFIG_OF_CONTROL
	/* For now, put this check after the console is ready */
	if (fdtdec_prepare_fdt()) {
		panic("** CONFIG_OF_CONTROL defined but no FDT - please see "
			"doc/README.fdt-control");
	}
#endif

	debug("monitor len: %08lX\n", gd->mon_len);
	/*
	 * Ram is setup, size stored in gd !!
	 */
	debug("ramsize: %08lX\n", gd->ram_size);

#ifdef CONFIG_NO_RELOCATION
	debug("Reserving %ldk for U-Boot from : %08x\n", gd->mon_len >> 10, CONFIG_SYS_TEXT_BASE);
	debug("Stack Pointer is: %08lx\n", (ulong)_stack_start);
	debug("Reserving %zu Bytes for Global Data at: %08x\n", sizeof (gd_t), (unsigned int)gd);

	/* setup stackpointer for exeptions */
	gd->irq_sp = (ulong)_irq_stack_start;

	addr = (ulong) _irq_stack_start;
	addr += sizeof(gd_t);
	gd->bd = (bd_t *)addr;
	debug("Reserving %zu Bytes for Board Info at: %08x\n", sizeof (bd_t), (unsigned int)gd->bd);

	addr += sizeof(bd_t);

#ifdef CONFIG_HEAP_RELOCATION
	#ifndef IS_FPGA
		gd->heap_addr = rtk_mem_info->heap_relocation_addr;
	#else
		#ifdef IS_FPGA_RUN_ON_DISRAM
		extern int __stack_start;
		gd->heap_addr = (unsigned int)&__stack_start;
		#else
		gd->heap_addr = UBOOT_HEAP_RELOCATION_ADDR;
		#endif
	#endif  // #ifndef IS_FPGA
#else
	// 4K aligned
	if (addr&(0x1000-1)) {
		addr &= ~(0x1000-1);
        addr += 0x1000;
	}

	gd->heap_addr = addr;

	addr += TOTAL_MALLOC_LEN;
#endif
	debug("Reserving %zu Bytes for Heap at: %08lx\n", TOTAL_MALLOC_LEN, gd->heap_addr);

#ifdef CONFIG_NONCACHE_ALLOCATION
	// 1MB alignment
	#ifndef IS_FPGA
		gd->noncache_addr = rtk_mem_info->noncache_mem_addr;
	#else
		gd->noncache_addr = UBOOT_NONCACHE_MEMORY_ADDR;
	#endif
	debug("Reserving %zu Bytes for Non-cache allocation at: %08lx\n", CONFIG_SYS_NON_CACHE_LEN, gd->noncache_addr);
#endif

#if !(defined(CONFIG_SYS_ICACHE_OFF) && defined(CONFIG_SYS_DCACHE_OFF))
	/* round down to next 64 kB limit */
	addr &= ~(0x10000 - 1);
	addr += 0x10000;

	gd->tlb_addr = addr;
	debug("TLB table at: %08lx\n", gd->tlb_addr);
#endif

	gd->bd->bi_baudrate = gd->baudrate;
	/* Ram ist board specific, so move it to board code ... */
	dram_init_banksize();
	display_dram_config();  /* and display it */

	relocate_code(_stack_start, (gd_t *)gd, _TEXT_BASE);
#else	// !CONFIG_NO_RELOCATION
#if defined(CONFIG_SYS_MEM_TOP_HIDE)
	/*
	 * Subtract specified amount of memory to hide so that it won't
	 * get "touched" at all by U-Boot. By fixing up gd->ram_size
	 * the Linux kernel should now get passed the now "corrected"
	 * memory size and won't touch it either. This should work
	 * for arch/ppc and arch/powerpc. Only Linux board ports in
	 * arch/powerpc with bootwrapper support, that recalculate the
	 * memory size from the SDRAM controller setup will have to
	 * get fixed.
	 */
	gd->ram_size -= CONFIG_SYS_MEM_TOP_HIDE;
#endif

	addr = CONFIG_SYS_SDRAM_BASE + gd->ram_size;

#ifdef CONFIG_LOGBUFFER
#ifndef CONFIG_ALT_LB_ADDR
	/* reserve kernel log buffer */
	addr -= (LOGBUFF_RESERVE);
	debug("Reserving %dk for kernel logbuffer at %08lx\n", LOGBUFF_LEN,
		addr);
#endif
#endif

#ifdef CONFIG_PRAM
	/*
	 * reserve protected RAM
	 */
	reg = getenv_ulong("pram", 10, CONFIG_PRAM);
	addr -= (reg << 10);		/* size is in kB */
	debug("Reserving %ldk for protected RAM at %08lx\n", reg, addr);
#endif /* CONFIG_PRAM */

#if !(defined(CONFIG_SYS_ICACHE_OFF) && defined(CONFIG_SYS_DCACHE_OFF))
	/* reserve TLB table */
	addr -= (4096 * 4);

	/* round down to next 64 kB limit */
	addr &= ~(0x10000 - 1);

	gd->tlb_addr = addr;
	debug("TLB table at: %08lx\n", gd->tlb_addr);
#endif

	/* round down to next 4 kB limit */
	addr &= ~(4096 - 1);
	debug("Top of RAM usable for U-Boot at: %08lx\n", addr);

#ifdef CONFIG_LCD
#ifdef CONFIG_FB_ADDR
	gd->fb_base = CONFIG_FB_ADDR;
#else
	/* reserve memory for LCD display (always full pages) */
	addr = lcd_setmem(addr);
	gd->fb_base = addr;
#endif /* CONFIG_FB_ADDR */
#endif /* CONFIG_LCD */

	/*
	 * reserve memory for U-Boot code, data & bss
	 * round down to next 4 kB limit
	 */
	addr -= gd->mon_len;
	addr &= ~(4096 - 1);

	debug("Reserving %ldk for U-Boot at: %08lx\n", gd->mon_len >> 10, addr);

#ifndef CONFIG_SPL_BUILD
	/*
	 * reserve memory for malloc() arena
	 */
	addr_sp = addr - TOTAL_MALLOC_LEN;
	debug("Reserving %dk for malloc() at: %08lx\n",
			TOTAL_MALLOC_LEN >> 10, addr_sp);
	/*
	 * (permanently) allocate a Board Info struct
	 * and a permanent copy of the "global" data
	 */
	addr_sp -= sizeof (bd_t);
	bd = (bd_t *) addr_sp;
	gd->bd = bd;
	debug("Reserving %zu Bytes for Board Info at: %08lx\n",
			sizeof (bd_t), addr_sp);

#ifdef CONFIG_MACH_TYPE
	gd->bd->bi_arch_number = CONFIG_MACH_TYPE; /* board id for Linux */
#endif

	addr_sp -= sizeof (gd_t);
	id = (gd_t *) addr_sp;
	debug("Reserving %zu Bytes for Global Data at: %08lx\n",
			sizeof (gd_t), addr_sp);

	/* setup stackpointer for exeptions */
	gd->irq_sp = addr_sp;
#ifdef CONFIG_USE_IRQ
	addr_sp -= (CONFIG_STACKSIZE_IRQ+CONFIG_STACKSIZE_FIQ);
	debug("Reserving %zu Bytes for IRQ stack at: %08lx\n",
		CONFIG_STACKSIZE_IRQ+CONFIG_STACKSIZE_FIQ, addr_sp);
#endif
	/* leave 3 words for abort-stack    */
	addr_sp -= 12;

	/* 8-byte alignment for ABI compliance */
	addr_sp &= ~0x07;
#else
	addr_sp += 128;	/* leave 32 words for abort-stack   */
	gd->irq_sp = addr_sp;
#endif

	debug("New Stack Pointer is: %08lx\n", addr_sp);

#ifdef CONFIG_POST
	post_bootmode_init();
	post_run(NULL, POST_ROM | post_bootmode_get(0));
#endif

	gd->bd->bi_baudrate = gd->baudrate;
	/* Ram ist board specific, so move it to board code ... */
	dram_init_banksize();
	display_dram_config();	/* and display it */

	gd->relocaddr = addr;
	gd->start_addr_sp = addr_sp;
	gd->reloc_off = addr - _TEXT_BASE;
	debug("relocation Offset is: %08lx\n", gd->reloc_off);
	memcpy(id, (void *)gd, sizeof(gd_t));
	relocate_code(addr_sp, id, addr);

	/* NOTREACHED - relocate_code() does not return */
#endif	//CONFIG_NO_RELOCATION
}

extern int coproc_handler(void);
void secondary_init_r(unsigned int cpu_id)
{
#ifdef CONFIG_SYS_SUPPORT_MULTICORE
    u32 cpuID;
    //unsigned int regValue = 0;
    //u32 count = 0;
    //unsigned int flags;

#if defined(CONFIG_CMD_MTEST_MULTICORE) || (CONFIG_MAX_POWER_MEASURE != 0)
    smp_mutex_lock();
    cpu_id_list[cpu_id] = get_MPIDR();
    smp_mutex_unlock();
    coproc_putc(0x21 + smp_processor_id(get_MPIDR())); // print ["#$] to debug
    coproc_handler();
    while(1);
#endif

    if(!cpu_id)
        return;

    cpuID = smp_processor_id(get_MPIDR());

    enable_caches();

#ifdef CONFIG_USE_IRQ
	// init gic
//	rtk_interrupt_gic_dist_init();
//	rtk_interrupt_gic_cpu_init();

//	mhal_interrupt_unmask(E_INTERRUPT_IRQ);

#ifdef CONFIG_SUPPORT_TIMER_INTERRUPT
	arch_timer_init_core();
#endif

#if 0
	// enable timer
	MAsm_CPU_TimerInit();
	MAsm_CPU_TimerStart();
#endif

	// setup irq stack pointer
	extern void set_irq_sp(ulong);
	unsigned int sp_addr = SMP_CORE1_IRQ_SP_ADDR;
	sp_addr = sp_addr + (cpuID - 1) * SMP_COREX_IRQ_SP_SIZE;
	set_irq_sp(sp_addr);

//	enable_interrupts();
#endif

    rtd_outl(smp_magic_tag(cpu_id), MAGIC_COPROC_OP_GET_READY);
    coproc_putc(0x21 + cpuID); // print ["#$] to debug

    while(1)
    {
    #ifdef CONFIG_USE_IRQ
        asm volatile("WFI");
    #else
	 asm volatile("WFE");
    #endif
        if((GlobalActive_Area[cpuID] == 1) && (ActiveFuncPointer[cpuID] != 0))
        {
            ActiveFuncPointer[cpuID]();
            GlobalActive_Area[cpuID]  = 0;
        }
    }
#endif
}

#ifdef CONFIG_BSP_REALTEK

#if defined(CONFIG_SYS_RTK_EMMC_FLASH)
	#define BOOT_FLASH_TYPE	BOOT_EMMC
#elif defined(CONFIG_SYS_RTK_NAND_FLASH)
	#define BOOT_FLASH_TYPE	BOOT_NAND
#elif defined(CONFIG_SYS_RTK_SPI_NAND)
	#define BOOT_FLASH_TYPE	BOOT_SPI_NAND
#else
	#define BOOT_FLASH_TYPE BOOT_NOR_SERIAL
#endif

BOOT_FLASH_T boot_flash_type = BOOT_FLASH_TYPE;	/* used to save extern param, logo, rescue */

#ifdef CONFIG_RAM_SIZE_FROM_OTP_SETTING

typedef union
{
    unsigned int regValue;
    struct{
        unsigned int  dc1_u1_size:4;
        unsigned int  dc1_u1_type:2;
        unsigned int  dc1_u1_vendor:2;
        unsigned int  dc1_u2_size:4;
        unsigned int  dc1_u2_type:2;
        unsigned int  dc1_u2_vendor:2;
        unsigned int  dc1_u3_size:4;
        unsigned int  dc1_u3_type:2;
        unsigned int  dc1_u3_vendor:2;
        unsigned int  dc1_u4_size:4;
        unsigned int  dc1_u4_type:2;
        unsigned int  dc1_u4_vendor:2;
    };
}otp_ddr_info_RBUS;

#define OTP_DDR_TYPE_IS_DDR3	(1)
#define OTP_DDR_TYPE_IS_DDR4	(2)

unsigned int ddr_size_in_otp_t[8] = {
	0x0,		/* 0: None */
	0x04000000,	/* 1: 512Mbx16 */
	0x08000000,	/* 2: 1Gbx16 */
	0x10000000,	/* 3: 2Gbx16 */
	0x20000000,	/* 4: 4Gbx16 */
	0x40000000,	/* 5: 8Gbx16 */
	0x20000000,	/* 6: 4Gbx8 */
	0x0
};

static unsigned int rtk_get_ddr_size_from_OTP(void)
{
	otp_ddr_info_RBUS otp_ddr_info;
	unsigned int total_size = 0;

#if defined(CONFIG_OTP_UTIL)
        if(rtk_get_ddr_info(&otp_ddr_info.regValue) == false)
            return 0;
#else
        return 0;
#endif
	// sum of all DC unit
	total_size = ddr_size_in_otp_t[otp_ddr_info.dc1_u1_size] +
		ddr_size_in_otp_t[otp_ddr_info.dc1_u2_size] +
		ddr_size_in_otp_t[otp_ddr_info.dc1_u3_size] +
		ddr_size_in_otp_t[otp_ddr_info.dc1_u4_size];

	// check size is available or not
	switch(total_size) {
		case 0x20000000: // 512M
		case 0x40000000: // 1G
		case 0x60000000: // 1.5G
		case 0x80000000: // 2G
			break;
		default: // unknown size?
			return 0;
	}

	return total_size;
}

#endif

/*
 * get_ddr_size()
 * @param dcu_id
 *       0: DCU1
 *       1: DCU2
 */
unsigned int get_ddr_size(void)
{
#ifdef IS_FPGA
	return CONFIG_SYS_RAM_DCU1_SIZE;
#endif

#ifdef CONFIG_RAM_SIZE_FROM_OTP_SETTING
	return rtk_get_ddr_size_from_OTP();
#endif

	return (unsigned int)CONFIG_SYS_RAM_DCU1_SIZE + (unsigned int)CONFIG_SYS_RAM_DCU2_SIZE;
}

#ifdef CONFIG_PATCH_FOR_LOW_TEMPERATURE_BOOT
int patch_for_low_temperature_boot(void)
{
	int tml_val_t20, tml_val_cur;
	int is_2992 = 0;
	int cur_n;

#ifdef CONFIG_PATCH_FOR_LT_BOOT_2992
	is_2992 = 1;
#endif

	tml_val_t20 = (rtd_inl(0xb80381ec)&0x1F800000)>>23; //0xb80381ec[28:23] tml_value at 20 degrees
	printf("Tml Val@20: 0x%x\n", tml_val_t20); // debug use

	tml_val_cur = (rtd_inl(0xb8000280)&0x003f0000)>>16;
	printf("Cur Tml Val: 0x%x \n", tml_val_cur); // debug use

	cur_n = (rtd_inl(0xb8000534)& 0x0FF00000)>>20;
	printf("cur_n: 0x%x, efuse: 0x%x \n", cur_n, (rtd_inl(0xb80381F0) & 0x10000000));

	if( tml_val_t20 > 0 &&
		tml_val_cur >= (tml_val_t20-3) &&
		cur_n < 0x37 &&
		(rtd_inl(0xb80381F0) & 0x10000000) == 0x0 )
	{
		rtd_outl(0xb8003828, 0x00000008);        // Enter Self Refresh
		udelay(10);

		if((is_2992 == 0) && (tml_val_cur>=(tml_val_t20+3))) {     //36 degrees
			rtd_outl(0xb8000534, 0x03700000);	//769MHz

			rtd_outl(0xb8003800, 0x001CC819); // tCL:0xc(12nCK) / tCWL:0x8(8nCK) / tmCLRD:0x19(25/2=12.5)(12.5nCK)
			rtd_outl(0xb8003844, 0x00060D71); // MOD_REG01,  CL11/BC4&BL8/WR12/AL0, 34/60
			rtd_outl(0xb8003848, 0x00000018); // MOD23_REG for DDR3:Rtt_WR: disable,  #CWL:8,  ASR disable,  dynamic ODT off.
			rtd_outl(0xb8003820, 0x08007fff); // ODT_CTRL
		}
		else if( tml_val_cur>=(tml_val_t20+1)) {//25 degrees
			rtd_outl(0xb8000534, 0x02f00000);	//661MHz

			rtd_outl(0xb8003800, 0x001CA715); // tCL:0xA(10nCK) / tCWL:0x7(7nCK) / tmCLRD:0x19(21/2=10.5)(10.5nCK)
			rtd_outl(0xb8003844, 0x00060b51); // MOD_REG01,  CL9/BC4&BL8/WR12/AL0, 34/60
			rtd_outl(0xb8003848, 0x00000010); // MOD23_REG for DDR3:Rtt_WR: disable,  #CWL:7,  ASR disable,  dynamic ODT off.
			rtd_outl(0xb8003820, 0x08000fff); // ODT_CTRL
		}
		else if( tml_val_cur>=(tml_val_t20-1)) {//15 degrees
			rtd_outl(0xb8000534, 0x02b00000);	//607MHz

			rtd_outl(0xb8003800, 0x001CA715); // tCL:0xA(10nCK) / tCWL:0x7(7nCK) / tmCLRD:0x19(21/2=10.5)(10.5nCK)
			rtd_outl(0xb8003844, 0x00060b51); // MOD_REG01,  CL9/BC4&BL8/WR12/AL0, 34/60
			rtd_outl(0xb8003848, 0x00000010); // MOD23_REG for DDR3:Rtt_WR: disable,  #CWL:7,  ASR disable,  dynamic ODT off.
			rtd_outl(0xb8003820, 0x08000fff); // ODT_CTRL
		}
		else if( tml_val_cur>=(tml_val_t20-3)) {//4 degrees
			rtd_outl(0xb8000534, 0x02600000);	//540MHz

			rtd_outl(0xb8003800, 0x001CA715); // tCL:0xA(10nCK) / tCWL:0x7(7nCK) / tmCLRD:0x19(21/2=10.5)(10.5nCK)
			rtd_outl(0xb8003844, 0x00060b51); // MOD_REG01,  CL9/BC4&BL8/WR12/AL0, 34/60
			rtd_outl(0xb8003848, 0x00000010); // MOD23_REG for DDR3:Rtt_WR: disable,  #CWL:7,  ASR disable,  dynamic ODT off.
			rtd_outl(0xb8003820, 0x08000fff); // ODT_CTRL
		}
		udelay(2500);

		rtd_outl(0xb8003828, 0x00000004); // Exit Self Refresh
		udelay(10);

		rtd_outl(0xb8003840,0x0000000C);    // Exe MR0 Cmd
		rtd_outl(0xb8003840,0x000000C0);    // Exe MR2 2md
		udelay(10);
	}

	return 0;
}
#endif

#ifdef IS_BOX
int rtk_box_init(void)
{
	printf("%s FIXME (maybe need some settings for box)\n", __FUNCTION__);



#if 0
	unsigned int tmp;

	//disable AIO1 AIO2 ADCFE ADC HPO power
	tmp = rtd_inl(0xb8006b28) & ~(_BIT12|_BIT11|_BIT10|_BIT3);
	rtd_outl(0xb8006b28, tmp);
	debug("REG32(0xb8006b28) = 0x%x\n",  rtd_inl(0xb8006b28));

	//disable YPP VD+ADC power
	//--b8020000[7,6,5,2,1,0]=0
	tmp = rtd_inl(0xb8020000) & ~(_BIT7|_BIT6|_BIT5|_BIT2|_BIT1|_BIT0);
	rtd_outl(0xbb8020000, tmp);
	debug("REG32(0xb8020000) = 0x%x\n",  rtd_inl(0xb8020000));

	//disable LDO
	//--B802005c[1:0]=0
	tmp = rtd_inl(0xb802005c) & ~(_BIT1|_BIT0);
	rtd_outl(0xb802005c, tmp);
	debug("REG32(0xb802005c) = 0x%x\n",  rtd_inl(0xb802005c));

	//disable Hsync
	//--B8020064[9]=1
	tmp = rtd_inl(0xb8020064) | (_BIT9);
	rtd_outl(0xb8020064, tmp);
	debug("REG32(0xb8020064) = 0x%x\n",  rtd_inl(0xb8020064));

	//disable SCART ADC
	//--b802006c[0]=0
	tmp = rtd_inl(0xb802006c)  & ~(_BIT0);
	rtd_outl(0xb802006c, tmp);
	debug("REG32(0xb802006c) = 0x%x\n",  rtd_inl(0xb802006c));

	//0x1802_D010[7:6] = 0
	tmp = rtd_inl(0xb802d010)  & ~(_BIT7|_BIT6);
	rtd_outl(0xb802d010, tmp);
	debug("REG32(0xb802d010) = 0x%x\n",  rtd_inl(0xb802d010));

	//Close LVDS power
	//0xb800_0C78[6:0]=0
	//0xb800_0C78[15:8]=0
	//0xb800_0C78[22:16]=0
	//0xb800_0C78[30:23]=0
	tmp = rtd_inl(0xb8000c78)  & ~(_BIT30|_BIT29|_BIT28|_BIT27|_BIT26|_BIT25|_BIT24|_BIT23|_BIT22|_BIT21|_BIT20|_BIT19|_BIT18|_BIT17|_BIT16|_BIT15|_BIT14|_BIT13|_BIT12|_BIT11|_BIT10|_BIT9|_BIT8|_BIT6|_BIT5|_BIT4|_BIT3|_BIT2|_BIT1|_BIT0);
	rtd_outl(0xb8000c78, tmp);
	debug("REG32(0xb8000c78) = 0x%x\n",  rtd_inl(0xb8000c78));

	//0xb800_7b08[5:3] = 1
	tmp = rtd_inl(0xb8007b08) | (_BIT5|_BIT4|_BIT3);
	rtd_outl(0xb8007b08, tmp);
	debug("REG32(0xb8007b08) = 0x%x\n",  rtd_inl(0xb8007b08));

	//0xb800_7b00[29] = 0
	tmp = rtd_inl(0xb8007b00)& ~(_BIT29);
	rtd_outl(0xb8007b00, tmp);
	debug("REG32(0xb8007b00) = 0x%x\n",  rtd_inl(0xb8007b00));

	//0xb800_7b6c[3][0] = 0
	tmp = rtd_inl(0xb8007b6c)& ~(_BIT3|_BIT0);
	rtd_outl(0xb8007b6c, tmp);
	debug("REG32(0xb8007b6c) = 0x%x\n",  rtd_inl(0xb8007b6c));

	//0xb800_7b50[18:3] = 0
	tmp = rtd_inl(0xb8007b50)  & ~(_BIT18|_BIT17|_BIT16|_BIT15|_BIT14|_BIT13|_BIT12|_BIT11|_BIT10|_BIT9|_BIT8|_BIT7|_BIT6|_BIT5|_BIT4|_BIT3);
	rtd_outl(0xb8007b50, tmp);
	debug("REG32(0xb8007b50) = 0x%x\n",  rtd_inl(0xb8007b50));

	//0xb800_7be0[10:8] = 0
	tmp = rtd_inl(0xb8007be0)  & ~(_BIT10|_BIT9|_BIT8);
	rtd_outl(0xb8007be0, tmp);
	debug("REG32(0xb8007be0) = 0x%x\n",  rtd_inl(0xb8007be0));
#endif

	return 0;
}
#endif

#define SCPU_TEXT_START	0x00200000
#define SCPU_TEXT_END	0x00d00000
#define ACPU_TEXT_START	0x1b200000
#define ACPU_TEXT_END	0x1b800000
#define VCPU_TEXT_STRT	0x1a900000
#define VCPU_TEXT_END	0x1ac00000
void calculate_DDR_checksum(void)
{

	//SCPU text
	unsigned int *data_ptr = (unsigned int *)(SCPU_TEXT_START);
	unsigned int *end_ptr =  (unsigned int *)(SCPU_TEXT_END);
	unsigned int sumValue=0;
    unsigned int pinmux = 0;

    /* Switch UART pin to output log */
    pinmux = rtd_inl(PINMUX_ST_GPIO_ST_CFG_0_reg);
    rtd_outl(PINMUX_ST_GPIO_ST_CFG_0_reg, (pinmux & 0xFFFFFF0F) | 0x70);

	while(data_ptr<end_ptr)
	{
		sumValue+=*data_ptr;
		data_ptr++;
	}
	printf("Boot DDR_checksum S(%x)\n", sumValue);

	//ACPU text
	data_ptr = (unsigned int *)(ACPU_TEXT_START);
	end_ptr =  (unsigned int *)(ACPU_TEXT_END);
	sumValue=0;
	while(data_ptr<end_ptr)
	{
		sumValue+=*data_ptr;
		data_ptr++;
	}
	printf("Boot DDR_checksum A(%x)\n", sumValue);

	//VCPU text
	data_ptr = (unsigned int *)(VCPU_TEXT_STRT);
	end_ptr =  (unsigned int *)(VCPU_TEXT_END);
	sumValue=0;
	while(data_ptr<end_ptr)
	{
		sumValue+=*data_ptr;
		data_ptr++;
	}
	printf("Boot DDR_checksum V(%x)\n", sumValue);
    /* Switch back UART pin setting */
    rtd_outl(PINMUX_ST_GPIO_ST_CFG_0_reg, pinmux);
}


int rtk_memory_info_init(void)
{
	uint kernel_rsv_mem_info_addr;
	uint tmp_addr1 = 0;
//	uint tmp_size1 = 0;
	uint tmp_addr2 = 0;
	uint tmp_size2 = 0;
	uint tmp_addr3 = 0;
//	uint tmp_size3 = 0;
	uint bAvailable = 0;
	uint i = 0;
	kernel_rsv_mem_info_t *rsv_mem_info;

#ifndef IS_FPGA
	// check if boot from resume flow
	if ((rtd_inl(REG_CRT_SUSPEND_reg) == KERNEL_RSV_MEM_MAGICNO) && (rtd_inl(REG_STR_JUMP_ADDR_reg) != 0))
	{
		if(rtd_inl(STB_WDOG_DATA14_reg) == 0xfafefafe)
			calculate_DDR_checksum();
		kernel_rsv_mem_info_addr = rtd_inl(REG_KERNEL_RSV_MEM_reg);

		if (kernel_rsv_mem_info_addr != 0)
		{
			rsv_mem_info = (kernel_rsv_mem_info_t *)kernel_rsv_mem_info_addr;

			if (rsv_mem_info->dwMagicNumber == KERNEL_RSV_MEM_MAGICNO)
			{
				if (rsv_mem_info->dwEntryCount < 3)
				{
					printf("[ERROR] kernel rsv memory is not enough(%d). (reset...)\n", rsv_mem_info->dwEntryCount);
					mdelay(50);
					// clear resume flag
					rtd_outl(REG_CRT_SUSPEND_reg, 0);
					rtd_outl(REG_STR_JUMP_ADDR_reg, 0);
					// clear kernel rsv mem flag
					rtd_outl(REG_KERNEL_RSV_MEM_reg, 0x0);
					// trigger watchdog reset
					disable_interrupts();
					mdelay(50);
#if 0 // fix me
               // kick the dog no matter it is enabled.
               rtd_outl(MIS_TCWTR, _BIT0);
               // give a any small number
               rtd_outl(MIS_TCWOV_reg, 0x19BFCC0); // around 1 sec
               // enable the dog
               rtd_clearbits(MIS_TCWCR_reg, 0xff);
               while(1);
#endif
				}
				if (rsv_mem_info->dwEntryCount > 0) // get the 1st memory region
				{
					if (rsv_mem_info->entry[0].address % 0x100000 != 0x0) // align MB
					{
						tmp_addr1 = rsv_mem_info->entry[0].address + 0x100000
									- rsv_mem_info->entry[0].address % 0x100000;
//						tmp_size1 = rsv_mem_info->entry[0].size - 0x100000
//									+ rsv_mem_info->entry[0].address % 0x100000;
					}
					else
					{
						tmp_addr1 = rsv_mem_info->entry[0].address;
//						tmp_size1 = rsv_mem_info->entry[0].size;
					}

					if (rsv_mem_info->dwEntryCount > 1) // get the 2nd memory region
					{
						tmp_addr2 = rsv_mem_info->entry[1].address;
						tmp_size2 = rsv_mem_info->entry[1].size;

						if (rsv_mem_info->dwEntryCount > 2) // get the 3rd memory region
						{
							tmp_addr3 = rsv_mem_info->entry[2].address;
//							tmp_size3 = rsv_mem_info->entry[2].size;
						}
						else
						{
							printf("[ERROR] kernel rsv memory is not enough. (count:%d)\n", rsv_mem_info->dwEntryCount);
						}
					}
					else
					{
						printf("[ERROR] kernel rsv memory is not enough. (count:%d)\n", rsv_mem_info->dwEntryCount);
					}

				}
				else
				{
					printf("[ERROR] kernel rsv memory is not enough. (count:%d)\n", rsv_mem_info->dwEntryCount);
				}

				bAvailable = 1;
			}
		}
	}

	// reset default value
	rtd_outl(REG_KERNEL_RSV_MEM_reg, 0x0);

#endif

	if (bAvailable)
	{
		// use kernel reserve memory
		rtk_mem_info->heap_relocation_addr = tmp_addr1;
		rtk_mem_info->noncache_mem_addr = tmp_addr1 + 0x100000;
		rtk_mem_info->factory_data_addr = rtk_mem_info->noncache_mem_addr + CONFIG_SYS_NON_CACHE_LEN;
		rtk_mem_info->factory_ro_data_addr = rtk_mem_info->factory_data_addr + CONFIG_FACTORY_SIZE;
		rtk_mem_info->fw_desc_table_base_addr = rtk_mem_info->factory_ro_data_addr + CONFIG_FACTORY_RO_SIZE;
		rtk_mem_info->encrypted_fw_image_addr = rtk_mem_info->fw_desc_table_base_addr + FW_DESC_TABLE_SIZE;
		rtk_mem_info->secure_mcp_mem_buffer_addr = tmp_addr2;

		if (tmp_addr3 != 0)
			rtk_mem_info->temp_buffer_for_flash_data_addr = tmp_addr3; // use 32MB in region 3
		else
			rtk_mem_info->temp_buffer_for_flash_data_addr = tmp_addr2 + tmp_size2 - 0x400000; // use last 4MB in region 2

		printf("[krsv] use kernel reserve memory:\n");
		printf("[krsv] dwEntryCount = %d\n", rsv_mem_info->dwEntryCount);
		for(i = 0;i < rsv_mem_info->dwEntryCount;i++)
		{
			printf("[krsv] addr:0x%x size:0x%x\n", rsv_mem_info->entry[i].address, rsv_mem_info->entry[i].size);
		}
	}
	else
	{
		// use default memory
		rtk_mem_info->heap_relocation_addr = UBOOT_HEAP_RELOCATION_ADDR;
		rtk_mem_info->noncache_mem_addr = UBOOT_NONCACHE_MEMORY_ADDR;
		rtk_mem_info->factory_data_addr = FACTORY_DATA_ADDR;
		rtk_mem_info->factory_ro_data_addr = FACTORY_RO_DATA_ADDR;
		rtk_mem_info->fw_desc_table_base_addr = FIRMWARE_DESCRIPTION_TABLE_ADDR;
		rtk_mem_info->encrypted_fw_image_addr = ENCRYPTED_LINUX_KERNEL_ADDR;
		rtk_mem_info->secure_mcp_mem_buffer_addr = UBOOT_SECURE_MCP_MEMORY_ADDR;
		rtk_mem_info->temp_buffer_for_flash_data_addr = TEMP_BUFFER_FOR_FLASH_DATA_ADDR;

#ifndef CONFIG_LESS_CONSOLE
		printf("[krsv] use default uboot memory:\n");
#endif
	}

#if 0 // dump mem info
	printf("[krsv] heap_relocation_addr       = 0x%x\n", rtk_mem_info->heap_relocation_addr);
	printf("[krsv] noncache_mem_addr          = 0x%x\n", rtk_mem_info->noncache_mem_addr);
	printf("[krsv] factory_data_addr          = 0x%x\n", rtk_mem_info->factory_data_addr);
	printf("[krsv] factory_ro_data_addr       = 0x%x\n", rtk_mem_info->factory_ro_data_addr);
	printf("[krsv] fw_desc_table_base_addr    = 0x%x\n", rtk_mem_info->fw_desc_table_base_addr);
	printf("[krsv] encrypted_fw_image_addr    = 0x%x\n", rtk_mem_info->encrypted_fw_image_addr);
	printf("[krsv] secure_mcp_mem_buffer_addr = 0x%x\n", rtk_mem_info->secure_mcp_mem_buffer_addr);
	printf("[krsv] temp_buffer_for_flash_data = 0x%x\n", rtk_mem_info->temp_buffer_for_flash_data_addr);
#endif

	return 0;
}

int rtk_package_init(void)
{
#if 0 // pass flash_type(boot_flash) to kernel using system_parameters
	unsigned int package_type, flash_type, other_check, boot_type;

	#define PACKAGE_TYPE_MAG_NUM 0x294

	boot_type = 0;
	other_check = 0;

#if defined(CONFIG_SYS_RTK_NAND_FLASH)
	flash_type = 2;
#elif defined(CONFIG_SYS_RTK_SPI_FLASH)
	flash_type = 3;
#elif defined(CONFIG_SYS_RTK_SPI_NAND_FLASH)
	flash_type = 0;
#elif defined(CONFIG_SYS_RTK_EMMC_FLASH)
	flash_type = 1;
#else
	#error "flash type not defined"
#endif

	package_type = ((PACKAGE_TYPE_MAG_NUM & 0xfff) << 20) | ((flash_type & 0x3) << 4) | ((other_check & 0x1) << 3) | (boot_type & 0x7);

	rtd_outl(REG_PACKAGE_TYPE_reg, package_type);

	printf("package type: 0x%08x\n", rtd_inl(REG_PACKAGE_TYPE_reg));
#endif
	return 0;
}

int rtk_auto_program_otp(void)
{
	printf("%s(): enable check new otp bitmap and program it ...\n", __FUNCTION__);

#if 0 // CK FIXME: need to verify the otp bitmap
	printf("%s(): need to confirm AGAIN and AGAIN!!!!!!\n", __FUNCTION__);
#else
#ifdef CONFIG_OTP_UTIL
	if(!otp_is_ever_programed()) {
		printf("OTP: Start Programming ...\n");
		otp_program_with_bitmap_with_verify();

	} else {
            otp_check_and_program_special_regions();
	}
#endif
#endif


	return 0;
}

int rtk_osc_autok(void)
{
	uint getReg, getReg1;
	int cnt;

	// restore options in rbus timer out
	getReg1 = rtd_inl(0x1801a004);
	rtd_outl(0x1801a004, getReg1 & 0x00000030);
//	printf("\nOTP[0x180382c0] : %x\n", rtd_inl(0x180382c0));
	if((rtd_inl(0x180382c0) & 0x00008000) == 0) {
		getReg = rtd_inl(0xb801a600) & 0xff;
		printf("\nOSC K value : %x\n", getReg);

		// Write to OTP [5646:5640]
		for(cnt = 0; cnt < 7; cnt++) {
			if(getReg & (1 << cnt)) {
				rtd_outl(0x18038800, 0x4000 | (5640 + cnt));	// write address
				rtd_outl(0x18038800, 0x00018000);				// enable program otp
				udelay(1000);
			}
		}
		rtd_outl(0x18038800, 0x0000560f);				// write done into otp
		rtd_outl(0x18038800, 0x00018000);				// enable program otp
		udelay(1000);

		printf("OTP: Programmed in OSC auto K\n");
	}

	getReg = rtd_inl(0x180382C0);
	printf("\nosc:[0xb80382C0]=%x\n", getReg);

	rtd_outl(0x1801a004, getReg1 & 0x00000031);

	return 0;
}

int rtk_disable_ng(void)
{
	uint getReg, getReg1;
//	int cnt;

	// restore options in rbus timer out
	getReg1 = rtd_inl(0x1801a004);
	rtd_outl(0x1801a004, getReg1 & 0x00000030);

	rtd_outl(0x18038834, 0x00ff0000);
	rtd_outl(0x18038830, 0x00000001);

	getReg = rtd_inl(0x1803818c);
	getReg = rtd_inl(0x180381a8);
	getReg = rtd_inl(0x1803828c);

	// Read CRC value
	getReg = rtd_inl(0x18038834);
	rtd_outl(0x18038830,00000000);
	if((getReg & 0x000000ff) == 0x50) {	// Burn otp because o empty
		//------------------------------------------------------------------------
		// File Name : Nagra_disable_crc
		// OTP field name : OTP_Clock_Selection
		// OTP bit : 3187-3185 (total : 3 bits)
		// Rbus addr : 0xb803818C[19:17] = b'011: free running ring oscillator
		rtd_outl(0x18038800,0x00004C71);	// burn 0xb8038000 bit 3185
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value

		rtd_outl(0x18038800,0x00004C72);	// burn 0xb8038000 bit 3186
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x1803818C); 		//[19:17] = b'011: free running ring oscillator

		//------------------------------------------------------------------------
		// OTP field name : Nagra_SecretDebugInterfaceDeactivation
		// OTP bit : 3415-3412 (total : 4 bits)
		// Rbus addr : 0xb80381A8[23:20] = b'0011 : secret debug interface is closed
		rtd_outl(0x18038800,0x00004D54);	// burn 0xb8038000 bit 3412
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value

		rtd_outl(0x18038800,0x00004D55);	// burn 0xb8038000 bit 3413
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x180381A8); 		//[23:20] = b'0011 : secret debug interface is closed

		//------------------------------------------------------------------------
		// OTP field name : Nagra_CERT_SCAN_Disable
		// OTP bit : 3423-3420 (total : 4 bits)
		// Rbus addr : 0xb80381A8[31:28] = b'0011 : CERT IP SCAN chain disable flag disable
		rtd_outl(0x18038800,0x00004D5C);	// burn 0xb8038000 bit 3420
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value

		rtd_outl(0x18038800,0x00004D5D);	// burn 0xb8038000 bit 3421
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x180381A8); 		//[31:28] = b'0011 : CERT IP SCAN chain disable flag disable

		//------------------------------------------------------------------------
		// OTP field name : Nagra_CERT_Disable
		// OTP bit : 5228 (total : 1 bits)
		// Rbus addr : 0xb803828C[12] = b'1 : CERT IP disable
		rtd_outl(0x18038800,0x0000546C);	// burn 0xb8038000 bit 5228
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x1803828C); 		//[12] = b'1 : CERT IP disable

		//------------------------------------------------------------------------
		// OTP field name : Nagra_DSC_Other_Disable
		// OTP bit : 5230 (total : 1 bits)
		// Rbus addr : 0xb803828C[14] = b'1 : Nagra DSC IP except DVBCSA3 disable
		rtd_outl(0x18038800,0x0000546E);	// burn 0xb8038000 bit 5230
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x1803828C); 		//[14] = b'1 : Nagra DSC IP except DVBCSA3  disable

		//------------------------------------------------------------------------
		// OTP field name : Nagra_RNG_BUFF_Acc_En
		// OTP bit : 5235-5232 (total : 4 bits)
		// Rbus addr : 0xb803828C[19:16] = b'0011 : RNG Nagra Buffer CPU access control not allow
		rtd_outl(0x18038800,0x00005470);	// burn 0xb8038000 bit 5232
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value

		rtd_outl(0x18038800,0x00005471);	// burn 0xb8038000 bit 5233
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x1803828C); 		//[19:16] = b'0011 : RNG Nagra Buffer CPU access control not allow

		//------------------------------------------------------------------------
		// OTP field name : Nagra_KeyLadderDeactivation_Flag
		// OTP bit : 5239-5236 (total : 4 bits)
		// Rbus addr : 0xb803828C[23:20] = b'0011 : Nagravision key ladder deactivation flag is disabled
		rtd_outl(0x18038800,0x00005474);	// burn 0xb8038000 bit 5236
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value

		rtd_outl(0x18038800,0x00005475);	// burn 0xb8038000 bit 5237
		rtd_outl(0x18038800,0x00018000);	// bit 15 : enable program otp
		udelay(1000);						// Delay for Stable Value
		getReg = rtd_inl(0x1803828C); 		//[23:20] = b'0011 : Nagravision key ladder deactivation flag is disabled

		//------------------------------------------------------------------------
		//crc check
		rtd_outl(0x18038834,0x00ff0000);
		rtd_outl(0x18038830,0x00000001);

		getReg = rtd_inl(0x1803818C);
		getReg = rtd_inl(0x180381A8);
		getReg = rtd_inl(0x1803828C);

		// Read CRC value
		getReg = rtd_inl(0x18038834);
		rtd_outl(0x18038830,0x00000000);
		if((getReg & 0x000000ff) != 0x5f) { // Burn otp because of empty
			printf("OTP: Error Programmed in Ng disable\n");
		}

		printf("OTP: Programmed in Ng disable\n");
	}

	getReg = rtd_inl(0x1803818c);
	printf("ng:[0x1803818c]=%x\n", getReg);

	getReg = rtd_inl(0x180381a8);
	printf("ng:[0x180381a8]=%x\n", getReg);

	getReg = rtd_inl(0x1803828c);
	printf("ng:[0x1803828c]=%x\n", getReg);

	rtd_outl(0x1801a004, getReg1 & 0x00000031);

 	return 0;
}

#endif

#if !defined(CONFIG_SYS_NO_FLASH)
static char *failed = "*** failed ***\n";
#endif

extern void greentable_status(void);

//extern int rtl8139_initialize(bd_t *bis);
extern int rtl8168_initialize(bd_t *bis);

/*
 ************************************************************************
 *
 * This is the next part if the initialization sequence: we are now
 * running from RAM and have a "normal" C environment, i. e. global
 * data can be written, BSS has been cleared, the stack size in not
 * that critical any more, etc.
 *
 ************************************************************************
 */

void do_panel_init(void)
{
#ifdef CONFIG_SYS_PANEL_SUPPORT
    panel_init();
#endif
    guipanel_init_done = 1;
    return;
}

void board_init_r(gd_t *id, ulong dest_addr)
{
	init_fnc_t **init_fnc_ptr_r;

	strboot_init_r();

	ulong malloc_start;
#if !defined(CONFIG_SYS_NO_FLASH)
	ulong flash_size;
#endif

#ifdef CONFIG_FAT_USE_EXTMEM_FOR_LARGE_ARRAY
	extern __u8 * get_vfatname_block;
	extern __u8 * get_dentfromdir_block;
	extern __u8 * do_fat_read_block;
	#define FAT_EXT_MEM_BASE 0x01300000
	get_vfatname_block = (__u8 *) (FAT_EXT_MEM_BASE);
	get_dentfromdir_block = (__u8 *) (FAT_EXT_MEM_BASE+0x10000);// MAX_CLUSTSIZE=65536
	do_fat_read_block = (__u8 *) (FAT_EXT_MEM_BASE+0x20000);
#endif

#ifdef CONFIG_REALTEK_WATCHDOG
	WATCHDOG_KICK();
	puts("Watchdog: Enabled\n");
#else
	puts("Watchdog: Disabled\n");
	WATCHDOG_DISABLE();
#endif
//#ifdef CONFIG_SYS_SUPPORT_MULTICORE
	 /* set up exceptions */
	interrupt_init();
	/* enable exceptions */
	enable_interrupts();
	/* Enable caches */
	enable_caches();
//#endif
	for (init_fnc_ptr_r = init_sequence_r; *init_fnc_ptr_r; ++init_fnc_ptr_r) {
		if ((*init_fnc_ptr_r)() != 0) {
			hang ();
		}
	}

#ifdef CONFIG_JUMP_TO_64BIT_KERNEL
#ifndef CONFIG_SYS_SUPPORT_MULTICORE
#ifndef Config_Boot_ATF_TRUE /*Remove secondary setting here*/
	rtd_outl(MAGIC_TAG_CORE1_reg, MAGIC_COPROC_OP_SMP_DISABLE);
	rtd_outl(MAGIC_TAG_CORE2_reg, MAGIC_COPROC_OP_SMP_DISABLE);
	rtd_outl(MAGIC_TAG_CORE3_reg, MAGIC_COPROC_OP_SMP_DISABLE);
	rtd_outl(MAGIC_TAG_CORE4_reg, MAGIC_COPROC_OP_SMP_DISABLE);
#endif
#endif
#endif
#ifndef IS_FPGA

	rtd_outl(REG_BOOT_STAGE, UBOOT_STAGE);
	/* check if ac_on ; use 0xb806012c to detect */
	boot_ac_on = (rtd_inl(REG_AC_DC_ON_reg) == 0) ? 1 : 0;

#if defined(CONFIG_CUSTOMER_TV010)
	boot_on_fast_install_detect = ((rtd_inl(REG_AC_DC_ON_reg) & 0x3fffffff) == 0x2379aacc) ? 1 : 0;

	printf("POWER ON: %s\n", boot_ac_on ? "AC" : "DC");

	/* fill 0x2379beef that sync from MacArthur */
	rtd_outl(REG_AC_DC_ON_reg, (rtd_inl(REG_AC_DC_ON_reg) & 0xc0000000) | 0x2379beef);
#else
	boot_on_fast_install_detect = (rtd_inl(REG_AC_DC_ON_reg) == 0x2379aacc) ? 1 : 0;

	printf("POWER ON: %s\n", boot_ac_on ? "AC" : "DC");

	/* fill 0x2379beef that sync from MacArthur */
	rtd_outl(REG_AC_DC_ON_reg, 0x2379beef);
#endif

/*
 *********************************************************
 * Realtek Patch:
 *	Copy several mips codes from .data section
 *	to specific ddr region for A/V CPU use.
 *********************************************************
 */
	unsigned char *a,*b;
	boot_av_info_t *boot_av;
#ifdef ENABLE_PCB_AUDIO_OUTPUT_TYPE
	uint tmpValue;
#endif
	extern uint *uart_reg_base_ptr;
	extern uint *boot_av_info_ptr;
	extern uint *AudioFlag_ptr_A1;
	extern uint *AudioFlag_ptr_A2;
	extern uint *VideoFlag_ptr_V1;
	extern uint *VideoFlag_ptr_V2;
	extern uint *AudioFW_entry_ptr_A1;
	extern uint *AudioFW_entry_ptr_A2;
	extern uint *VideoFW_entry_ptr_V1;
	extern uint *VideoFW_entry_ptr_V2;
	extern uint *shared_printk_buffer_ptr;
	extern uint *audio_output_info_ptr;
	extern uint *semaphore_sharemem_info_ptr;

	// copy .exc_redirect (MIPS exception redirect)
	a = (unsigned char *)&_e_exc_redirect_img;
	b = (unsigned char *)&_f_exc_redirect_img;
	memcpy((unsigned char *)MIPS_EXC_REDIRECT_CODE_ADDR, b, a-b);

	// copy .exc_redirect_opt (MIPS exception redirect option)
	a = (unsigned char *)&_e_exc_redirect_opt_img;
	b = (unsigned char *)&_f_exc_redirect_opt_img;
	memcpy((unsigned char *)MIPS_EXC_REDIRECT_OPT_CODE_ADDR, b, a-b);

	// copy .exc_dispatch (MIPS exception dispatch)
	a = (unsigned char *)&_e_exc_dispatch_img;
	b = (unsigned char *)&_f_exc_dispatch_img;
	memcpy((unsigned char *)MIPS_EXC_DISPATCH_CODE_ADDR, b, a-b);

	// copy .v_entry (VCPU bootcode)
	a = (unsigned char *)&_e_v_entry_img;
	b = (unsigned char *)&_f_v_entry_img;
	memcpy((unsigned char *)MIPS_V_ENTRY_CODE_ADDR, b, a-b);

	/*
	 * fill the VCPU jump address.
	 * ROM code will use it to decide VCPU jump address.
	 *     => if enable BISR testing, not run code in cache segment.
	 */
#ifdef ENABLE_VCPU_BISR
	rtd_outl(VCPU_JUMP_ADDR_reg, MIPS_V_ENTRY_CODE_ADDR | MIPS_KSEG1BASE);
#ifdef CONFIG_VCPU2_SUPPORT
	rtd_outl(VCPU2_JUMP_ADDR_reg, MIPS_V_ENTRY_CODE_ADDR | MIPS_KSEG1BASE);
#endif
#else
	rtd_outl(VCPU_JUMP_ADDR_reg, MIPS_V_ENTRY_CODE_ADDR | MIPS_KSEG0BASE);
#ifdef CONFIG_VCPU2_SUPPORT
	rtd_outl(VCPU2_JUMP_ADDR_reg, MIPS_V_ENTRY_CODE_ADDR | MIPS_KSEG0BASE);
#endif
#endif

	// copy .isrvideoimg (video cpu isr handler)
	a = (unsigned char *)&_e_isrvideo_img;
	b = (unsigned char *)&_f_isrvideo_img;
	memcpy((unsigned char *)MIPS_ISR_VIDEO_IMG_ADDR, b, a-b);

	// copy .rosbootvectorimg (MIPS vector interrupt)
	a = (unsigned char *)&_e_rosbootvector_img;
	b = (unsigned char *)&_f_rosbootvector_img;
	memcpy((unsigned char *)MIPS_ROS_BOOT_VECTOR_IMG_ADDR, b, a-b);

	// copy .a_entry (ACPU bootcode)
	a = (unsigned char *)&_e_a_entry_img;
	b = (unsigned char *)&_f_a_entry_img;
	memcpy((unsigned char *)MIPS_A_ENTRY_CODE_ADDR, b, a-b);

#if 1 // only apply this feature if booting cpu is not AVCPU
	// copy .av_reset (AVCPU reset handler)
	a = (unsigned char *)&_e_av_reset_img;
	b = (unsigned char *)&_f_av_reset_img;
	memcpy((unsigned char *)MIPS_AV_RESET_HANDLER_CODE_ADDR, b, a-b);
#endif

#if !defined(CONFIG_RUN_FLASH_WRITER)
	// fill the ACPU jump address.
	// After ACPU got HW semaphore in rom code, it will check this register.
#ifdef ENABLE_ACPU_BISR
	rtd_outl(ACPU_JUMP_ADDR_reg, MIPS_A_ENTRY_CODE_ADDR | MIPS_KSEG1BASE);
#else
	rtd_outl(ACPU_JUMP_ADDR_reg, MIPS_A_ENTRY_CODE_ADDR | MIPS_KSEG0BASE);
#endif
#endif

	// fill the UART register base address for A/V CPU.
	*uart_reg_base_ptr = SWAPEND32(CONFIG_SYS_NS16550_COM1 | 0xb0000000);

#ifdef SHARED_CONSOLE_UART // sync from Macarthur
	if (CONSOLE_UART == PCB_UART_1) {
		*uart_reg_base_ptr = SWAPEND32(0xb801b100);
	} else if (CONSOLE_UART == PCB_UART_2) {
		*uart_reg_base_ptr = SWAPEND32(0xb801b200);
	} else if (CONSOLE_UART == PCB_UART_3) {
		*uart_reg_base_ptr = SWAPEND32(0xb801b300);
	} else {
		*uart_reg_base_ptr = SWAPEND32(0xb8061300);
	}
#endif

	*boot_av_info_ptr = 0;
	*AudioFlag_ptr_A1 = 0;
	*AudioFlag_ptr_A2 = 0;
	*VideoFlag_ptr_V1 = 0;
	*VideoFlag_ptr_V2 = 0;
	*AudioFW_entry_ptr_A1 = 0;
	*AudioFW_entry_ptr_A2 = 0;
	*VideoFW_entry_ptr_V1 = 0;
	*VideoFW_entry_ptr_V2 = 0;

	memset(shared_printk_buffer_ptr, 0, MIPS_SHARED_PRINTK_BUFFER_SIZE);
	memset(audio_output_info_ptr, 0, MIPS_AUDIO_OUTPUT_INFO_SIZE);
	memset((unsigned char *)semaphore_sharemem_info_ptr, 0, KERNEL_SEMAPHORE_BUFFER_SIZE);

	/* clear boot_av_info memory */
	boot_av = (boot_av_info_t *) MIPS_BOOT_AV_INFO_ADDR;
	memset(boot_av, 0, sizeof(boot_av_info_t));

#ifdef ENABLE_PCB_AUDIO_OUTPUT_TYPE
	audio_output_info_ptr[0] = SWAPEND32(0x24520004);

    tmpValue = (AUDIO_OUTPUT_AIO1 << 8) | 0x50; // 'O' + 1
	audio_output_info_ptr[1] = SWAPEND32(tmpValue);

    tmpValue = (AUDIO_OUTPUT_AIO2 << 8) | 0x51; // 'O' + 2
	audio_output_info_ptr[2] = SWAPEND32(tmpValue);

    tmpValue = (AUDIO_OUTPUT_HEADPHONE << 8) | 0x48; // 'H'
	audio_output_info_ptr[3] = SWAPEND32(tmpValue);

#ifdef DAC0_SRC
    tmpValue = DAC0_SRC;
#else
    tmpValue = DAC_SOURCE_PB_AF_AVC2_CH01;   //default
#endif
    tmpValue = (0xdac0 << 16) | tmpValue;   //dac0 magic number
    audio_output_info_ptr[9] = SWAPEND32(tmpValue);


#ifdef DAC1_SRC
    tmpValue = DAC1_SRC;
#else
    tmpValue = DAC_SOURCE_PB_AF_AVC2_CH01;   //default
#endif
    tmpValue = (0xdac1 <<16) | tmpValue;    //dac1 magic number
    audio_output_info_ptr[10] = SWAPEND32(tmpValue);

#endif
#endif //#ifndef IS_FPGA

	gd = id;

#if 0//#ifdef Config_Boot_Type_is_RELEASE
	gd->flags |= GD_FLG_DISABLE_CONSOLE;
#endif
	gd->flags |= GD_FLG_RELOC;	/* tell others: relocation done */
	bootstage_mark_name(BOOTSTAGE_ID_START_UBOOT_R, "board_init_r");
	monitor_flash_len = _end_ofs;

	debug("monitor flash len: %08lX\n", monitor_flash_len);
	board_init();	/* Setup chipselects */

	/*
	 * TODO: printing of the clock inforamtion of the board is now
	 * implemented as part of bdinfo command. Currently only support for
	 * davinci SOC's is added. Remove this check once all the board
	 * implement this.
	 */
#ifdef CONFIG_CLOCKS
	set_cpu_clk_info(); /* Setup clock information */
#endif
#ifdef CONFIG_SERIAL_MULTI
	serial_initialize();
#endif

#ifdef CONFIG_NO_RELOCATION
	debug("Now running in RAM - U-Boot at: %08lx\n", _TEXT_BASE);
#else
	debug("Now running in RAM - U-Boot at: %08lx\n", dest_addr);
#endif

#ifdef CONFIG_LOGBUFFER
	logbuff_init_ptrs();
#endif
#ifdef CONFIG_POST
	post_output_backlog();
#endif

	/* The Malloc area is immediately below the monitor copy in DRAM */
#ifdef CONFIG_NO_RELOCATION
	malloc_start = gd->heap_addr;
	mem_malloc_init (malloc_start, TOTAL_MALLOC_LEN);
#else
	malloc_start = dest_addr - TOTAL_MALLOC_LEN;
	mem_malloc_init (malloc_start, TOTAL_MALLOC_LEN);
#endif

#ifdef CONFIG_NONCACHE_ALLOCATION
	mem_malloc_noncache_init(gd->noncache_addr, CONFIG_SYS_NON_CACHE_LEN);
#endif

#ifdef CONFIG_ARCH_EARLY_INIT_R
	arch_early_init_r();
#endif

#if !defined(CONFIG_SYS_NO_FLASH)
	puts("Flash: ");

	flash_size = flash_init();
	if (flash_size > 0) {
# ifdef CONFIG_SYS_FLASH_CHECKSUM
		char *s = getenv("flashchecksum");

		print_size(flash_size, "");
		/*
		 * Compute and print flash CRC if flashchecksum is set to 'y'
		 *
		 * NOTE: Maybe we should add some WATCHDOG_RESET()? XXX
		 */
		if (s && (*s == 'y')) {
			printf("  CRC: %08X", crc32(0,
				(const unsigned char *) CONFIG_SYS_FLASH_BASE,
				flash_size));
		}
		putc('\n');
# else	/* !CONFIG_SYS_FLASH_CHECKSUM */
		print_size(flash_size, "\n");
# endif /* CONFIG_SYS_FLASH_CHECKSUM */
	} else {
		puts(failed);
		hang();
	}
#endif

#if defined(CONFIG_SYS_RTK_SPI_FLASH)
	puts("SPI_NOR: ");
	rtk_spi_nor_init();
#endif

#if defined(CONFIG_SYS_RTK_NAND_FLASH)

#if (defined(Config_Board_TV043_RENO_V001) || defined(Config_Board_TV043_RENO_V002))
	//USER : LewisLee DATE : 2018/08/01
	//short time patch for nand Flash WP pin
//	IO_Set(PIN_FLASH_WP, 1);
	rtd_outl(0xb801bd0c, 0x00000081);
	rtd_outl(0xb801bd20, 0x00000081);
	puts("Set Nand WP as High\n");
#endif //#if (defined(Config_Board_TV043_RENO_V001) || defined(Config_Board_TV043_RENO_V002))

	puts("NAND:  ");
	get_flash_shared_semaphore();
	nand_init();		/* go init the NAND */
	release_flash_shared_semaphore();
#endif

#if defined(CONFIG_CMD_SPI_NAND)
	puts("SPI_NAND:  \n");
	spi_nand_init();
#endif

#if defined(CONFIG_CMD_ONENAND)
	onenand_init();
#endif

#ifdef CONFIG_GENERIC_MMC
	puts("MMC:   ");

	mmc_initialize(gd->bd);

	if(bringup_mmc_driver() < 0) {
		printf("[ERR] bringup mmc failed.\n");
	}
#endif

#ifdef CONFIG_SYS_FACTORY

#ifndef CONFIG_LESS_CONSOLE
	puts("Factory: ");
#endif

#ifndef CONFIG_BRING_UP
	factory_init();
	get_bootparam();
	get_layout();
	get_oemkey();
#endif
#endif

#ifdef Config_EXT4_Load_TvConfigs_TRUE
    tvconfig_init();
#endif
#ifdef Config_EXT4_Load_Takeover_TRUE
	takeover_init();
#endif
	get_power_on_cause();
#if defined(CONFIG_BOARD_298X_TV010_QFP176_V3_EMMC)
	 if(boot_power_on_mode == POWER_ON) {
                IO_Set(PIN_LED_ON_OFF, 1);
        }
#endif

#ifdef CONFIG_REALTEK_AMP
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013)
	init_amp();
#endif
#endif

//wangzhh add for power on pop

#ifdef CONFIG_SYS_FACTORY_READ_ONLY

#ifndef CONFIG_LESS_CONSOLE
	puts("Factory_RO: ");
#endif

#ifndef CONFIG_BRING_UP
	factory_ro_init();
#endif
#endif
#ifdef CONFIG_HAS_DATAFLASH
	AT91F_DataflashInit();
	dataflash_print_info();
#endif

	/* initialize environment */
	env_relocate();

	init_rtd_logbuf();  /*init rtd_logbuf DDR param*/

        get_factory_platform_resource();
        get_factory_ir_table();
#ifdef CONFIG_CMD_MISC
	set_uart2rbus_status();
#endif

#ifdef CONFIG_REALTEK_AMP
#ifndef CONFIG_BRING_UP
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_AD83586) || defined(CONFIG_REALTEK_AMP_TAS5707_TV013) || defined(CONFIG_REALTEK_AMP_RT9107B) || defined(CONFIG_AMP_RT9119)
	init_amp();
#endif
#endif
#endif

#ifdef ENABLE_SCPU1_BISR
	rtk_scpu1_bisr();
#endif

#ifdef ENABLE_SCPU2_BISR
	rtk_scpu2_bisr();
#endif

#ifndef CONFIG_SVT_CLK_RMA
#if defined(CONFIG_PANEL_SHARP_60_MEMC) || defined(CONFIG_PANEL_SHARP_NT71912_MEMC)
	I2C_Init();
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

	if (tstc()) {	/* we got a key press from UART */ //if key=delete, skip panel_init
                int hit_count = 0;
                int pre_console_key = 0;
		int console_key = getc();
                if (console_key) {              //avoid dirty uart data
                        pre_console_key = console_key;
                        printf("\n");
                        WATCHDOG_KICK();
                        for (hit_count = 0; hit_count < 5; hit_count++) {
                                printf("%s %s %d -- (%d) key=0x%x\n", __FUNCTION__, __FILE__, __LINE__, hit_count, console_key);
                                if (tstc()) {
                                        console_key = getc();
                                        if (console_key != pre_console_key) {
                                                console_key = 0;
                                                break;
                                        }
                                }
                                else {
                                        console_key = 0;
                                        break;
                                }
                        }
                }
		if (console_key == 0x7f)
			boot_mode = BOOT_CONSOLE_MODE;

#ifdef CONFIG_PANEL_INIT_2ND_AFTER_LOGO
		if (console_key != 0x7f && hit_count > 3) {
			printf("Press Key??\n");
#ifdef CONFIG_PANEL_INIT_2ND_AFTER_LOGO	//put here, need to modify videofw too
			panel_init_2nd();
#endif
		}

		if (console_key == 0x7f && hit_count > 3) {
			printf("Press DEL Key??\n");
			udelay(1000000);
			WATCHDOG_KICK();
			udelay(1000000);
			WATCHDOG_KICK();
			udelay(1000000);
			WATCHDOG_KICK();
		}
#endif

	}

#ifdef CONFIG_SYS_PANEL_SUPPORT
#ifndef CONFIG_PANEL_INIT_MULTICORE
	/* panel parameters setting */
    #if defined(CONFIG_TV010_DETECT_OLED)
        unsigned char system_lock = 0;
        getOledSysLock(&system_lock);
        if (system_lock == 1)
        {
            //do nothng
        }
        else
        {
            panel_init();
        }
    #else
	panel_init();
    #endif
#else
    if ((rtd_inl(REG_CRT_SUSPEND_reg) == KERNEL_RSV_MEM_MAGICNO) && (rtd_inl(REG_STR_JUMP_ADDR_reg) != 0))
        panel_init();
    else
#ifndef CONFIG_SYS_SUPPORT_MULTITHREAD
#ifdef CONFIG_USE_IRQ
        Core_Wakeup(do_panel_init, 0x1);
#else
        Core_Wakeup(do_panel_init, 0x1);
#endif
#endif
#endif
#endif
#endif	//!CONFIG_SVT_CLK_RMA

#ifdef IS_BOX
	rtk_box_init(); /* used for box */
#endif

#ifdef CONFIG_SYS_LOGO_DISP
	puts("Logo: ");
	LOGO_DISP_init(); // after panel init
#endif

#if defined(CONFIG_CMD_PCI) || defined(CONFIG_PCI)
	arm_pci_init();
#endif

	stdio_init();	/* get the devices list going. */

	jumptable_init();

#if defined(CONFIG_API)
	/* Initialize API */
	api_init();
#endif

#if defined(Config_Module_Test_Boot_TRUE)
	modt_init(); // module test init
#endif
	console_init_r();	/* fully init console as a device */

#if defined(CONFIG_ARCH_MISC_INIT)
	/* miscellaneous arch dependent initialisations */
	arch_misc_init();
#endif
#if defined(CONFIG_MISC_INIT_R)
	/* miscellaneous platform dependent initialisations */
	misc_init_r();
#endif
#ifndef CONFIG_SYS_SUPPORT_MULTICORE
	 /* set up exceptions */
	interrupt_init();
	/* enable exceptions */
	enable_interrupts();
#endif
#ifdef CONFIG_SUPPORT_TIMER_INTERRUPT
	arch_timer_init();
#endif
	/* Perform network card initialisation if necessary */
#if defined(CONFIG_DRIVER_SMC91111) || defined (CONFIG_DRIVER_LAN91C96)
	/* XXX: this needs to be moved to board init */
	if (getenv("ethaddr")) {
		uchar enetaddr[6];
		eth_getenv_enetaddr("ethaddr", enetaddr);
		smc_set_mac_addr(enetaddr);
	}
#endif /* CONFIG_DRIVER_SMC91111 || CONFIG_DRIVER_LAN91C96 */

	/* Initialize from environment */
	load_addr = getenv_ulong("loadaddr", 16, load_addr);

#ifdef CONFIG_BOARD_LATE_INIT
	board_late_init();
#endif

#ifndef IS_FPGA
#if 1 // move from greentable_modify() to reduce 60ms delay time
	greentable_status();
#endif
#endif

#ifdef CONFIG_BITBANGMII
	bb_miiphy_init();
#endif


#ifndef CONFIG_PANEL_INIT_2ND_AFTER_LOGO
#if defined(CONFIG_CMD_NET)
	extern void init_network_driver(void);
	init_network_driver();
#endif
#endif

#ifdef CONFIG_POST
	post_run(NULL, POST_RAM | post_bootmode_get(0));
#endif

#if defined(CONFIG_PRAM) || defined(CONFIG_LOGBUFFER)
	/*
	 * Export available size of memory for Linux,
	 * taking into account the protected RAM at top of memory
	 */
	{
		ulong pram = 0;
		uchar memsz[32];

#ifdef CONFIG_PRAM
		pram = getenv_ulong("pram", 10, CONFIG_PRAM);
#endif
#ifdef CONFIG_LOGBUFFER
#ifndef CONFIG_ALT_LB_ADDR
		/* Also take the logbuffer into account (pram is in kB) */
		pram += (LOGBUFF_LEN + LOGBUFF_OVERHEAD) / 1024;
#endif
#endif
		sprintf((char *)memsz, "%ldk", (gd->ram_size / 1024) - pram);
		setenv("mem", (char *)memsz);
	}
#endif

#if defined(CONFIG_SYS_SUPPORT_MULTITHREAD)
	thread_start();
#else

	WATCHDOG_KICK();

	/* main_loop() can return to retry autoboot, if so just run it again. */
	for (;;) {
		main_loop();
	}
#endif
	/* NOTREACHED - no way out of command loop except booting */
}

void init_network_driver(void)
{
#ifndef CONFIG_BRING_UP
#if defined(CONFIG_CMD_NET)
	puts("Net:   ");
#ifdef CONFIG_BSP_REALTEK
	//rtl8139_initialize(gd->bd);
	rtl8168_initialize(gd->bd);
#else
	eth_initialize(gd->bd);
#endif
#if defined(CONFIG_RESET_PHY_R)
	debug("Reset Ethernet PHY\n");
	reset_phy();
#endif
#endif
#endif
}

void hang(void)
{
	puts("### ERROR ### Please RESET the board ###\n");
	for (;;);
}

#ifdef CONFIG_SYS_VIDDQ
int rtk_do_viddq_cal(void)
{
	board_viddq_cal();
	return 0;
}

int do_showvdq(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
#ifdef CONFIG_OTP_UTIL
	unsigned int iddqcheck = 0;
	unsigned int iddqdonebit = 0;

	printf("\033[1;44mdo RTK IC setting\033[0m\n");

	rtk_get_iddq_done(&iddqdonebit); // get iddq done
	rtk_get_core_iddq(&iddqcheck); // get core iddq

	printf("viddq register value is = 0x%x, 0x%x\n", iddqdonebit, iddqcheck);

	if (iddqdonebit)
	{
		if( iddqcheck >= CONFIG_CORE_IDDQ_THRESHOLD) //high iddq
		{
			printf("High IDDQ / Low VID, and Core IDDQ= %d \n", iddqcheck);
		}
		else // low iddq
		{
			printf("Low IDDQ / High VID, and Core IDDQ= %d \n", iddqcheck);
		}
	}
	else
	{
		printf("\033[1;44middq done bit is 0 !!\033[0m\n");
	}
#else
	printf("CONFIG_OTP_UTIL is disabled\n");
#endif

	return 0;
}

U_BOOT_CMD(
	showvdq, 3, 0, do_showvdq,
	"showvdq - show vdq info",
	"for rtk printing"
	""
);

#endif


