#include <common.h>
#include <parse_h.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <factorylib.h>
#include <platform_lib/board/pcb.h>

extern uchar boot_ac_on;
extern int boot_power_on_mode;
extern int prev_power_on_status;

#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR)|| defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G)//20140506  xq_xiao
extern int konka_boot_vol;
extern int konka_sleepled_mode;
extern int konka_uart_enable;
#endif

void CusApi_get_bootparam(char *dst_addr, int dst_length)
{
#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR)  || defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G)//20140506  xq_xiao
	char *retAddr = NULL;
	uint retVal;

	if (parse_h("BOOT_BACKLIGHT_VALUE", dst_addr, (uint)dst_length, &retVal, &retAddr) == 0) {
		bootparam.backlight_value = retVal;
		printf("BOOT_BACKLIGHT_VALUE=%d\n", retVal);
	}
	else {
		bootparam.backlight_value = 254;
		DEBUG("can't find backlight value\n");
	}

	if (parse_h("BOOT_KONKA_BOOT_VOL", dst_addr, (uint)dst_length, &retVal, &retAddr) == 0) {
		konka_boot_vol = retVal;
		printf("BOOT_KONKA_BOOT_VOL=%d\n", retVal);
	}
	else {
		konka_boot_vol = 0;
		DEBUG("can't find konka_boot_vol\n");
	}

	if (parse_h("BOOT_KONKA_SLEEPLED_MODE", dst_addr, (uint)dst_length, &retVal, &retAddr) == 0) {
		konka_sleepled_mode = retVal;
		printf("BOOT_KONKA_SLEEPLED_MODE=%d\n", retVal);
	}
	else {
		konka_sleepled_mode = 0;
		DEBUG("can't find konka_sleepled_mode\n");
	}

	if (parse_h("BOOT_KONKA_UART_ENABLE", dst_addr, (uint)dst_length, &retVal, &retAddr) == 0) {
		konka_uart_enable = retVal;
		printf("BOOT_KONKA_UART_ENABLE=%d\n", retVal);
	}
	else {
		konka_uart_enable = 1;
		DEBUG("can't find konka_uart_enable\n");
	}
#endif

}

void CusApi_decide_power_on_mode(void)
{
#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR)  || defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G)//20140506  xq_xiao
	boot_power_on_mode = bootparam.prev_power_state;
	if ( boot_ac_on == 0 )	 //DC  ON
	{
		boot_power_on_mode = POWER_ON;
		set_bootparam_power_state(POWER_ON);
		mdelay(10);
	}
#endif
}
