//#include <common.h>
//#include <command.h>
//#include <linux/compiler.h>
//#include <rbus/crt_reg.h>
//#include <asm/arch/io.h>
#include <qc_verify_common.h>


#define Code_Type_QC
//#define Code_Type_Verify

//#define Print_Open 

//#define BIT_Mode_1
#define BIT_Mode_4


#ifdef BIT_Mode_4
static unsigned int BUS_WIDTH_HS = 0x11;    // define Mode sel,bus width,div,    11(no divid 4bit),10no divid 1bit
#endif

#ifdef BIT_Mode_1
static unsigned int BUS_WIDTH_HS = 0x10;    // define Mode sel,bus width,div,    11(no divid 4bit),10no divid 1bit
#endif

static unsigned int SD_freq = 0x3;  // 6 =15MHz   3=30MHz

//295MHz/250MHz/
//0: div2 (147.5 / 125)
//1: div3 (98.3   / 83.3)
//2: div4 (73.75 / 62.5)
//3: div5 (59      / 50)
//4: div6 (49.16 / 41.6)
//5: div8 (36.875/ 31.25)
//6: div10 (29.5 / 25) (default)
//Other: div10


#define		DIV				  0xd0    //0x90 div128,
#define		NO_DIV			0x10
#define		timeout     50000
#define   busy        5

#define	SETBIT(x,n)		x = x | (1<<n)
#define	CLRBIT(x,n)		x = x & ~(1<<n)
#define SetBit(addr, nbit)	  	*((volatile unsigned int *) (addr-0xa0000000)) |= 1<<nbit
#define ResetBit(addr, nbit)	*((volatile unsigned int *) (addr-0xa0000000)) &= ~(1<<nbit)
#define ToggleBit(addr, nbit)	*((volatile unsigned int *) (addr-0xa0000000)) ^= 1<<nbit
#define WReg(addr, data)		*((volatile unsigned int *) (addr-0xa0000000)) = data
#define RReg(addr) 		    	*((volatile unsigned int *) (addr-0xa0000000))

#define		SD_CMD0			0xb8010c24
#define		SD_CMD1			0xb8010c28
#define		SD_CMD2			0xb8010c2c
#define		SD_CMD3			0xb8010c30
#define		SD_CMD4			0xb8010c34
#define		SD_CMD5			0xb8010c38

#define		SD_RSP0			0xb8010c24
#define		SD_RSP1			0xb8010c28
#define		SD_RSP2			0xb8010c2C
#define		SD_RSP3			0xb8010c30
#define		SD_RSP4			0xb8010c34
#define		SD_RSP5			0xb8010c38

#define		SD_EXT_RSP0		0xb8010d28   //17 byte resp, rsp1~2
#define		SD_EXT_RSP1		0xb8010d2c
#define		SD_EXT_RSP2		0xb8010d30
#define		SD_EXT_RSP3		0xb8010d34
#define		SD_EXT_RSP4		0xb8010d38
#define		SD_EXT_RSP5		0xb8010d3c
#define		SD_EXT_RSP6		0xb8010d40
#define		SD_EXT_RSP7		0xb8010d44


#define		SD_SRAM_DATA		0xb8010d20
#define		SD_CP_CTRL			0xb8010d18

static unsigned int transfer_enable = 0;
static unsigned int BUS_WIDTH = 0;  
static unsigned int Set_BUS_WIDTH = 0;  
static unsigned int HS_TIMMING = 0;
static unsigned int RCA_H = 0;
static unsigned int RCA_L = 0;
static unsigned int SET_BLOCKLEN = 0x2;


static unsigned int DDR_ADDR = 0;
static unsigned int DATA_ADDR = 0;
static unsigned int Byte_Count = 0;
static unsigned int BYTE_CNT = 128;

static unsigned int Block_Count = 0;
static unsigned int i = 0, j = 0 ,k = 0, m = 0,n = 0;


static int INDEX = 0;

static void SD_PWR_EN()
{
//Merlin4 CI_CA_POWER_EN/SD_Card ST_GPIO40
rtd_part_outl(0x1806021c,23,20,0xF);  //ST_GPIO40 Pinmux

rtd_outl(0x18061104,0x00000401);  //set GPIO
rtd_outl(0x1806110c,0x00000401);  //output 1 

}

static void sd_ip_reset()
{
//SD IP Reset bit16
rtd_outl(0xb800011C,0x00010000);    //clk enable                              
rtd_outl(0xb800010C,0x00010000);    //reset
udelay(20);
rtd_outl(0xb800011C,0x00010001);    //clk enable                                
rtd_outl(0xb800010C,0x00010001);    //reset
}

static void SD_pin_mux_setting()
{
//Merlin4 Cardreader Pinmux
//rtd_part_outl(0xb80008e0,01,00,0x0);    //src0:input mux
//rtd_part_outl(0xb8000844,23,20,0x2);    //   SD_CD_src0,<I>,<HS>            Ps_Reg:gpio_62_ps 
//rtd_part_outl(0xb8000844,15,12,0x2);    //   SD_WP_src0,<I>,<HS>            Ps_Reg:gpio_63_ps 
//rtd_part_outl(0xb8000844,07,04,0x2);    //   SD_Data1_pad_src0,<I/O>,<HS>   Ps_Reg:gpio_64_ps 
//rtd_part_outl(0xb8000848,31,28,0x2);    //   SD_Data0_pad_src0,<I/O>,<HS>   Ps_Reg:gpio_65_ps 
//rtd_part_outl(0xb8000848,23,20,0x2);    //   SD_CLK_pad_src0,<O>,<HS>       Ps_Reg:gpio_66_ps 
//rtd_part_outl(0xb8000848,15,12,0x2);    //   SD_CMD_pad_src0,<I/O>,<HS>     Ps_Reg:gpio_67_ps 
//rtd_part_outl(0xb8000848,07,04,0x2);    //   SD_Data3_pad_src0,<I/O>,<HS>   Ps_Reg:gpio_68_ps 
//rtd_part_outl(0xb800084c,31,28,0x2);    //   SD_Data2_pad_src0,<I/O>,<HS>   Ps_Reg:gpio_69_ps 

//rtd_part_outl(0xb80008e0,01,00,0x1);//src1:input mux
//rtd_part_outl(0xb8000828,23,20,0x2);//SD_CD_src1,<I>,<HS>             MIS_GPIO_bit34,<I/O>
//rtd_part_outl(0xb8000828,19,16,0x2);//SD_WP_src1,<I>,<HS>             MIS_GPIO_bit35,<I/O>
//rtd_part_outl(0xb8000828,15,12,0x2);//SD_Data1_pad_src1,<I/O>,<HS>    MIS_GPIO_bit36,<I/O>
//rtd_part_outl(0xb8000828,11,08,0x2);//SD_Data0_pad_src1,<I/O>,<HS>    MIS_GPIO_bit37,<I/O>
//rtd_part_outl(0xb8000844,23,20,0x3);//SD_CLK_pad_src1,<O>,<HS>	      MIS_GPIO_bit62,<I/O>
//rtd_part_outl(0xb8000844,15,12,0x3);//SD_CMD_pad_src1,<I/O>,<HS>	    MIS_GPIO_bit63,<I/O>
//rtd_part_outl(0xb8000844,07,04,0x3);//SD_Data3_pad_src1,<I/O>,<HS>	  MIS_GPIO_bit64,<I/O>
//rtd_part_outl(0xb8000848,31,28,0x3);//SD_Data2_pad_src1,<I/O>,<HS>	  MIS_GPIO_bit65,<I/O>

rtd_part_outl(0xb80008e0,01,00,0x2);//src2:input mux
rtd_part_outl(0xb80008b0,23,20,0x2);//SD_WP_src2,<I>,<HS>            Ps_Reg:gpio_144_ps 
rtd_part_outl(0xb80008b0,15,12,0x2);//SD_CD_src2,<I>,<HS>            Ps_Reg:gpio_145_ps 
rtd_part_outl(0xb80008b0,07,04,0x2);//SD_Data1_pad_src2,<I/O>,<HS>   Ps_Reg:gpio_146_ps 
rtd_part_outl(0xb80008b4,31,28,0x2);//SD_Data0_pad_src2,<I/O>,<HS>   Ps_Reg:gpio_147_ps 
rtd_part_outl(0xb80008b4,23,20,0x2);//SD_CLK_pad_src2,<O>,<HS>       Ps_Reg:gpio_148_ps 
rtd_part_outl(0xb80008b4,15,12,0x2);//SD_CMD_pad_src2,<I/O>,<HS>     Ps_Reg:gpio_149_ps 
rtd_part_outl(0xb80008b4,07,04,0x2);//SD_Data3_pad_src2,<I/O>,<HS>   Ps_Reg:gpio_150_ps 
rtd_part_outl(0xb80008b8,31,28,0x2);//SD_Data2_pad_src2,<I/O>,<HS>   Ps_Reg:gpio_151_ps 
}



static void SD_change_freq()
{
		rtd_part_inl(0xb8000204,28,27); 
    rtd_part_outl(0xb8000204,28,27,0x1);  // SD/SD clock source selection,00: from rbus_clk 250MHz,01: from Audio 295MHz

    rtd_part_outl(0xb8000204,22,20,SD_freq);  // div2 div3 div4 div5 div6 div8 div10(default,0x6)  SD card 
//(295MHz/250MHz/
//0: div2 (147.5 / 125)
//1: div3 (98.3   / 83.3)
//2: div4 (73.75 / 62.5)
//3: div5 (59      / 50)
//4: div6 (49.16 / 41.6)
//5: div8 (36.875/ 31.25)
//6: div10 (29.5 / 25) (default)
//Other: div10
	
  //#ifdef  Print_Open
	printf( "Change freq reg value.\n");
	printf( "rtd_inl(0xb8000204) = 0x%08x\n", RReg( 0xb8000204 ) );
	//#endif
	
}



static void ddr_pattern_write( unsigned int PATTERN, unsigned int DDR_ADDR, unsigned int BYTE_CNT )
{
	printf( "\nwrite ddr \n");
	unsigned int i,DDR_VAL;
	DDR_VAL	 =	PATTERN;
	printf( "write ddr from addr = 0x%08x\n",( DDR_ADDR) );
	for( i=0; i < BYTE_CNT; i++ ) {
		//WReg( DDR_ADDR , DDR_VAL );
		rtd_outl(DDR_ADDR, DDR_VAL);
		
		#ifdef  Print_Open
		//printf( "DDR_ADDR=0x%08x, Value=0x%08x\n",( DDR_ADDR-0xa0000000),RReg( DDR_ADDR ) ); 
		printf( "DDR_ADDR=0x%08x, Value=0x%08x\n",DDR_ADDR,rtd_inl(DDR_ADDR) );
		#endif
		
		DDR_ADDR = DDR_ADDR + 4;
	}
}

static void ddr_pattern_erase( unsigned int DDR_ADDR, unsigned int BYTE_CNT )
{
	printf( "\nerase ddr \n");
	unsigned int i, DDR_VAL;
	DDR_VAL	 =	0x0;
	for( i=0; i < BYTE_CNT; i++ ) {
		//WReg( DDR_ADDR , DDR_VAL );
		rtd_outl(DDR_ADDR, DDR_VAL);
		
		#ifdef  Print_Open
		//printf( "DDR_ADDR=0x%08x, Value=0x%08x\n",( DDR_ADDR-0xa0000000),RReg( DDR_ADDR ) ); 
		printf( "DDR_ADDR=0x%08x, Value=0x%08x\n",DDR_ADDR,rtd_inl(DDR_ADDR) );
		#endif
		
		DDR_ADDR = DDR_ADDR + 4;
	}
}




static void ddr_pattern_read( unsigned int DDR_ADDR, unsigned int BYTE_CNT,unsigned int PATTERN )
{
	printf( "\nread ddr \n");
	unsigned int i;
	for( i=0; i < BYTE_CNT; i++ ) 
	{
		if( rtd_inl(DDR_ADDR) != PATTERN){
		//if( RReg( DDR_ADDR ) != PATTERN){
			//INDEX = -1;  
			//printf("check crc only.\n ");
      //INDEX = -1;  //only check error bit, don't check data.
			//break;
		}
		 
		#ifdef  Print_Open
		//printf( "DDR_ADDR=0x%08x, Value=0x%08x\n",( DDR_ADDR-0xa0000000),RReg( DDR_ADDR ) ); 
		printf( "DDR_ADDR=0x%08x, Value=0x%08x\n",DDR_ADDR,rtd_inl(DDR_ADDR) );
		#endif
		//mdelay(10);
		DDR_ADDR =DDR_ADDR+ 4;
	}
	
	if(i == BYTE_CNT)
	printf("\ncheck ddr pattern ok, ByteCNT = %d\n",i);
	//printf("\n ");
	else
		INDEX = -1;

}


static void print_normal_resp()                                         
{                                                                      
j = 0;
for(i = 0 ; i < 5; i++)
	{ 	
	 #ifdef  Print_Open
	 printf("SD_resp[%d]: rtd(0x%08x) = 0x%08x\n",i,( 0xb8010c24 + j),RReg( 0xb8010c24 + j));
	 #endif
   j += 4; 
  
  }                                                                   
  #ifdef  Print_Open
  printf("tansfer code is: rtd(0xb8010c4c) = 0x%08x\n",RReg( 0xb8010c4c));   
  #endif                                                              
}

static void print_long_resp()                                         
{                                                                      
j = 0;
for(i = 0 ; i < 8; i++)  //Total 17Byte  0xb801_0928~0xb801_0944
	{ 	
	 #ifdef  Print_Open
	 printf("SD_lresp[%d]: rtd(0x%08x) = 0x%08x\n",i,( 0xb8010d28 + j),RReg( 0xb8010d28 + j));
	 #endif
   j += 4; 
  
  }                                                                   
                                                                     
}

static int check_transfer_status()
{
	int i;
	i=0;
	while( 1 ) {
		if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) {
			#ifdef  Print_Open
			printf( "transfer done" ); 
			#endif 

			if( rtd_part_inl( 0xb8010c4c,4,4 ) == 1 ) {
				if( rtd_part_inl( 0xb8010c0c,7,7 )==1 )
					printf( " -->CRC7 Error\n" );
				if( rtd_part_inl( 0xb8010c0c,6,6 )==1 )
					printf( " -->CRC16 Error\n" );
				if( rtd_part_inl( 0xb8010c0c,5,5 )==1 )
					{
						printf( " -->Write CRC Error\n" );
						printf( "Status of write crc  = %x\n",rtd_part_inl( 0xb8010c0c,4,2 ) );
					}
				printf( " -->DAT0 = %x\n",rtd_part_inl( 0xb8010c14,1,1 ) );
				INDEX = -1;
			} else {
				#ifdef  Print_Open
				printf( " -->Correct\n" );
				#endif
				}
			break;
		}
		mdelay( 1 );
		i++;
		if( i == 200 ) {
			printf( "transfer didn't complete, End bit = 0\n" );
      return FAILED;
			break;
		}
	} 
	printf("tansfer code is: rtd(0xb8010c4c) = 0x%08x\n",RReg( 0xb8010c4c));  
}





static void check_cid()
{
	#ifdef  Print_Open
	printf( "CID register value\n" );
	printf( "CID[127:112] =0x%02x\n",RReg( SD_EXT_RSP0 ) );
	printf( "CID[111:96]  =0x%02x\n",RReg( SD_EXT_RSP1 ) );
	printf( "CID[95:80]   =0x%02x\n",RReg( SD_EXT_RSP2 ) );
	printf( "CID[79:64]   =0x%02x\n",RReg( SD_EXT_RSP3 ) );
	printf( "CID[63:48]   =0x%02x\n",RReg( SD_EXT_RSP4 ) );
	printf( "CID[77:32]   =0x%02x\n",RReg( SD_EXT_RSP5 ) );
	printf( "CID[31:8]    =0x%02x\n",RReg( SD_EXT_RSP6 ) );
	printf( "CID[7: 0]    =0x%02x\n",RReg( SD_EXT_RSP7 ) );
	#endif
}

static void check_csd()
{
  #ifdef  Print_Open
  printf( "CSD register\n" );
	printf( "CSD register value\n" );
	printf( "CSD[127:112] =0x%02x\n",RReg( SD_EXT_RSP0 ) );
	printf( "CSD[111:96]  =0x%02x\n",RReg( SD_EXT_RSP1 ) );
	printf( "CSD[95:80]   =0x%02x\n",RReg( SD_EXT_RSP2 ) );
	printf( "CSD[79:64]   =0x%02x\n",RReg( SD_EXT_RSP3 ) );
	printf( "CSD[63:48]   =0x%02x\n",RReg( SD_EXT_RSP4 ) );
	printf( "CSD[77:32]   =0x%02x\n",RReg( SD_EXT_RSP5 ) );
	printf( "CSD[31:8]    =0x%02x\n",RReg( SD_EXT_RSP6 ) );
	printf( "CSD[7: 0]    =0x%02x\n",RReg( SD_EXT_RSP7 ) );
	#endif
}


static void check_OCR()
{
	#ifdef  Print_Open
	printf( "OCR register\n" );
	printf( "OCR[31:24]=0x%02x\n",RReg( SD_RSP1 ) );
	printf( "OCR[23:16]=0x%02x\n",RReg( SD_RSP2 ) );
	printf( "OCR[15: 8]=0x%02x\n",RReg( SD_RSP3 ) );
	printf( "OCR[ 7: 0]=0x%02x\n",RReg( SD_RSP4 ) );
	#endif
}

static void check_status()
{
  unsigned int status_num;
  #ifdef  Print_Open
	printf( "cmd index=%d\n",rtd_part_inl( SD_RSP0,5,0 ) );
//	printf( "card status[31:24]=0x%02x\n",RReg( SD_RSP1 ) );
//	printf( "card status[23:16]=0x%02x\n",RReg( SD_RSP2 ) );
//	printf( "card status[15: 8]=0x%02x\n",RReg( SD_RSP3 ) );
//	printf( "card status[ 7: 0]=0x%02x\n",RReg( SD_RSP4 ) );
  #endif
  
	status_num = rtd_part_inl( SD_RSP3,4,1 );
	switch( status_num ) 
	{
		case 0:
			printf( "current_state = Idle\n" );
			break;
		case 1:
			printf( "current_state = Ready\n" );
			break;
		case 2:
			printf( "current_state = Ident\n" );
			break;
		case 3:
			printf( "current_state = Stby\n" );
			break;
		case 4:
			printf( "current_state = Tran\n" );
			break;
		case 5:
			printf( "current_state = Data\n" );
			break;
		case 6:
			printf( "current_state = Rcv\n" );
			break;
		case 7:
			printf( "current_state = Prg\n" );
			break;
		case 8:
			printf( "current_state = Dis\n" );
			break;
		case 9:
			printf( "current_state = Btst\n" );
			break;
		default:
			printf( "error state\n" );
			break;
	}
}



static void cmd_0()
{
	printf( "\ncmd0 : GO_IDLE_STATE\n" );
  rtd_outl(0xb8010c24, 0x40);  //  transmission bit,  0x1 ; cmd0
  rtd_outl(0xb8010c28, 0x0);   
  rtd_outl(0xb8010c2c, 0x0); 		
  rtd_outl(0xb8010c30, 0x0);  
  rtd_outl(0xb8010c34, 0x0);  
  rtd_outl(0xb8010c04, 0x4);  	//  no response and    no check crc7
  rtd_outl(0xb8010c00, DIV); 	//  diviede  256
  rtd_outl(0xb8010c4c, 0x8);   
  rtd_outl(0xb8010c4c, 0x88);  
  
	check_transfer_status();
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); //write1 clear interrupt
}

static void cmd_8()
{
	printf( "\ncmd8 : check voltage range\n" );
	rtd_outl( 0xb8010c24, 0x48 ); //  transmission bit =  0x1 ;
	rtd_outl( 0xb8010c28, 0x0 );
	rtd_outl( 0xb8010c2c, 0x0 );
	rtd_outl( 0xb8010c30, 0x01 );
	rtd_outl( 0xb8010c34, 0xaa );
	rtd_outl( 0xb8010c04, 0x01 );	//  
	rtd_outl( 0xb8010c00, DIV );	//  diviede 256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	//print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}


static void cmd_55()
{
	printf( "\ncmd55 : send cmd55 before acmd\n" );
	rtd_outl( 0xb8010c24, 0x77 ); //  transmission bit =  0x1 ;
	rtd_outl( 0xb8010c28, 0x0 );
	rtd_outl( 0xb8010c2c, 0x0 );
	rtd_outl( 0xb8010c30, 0x0 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x01 );	//  
	rtd_outl( 0xb8010c00, DIV );	//  diviede 256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	//print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}


static void cmd_55_RCA()
{
	printf( "\ncmd55 : send cmd55 before acmd\n" );
	rtd_outl( 0xb8010c24, 0x77 ); //  transmission bit =  0x1 ;
	rtd_outl( 0xb8010c28, RCA_H );
	rtd_outl( 0xb8010c2c, RCA_L );
	rtd_outl( 0xb8010c30, 0x0 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x01 );	//  
	rtd_outl( 0xb8010c00, DIV );	//  diviede 256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	//print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}

static unsigned int acmd_41()
{
	printf( "\nacmd41: SEND_OP_COND\n" );

	//ask the card to send its OCR contents
	rtd_outl( 0xb8010c24, 0x69 );		//  transmission bit =  0x1 ;
	rtd_outl( 0xb8010c28, 0x40 );		// [31]: power up status, [30:29] access mode:2'b10 sector mode, [28:24] reserved
	rtd_outl( 0xb8010c2c, 0x3c );		// [23:15]  2.7~3.6V
	rtd_outl( 0xb8010c30, 0x00 ); 		// [14:8] 2.0~2.6V [7] 1.70~1.95V
	rtd_outl( 0xb8010c34, 0x00 );
	rtd_outl( 0xb8010c04, 0x5 );		//  check crc7 off  6 byte response
	rtd_outl( 0xb8010c00, DIV );		//diviede 256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	//print_normal_resp();
	//check_OCR();
	return ( rtd_part_inl( SD_RSP1,7,7 ) );  // C0     [7]: busy bit  [6:5] sector/byte mode
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_2()
{
	printf( "\ncmd2 : ALL_SEND_CID\n" );
	//ask the card to send its CID contents
  rtd_outl(0xb8010c24, 0x42);   //  transmission bit,  0x1  ; cmd2
  rtd_outl(0xb8010c28, 0x0);   
  rtd_outl(0xb8010c2c, 0x0); 		
  rtd_outl(0xb8010c30, 0x0);  
  rtd_outl(0xb8010c34, 0x0);  
  rtd_outl(0xb8010c04, 0x02);  	//  17 byte response and CRc check
  rtd_outl(0xb8010c00, DIV); 	//  diviede  256
  rtd_outl(0xb8010c4c, 0x8);   
  rtd_outl(0xb8010c4c, 0x88);  
	check_transfer_status();
	print_long_resp();
	//check_cid();
	rtd_outl(0xb8010cdc, 0x7); 

}

static void cmd_3()
{
//	int ret;
	printf( "\ncmd3 : SET_RELATIVE_ADDR\n" );
  rtd_outl(0xb8010c24, 0x43);   //  transmission bit,  0x1 ;  command, 0x3
  rtd_outl(0xb8010c28, RCA_H);   
  rtd_outl(0xb8010c2c, RCA_L); 		
  rtd_outl(0xb8010c30, 0x0);  
  rtd_outl(0xb8010c34, 0x0);  
  rtd_outl(0xb8010c04, 0x01);  	//  6 byte  response  and  CRc check
  rtd_outl(0xb8010c00, DIV); 	//  diviede  256
  rtd_outl(0xb8010c4c, 0x8);   
  rtd_outl(0xb8010c4c, 0x88);  
	check_transfer_status();
	print_normal_resp();
	printf( "Assign SD address: RCA_H=0x%02x, RCA_L=0x%02x\n",RCA_H,RCA_L );
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_6_switch_bit(unsigned int value )    //value, 0:1-bit, 1:4-bit 2:8-bit
{
	printf( "\ncmd6 : SWITCH\n" );
	//printf("change bus_width = %d-bit\n",bus_width);

	rtd_outl(0xb8010c24, 0x46);     //  transmission bit,  0x1  ;  command, 0x6
rtd_outl(0xb8010c28, 0x03);       //[31:26] set 0, [25:24] access, =2b'11, Write byte
rtd_outl(0xb8010c2c, 0xb7);  	 	  //[23:16] index,
rtd_outl(0xb8010c30, value);     // change bit mode setting:Value= 0x1=4-bit, 0x0=1-bit,0x2=8-bit,0x6=8-bit-ddr,0x5=4bit-ddr
rtd_outl(0xb8010c34, 0x00);     //[7:3] set 0, [2:0] cmd set
rtd_outl(0xb8010c04, 0x01);  	  //  6 byte  response and CRc check
rtd_outl(0xb8010c00, DIV);  	//  diviede  
rtd_outl(0xb8010c4c, 0x8);   
rtd_outl(0xb8010c4c, 0x88);
	check_transfer_status();
	print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}


static void acmd_6(UINT32 value )    //value, 0:1-bit, 1:4-bit 2:8-bit
{
	printf( "\ncmd6 : SWITCH\n" );
	//printf("change bus_width = %d-bit\n",bus_width);

	rtd_outl( 0xb8010c24, 0x46 );		 
	rtd_outl( 0xb8010c28, 0x0 );		 
	rtd_outl( 0xb8010c2c, 0x0 );		 
	rtd_outl( 0xb8010c30, 0x0 );		
	rtd_outl( 0xb8010c34, value );		//[15:8] value, 0:1-bit, 2:4-bit   
	rtd_outl( 0xb8010c04, 0x1 );		 
	rtd_outl( 0xb8010c00, DIV );		 
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	//print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}


static setting_bus_width( UINT32 bus_width ) 
{
	
	switch ( bus_width ) {
		case 1:
			cmd_55_RCA();
			BUS_WIDTH = 0x0;
			acmd_6(BUS_WIDTH );
			printf( "Set bus width = 1-bit\n" );
			break;
		case 4:
			cmd_55_RCA();
			BUS_WIDTH = 0x2;
			acmd_6(BUS_WIDTH );
			printf( "Set bus width = 4-bit\n" );
			break;
		default:
			printf( "Bus Width setting is invalid\n" );
			break;
	}
}


// HS_TIMING  [185] [7:4] Selected Driver Strength  ,[3:0] Hspeed mode

static setting_HS_Mode()   // Value= 1, high speed,default = 0, backwards compatibility interface timming
{                                               // Value= 2, HS200

  printf( "\nSetting_HS_Mode\n" );


rtd_outl(0xb8010cd8, 0x00800000); //DDR address
rtd_outl(0xb8010cd4, 0x00800000); //DDR address
rtd_outl(0xb8010c24, 0x46);		//A0
rtd_outl(0xb8010c28, 0x80);		//A1, [31:24], 0x80:switch function, 0x0:check function
rtd_outl(0xb8010c2c, 0xff);		//A2, [23:16]
rtd_outl(0xb8010c30, 0xff);		//A3, [15:8]
rtd_outl(0xb8010c34, 0xf1);		//A4, [7:0]    high speed
rtd_outl(0xb8010c04, 0x41);	//   6 byte response
rtd_outl(0xb8010c00, 0x10 );	//  no diviede ; 1-bit
//rtd_outl( 0xb8010c00, DIV );
 
rtd_outl(0xb8010c3c, 0x0);	// byte count [7:0]
rtd_outl(0xb8010c40, 0x2);	// byte count [10:8]
rtd_outl(0xb8010c44, 0x01);	// block count [7:0]
rtd_outl(0xb8010c48, 0x0);	// block count [11:8]
rtd_outl(0xb8010c4c, 0xc);
rtd_outl(0xb8010c4c, 0x8c);
rtd_outl(0xb8010d18, 0x10); 	// Transfer Direction  1,read  0,write 

rtd_inl(0xb8010cdc);   
rtd_inl(0xb8010cdc);   
rtd_inl(0xb8010cdc);   
rtd_inl(0xb8010c4c);   
rtd_inl(0xb8010c4c);   
rtd_inl(0xb8010c4c);   
rtd_inl(0xb8010cdc);   
rtd_outl(0xb8010cdc, 0x7);
rtd_inl(0xb8010cdc);   
rtd_inl(0xb8010c4c); 
rtd_inl(0xb8010c4c); 
rtd_inl(0xb8010c24); 
rtd_inl(0xb8010c28); 
rtd_inl(0xb8010c2c); 
rtd_inl(0xb8010c30); 
rtd_inl(0xb8010c34); 

	check_transfer_status();
	print_normal_resp();
	//printf( "\n\nExtended CSD Value\n" );
	
	//ddr_pattern_read
	
	//unsigned int i;
	DDR_ADDR = 	0x00800000;


	
	//for( i=0; i < 128; i++ ) {
	//	#ifdef  Print_Open
	//	printf( "DDR_ADDR = 0x%08x, Value = 0x%08x\n",( DDR_ADDR ), RReg( DDR_ADDR ) );
	//	#endif
	//	DDR_ADDR =DDR_ADDR+ 4;
	//}
	for( i=0; i < 128; i++ ) {
		#ifdef  Print_Open
		printf( "DDR_ADDR = 0x%08x, Value = 0x%08x\n",( DDR_ADDR ), rtd_inl( DDR_ADDR ) );
		#endif
		DDR_ADDR =DDR_ADDR+ 4;
	}
	  
}


static void cmd_7()
{
	printf( "\ncmd7 : SELECT/DESELECT_CARD  RCA_H=%x, RCA_L=%x\n",RCA_H,RCA_L );
	rtd_outl( 0xb8010c24, 0x47 ); 	//  transmission bit =  0x1 ;  command = 0x7
	rtd_outl( 0xb8010c28, RCA_H );
	rtd_outl( 0xb8010c2c, RCA_L );
	rtd_outl( 0xb8010c30, 0x0 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x1 );	//  6 byte response and CRC check
	rtd_outl( 0xb8010c00, DIV );	//  divide  256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_7_0()
{
	printf( "\ncmd7_0 RCA_H=%x, RCA_L=%x\n",0,0 );
	rtd_outl( 0xb8010c24, 0x47 ); 	//  transmission bit =  0x1 ;  command = 0x7
	rtd_outl( 0xb8010c28, 0x0 );
	rtd_outl( 0xb8010c2c, 0x0 );
	rtd_outl( 0xb8010c30, 0x0 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x0 );	//  no response and CRC check
	rtd_outl( 0xb8010c00, DIV );	//  divide  256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}



static void cmd_9()
{
	printf( "\ncmd9 : SEND_CSD RCA_H=%x, RCA_L=%x\n",RCA_H,RCA_L );
	rtd_outl( 0xb8010c24, 0x49 ); //  transmission bit =  0x1 ;  command = 0x9
	rtd_outl( 0xb8010c28, RCA_H );
	rtd_outl( 0xb8010c2c, RCA_L );
	rtd_outl( 0xb8010c30, 0x0 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x2 );	//  17 byte response and CRC check
	rtd_outl( 0xb8010c00, DIV );	//  diviede 256
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_long_resp();
	check_csd();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_10()
{
	printf( "\ncmd10 : SEND_CID RCA_H=%x, RCA_L=%x\n",RCA_H,RCA_L );
	//ask the card to send its CID contents
rtd_outl(0xb8010c24, 0x4a);   //  transmission bit,  0x1 ; cmd10
rtd_outl(0xb8010c28, RCA_H );   
rtd_outl(0xb8010c2c, RCA_L); 		
rtd_outl(0xb8010c30, 0x0);  
rtd_outl(0xb8010c34, 0x0);  
rtd_outl(0xb8010c04, 0x2);  	//  17  byte  response  and  CRc  check
rtd_outl(0xb8010c00, DIV); 	//  diviede  256
rtd_outl(0xb8010c4c, 0x8);   
rtd_outl(0xb8010c4c, 0x88); 
	check_transfer_status();
	print_long_resp();
	check_cid();
	rtd_outl(0xb8010cdc, 0x7); 

}


static void cmd_12()
{
	printf( "\ncmd12 : STOP_TRANSMISSION\n" );
	rtd_outl( 0xb8010c24, 0x4C );
	rtd_outl( 0xb8010c28, 0x0 );
	rtd_outl( 0xb8010c2c, 0x0 );
	rtd_outl( 0xb8010c30, 0x0 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
	rtd_outl( 0xb8010c00, NO_DIV);	//  auto2/3 set this reg
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 ); 	//1000 command response
	check_transfer_status();
	print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_13()
{
	printf( "\ncmd13 : SEND_STATUS\n" );
	rtd_outl( 0xb8010c24, 0x4d );		//transmission bit =  0x1 ;  command = 0xd
	rtd_outl( 0xb8010c28, RCA_H );		//[31:24] RCA
	rtd_outl( 0xb8010c2c, RCA_L );		//[23:16]RCA
	rtd_outl( 0xb8010c30, 0x0 );  		//stuff bit
	rtd_outl( 0xb8010c34, 0x0 );		//stuff bit
	rtd_outl( 0xb8010c04, 0x1 );		//  6 byte response and CRC check
	rtd_outl( 0xb8010c00, NO_DIV );	//  no divide
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_16()
{
	printf( "\ncmd16 : SET_BLOCKLEN\n" );

	rtd_outl( 0xb8010c24, 0x50 );		//  transmission bit =  0x1 ;  command = 0x10
	rtd_outl( 0xb8010c28, 0x0 );
	rtd_outl( 0xb8010c2c, 0x0 );
	rtd_outl( 0xb8010c30, SET_BLOCKLEN );     
	//rtd_outl( 0xb8010c30, 0x2 );
	rtd_outl( 0xb8010c34, 0x0 );
	rtd_outl( 0xb8010c04, 0x1 );		//  6 byte response and CRC check
	rtd_outl( 0xb8010c00, NO_DIV );	//  no divide 
	rtd_outl( 0xb8010c4c, 0x8 );
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_normal_resp();
	//check_status();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void cmd_18()
{
	printf( "\ncmd18 : READ_MULTIPLE_BLOCK\n" );

	rtd_outl( 0xb8010c24, 0x52 ); //  transmission bit ,  0x12 ;
	
	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
 
	rtd_outl( 0xb8010c4c, 0x8 ); // normal cmd
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}


static void cmd_25()
{
	printf( "\ncmd25 : WRITE_MULTIPLE_BLOCK\n" );
	rtd_outl( 0xb8010c24, 0x59 ); //  transmission bit ,  0x19 ;

	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response


	rtd_outl( 0xb8010c4c, 0x8 ); // normal cmd
	rtd_outl( 0xb8010c4c, 0x88 );
	check_transfer_status();
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}			


static void auto_write_1()
{
	printf( "\nauto_write_1 : WRITE_MULTIPLE_BLOCK\n" );
	rtd_outl( 0xb8010c24, 0x59 ); //  transmission bit ,  0x19 ;

	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
 
  rtd_part_outl( 0xb8010d18,4,4, 0x0 );  //Transfer direction  write 0   
  
	rtd_outl( 0xb8010c4c, 0x9 ); // auto write1: 0x9, auto write2:0xA
	rtd_outl( 0xb8010c4c, 0x89 );
	
	mdelay(5);
		
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}			

static void auto_write_2()
{
	printf( "\nauto_write_2 : WRITE_MULTIPLE_BLOCK\n" );
	rtd_outl( 0xb8010c24, 0x59 ); //  transmission bit ,  0x19 ;

	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
 
  rtd_part_outl( 0xb8010d18,4,4, 0x0 );  //Transfer direction  write 0   
  
	rtd_outl( 0xb8010c4c, 0xa ); // auto write1: 0x9, auto write2:0xA
	rtd_outl( 0xb8010c4c, 0x8a );
	
	mdelay(5);
	
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}	

static void auto_write_3()
{
	printf( "\nauto_write_3 : WRITE_MULTIPLE_BLOCK\n" );

	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
 
  rtd_part_outl( 0xb8010d18,4,4, 0x0 );  //Transfer direction  write 0   
  
	rtd_outl( 0xb8010c4c, 0x1 ); // auto write1: 0x9, auto write2:0xA
	rtd_outl( 0xb8010c4c, 0x81 );
	
	mdelay(5);
	
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}	

static void auto_write_4()
{
	printf( "\nauto_write_4 : WRITE_MULTIPLE_BLOCK\n" );

	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
 
  rtd_part_outl( 0xb8010d18,4,4, 0x0 );  //Transfer direction  write 0   
  
	rtd_outl( 0xb8010c4c, 0x2 ); // auto write1: 0x9, auto write2:0xA
	rtd_outl( 0xb8010c4c, 0x82 );
	
	mdelay(5);
	
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}	


static void auto_read_1()
{
	printf( "\nauto_read_1 : READ_MULTIPLE_BLOCK\n" );

	rtd_outl( 0xb8010c24, 0x52 ); //  transmission bit ,  0x12 ;
	
	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
	
	rtd_part_outl( 0xb8010d18,4,4, 0x1 );  //Transfer direction  read 1
 
	rtd_outl( 0xb8010c4c, 0xd ); // auto read1:0xd, auto read2:0xe
	rtd_outl( 0xb8010c4c, 0x8d );
  mdelay(5);
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void auto_read_2()
{
	printf( "\nauto_read_2 : READ_MULTIPLE_BLOCK\n" );

	rtd_outl( 0xb8010c24, 0x52 ); //  transmission bit ,  0x12 ;
	
	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
  
	rtd_part_outl( 0xb8010d18,4,4, 0x1 );  //Transfer direction  read 1
 
	rtd_outl( 0xb8010c4c, 0xe ); // auto read1:0xd, auto read2:0xe
	rtd_outl( 0xb8010c4c, 0x8e );
	mdelay(5);
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void auto_read_3()
{
	printf( "\nauto_read_3 : READ_MULTIPLE_BLOCK\n" );
	
	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
  
	rtd_part_outl( 0xb8010d18,4,4, 0x1 );  //Transfer direction  read 1
 
	rtd_outl( 0xb8010c4c, 0x5 ); // auto read1:0xd, auto read2:0xe
	rtd_outl( 0xb8010c4c, 0x85 );
	mdelay(5);
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}

static void auto_read_4()
{
	printf( "\nauto_read_4 : READ_MULTIPLE_BLOCK\n" );
	
	rtd_outl( 0xb8010c04, 0x1 );	//   6 byte response
  
	rtd_part_outl( 0xb8010d18,4,4, 0x1 );  //Transfer direction  read 1
 
	rtd_outl( 0xb8010c4c, 0x6 ); // auto read1:0xd, auto read2:0xe
	rtd_outl( 0xb8010c4c, 0x86 );
	mdelay(5);
	//check_transfer_status();
	for(m=0;m<busy;m++)
{
	mdelay(1);
	check_transfer_status(); 

 	if( rtd_part_inl( 0xb8010c4c,6,6 ) == 1 ) 
		break;
	}
	print_normal_resp();
	rtd_outl(0xb8010cdc, 0x7); 
}


static sram_read(unsigned int SRAM_Data)
{
	unsigned int i,SRAM_ADDR,BYTE_CNT;
	SRAM_ADDR = SD_SRAM_DATA;
	BYTE_CNT =  128;
	printf( "read sram\n" );
	for( i=0; i<BYTE_CNT; i++ ) {
		if( RReg( SRAM_ADDR ) != SRAM_Data ){
		//break;
		}
		#ifdef  Print_Open
	
 		printf( "SRAM_ADDR=0x%03x, Value=0x%08x\n",( 0xb8010d20 ),RReg( SRAM_ADDR ) );
		
		#endif
	}
	if(i == BYTE_CNT)
	printf("\ncheck sram data ok, ByteCNT = %d\n",i);
	else
		{
		printf("\ncheck sram data fail, ByteCNT = %d\n",i);
		return FAILED;
	}
}


static void SD_r_w_setting(UINT32 DDR_A, UINT32 DATA_A, UINT32 Bus_Width_Highspeed_Byte ,UINT32 Byte_CNT, UINT32 Block_CNT)
{
	rtd_outl( 0xb8010cd4, DDR_A ); //DDR address: card to ddr
	rtd_outl( 0xb8010cd8, DDR_A ); //DDR address ddr to card
	rtd_outl( 0xb8010c28, (DATA_A & 0xff000000)>>24 );
	rtd_outl( 0xb8010c2c, (DATA_A & 0x00ff0000)>>16 );
	rtd_outl( 0xb8010c30, (DATA_A & 0x0000ff00)>>8 );
  rtd_outl( 0xb8010c34, (DATA_A & 0x000000ff) );
  rtd_outl( 0xb8010c00, Bus_Width_Highspeed_Byte );	//div & bit width
  rtd_outl( 0xb8010c3c, (Byte_CNT & 0x000000ff) );	// byte count [7:0]
  rtd_outl( 0xb8010c40, (Byte_CNT & 0x0000ff00)>>8 );	// byte count [10:8]   512Byte
  rtd_outl( 0xb8010c44, (Block_CNT & 0x000000ff) );	// block count [7:0]
  rtd_outl( 0xb8010c48, (Block_CNT & 0x0000ff00)>>8 );	// block count [14:8]
	mdelay(3);
	#ifdef  Print_Open
  printf( "\nSD_r_w_setting:\n" );   
  
  printf( "REG ADDR:0xb8010cd4 = 0x%08x\n",rtd_inl( 0xb8010cd4 ) );
  printf( "REG ADDR:0xb8010cd8 = 0x%08x\n",rtd_inl( 0xb8010cd8 ) );
  printf( "REG ADDR:0xb8010c28 = 0x%08x\n",rtd_inl( 0xb8010c28 ) );
  printf( "REG ADDR:0xb8010c2c = 0x%08x\n",rtd_inl( 0xb8010c2c ) );
  printf( "REG ADDR:0xb8010c30 = 0x%08x\n",rtd_inl( 0xb8010c30 ) );
  printf( "REG ADDR:0xb8010c34 = 0x%08x\n",rtd_inl( 0xb8010c34 ) );
  printf( "REG ADDR:0xb8010c00 = 0x%08x\n",rtd_inl( 0xb8010c00 ) );
  printf( "REG ADDR:0xb8010c3c = 0x%08x\n",rtd_inl( 0xb8010c3c ) ); 
  printf( "REG ADDR:0xb8010c40 = 0x%08x\n",rtd_inl( 0xb8010c40 ) ); 
  printf( "REG ADDR:0xb8010c44 = 0x%08x\n",rtd_inl( 0xb8010c44 ) ); 
  printf( "REG ADDR:0xb8010c48 = 0x%08x\n",rtd_inl( 0xb8010c48 ) ); 
	#endif
	}


static void SD_r_w_cmd_setting(UINT32 DATA_A, UINT32 Bus_Width_Highspeed_Byte ,UINT32 Byte_CNT, UINT32 Block_CNT)
{
	rtd_outl( 0xb8010c28, (DATA_A & 0xff000000)>>24 );
	rtd_outl( 0xb8010c2c, (DATA_A & 0x00ff0000)>>16 );
	rtd_outl( 0xb8010c30, (DATA_A & 0x0000ff00)>>8 );
	rtd_outl( 0xb8010c34, (DATA_A & 0x000000ff) );
	
	rtd_outl( 0xb8010c00, Bus_Width_Highspeed_Byte );	//0:1-bit, 1:4-bit 

	rtd_outl( 0xb8010c3c, (Byte_CNT & 0x000000ff) );	// byte count [7:0]
	rtd_outl( 0xb8010c40, (Byte_CNT & 0x0000ff00)>>8 );	// byte count [10:8]   512Byte
	rtd_outl( 0xb8010c44, (Block_CNT & 0x000000ff) );	// block count [7:0]
	rtd_outl( 0xb8010c48, (Block_CNT & 0x0000ff00)>>8 );	// block count [11:8]
	#ifdef  Print_Open
  printf( "\nSD_r_w_setting:\n" );   
  
  printf( "REG ADDR:0xb8010cd4 = 0x%08x\n",rtd_inl( 0xb8010cd4 ) );
  printf( "REG ADDR:0xb8010cd8 = 0x%08x\n",rtd_inl( 0xb8010cd8 ) );
  printf( "REG ADDR:0xb8010c28 = 0x%08x\n",rtd_inl( 0xb8010c28 ) );
  printf( "REG ADDR:0xb8010c2c = 0x%08x\n",rtd_inl( 0xb8010c2c ) );
  printf( "REG ADDR:0xb8010c30 = 0x%08x\n",rtd_inl( 0xb8010c30 ) );
  printf( "REG ADDR:0xb8010c34 = 0x%08x\n",rtd_inl( 0xb8010c34 ) );
  printf( "REG ADDR:0xb8010c00 = 0x%08x\n",rtd_inl( 0xb8010c00 ) );
  printf( "REG ADDR:0xb8010c3c = 0x%08x\n",rtd_inl( 0xb8010c3c ) ); 
  printf( "REG ADDR:0xb8010c40 = 0x%08x\n",rtd_inl( 0xb8010c40 ) ); 
  printf( "REG ADDR:0xb8010c44 = 0x%08x\n",rtd_inl( 0xb8010c44 ) ); 
  printf( "REG ADDR:0xb8010c48 = 0x%08x\n",rtd_inl( 0xb8010c48 ) ); 
	#endif
	}


	
	
static void SD_r_w_3_4_setting(UINT32 DDR_A, UINT32 Bus_Width_Highspeed_Byte ,UINT32 Byte_CNT, UINT32 Block_CNT)
{
	rtd_outl( 0xb8010cd4, DDR_A ); //DDR address: card to ddr
	rtd_outl( 0xb8010cd8, DDR_A ); //DDR address ddr to card
		
	rtd_outl( 0xb8010c00, Bus_Width_Highspeed_Byte );	//0:1-bit, 1:4-bit 

	rtd_outl( 0xb8010c3c, (Byte_CNT & 0x000000ff) );	// byte count [7:0]
	rtd_outl( 0xb8010c40, (Byte_CNT & 0x0000ff00)>>8 );	// byte count [10:8]   512Byte
	rtd_outl( 0xb8010c44, (Block_CNT & 0x000000ff) );	// block count [7:0]
	rtd_outl( 0xb8010c48, (Block_CNT & 0x0000ff00)>>8 );	// block count [11:8]
	#ifdef  Print_Open
  printf( "\nSD_r_w_setting:\n" );   
  
  printf( "REG ADDR:0xb8010cd4 = 0x%08x\n",rtd_inl( 0xb8010cd4 ) );
  printf( "REG ADDR:0xb8010cd8 = 0x%08x\n",rtd_inl( 0xb8010cd8 ) );
  printf( "REG ADDR:0xb8010c28 = 0x%08x\n",rtd_inl( 0xb8010c28 ) );
  printf( "REG ADDR:0xb8010c2c = 0x%08x\n",rtd_inl( 0xb8010c2c ) );
  printf( "REG ADDR:0xb8010c30 = 0x%08x\n",rtd_inl( 0xb8010c30 ) );
  printf( "REG ADDR:0xb8010c34 = 0x%08x\n",rtd_inl( 0xb8010c34 ) );
  printf( "REG ADDR:0xb8010c00 = 0x%08x\n",rtd_inl( 0xb8010c00 ) );
  printf( "REG ADDR:0xb8010c3c = 0x%08x\n",rtd_inl( 0xb8010c3c ) ); 
  printf( "REG ADDR:0xb8010c40 = 0x%08x\n",rtd_inl( 0xb8010c40 ) ); 
  printf( "REG ADDR:0xb8010c44 = 0x%08x\n",rtd_inl( 0xb8010c44 ) ); 
  printf( "REG ADDR:0xb8010c48 = 0x%08x\n",rtd_inl( 0xb8010c48 ) );
  #endif
	}
	
	

static void auto_r_w_1_test( )
{
  
  printf( "\n/*** SD auto_r_w_1_test ***|\n");
  
  ddr_pattern_write(0x12345678,0x00800000,128);
  
  SD_r_w_setting(DDR_ADDR,DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);      
  
  auto_write_1();
  
  udelay(100);

  ddr_pattern_erase(0x00800000,128);


  SD_r_w_setting(DDR_ADDR,DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);
   
  auto_read_1();
  
  udelay(100);
  ddr_pattern_read(0x00800000,128,0x12345678);
}


static void auto_r_w_2_test( )
{
  
  printf( "\n/*** SD auto_r_w_2_test ***/\n");
  
  ddr_pattern_write(0x55555555,0x00800000,128);

  
  SD_r_w_setting(DDR_ADDR,DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);      
  
  auto_write_2();
  cmd_12();
  
  ddr_pattern_erase(0x00800000,128);
  
  
  SD_r_w_setting(DDR_ADDR,DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count); 
  
  auto_read_2();
  cmd_12();
 
  udelay(100);
  ddr_pattern_read(0x00800000,128,0x55555555);
}

static void auto_r_w_3_test( )
{
  
  printf( "\n/*** SD auto_r_w_3_test ***/\n");
  

  ddr_pattern_write(0x10101010,0x00800000,128);
  
 
  SD_r_w_cmd_setting(DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);      
  
  cmd_25();
  
  SD_r_w_3_4_setting(DDR_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);
  
  auto_write_3();
  cmd_12();
  
  ddr_pattern_erase(0x00800000,128);
  
  SD_r_w_cmd_setting(DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);  
  
  cmd_18();
  
  SD_r_w_3_4_setting(DDR_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);
  
  auto_read_3();
  cmd_12();
 
  udelay(100);
  ddr_pattern_read(0x00800000,128,0x10101010);
}


static void auto_r_w_4_test( )
{
  
  printf( "\n/*** SD auto_r_w_4_test ***/\n");
  
   
  ddr_pattern_write(0xffffffff,0x00800000,128);
  
  SD_r_w_cmd_setting(DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);  
  
  cmd_25();
  
  SD_r_w_3_4_setting(DDR_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);
  
  auto_write_4();
  
  ddr_pattern_erase(0x00800000,128);
  
  SD_r_w_cmd_setting(DATA_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);  

  cmd_18();

  SD_r_w_3_4_setting(DDR_ADDR,BUS_WIDTH_HS,Byte_Count,Block_Count);

  auto_read_4();
  
  udelay(100);
  ddr_pattern_read(0x00800000,128,0xffffffff);
}




int SD_init()
{
	unsigned int pwr_up_status,i;
	i=0;
		 
 
	//setting SD source clock frequency
	//SD_change_freq();  
	rtd_part_inl(0xb8000204,28,27); 
  rtd_part_outl(0xb8000204,28,27,0x1);  // SD/SD clock source selection,00: from rbus_clk 250MHz,01: from PLL27X 295MHz

  rtd_part_outl(0xb8000204,22,20,0x6);  // div2 div3 div4 div5 div6 div8 div10(default,0x6)  SD card  

	printf( "\n****** Card identification mode *******\n" );
	
	cmd_0();
	cmd_8();
	
	while( 1 ) {
		cmd_55();
		pwr_up_status = acmd_41();
		if( pwr_up_status == 1 ) {
		printf("\n ****** Read transmission done ******\n");
			break;
		}
		mdelay( 100 );
		i++;
		if( i == 10 ) {
			printf( "acmd41 fail\n" );
			break;
		}
	}

	cmd_2();     //send_cid 
	cmd_3();     // set RCA 
	
	RCA_H = rtd_inl(0xb8010c28);
	RCA_L = rtd_inl(0xb8010c2c);
	
  printf( "\n sd card RCA ADDR is: RCA_H=%x, RCA_L=%x\n",RCA_H ,RCA_L );	
 

	printf( "\n****** Data transfer mode *******\n" );
	
	cmd_9();		//send_csd
	cmd_10();	  //send_cid same as cmd_2
	
	cmd_7();		//select card
  if(SD_freq<5)
  	{
  setting_HS_Mode();
   }  
  setting_bus_width( BUS_WIDTH );   // set 1 , 4  bit
  
  SD_change_freq();     
    
  cmd_13();
	cmd_16();		//SET_BLOCKLEN
}


int QC_Verifier_CardReader(void)
{
	UINT8 test_flag = 1;

	#if CONFIG_FT
	if((rtd_inl(0xb8061110)&0x4000) != 0x4000) //[14]=0 dora_hiesh add
		test_flag = 0;
	#endif
	
	if(test_flag == 1)
	{
  		int i =0,DETECT=0;

		INDEX = 0;
		
		#ifdef BIT_Mode_4
		BUS_WIDTH = 4;		//set 1,4 
    #endif	
		
		#ifdef BIT_Mode_1
		BUS_WIDTH = 1;		//set 1,4 
    #endif	 
     	 
		SET_BLOCKLEN = 0x02;	//
		RCA_H = 0x00;
		RCA_L = 0x00;
	
		DDR_ADDR = 0x00800000;      
		DATA_ADDR = 0x00010000; 
     
		Byte_Count = 0x00000200;    
		Block_Count = 0x00000001;    
	
		SD_pin_mux_setting();
		SD_PWR_EN();
	
    sd_ip_reset();
	
  		printf( "INDEX = %d\n",INDEX );
  		printf("Card detect value is 0x%08x\n",rtd_part_inl(0xb8010cdc,4,4));
 
		DETECT =  rtd_part_inl(0xb8010cdc,4,4);
	
		if(DETECT == 1)
 		{
 			INDEX = -1;
 			printf( "\n******SD Card is not Inserted *******\n" );
		}
 		else
 		{                                                                                                         
  		//rtd_part_outl(0xb8010d70,0,0,0x1);   //Non security cpu select	                
  		
  			SD_init();
  
  		printf( "INDEX = %d\n",INDEX ); 	
			//printf( "\n******SD Card IP Reset Done *******\n" );
  
    DDR_ADDR = 0x00800000;      
		DATA_ADDR = 0x00010000; 
     
		Byte_Count = 0x00000200;    
		Block_Count = 0x00000001; 
  
  
  			#ifdef Code_Type_QC
  			
  			printk("\nCardreader QC code Test Begin!\n");     

  		for(i=0;i<3;i++)
			{
				auto_r_w_1_test();
				printf("number %d sd w/r test\n",i);
  			} 
	      #endif
	      
  			#ifdef Code_Type_Verify
  			
  			printk("\nCardreader verify code Test Begin!\n");

  		auto_r_w_1_test();
			auto_r_w_2_test();  		
			auto_r_w_3_test();
			auto_r_w_4_test();

    
  			for(i=0;i<5;i++)
			{
				auto_r_w_1_test();
				printf("number %d sd w/r test\n",i);
  			} 
                                                              
  			#endif   
  
  		printf( "INDEX = %d\n",INDEX );  
			if(INDEX == -1) return INDEX;
 	
 			//SUCCESS=0, FAILED =-1

			return 0;
		}
	}
	else
	{
		printk("Do not test CardReader!\n");
		return SUCCESS;
	}
}
