#include "config.h"
#include "../tb_util.h"
#if MP_M470_MP_F048_BDC_APB

static const char* pattern_0 ="\
TRUE\n\
TRUE\n";


static test_vector mp_m470_mp_F048_BDC_APB_vector = {
	.vector_name = "mp_m470_mp_F048_BDC_APB",
	.cmd_string = "reset\n\
# ---------------------------------------------\n\
# Broadcast PP setup\n\
# BROADCAST CONFIG: 0x80013000 - 0x80013FFF\n\
# ---------------------------------------------\n\
writereg 80013000 00000001 # Broadcast mask register\n\
writereg 80013004 00000001 # Interrupt mask override\n\
# ---------------------------------------------\n\
# Broadcast PP setup\n\
# BROADCAST CONFIG: 0x80013000 - 0x80013FFF\n\
# ---------------------------------------------\n\
check_reg 80013000 = 00000001 > 0 # Broadcast mask register\n\
check_reg 80013004 = 00000001 >> 0 # Interrupt mask override\n"
};

mali_error_code mp_m470_mp_F048_BDC_APB(void){
	mali_error_code err = MALI_ERROR_NO_ERROR;
	mp_m470_mp_F048_BDC_APB_vector.pattern_num = 1;
	mp_m470_mp_F048_BDC_APB_vector.pattern[0] = pattern_0;
	mp_m470_mp_F048_BDC_APB_vector.pattern_offset[0] = 0;
	IPRINTF("\n\n\n\n>>>>>enter function mp_m470_mp_F048_BDC_APB <<<<<\n");
	err = cmd_read_configtxt(&mp_m470_mp_F048_BDC_APB_vector);
	return err;

}

#endif
