#include "config.h"
#include "../tb_util.h"

#if POWER_SUSTAINED_HIGH_POWER
static test_vector power_sustained_high_power_vector = {
	.vector_name = "power_sustained_high_power",
	.cmd_string = "\
timeout -1\n\
#buslog 1\n\
reset\n\
writereg 01000018 0000001c # enable_cache (L2 #0)\n\
writereg 0100001c 00000003 # enable_cache (L2 #0)\n\
writereg 00000028 00707bfe # Clear interrupt status for GP\n\
writereg 02000018 00000003 # Clear MMU interrupt status for GP\n\
writereg 80013000 00030003 # Enable all desired PPs and PP MMUs for broadcast writes\n\
writereg 80017024 00000fff # Clear interrupt status for all PPs\n\
writereg 80013004 00000003 # Setup interrupt mask filter so we only get one interrupt for the PPs combined\n\
writereg 80014018 00000003 # PP enable mask\n\
writereg 80015018 00000003 # Clear MMU interrupt status for all PPs\n\
writereg 0200001C 00000003 # Enable MMU page fault interrupts for GP\n\
writereg 1200001C 00000003 # Enable MMU page fault interrupts for PP0\n\
writereg 1201001C 00000003 # Enable MMU page fault interrupts for PP1\n\
#\n\
# Dumping Start gp Job nr: 1, subjob 0 from Frame nr: 2\n\
# MMU page tables\n\
load_mem mali_dump_0002_gp_001_start_mmu.hex # Page Tables\n\
# MMU registers\n\
writereg 02000000 80000000\n\
writereg 02000008 00000004\n\
writereg 02000008 00000000\n\
# MMU end\n\
#\n\
load_mem mali_dump_0002_gp_001_start.hex\n\
writereg 00 10c02e80\n\
writereg 04 10c02ed0\n\
writereg 08 10c04e80\n\
writereg 0c 10c04f08\n\
writereg 10 11042000\n\
writereg 14 1104a000\n\
writereg 2c 000003fe  # Set interrupt mask: wait for PLBU\n\
writereg 20 00000013  # Start GP Core\n\
#\n\
# Dumping Start pp Job nr: 1, subjob 0 from Frame nr: 2\n\
# MMU page tables\n\
load_mem mali_dump_0002_pp_001_start_mmu.hex # Page Tables\n\
# MMU registers\n",
};

mali_error_code power_sustained_high_power(void){

	return MALI_ERROR_NO_ERROR;
}

#endif
