#include"ifd_driver.h"
#include <platform_lib/board/pcb.h>

extern UINT8 drvif_scaleri2c_tuner_read(I2C_MODULE *pI2CModule, UINT8 *pReadArray);
extern UINT8 drvif_scaleri2c_tuner_write(I2C_MODULE *pI2CModule, UINT8 *pWriteArray);
extern ATV_TUNER_MODULE *pTuner;
extern IFD_MSG_LEVEL g_ifd_msg_level;

ATV_TUNER_MODULE pTunerModuleMemory[_Tuner_MAX_NO];
SYS_MODULE *pSysModule;
I2C_MODULE *pI2CModule;
SYS_MODULE pSysModuleMemory[_Tuner_MAX_NO];
I2C_MODULE pI2CModuleMemory[_Tuner_MAX_NO];

#define I2C_MASTER0 TUNER_I2C_MASTER_0
#define I2C_MASTER1 TUNER_I2C_MASTER_1
#define I2C_MASTER2 TUNER_I2C_MASTER_2
#define I2C_MASTER3 TUNER_I2C_MASTER_3
#define I2C_MASTER4 TUNER_I2C_MASTER_4

StructTunerDataType	/*IFD_CODE*/ gTunerData[_Tuner_MAX_NO] = 
{
	#ifdef CONFIG_TUNER_NXP_TDA18273
	{
	0xc0, //tunerI2C_ADD;
	452500,//tunerMinFreq;
	3680000,//tunerVHF_LowFreq;
	8660000,//tunerVHF_HighFreq;
	8660000,//tunerMaxFreq;
	55000,                  //tunerPIF;
	IFD_IF_FREQ_5P5M,      //tunerPIF_MN;
	IFD_IF_FREQ_6P6M,       //tunerPIF_B;
	IFD_IF_FREQ_6P6M,      //tunerPIF_GH;
	IFD_IF_FREQ_7P45M,       //tunerPIF_I;
	IFD_IF_FREQ_6P85M,      //tunerPIF_DK;
	IFD_IF_FREQ_6P75M,       //tunerPIF_L;
	IFD_IF_FREQ_1P25M,    //tunerPIF_LA;
	IFD_IF_FREQ_6P85M,     //tunerPIF_SCAN;
	TUNER_IF_TYPE_NEG,  //tunerIFType;
	500,//tunerRATIOStepSize;
	{//tunerBandFreq[IFD_TUNER_BAND_MAX];
	    3680000,8660000,8660000,8660000,8700000,8700000,8700000,8700000,8700000,8700000,
	    8700000,8700000,8700000,8700000,8700000,8700000,8700000,8700000,8700000,8700000,
	    8700000,8700000,8700000,8700000,
	},
	{//tunerRegisterByte[IFD_TUNER_REG_BAND_MAX];
	    0x00,0x00,0x00, //band0
	    0x00,0x00,0x00, //band1
	    0x00,0x00,0x00, //band2
	    0x00,0x00,0x00, //band3 
	    0x00,0x00,0x00, 
	    0x00,0x00,0x00, 
	    0x00,0x00,0x00, 
	    0x00,0x00,0x00,
	}, 
	{//tunerRegisterByteSearch[IFD_TUNER_REG_BAND_MAX];
		0x00,0x00,0x00, //band0
		0x00,0x00,0x00, //band1
		0x00,0x00,0x00, //band2
		0x00,0x00,0x00, //band3 
		0x00,0x00,0x00, 
		0x00,0x00,0x00, 
		0x00,0x00,0x00, 
		0x00,0x00,0x00,
	}, 
	_FALSE,//tunerRfInputSwitchUsedTag;
	0,//tunerRfInputByte;
	0,//tunerRfInputLocation;
	0,//tunerFLStatusBit;
	0,//tunerBandNo;
	0,//tunerRegNoPerBand;
	_FALSE,//tunerUsedTag;
	TUNER_RFAGC_IC_IFAGC,//tunerAGCtype;
	TUNER_RF_POS_IF_NONE,//tunerAGCpolarity;
	TUNER_LOW_IF,//tunerType;
	0,//tunerSpecificTag;
	TUNER_NXP_TDA18273,//tunerID;
	}
	#endif
}; 

UINT8				gTunerNo = 0;
UINT8				gTunerActiveID = TUNER_NULL;
UINT8 g_tuner_bytenum=9, g_tuner_byte[9]={0,0,0,0,0,0,0,0,0};
    
void tuner_rf_data_init(void);
void tuner_lowif_data_init(void);
      
void
BuildInterface(
	SYS_MODULE **ppSysModule,
	SYS_MODULE *pSysModuleMemory,
	I2C_MODULE **ppI2CModule,
	I2C_MODULE *pI2CModuleMemory,
	I2C_FP_READ I2cRead,
	I2C_FP_WRITE I2cWrite,
	TIMER_FP_DELAY_MS WaitMs,
	UINT8 master_id,
	UINT8 device_id,
	UINT8 addrtype
	)
{
       //IFD_QC_MSG( "BuildInterface()\n");//by Lee, 07
        
	// Set base interface module pointer.
	*ppSysModule = pSysModuleMemory;
	*ppI2CModule = pI2CModuleMemory;


	// Set all base interface function pointers and arguments.
	(*ppI2CModule)->i2c_read                   = I2cRead;
	(*ppI2CModule)->i2c_write                  = I2cWrite;
	(*ppSysModule)->timer_delay_ms        = WaitMs;
	(*ppI2CModule)->master_id		= master_id;
	(*ppI2CModule)->device_id		= device_id;
	(*ppI2CModule)->addrtype		= addrtype;
	(*ppI2CModule)->len	= 0;
	(*ppI2CModule)->slave_addr = 0;
	
	return;
}
void drv_ifd_tuner_data_init(void){

	IFD_DEBUG_MSG(IFD_MSG_INIT,"drv_ifd_tuner_data_init\n");
	gTunerNo = 0;

	tuner_rf_data_init();
	tuner_lowif_data_init();
	#ifdef CONFIG_TUNER_DEFAULT
	if(gTunerActiveID == TUNER_NULL)
		gTunerActiveID = CONFIG_TUNER_DEFAULT;
	IFD_DEBUG_MSG(IFD_MSG_INIT,"gTunerActiveID=%d\n", gTunerActiveID);
	#else
	if(gTunerActiveID == TUNER_NULL)
		gTunerActiveID = gTunerData[0].tunerID;
	#endif	
}


void drv_ifd_tuner_BuildTuner(void)
{
	UINT8 i=0;
	IFD_QC_FUNC();
	IFD_QC_MSG("gTunerNo=%d\n", gTunerNo);

#ifdef CONFIG_TUNER_RF_TYPE

	BuildInterface(
		&pSysModule,
		&pSysModuleMemory[i],
		&pI2CModule,
		&pI2CModuleMemory[i],
		drvif_scaleri2c_tuner_read,
		drvif_scaleri2c_tuner_write,
		//udelay,
		sys_wait_us,
		TUNER_I2C,
		gTunerData[i].tunerI2C_ADD,
		I2C_NOADDR
	);
	BuildRFTuner(&pTuner, &pTunerModuleMemory[i], pSysModule,
		pI2CModule, gTunerData[i].tunerI2C_ADD, 0x00, gTunerData[i].tunerMaxFreq, gTunerData[i].tunerMinFreq, 0x00, 0x00);

#elif defined(CONFIG_TUNER_LOWIF_TYPE)

	#ifdef CONFIG_TUNER_NXP_TDA18273
	BuildInterface(
		&pSysModule,
		&pSysModuleMemory[i],
		&pI2CModule,
		&pI2CModuleMemory[i],
		drvif_scaleri2c_tuner_read,
		drvif_scaleri2c_tuner_write,
		(TIMER_FP_DELAY_MS)udelay,
		TUNER_I2C,
		gTunerData[i].tunerI2C_ADD,
		I2C_ADDR_8
	);		
	BuildTda18273Module(&pTuner, &pTunerModuleMemory[i], pSysModule,
		pI2CModule, gTunerData[i].tunerI2C_ADD, 0x00, gTunerData[i].tunerMaxFreq, gTunerData[i].tunerMinFreq, 0x00, 0x7);		
	IFD_QC_MSG("CONFIG_TUNER_NXP_TDA18273\n");
	#endif	
	
#endif

}

void tuner_rf_data_init(void){
	
}

void tuner_lowif_data_init(void){

}

