#include <qc_verify_common.h>

//#define DEBUGMODE  
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);
int Verifier_LSADC(void)
{
    //***********************************************************
		//CRT INIT
		rtd_outl(0x18060044, 0x8000);  //clken:0
		rtd_outl(0x18060034, 0x10000);  //RSTN:0
		rtd_outl(0x18060044, 0x8001);  //clken:1
		rtd_outl(0x18060044, 0x8000);  //clken:0
		rtd_outl(0x18060034, 0x10001);   //RSTN:1
		rtd_outl(0x18060044, 0x8001);  //clken:1

		//pinshare
 		rtd_outl(0xb8060204,0xccccc000);//  Ps_Reg:lsadc0 1 2 3 4   
		rtd_outl(0xb8060200,0xcccccc00);//  Ps_Reg:lsadc5 6 7 8 9 10	

		UINT32 Data;
		__attribute__ ((unused)) UINT32 ADDR;

		rtd_outl(0xb8061500, 0x00000000);  //lasdc0
		rtd_outl(0xb8061504, 0x00000000);  //lasdc1
		rtd_outl(0xb8061508, 0x00000000);  //lasdc2
		rtd_outl(0xb806150c, 0x00000000);  //lasdc3
		rtd_outl(0xb8061510, 0x00000000);  //lasdc4
		rtd_outl(0xb8061514, 0x00000000);  //lasdc5
		rtd_outl(0xb8061518, 0x00000000);  //lasdc6
		rtd_outl(0xb806151c, 0x00000000);  //lasdc7
		rtd_outl(0xb8061520, 0x00000000);  //lasdc8
		rtd_outl(0xb8061524, 0x00000000);  //lsadc9
		rtd_outl(0xb8061528, 0x00000000);  //lsadc10

		rtd_outl(0xb8061530, 0x16000000);
		rtd_outl(0xb8061534, 0x00000000);
		rtd_outl(0xb8061538, 0x00011000);
	
  		printk("LSADC:\n");
 
  		//voltage mode	
		rtd_outl(0xb8061500, 0x80000000);//pad0                     
		rtd_outl(0xb8061504, 0x80001000);//pad1                         
		rtd_outl(0xb8061508, 0x80002000);//pad2                           
		rtd_outl(0xb806150c, 0x80003000);//pad3                           
		rtd_outl(0xb8061510, 0x80004000);//pad4          
		rtd_outl(0xb8061514, 0x80005000);//pad5                          
		rtd_outl(0xb8061518, 0x80006000);//pad6
		rtd_outl(0xb806151c, 0x80007000);//pad7
		rtd_outl(0xb8061520, 0x80008000);//pad8
		rtd_outl(0xb8061524, 0x80009000);//pad9
		rtd_outl(0xb8061528, 0x8000a000);//pad10
		

		rtd_outl(0xb8061538, 0x00010001);       //Analog Enable
	 	rtd_outl(0xb8061530, 0x16100000);       //Digital setting
	 	rtd_outl(0xb8061530, 0x16100001);       //Digital Enable
	 	
		udelay(20000);   //delay for convert
		
			

	 bool bFail=0;

	udelay(5000);  //wait for value steady
	

  #ifdef DEBUGMODE

    printk("Address:0xb8060040=>0x%x\n",dw(0xb8060040));
    printk("Address:0xb8060044=>0x%x\n",dw(0xb8060044));
    printk("Address:0xb8060030=>0x%x\n",dw(0xb8060030));
    printk("Address:0xb8060034=>0x%x\n",dw(0xb8060034));

    printk("Pinshare:\n");	
    printk("Address:0xb8060204=>0x%x\n",dw(0xb8060204));
    printk("Address:0xb8060200=>0x%x\n",dw(0xb8060200));
	

    for(ADDR = 0xb8061500;ADDR<=0xb8061528;ADDR+=4)
    {
	    Data = dw(ADDR);
		printk("Address:0x%x=>0x%x\n",ADDR,Data);
    }
    for(ADDR = 0xb8061530;ADDR<=0xb8061538;ADDR+=4)
    {
	    Data = dw(ADDR);
		printk("Address:0x%x=>0x%x\n",ADDR,Data);
    }		

   #endif


	  Data = dw(0xb8061500)&0xff;     // 0  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD0=0x%x\n",Data);
		bFail = 1;
		}

	  udelay(20000);

	//do not test in B27
#if defined(CONFIG_RTK_B22_QC)
	  Data = dw(0xb8061504)&0xff;     // 1  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)            
		{
		ROSPrintf("PAD1=0x%x\n",Data);
		bFail = 1;
		}

	 udelay(2000);  //wait for value steady
#endif	 
	 
	
   	 Data = dw(0xb8061508)&0xff;     // 2  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD2=0x%x\n",Data);
		bFail = 1;
		}	

	udelay(2000);  //wait for value steady
		
    	Data = dw(0xb806150c)&0xff;     // 3  mean = 0x7F   ,   voltage mode
	if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD3=0x%x\n",Data);
		bFail = 1;
		}

	Data = dw(0xb8061510)&0xff;     // 4  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD4=0x%x\n",Data);
		bFail = 1;
		}

    	Data = dw(0xb8061514)&0xff;     // 5  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD5=0x%x\n",Data);
		bFail = 1;
		}	


		
	Data = dw(0xb8061518)&0xff;     // 6  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD6=0x%x\n",Data);
		bFail = 1;
		}

	Data = dw(0xb806151c)&0xff;     // 7  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD7=0x%x\n",Data);
		bFail = 1;
		}
		
	Data = dw(0xb8061520)&0xff;     // 8  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD8=0x%x\n",Data);
		bFail = 1;
		}
	
	Data = dw(0xb8061524)&0xff;     // 9  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD9=0x%x\n",Data);
		bFail = 1;
		}
		
	Data = dw(0xb8061528)&0xff;     // 10  mean = 0x7F   ,   voltage mode
	  if(Data<0x7A || Data>0x85)      
		{
		ROSPrintf("PAD10=0x%x\n",Data);
		bFail = 1;
		}

	ew(0xb8061538,0x0);

	return bFail;


}
