//------------------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from ARM Limited or its affiliates.
//
//            (C) COPYRIGHT 2013-2018 ARM Limited or its affiliates.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from ARM Limited or its affiliates.
//
//            Release Information : CORINTH-MP090-r4p0-00rel0
//
//------------------------------------------------------------------------------

// Enable UAL syntax
.syntax unified

                .section .text, "ax", %progbits
                .global arm_hello_world

arm_hello_world:
                // Initialise the register file as a safeguard against
                // spurious X propagation.
                push    {r4,r14}
                mov     r0,  #0
                mov     r1,  #0
                mov     r2,  #0
                mov     r3,  #0
                mov     r4,  #0
                mov     r5,  #0
                mov     r6,  #0
                mov     r7,  #0
                mov     r8,  #0
                mov     r9,  #0
//                mov     r10, #0
//                mov     r11, #0
//                mov     r12, #0
//                mov     r14, #0
//                mov     r13, r0

                // Only selected CPU prints the message and all other CPUs enter a
                // WFI state.
                mrc     p15, 0, r0, c0, c0, 5   // Read MPIDR
                mov     r1, #0xff00
                orr     r1, r1, #0xff
                and     r0, r0, r1      // r0 == AFF1 and AFF0
//                mov     r3, #0x13000000 // Tube address
//                mov     r3, #0x1801B100 // Tube address
//                ldr     r1, [r3, #0x20]
                .ifdef BIGEND
                rev     r1, r1
                .endif
//                cmp     r0, r1
//                bne     wfi_spin                // WFI if not selected CPU

                // CPU0:
                // Write the text one byte at a time to the tube address
//                ldr     r0, =0x13000000 // Tube address
                ldr     r0, =0x1801B100         // Tube address
                ldr     r1, =message

loop:           ldrb    r2, [r1], #1
                cmp     r2, #0
                beq     end
                strb    r2, [r0]
                b       loop

end:            mov     r2, #0x04       // EOT character
                strb    r2, [r0]
                dsb
                pop     {r4,pc}
//                mov     pc, lr

wfi_spin:       wfi
                b       wfi_spin

// The message to print.  It is NULL-terminated so that the print loop
// can detect the end of the string.
                .balign 4
message:        .asciz "\n  Hello World!\n\n** TEST PASSED OK **\n"
                .ltorg
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop


