/**
* @file rbusDispd_boe_rgbwReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DISPD_BOE_RGBW_REG_H_
#define _RBUS_DISPD_BOE_RGBW_REG_H_

#include "rbusTypes.h"



//  DISPD_BOE_RGBW Register Address



#define  DISPD_BOE_RGBW_APB_W_CONTROL_VADDR                 	(0xb802ec00)
#define  DISPD_BOE_RGBW_APB_W_DATA_VADDR                    	(0xb802ec04)
#define  DISPD_BOE_RGBW_APB_R_CONTROL_VADDR                 	(0xb802ec08)
#define  DISPD_BOE_RGBW_APB_R_DATA_VADDR                    	(0xb802ec0c)
#define  DISPD_BOE_RGBW_APB_ADDR_VADDR                      	(0xb802ec10)
#define  DISPD_BOE_RGBW_APB_TIMING_VADDR                    	(0xb802ec14)
#define  DISPD_BOE_RGBW_APB_ALIGN_VADDR                     	(0xb802ec18)
#define  DISPD_BOE_RGBW_APB_ALIGN_RESULT_VADDR              	(0xb802ec1c)
#define  DISPD_BOE_RGBW_MCU_CONTROL_VADDR                   	(0xb802ec20)
#define  DISPD_BOE_RGBW_MCU_ST_VADDR                        	(0xb802ec24)
#define  DISPD_BOE_RGBW_APB_LATENCY_VADDR                   	(0xb802ec28)
#define  DISPD_BOE_RGBW_APB_DUMMY_VADDR                     	(0xb802ec2c)
#define  DISPD_BOE_RGBW_APB_SRAM_RM_VADDR                   	(0xb802ec30)
#define  DISPD_BOE_RGBW_APB_SRAM_BIST_FAIL_VADDR            	(0xb802ec34)
#define  DISPD_BOE_RGBW_APB_SRAM_DRF_BIST_FAIL_VADDR        	(0xb802ec38)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DISPD_BOE_RGBW register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  apb_w_mode:2;
        RBus_UInt32  apb_w_addr:16;
    };
}dispd_boe_rgbw_apb_w_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_w_data3:8;
        RBus_UInt32  apb_w_data2:8;
        RBus_UInt32  apb_w_data1:8;
        RBus_UInt32  apb_w_data0:8;
    };
}dispd_boe_rgbw_apb_w_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  apb_r_addr:16;
    };
}dispd_boe_rgbw_apb_r_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  apb_r_data:8;
    };
}dispd_boe_rgbw_apb_r_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_w_addr_st:16;
        RBus_UInt32  apb_r_addr_st:16;
    };
}dispd_boe_rgbw_apb_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  apb_extend_vde:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  apb_height:13;
    };
}dispd_boe_rgbw_apb_timing_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  auto_detect_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  user_timing_sel:2;
    };
}dispd_boe_rgbw_apb_align_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  vde_hit_vsync:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  auto_detect_result:2;
    };
}dispd_boe_rgbw_apb_align_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  dbg_gpio_mode_en:1;
        RBus_UInt32  dbg_gpio_oe:1;
        RBus_UInt32  dbg_gpio_o:1;
        RBus_UInt32  dbg_gpio_i:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  connet_int_out_to_dtg_en:1;
        RBus_UInt32  mcu_int_in:1;
    };
}dispd_boe_rgbw_mcu_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_error:1;
        RBus_UInt32  apb_busy:1;
        RBus_UInt32  latency_chk_error:1;
        RBus_UInt32  self_deno_chk_error:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  mcu_int_st:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  uart_tx:1;
        RBus_UInt32  mcu_int_out:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  rgbw_gpio_oe:1;
        RBus_UInt32  rgbw_gpio_o:1;
        RBus_UInt32  rgbw_gpio_i:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  dispd_rgbw_gpio_oe:1;
        RBus_UInt32  dispd_rgbw_gpio_o:1;
        RBus_UInt32  dispd_rgbw_gpio_i:1;
        RBus_UInt32  mcu_dbg_bus:8;
    };
}dispd_boe_rgbw_mcu_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  latency_chk_en:1;
        RBus_UInt32  self_deno_mode:1;
        RBus_UInt32  self_deno_chk_en:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  latency_golden:8;
        RBus_UInt32  latency_st:8;
    };
}dispd_boe_rgbw_apb_latency_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ec2c_31_0:32;
    };
}dispd_boe_rgbw_apb_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  test_rwm:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  ls_1024x8:1;
        RBus_UInt32  ls_256x16:1;
        RBus_UInt32  ls_256x8:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  rme_1024x8:1;
        RBus_UInt32  rme_256x16:1;
        RBus_UInt32  rme_256x8:1;
        RBus_UInt32  res3:4;
        RBus_UInt32  rm_1024x8:4;
        RBus_UInt32  rm_256x16:4;
        RBus_UInt32  rm_256x8:4;
    };
}dispd_boe_rgbw_apb_sram_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  bist_fail_25:1;
        RBus_UInt32  bist_fail_24:1;
        RBus_UInt32  bist_fail_23:1;
        RBus_UInt32  bist_fail_22:1;
        RBus_UInt32  bist_fail_21:1;
        RBus_UInt32  bist_fail_20:1;
        RBus_UInt32  bist_fail_19:1;
        RBus_UInt32  bist_fail_18:1;
        RBus_UInt32  bist_fail_17:1;
        RBus_UInt32  bist_fail_16:1;
        RBus_UInt32  bist_fail_15:1;
        RBus_UInt32  bist_fail_14:1;
        RBus_UInt32  bist_fail_13:1;
        RBus_UInt32  bist_fail_12:1;
        RBus_UInt32  bist_fail_11:1;
        RBus_UInt32  bist_fail_10:1;
        RBus_UInt32  bist_fail_9:1;
        RBus_UInt32  bist_fail_8:1;
        RBus_UInt32  bist_fail_7:1;
        RBus_UInt32  bist_fail_6:1;
        RBus_UInt32  bist_fail_5:1;
        RBus_UInt32  bist_fail_4:1;
        RBus_UInt32  bist_fail_3:1;
        RBus_UInt32  bist_fail_2:1;
        RBus_UInt32  bist_fail_1:1;
        RBus_UInt32  bist_fail_0:1;
    };
}dispd_boe_rgbw_apb_sram_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  drf_bist_fail_25:1;
        RBus_UInt32  drf_bist_fail_24:1;
        RBus_UInt32  drf_bist_fail_23:1;
        RBus_UInt32  drf_bist_fail_22:1;
        RBus_UInt32  drf_bist_fail_21:1;
        RBus_UInt32  drf_bist_fail_20:1;
        RBus_UInt32  drf_bist_fail_19:1;
        RBus_UInt32  drf_bist_fail_18:1;
        RBus_UInt32  drf_bist_fail_17:1;
        RBus_UInt32  drf_bist_fail_16:1;
        RBus_UInt32  drf_bist_fail_15:1;
        RBus_UInt32  drf_bist_fail_14:1;
        RBus_UInt32  drf_bist_fail_13:1;
        RBus_UInt32  drf_bist_fail_12:1;
        RBus_UInt32  drf_bist_fail_11:1;
        RBus_UInt32  drf_bist_fail_10:1;
        RBus_UInt32  drf_bist_fail_9:1;
        RBus_UInt32  drf_bist_fail_8:1;
        RBus_UInt32  drf_bist_fail_7:1;
        RBus_UInt32  drf_bist_fail_6:1;
        RBus_UInt32  drf_bist_fail_5:1;
        RBus_UInt32  drf_bist_fail_4:1;
        RBus_UInt32  drf_bist_fail_3:1;
        RBus_UInt32  drf_bist_fail_2:1;
        RBus_UInt32  drf_bist_fail_1:1;
        RBus_UInt32  drf_bist_fail_0:1;
    };
}dispd_boe_rgbw_apb_sram_drf_bist_fail_RBUS;

#else //apply LITTLE_ENDIAN

//======DISPD_BOE_RGBW register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_w_addr:16;
        RBus_UInt32  apb_w_mode:2;
        RBus_UInt32  res1:14;
    };
}dispd_boe_rgbw_apb_w_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_w_data0:8;
        RBus_UInt32  apb_w_data1:8;
        RBus_UInt32  apb_w_data2:8;
        RBus_UInt32  apb_w_data3:8;
    };
}dispd_boe_rgbw_apb_w_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_r_addr:16;
        RBus_UInt32  res1:16;
    };
}dispd_boe_rgbw_apb_r_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_r_data:8;
        RBus_UInt32  res1:24;
    };
}dispd_boe_rgbw_apb_r_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_r_addr_st:16;
        RBus_UInt32  apb_w_addr_st:16;
    };
}dispd_boe_rgbw_apb_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apb_height:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  apb_extend_vde:13;
        RBus_UInt32  res2:3;
    };
}dispd_boe_rgbw_apb_timing_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  user_timing_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  auto_detect_en:1;
        RBus_UInt32  res2:27;
    };
}dispd_boe_rgbw_apb_align_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  auto_detect_result:2;
        RBus_UInt32  res1:14;
        RBus_UInt32  vde_hit_vsync:1;
        RBus_UInt32  res2:15;
    };
}dispd_boe_rgbw_apb_align_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcu_int_in:1;
        RBus_UInt32  connet_int_out_to_dtg_en:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  dbg_gpio_i:1;
        RBus_UInt32  dbg_gpio_o:1;
        RBus_UInt32  dbg_gpio_oe:1;
        RBus_UInt32  dbg_gpio_mode_en:1;
        RBus_UInt32  res2:12;
    };
}dispd_boe_rgbw_mcu_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcu_dbg_bus:8;
        RBus_UInt32  dispd_rgbw_gpio_i:1;
        RBus_UInt32  dispd_rgbw_gpio_o:1;
        RBus_UInt32  dispd_rgbw_gpio_oe:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  rgbw_gpio_i:1;
        RBus_UInt32  rgbw_gpio_o:1;
        RBus_UInt32  rgbw_gpio_oe:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mcu_int_out:1;
        RBus_UInt32  uart_tx:1;
        RBus_UInt32  res3:6;
        RBus_UInt32  mcu_int_st:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  self_deno_chk_error:1;
        RBus_UInt32  latency_chk_error:1;
        RBus_UInt32  apb_busy:1;
        RBus_UInt32  apb_error:1;
    };
}dispd_boe_rgbw_mcu_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  latency_st:8;
        RBus_UInt32  latency_golden:8;
        RBus_UInt32  res1:13;
        RBus_UInt32  self_deno_chk_en:1;
        RBus_UInt32  self_deno_mode:1;
        RBus_UInt32  latency_chk_en:1;
    };
}dispd_boe_rgbw_apb_latency_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ec2c_31_0:32;
    };
}dispd_boe_rgbw_apb_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_256x8:4;
        RBus_UInt32  rm_256x16:4;
        RBus_UInt32  rm_1024x8:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  rme_256x8:1;
        RBus_UInt32  rme_256x16:1;
        RBus_UInt32  rme_1024x8:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  ls_256x8:1;
        RBus_UInt32  ls_256x16:1;
        RBus_UInt32  ls_1024x8:1;
        RBus_UInt32  res3:4;
        RBus_UInt32  test_rwm:1;
    };
}dispd_boe_rgbw_apb_sram_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_0:1;
        RBus_UInt32  bist_fail_1:1;
        RBus_UInt32  bist_fail_2:1;
        RBus_UInt32  bist_fail_3:1;
        RBus_UInt32  bist_fail_4:1;
        RBus_UInt32  bist_fail_5:1;
        RBus_UInt32  bist_fail_6:1;
        RBus_UInt32  bist_fail_7:1;
        RBus_UInt32  bist_fail_8:1;
        RBus_UInt32  bist_fail_9:1;
        RBus_UInt32  bist_fail_10:1;
        RBus_UInt32  bist_fail_11:1;
        RBus_UInt32  bist_fail_12:1;
        RBus_UInt32  bist_fail_13:1;
        RBus_UInt32  bist_fail_14:1;
        RBus_UInt32  bist_fail_15:1;
        RBus_UInt32  bist_fail_16:1;
        RBus_UInt32  bist_fail_17:1;
        RBus_UInt32  bist_fail_18:1;
        RBus_UInt32  bist_fail_19:1;
        RBus_UInt32  bist_fail_20:1;
        RBus_UInt32  bist_fail_21:1;
        RBus_UInt32  bist_fail_22:1;
        RBus_UInt32  bist_fail_23:1;
        RBus_UInt32  bist_fail_24:1;
        RBus_UInt32  bist_fail_25:1;
        RBus_UInt32  res1:6;
    };
}dispd_boe_rgbw_apb_sram_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_0:1;
        RBus_UInt32  drf_bist_fail_1:1;
        RBus_UInt32  drf_bist_fail_2:1;
        RBus_UInt32  drf_bist_fail_3:1;
        RBus_UInt32  drf_bist_fail_4:1;
        RBus_UInt32  drf_bist_fail_5:1;
        RBus_UInt32  drf_bist_fail_6:1;
        RBus_UInt32  drf_bist_fail_7:1;
        RBus_UInt32  drf_bist_fail_8:1;
        RBus_UInt32  drf_bist_fail_9:1;
        RBus_UInt32  drf_bist_fail_10:1;
        RBus_UInt32  drf_bist_fail_11:1;
        RBus_UInt32  drf_bist_fail_12:1;
        RBus_UInt32  drf_bist_fail_13:1;
        RBus_UInt32  drf_bist_fail_14:1;
        RBus_UInt32  drf_bist_fail_15:1;
        RBus_UInt32  drf_bist_fail_16:1;
        RBus_UInt32  drf_bist_fail_17:1;
        RBus_UInt32  drf_bist_fail_18:1;
        RBus_UInt32  drf_bist_fail_19:1;
        RBus_UInt32  drf_bist_fail_20:1;
        RBus_UInt32  drf_bist_fail_21:1;
        RBus_UInt32  drf_bist_fail_22:1;
        RBus_UInt32  drf_bist_fail_23:1;
        RBus_UInt32  drf_bist_fail_24:1;
        RBus_UInt32  drf_bist_fail_25:1;
        RBus_UInt32  res1:6;
    };
}dispd_boe_rgbw_apb_sram_drf_bist_fail_RBUS;




#endif 


#endif 
