/**
* @file rbusI_BIST_BISRReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_I_BIST_BISR_REG_H_
#define _RBUS_I_BIST_BISR_REG_H_

#include "rbusTypes.h"



//  I_BIST_BISR Register Address



#define  I_BIST_BISR_DISPI_BIST_MODE_VADDR                  	(0xb8025f00)
#define  I_BIST_BISR_DISPI_BIST_DONE_VADDR                  	(0xb8025f04)
#define  I_BIST_BISR_DISPI_BIST_FAIL_GROUP_VADDR            	(0xb8025f08)
#define  I_BIST_BISR_DISPI_DRF_MODE_VADDR                   	(0xb8025f0c)
#define  I_BIST_BISR_DISPI_DRF_RESUME_VADDR                 	(0xb8025f10)
#define  I_BIST_BISR_DISPI_DRF_DONE_VADDR                   	(0xb8025f14)
#define  I_BIST_BISR_DISPI_DRF_PAUSE_VADDR                  	(0xb8025f18)
#define  I_BIST_BISR_DISPI_DRF_FAIL_GROUP_VADDR             	(0xb8025f1c)
#define  I_BIST_BISR_DISPI_BISR_SECOND_RUN_EN_VADDR         	(0xb8025f20)
#define  I_BIST_BISR_DISPI_BISR_FAIL_GROUP_VADDR            	(0xb8025f24)
#define  I_BIST_BISR_DISPI_BISR_DRF_MODE_VADDR              	(0xb8025f28)
#define  I_BIST_BISR_DISPI_BISR_DRF_RESUME_VADDR            	(0xb8025f2c)
#define  I_BIST_BISR_DISPI_BISR_DRF_DONE_VADDR              	(0xb8025f30)
#define  I_BIST_BISR_DISPI_BISR_DRF_PAUSE_VADDR             	(0xb8025f34)
#define  I_BIST_BISR_DISPI_BISR_DRF_FAIL_GROUP_VADDR        	(0xb8025f38)
#define  I_BIST_BISR_DISPI_BIST_MODE_1_VADDR                	(0xb8025f40)
#define  I_BIST_BISR_DISPI_BIST_DONE_1_VADDR                	(0xb8025f44)
#define  I_BIST_BISR_DISPI_BIST_FAIL_GROUP_1_VADDR          	(0xb8025f48)
#define  I_BIST_BISR_DISPI_DRF_MODE_1_VADDR                 	(0xb8025f4c)
#define  I_BIST_BISR_DISPI_DRF_RESUME_1_VADDR               	(0xb8025f50)
#define  I_BIST_BISR_DISPI_DRF_DONE_1_VADDR                 	(0xb8025f54)
#define  I_BIST_BISR_DISPI_DRF_PAUSE_1_VADDR                	(0xb8025f58)
#define  I_BIST_BISR_DISPI_DRF_FAIL_GROUP_1_VADDR           	(0xb8025f5c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======I_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_bist_mode:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_mode:1;
        RBus_UInt32  ch2_mbist_hist_1p_bist_mode:1;
        RBus_UInt32  ch2_mbist_hist_2p_bist_mode:1;
        RBus_UInt32  pqdc1_bist_mode:1;
        RBus_UInt32  pqdc2_bist_mode:1;
        RBus_UInt32  pqc1_bist_mode:1;
        RBus_UInt32  pqc2_bist_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_mode:1;
        RBus_UInt32  isnr_dma_wdat_bist_mode:1;
        RBus_UInt32  di_li6_bist_mode:1;
        RBus_UInt32  di_li7_bist_mode:1;
        RBus_UInt32  di_li4_bist_mode:1;
        RBus_UInt32  di_li5_bist_mode:1;
        RBus_UInt32  i3ddma_bist_cap2_mode:1;
        RBus_UInt32  sdnr_ch1_bist_mode:1;
        RBus_UInt32  sdnr_ch2_bist_mode:1;
        RBus_UInt32  di_tr2to1_bist_mode:1;
        RBus_UInt32  di_hmc_bist_mode:1;
        RBus_UInt32  di_dma_wdat_bist_mode:1;
        RBus_UInt32  di_dma_rdat_bist_mode:1;
        RBus_UInt32  di_li1_bist_mode:1;
        RBus_UInt32  di_li2_bist_mode:1;
        RBus_UInt32  di_li3_bist_mode:1;
        RBus_UInt32  i3ddma_uzd_bist_mode:1;
        RBus_UInt32  i3ddma_bist_mode:1;
    };
}i_bist_bisr_dispi_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_bist_done:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_done:1;
        RBus_UInt32  ch2_mbist_hist_1p_bist_done:1;
        RBus_UInt32  ch2_mbist_hist_2p_bist_done:1;
        RBus_UInt32  pqdc1_bist_done:1;
        RBus_UInt32  pqdc2_bist_done:1;
        RBus_UInt32  pqc1_bist_done:1;
        RBus_UInt32  pqc2_bist_done:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_done:1;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_done:1;
        RBus_UInt32  isnr_dma_wdat_bist_done:1;
        RBus_UInt32  di_li6_bist_done:1;
        RBus_UInt32  di_li7_bist_done:1;
        RBus_UInt32  di_li4_bist_done:1;
        RBus_UInt32  di_li5_bist_done:1;
        RBus_UInt32  i3ddma_bist_cap2_done:1;
        RBus_UInt32  sdnr_ch1_bist_done:1;
        RBus_UInt32  sdnr_ch2_bist_done:1;
        RBus_UInt32  di_tr2to1_bist_done:1;
        RBus_UInt32  di_hmc_bist_done:1;
        RBus_UInt32  di_dma_wdat_bist_done:1;
        RBus_UInt32  di_dma_rdat_bist_done:1;
        RBus_UInt32  di_li1_bist_done:1;
        RBus_UInt32  di_li2_bist_done:1;
        RBus_UInt32  di_li3_bist_done:1;
        RBus_UInt32  i3ddma_uzd_bist_done:1;
        RBus_UInt32  i3ddma_bist_done:1;
    };
}i_bist_bisr_dispi_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_bist_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_1p_bist_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_2p_bist_fail_group:1;
        RBus_UInt32  pqdc1_bist_fail_group:1;
        RBus_UInt32  pqdc2_bist_fail_group:1;
        RBus_UInt32  pqc1_bist_fail_group:1;
        RBus_UInt32  pqc2_bist_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_fail_group:1;
        RBus_UInt32  isnr_dma_wdat_bist_fail_group:1;
        RBus_UInt32  di_li6_bist_fail_group:1;
        RBus_UInt32  di_li7_bist_fail_group:1;
        RBus_UInt32  di_li4_bist_fail_group:1;
        RBus_UInt32  di_li5_bist_fail_group:1;
        RBus_UInt32  i3ddma_bist_cap2_fail_group:1;
        RBus_UInt32  sdnr_ch1_bist_fail_group:1;
        RBus_UInt32  sdnr_ch2_bist_fail_group:1;
        RBus_UInt32  di_tr2to1_bist_fail_group:1;
        RBus_UInt32  di_hmc_bist_fail_group:1;
        RBus_UInt32  di_dma_wdat_bist_fail_group:1;
        RBus_UInt32  di_dma_rdat_bist_fail_group:1;
        RBus_UInt32  di_li1_bist_fail_group:1;
        RBus_UInt32  di_li2_bist_fail_group:1;
        RBus_UInt32  di_li3_bist_fail_group:1;
        RBus_UInt32  i3ddma_uzd_bist_fail_group:1;
        RBus_UInt32  i3ddma_bist_fail_group:1;
    };
}i_bist_bisr_dispi_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_drf_mode:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_mode:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_mode:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_mode:1;
        RBus_UInt32  pqdc1_drf_mode:1;
        RBus_UInt32  pqdc2_drf_mode:1;
        RBus_UInt32  pqc1_drf_mode:1;
        RBus_UInt32  pqc2_drf_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_mode:1;
        RBus_UInt32  isnr_dma_wdat_drf_mode:1;
        RBus_UInt32  di_li6_drf_mode:1;
        RBus_UInt32  di_li7_drf_mode:1;
        RBus_UInt32  di_li4_drf_mode:1;
        RBus_UInt32  di_li5_drf_mode:1;
        RBus_UInt32  i3ddma_drf_cap2_mode:1;
        RBus_UInt32  sdnr_ch1_drf_mode:1;
        RBus_UInt32  sdnr_ch2_drf_mode:1;
        RBus_UInt32  di_tr2to1_drf_mode:1;
        RBus_UInt32  di_hmc_drf_mode:1;
        RBus_UInt32  di_dma_wdat_drf_mode:1;
        RBus_UInt32  di_dma_rdat_drf_mode:1;
        RBus_UInt32  di_li1_drf_mode:1;
        RBus_UInt32  di_li2_drf_mode:1;
        RBus_UInt32  di_li3_drf_mode:1;
        RBus_UInt32  i3ddma_uzd_drf_mode:1;
        RBus_UInt32  i3ddma_drf_mode:1;
    };
}i_bist_bisr_dispi_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_drf_resume:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_resume:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_resume:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_resume:1;
        RBus_UInt32  pqdc1_drf_resume:1;
        RBus_UInt32  pqdc2_drf_resume:1;
        RBus_UInt32  pqc1_drf_resume:1;
        RBus_UInt32  pqc2_drf_resume:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_resume:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_resume:1;
        RBus_UInt32  isnr_dma_wdat_drf_resume:1;
        RBus_UInt32  di_li6_drf_resume:1;
        RBus_UInt32  di_li7_drf_resume:1;
        RBus_UInt32  di_li4_drf_resume:1;
        RBus_UInt32  di_li5_drf_resume:1;
        RBus_UInt32  i3ddma_drf_cap2_resume:1;
        RBus_UInt32  sdnr_ch1_drf_resume:1;
        RBus_UInt32  sdnr_ch2_drf_resume:1;
        RBus_UInt32  di_tr2to1_drf_resume:1;
        RBus_UInt32  di_hmc_drf_resume:1;
        RBus_UInt32  di_dma_wdat_drf_resume:1;
        RBus_UInt32  di_dma_rdat_drf_resume:1;
        RBus_UInt32  di_li1_drf_resume:1;
        RBus_UInt32  di_li2_drf_resume:1;
        RBus_UInt32  di_li3_drf_resume:1;
        RBus_UInt32  i3ddma_uzd_drf_resume:1;
        RBus_UInt32  i3ddma_drf_resume:1;
    };
}i_bist_bisr_dispi_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_drf_done:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_done:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_done:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_done:1;
        RBus_UInt32  pqdc1_drf_done:1;
        RBus_UInt32  pqdc2_drf_done:1;
        RBus_UInt32  pqc1_drf_done:1;
        RBus_UInt32  pqc2_drf_done:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_done:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_done:1;
        RBus_UInt32  isnr_dma_wdat_drf_done:1;
        RBus_UInt32  di_li6_drf_done:1;
        RBus_UInt32  di_li7_drf_done:1;
        RBus_UInt32  di_li4_drf_done:1;
        RBus_UInt32  di_li5_drf_done:1;
        RBus_UInt32  i3ddma_drf_cap2_done:1;
        RBus_UInt32  sdnr_ch1_drf_done:1;
        RBus_UInt32  sdnr_ch2_drf_done:1;
        RBus_UInt32  di_tr2to1_drf_done:1;
        RBus_UInt32  di_hmc_drf_done:1;
        RBus_UInt32  di_dma_wdat_drf_done:1;
        RBus_UInt32  di_dma_rdat_drf_done:1;
        RBus_UInt32  di_li1_drf_done:1;
        RBus_UInt32  di_li2_drf_done:1;
        RBus_UInt32  di_li3_drf_done:1;
        RBus_UInt32  i3ddma_uzd_drf_done:1;
        RBus_UInt32  i3ddma_drf_done:1;
    };
}i_bist_bisr_dispi_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_drf_pause:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_pause:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_pause:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_pause:1;
        RBus_UInt32  pqdc1_drf_pause:1;
        RBus_UInt32  pqdc2_drf_pause:1;
        RBus_UInt32  pqc1_drf_pause:1;
        RBus_UInt32  pqc2_drf_pause:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_pause:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_pause:1;
        RBus_UInt32  isnr_dma_wdat_drf_pause:1;
        RBus_UInt32  di_li6_drf_pause:1;
        RBus_UInt32  di_li7_drf_pause:1;
        RBus_UInt32  di_li4_drf_pause:1;
        RBus_UInt32  di_li5_drf_pause:1;
        RBus_UInt32  i3ddma_drf_cap2_pause:1;
        RBus_UInt32  sdnr_ch1_drf_pause:1;
        RBus_UInt32  sdnr_ch2_drf_pause:1;
        RBus_UInt32  di_tr2to1_drf_pause:1;
        RBus_UInt32  di_hmc_drf_pause:1;
        RBus_UInt32  di_dma_wdat_drf_pause:1;
        RBus_UInt32  di_dma_rdat_drf_pause:1;
        RBus_UInt32  di_li1_drf_pause:1;
        RBus_UInt32  di_li2_drf_pause:1;
        RBus_UInt32  di_li3_drf_pause:1;
        RBus_UInt32  i3ddma_uzd_drf_pause:1;
        RBus_UInt32  i3ddma_drf_pause:1;
    };
}i_bist_bisr_dispi_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ch1_mbist_hist_1p_drf_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_fail_group:1;
        RBus_UInt32  pqdc1_drf_fail_group:1;
        RBus_UInt32  pqdc2_drf_fail_group:1;
        RBus_UInt32  pqc1_drf_fail_group:1;
        RBus_UInt32  pqc2_drf_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_fail_group:1;
        RBus_UInt32  isnr_dma_wdat_drf_fail_group:1;
        RBus_UInt32  di_li6_drf_fail_group:1;
        RBus_UInt32  di_li7_drf_fail_group:1;
        RBus_UInt32  di_li4_drf_fail_group:1;
        RBus_UInt32  di_li5_drf_fail_group:1;
        RBus_UInt32  i3ddma_drf_cap2_fail_group:1;
        RBus_UInt32  sdnr_ch1_drf_fail_group:1;
        RBus_UInt32  sdnr_ch2_drf_fail_group:1;
        RBus_UInt32  di_tr2to1_drf_fail_group:1;
        RBus_UInt32  di_hmc_drf_fail_group:1;
        RBus_UInt32  di_dma_wdat_drf_fail_group:1;
        RBus_UInt32  di_dma_rdat_drf_fail_group:1;
        RBus_UInt32  di_li1_drf_fail_group:1;
        RBus_UInt32  di_li2_drf_fail_group:1;
        RBus_UInt32  di_li3_drf_fail_group:1;
        RBus_UInt32  i3ddma_uzd_drf_fail_group:1;
        RBus_UInt32  i3ddma_drf_fail_group:1;
    };
}i_bist_bisr_dispi_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_second_run_en:1;
    };
}i_bist_bisr_dispi_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_fail_group:1;
    };
}i_bist_bisr_dispi_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_mode:1;
    };
}i_bist_bisr_dispi_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_resume:1;
    };
}i_bist_bisr_dispi_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_done:1;
    };
}i_bist_bisr_dispi_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_pause:1;
    };
}i_bist_bisr_dispi_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_fail_group:1;
    };
}i_bist_bisr_dispi_bisr_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_bist_mode:1;
        RBus_UInt32  tchdr_plut_bist_mode:1;
        RBus_UInt32  tchdr_cdlut_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_bist_mode:1;
        RBus_UInt32  mvf_rdat_bist_mode:1;
        RBus_UInt32  dexcxl_wdat_bist_mode:1;
        RBus_UInt32  dexcxl_winfo_bist_mode:1;
        RBus_UInt32  dexcxl_rdat1_bist_mode:1;
        RBus_UInt32  dexcxl_rdat2_bist_mode:1;
        RBus_UInt32  dexcxl_rinfo_bist_mode:1;
    };
}i_bist_bisr_dispi_bist_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_bist_done:1;
        RBus_UInt32  tchdr_plut_bist_done:1;
        RBus_UInt32  tchdr_cdlut_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_bist_done:1;
        RBus_UInt32  mvf_rdat_bist_done:1;
        RBus_UInt32  dexcxl_wdat_bist_done:1;
        RBus_UInt32  dexcxl_winfo_bist_done:1;
        RBus_UInt32  dexcxl_rdat1_bist_done:1;
        RBus_UInt32  dexcxl_rdat2_bist_done:1;
        RBus_UInt32  dexcxl_rinfo_bist_done:1;
    };
}i_bist_bisr_dispi_bist_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_bist_fail_group:1;
        RBus_UInt32  tchdr_plut_bist_fail_group:1;
        RBus_UInt32  tchdr_cdlut_bist_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_bist_fail_group:1;
        RBus_UInt32  mvf_rdat_bist_fail_group:1;
        RBus_UInt32  dexcxl_wdat_bist_fail_group:1;
        RBus_UInt32  dexcxl_winfo_bist_fail_group:1;
        RBus_UInt32  dexcxl_rdat1_bist_fail_group:1;
        RBus_UInt32  dexcxl_rdat2_bist_fail_group:1;
        RBus_UInt32  dexcxl_rinfo_bist_fail_group:1;
    };
}i_bist_bisr_dispi_bist_fail_group_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_drf_bist_mode:1;
        RBus_UInt32  tchdr_plut_drf_bist_mode:1;
        RBus_UInt32  tchdr_cdlut_drf_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_drf_mode:1;
        RBus_UInt32  mvf_rdat_drf_mode:1;
        RBus_UInt32  dexcxl_wdat_drf_mode:1;
        RBus_UInt32  dexcxl_winfo_drf_mode:1;
        RBus_UInt32  dexcxl_rdat1_drf_mode:1;
        RBus_UInt32  dexcxl_rdat2_drf_mode:1;
        RBus_UInt32  dexcxl_rinfo_drf_mode:1;
    };
}i_bist_bisr_dispi_drf_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_drf_test_resume:1;
        RBus_UInt32  tchdr_plut_drf_test_resume:1;
        RBus_UInt32  tchdr_cdlut_drf_test_resume:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_drf_resume:1;
        RBus_UInt32  mvf_rdat_drf_resume:1;
        RBus_UInt32  dexcxl_wdat_drf_resume:1;
        RBus_UInt32  dexcxl_winfo_drf_resume:1;
        RBus_UInt32  dexcxl_rdat1_drf_resume:1;
        RBus_UInt32  dexcxl_rdat2_drf_resume:1;
        RBus_UInt32  dexcxl_rinfo_drf_resume:1;
    };
}i_bist_bisr_dispi_drf_resume_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_drf_bist_done:1;
        RBus_UInt32  tchdr_plut_drf_bist_done:1;
        RBus_UInt32  tchdr_cdlut_drf_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_drf_done:1;
        RBus_UInt32  mvf_rdat_drf_done:1;
        RBus_UInt32  dexcxl_wdat_drf_done:1;
        RBus_UInt32  dexcxl_winfo_drf_done:1;
        RBus_UInt32  dexcxl_rdat1_drf_done:1;
        RBus_UInt32  dexcxl_rdat2_drf_done:1;
        RBus_UInt32  dexcxl_rinfo_drf_done:1;
    };
}i_bist_bisr_dispi_drf_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_drf_start_pause:1;
        RBus_UInt32  tchdr_plut_drf_start_pause:1;
        RBus_UInt32  tchdr_cdlut_drf_start_pause:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_drf_pause:1;
        RBus_UInt32  mvf_rdat_drf_pause:1;
        RBus_UInt32  dexcxl_wdat_drf_pause:1;
        RBus_UInt32  dexcxl_winfo_drf_pause:1;
        RBus_UInt32  dexcxl_rdat1_drf_pause:1;
        RBus_UInt32  dexcxl_rdat2_drf_pause:1;
        RBus_UInt32  dexcxl_rinfo_drf_pause:1;
    };
}i_bist_bisr_dispi_drf_pause_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  tchdr_silut_drf_bist_fail_group:1;
        RBus_UInt32  tchdr_plut_drf_bist_fail_group:1;
        RBus_UInt32  tchdr_cdlut_drf_bist_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_rinfo_drf_fail_group:1;
        RBus_UInt32  mvf_rdat_drf_fail_group:1;
        RBus_UInt32  dexcxl_wdat_drf_fail_group:1;
        RBus_UInt32  dexcxl_winfo_drf_fail_group:1;
        RBus_UInt32  dexcxl_rdat1_drf_fail_group:1;
        RBus_UInt32  dexcxl_rdat2_drf_fail_group:1;
        RBus_UInt32  dexcxl_rinfo_drf_fail_group:1;
    };
}i_bist_bisr_dispi_drf_fail_group_1_RBUS;

#else //apply LITTLE_ENDIAN

//======I_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_bist_mode:1;
        RBus_UInt32  i3ddma_uzd_bist_mode:1;
        RBus_UInt32  di_li3_bist_mode:1;
        RBus_UInt32  di_li2_bist_mode:1;
        RBus_UInt32  di_li1_bist_mode:1;
        RBus_UInt32  di_dma_rdat_bist_mode:1;
        RBus_UInt32  di_dma_wdat_bist_mode:1;
        RBus_UInt32  di_hmc_bist_mode:1;
        RBus_UInt32  di_tr2to1_bist_mode:1;
        RBus_UInt32  sdnr_ch2_bist_mode:1;
        RBus_UInt32  sdnr_ch1_bist_mode:1;
        RBus_UInt32  i3ddma_bist_cap2_mode:1;
        RBus_UInt32  di_li5_bist_mode:1;
        RBus_UInt32  di_li4_bist_mode:1;
        RBus_UInt32  di_li7_bist_mode:1;
        RBus_UInt32  di_li6_bist_mode:1;
        RBus_UInt32  isnr_dma_wdat_bist_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_mode:1;
        RBus_UInt32  pqc2_bist_mode:1;
        RBus_UInt32  pqc1_bist_mode:1;
        RBus_UInt32  pqdc2_bist_mode:1;
        RBus_UInt32  pqdc1_bist_mode:1;
        RBus_UInt32  ch2_mbist_hist_2p_bist_mode:1;
        RBus_UInt32  ch2_mbist_hist_1p_bist_mode:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_mode:1;
        RBus_UInt32  ch1_mbist_hist_1p_bist_mode:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_bist_done:1;
        RBus_UInt32  i3ddma_uzd_bist_done:1;
        RBus_UInt32  di_li3_bist_done:1;
        RBus_UInt32  di_li2_bist_done:1;
        RBus_UInt32  di_li1_bist_done:1;
        RBus_UInt32  di_dma_rdat_bist_done:1;
        RBus_UInt32  di_dma_wdat_bist_done:1;
        RBus_UInt32  di_hmc_bist_done:1;
        RBus_UInt32  di_tr2to1_bist_done:1;
        RBus_UInt32  sdnr_ch2_bist_done:1;
        RBus_UInt32  sdnr_ch1_bist_done:1;
        RBus_UInt32  i3ddma_bist_cap2_done:1;
        RBus_UInt32  di_li5_bist_done:1;
        RBus_UInt32  di_li4_bist_done:1;
        RBus_UInt32  di_li7_bist_done:1;
        RBus_UInt32  di_li6_bist_done:1;
        RBus_UInt32  isnr_dma_wdat_bist_done:1;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_done:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_done:1;
        RBus_UInt32  pqc2_bist_done:1;
        RBus_UInt32  pqc1_bist_done:1;
        RBus_UInt32  pqdc2_bist_done:1;
        RBus_UInt32  pqdc1_bist_done:1;
        RBus_UInt32  ch2_mbist_hist_2p_bist_done:1;
        RBus_UInt32  ch2_mbist_hist_1p_bist_done:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_done:1;
        RBus_UInt32  ch1_mbist_hist_1p_bist_done:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_bist_fail_group:1;
        RBus_UInt32  i3ddma_uzd_bist_fail_group:1;
        RBus_UInt32  di_li3_bist_fail_group:1;
        RBus_UInt32  di_li2_bist_fail_group:1;
        RBus_UInt32  di_li1_bist_fail_group:1;
        RBus_UInt32  di_dma_rdat_bist_fail_group:1;
        RBus_UInt32  di_dma_wdat_bist_fail_group:1;
        RBus_UInt32  di_hmc_bist_fail_group:1;
        RBus_UInt32  di_tr2to1_bist_fail_group:1;
        RBus_UInt32  sdnr_ch2_bist_fail_group:1;
        RBus_UInt32  sdnr_ch1_bist_fail_group:1;
        RBus_UInt32  i3ddma_bist_cap2_fail_group:1;
        RBus_UInt32  di_li5_bist_fail_group:1;
        RBus_UInt32  di_li4_bist_fail_group:1;
        RBus_UInt32  di_li7_bist_fail_group:1;
        RBus_UInt32  di_li6_bist_fail_group:1;
        RBus_UInt32  isnr_dma_wdat_bist_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_fail_group:1;
        RBus_UInt32  pqc2_bist_fail_group:1;
        RBus_UInt32  pqc1_bist_fail_group:1;
        RBus_UInt32  pqdc2_bist_fail_group:1;
        RBus_UInt32  pqdc1_bist_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_2p_bist_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_1p_bist_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_1p_bist_fail_group:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_drf_mode:1;
        RBus_UInt32  i3ddma_uzd_drf_mode:1;
        RBus_UInt32  di_li3_drf_mode:1;
        RBus_UInt32  di_li2_drf_mode:1;
        RBus_UInt32  di_li1_drf_mode:1;
        RBus_UInt32  di_dma_rdat_drf_mode:1;
        RBus_UInt32  di_dma_wdat_drf_mode:1;
        RBus_UInt32  di_hmc_drf_mode:1;
        RBus_UInt32  di_tr2to1_drf_mode:1;
        RBus_UInt32  sdnr_ch2_drf_mode:1;
        RBus_UInt32  sdnr_ch1_drf_mode:1;
        RBus_UInt32  i3ddma_drf_cap2_mode:1;
        RBus_UInt32  di_li5_drf_mode:1;
        RBus_UInt32  di_li4_drf_mode:1;
        RBus_UInt32  di_li7_drf_mode:1;
        RBus_UInt32  di_li6_drf_mode:1;
        RBus_UInt32  isnr_dma_wdat_drf_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_mode:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_mode:1;
        RBus_UInt32  pqc2_drf_mode:1;
        RBus_UInt32  pqc1_drf_mode:1;
        RBus_UInt32  pqdc2_drf_mode:1;
        RBus_UInt32  pqdc1_drf_mode:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_mode:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_mode:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_mode:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_mode:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_drf_resume:1;
        RBus_UInt32  i3ddma_uzd_drf_resume:1;
        RBus_UInt32  di_li3_drf_resume:1;
        RBus_UInt32  di_li2_drf_resume:1;
        RBus_UInt32  di_li1_drf_resume:1;
        RBus_UInt32  di_dma_rdat_drf_resume:1;
        RBus_UInt32  di_dma_wdat_drf_resume:1;
        RBus_UInt32  di_hmc_drf_resume:1;
        RBus_UInt32  di_tr2to1_drf_resume:1;
        RBus_UInt32  sdnr_ch2_drf_resume:1;
        RBus_UInt32  sdnr_ch1_drf_resume:1;
        RBus_UInt32  i3ddma_drf_cap2_resume:1;
        RBus_UInt32  di_li5_drf_resume:1;
        RBus_UInt32  di_li4_drf_resume:1;
        RBus_UInt32  di_li7_drf_resume:1;
        RBus_UInt32  di_li6_drf_resume:1;
        RBus_UInt32  isnr_dma_wdat_drf_resume:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_resume:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_resume:1;
        RBus_UInt32  pqc2_drf_resume:1;
        RBus_UInt32  pqc1_drf_resume:1;
        RBus_UInt32  pqdc2_drf_resume:1;
        RBus_UInt32  pqdc1_drf_resume:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_resume:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_resume:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_resume:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_resume:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_drf_done:1;
        RBus_UInt32  i3ddma_uzd_drf_done:1;
        RBus_UInt32  di_li3_drf_done:1;
        RBus_UInt32  di_li2_drf_done:1;
        RBus_UInt32  di_li1_drf_done:1;
        RBus_UInt32  di_dma_rdat_drf_done:1;
        RBus_UInt32  di_dma_wdat_drf_done:1;
        RBus_UInt32  di_hmc_drf_done:1;
        RBus_UInt32  di_tr2to1_drf_done:1;
        RBus_UInt32  sdnr_ch2_drf_done:1;
        RBus_UInt32  sdnr_ch1_drf_done:1;
        RBus_UInt32  i3ddma_drf_cap2_done:1;
        RBus_UInt32  di_li5_drf_done:1;
        RBus_UInt32  di_li4_drf_done:1;
        RBus_UInt32  di_li7_drf_done:1;
        RBus_UInt32  di_li6_drf_done:1;
        RBus_UInt32  isnr_dma_wdat_drf_done:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_done:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_done:1;
        RBus_UInt32  pqc2_drf_done:1;
        RBus_UInt32  pqc1_drf_done:1;
        RBus_UInt32  pqdc2_drf_done:1;
        RBus_UInt32  pqdc1_drf_done:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_done:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_done:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_done:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_done:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_drf_pause:1;
        RBus_UInt32  i3ddma_uzd_drf_pause:1;
        RBus_UInt32  di_li3_drf_pause:1;
        RBus_UInt32  di_li2_drf_pause:1;
        RBus_UInt32  di_li1_drf_pause:1;
        RBus_UInt32  di_dma_rdat_drf_pause:1;
        RBus_UInt32  di_dma_wdat_drf_pause:1;
        RBus_UInt32  di_hmc_drf_pause:1;
        RBus_UInt32  di_tr2to1_drf_pause:1;
        RBus_UInt32  sdnr_ch2_drf_pause:1;
        RBus_UInt32  sdnr_ch1_drf_pause:1;
        RBus_UInt32  i3ddma_drf_cap2_pause:1;
        RBus_UInt32  di_li5_drf_pause:1;
        RBus_UInt32  di_li4_drf_pause:1;
        RBus_UInt32  di_li7_drf_pause:1;
        RBus_UInt32  di_li6_drf_pause:1;
        RBus_UInt32  isnr_dma_wdat_drf_pause:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_pause:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_pause:1;
        RBus_UInt32  pqc2_drf_pause:1;
        RBus_UInt32  pqc1_drf_pause:1;
        RBus_UInt32  pqdc2_drf_pause:1;
        RBus_UInt32  pqdc1_drf_pause:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_pause:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_pause:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_pause:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_pause:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_drf_fail_group:1;
        RBus_UInt32  i3ddma_uzd_drf_fail_group:1;
        RBus_UInt32  di_li3_drf_fail_group:1;
        RBus_UInt32  di_li2_drf_fail_group:1;
        RBus_UInt32  di_li1_drf_fail_group:1;
        RBus_UInt32  di_dma_rdat_drf_fail_group:1;
        RBus_UInt32  di_dma_wdat_drf_fail_group:1;
        RBus_UInt32  di_hmc_drf_fail_group:1;
        RBus_UInt32  di_tr2to1_drf_fail_group:1;
        RBus_UInt32  sdnr_ch2_drf_fail_group:1;
        RBus_UInt32  sdnr_ch1_drf_fail_group:1;
        RBus_UInt32  i3ddma_drf_cap2_fail_group:1;
        RBus_UInt32  di_li5_drf_fail_group:1;
        RBus_UInt32  di_li4_drf_fail_group:1;
        RBus_UInt32  di_li7_drf_fail_group:1;
        RBus_UInt32  di_li6_drf_fail_group:1;
        RBus_UInt32  isnr_dma_wdat_drf_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_fail_group:1;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_fail_group:1;
        RBus_UInt32  pqc2_drf_fail_group:1;
        RBus_UInt32  pqc1_drf_fail_group:1;
        RBus_UInt32  pqdc2_drf_fail_group:1;
        RBus_UInt32  pqdc1_drf_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_2p_drf_fail_group:1;
        RBus_UInt32  ch2_mbist_hist_1p_drf_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_fail_group:1;
        RBus_UInt32  res1:5;
    };
}i_bist_bisr_dispi_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_second_run_en:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_fail_group:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_mode:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_resume:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_done:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_pause:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_fail_group:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_bist_mode:1;
        RBus_UInt32  dexcxl_rdat2_bist_mode:1;
        RBus_UInt32  dexcxl_rdat1_bist_mode:1;
        RBus_UInt32  dexcxl_winfo_bist_mode:1;
        RBus_UInt32  dexcxl_wdat_bist_mode:1;
        RBus_UInt32  mvf_rdat_bist_mode:1;
        RBus_UInt32  mvf_rinfo_bist_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_bist_mode:1;
        RBus_UInt32  tchdr_plut_bist_mode:1;
        RBus_UInt32  tchdr_silut_bist_mode:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_bist_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_bist_done:1;
        RBus_UInt32  dexcxl_rdat2_bist_done:1;
        RBus_UInt32  dexcxl_rdat1_bist_done:1;
        RBus_UInt32  dexcxl_winfo_bist_done:1;
        RBus_UInt32  dexcxl_wdat_bist_done:1;
        RBus_UInt32  mvf_rdat_bist_done:1;
        RBus_UInt32  mvf_rinfo_bist_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_bist_done:1;
        RBus_UInt32  tchdr_plut_bist_done:1;
        RBus_UInt32  tchdr_silut_bist_done:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_bist_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_bist_fail_group:1;
        RBus_UInt32  dexcxl_rdat2_bist_fail_group:1;
        RBus_UInt32  dexcxl_rdat1_bist_fail_group:1;
        RBus_UInt32  dexcxl_winfo_bist_fail_group:1;
        RBus_UInt32  dexcxl_wdat_bist_fail_group:1;
        RBus_UInt32  mvf_rdat_bist_fail_group:1;
        RBus_UInt32  mvf_rinfo_bist_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_bist_fail_group:1;
        RBus_UInt32  tchdr_plut_bist_fail_group:1;
        RBus_UInt32  tchdr_silut_bist_fail_group:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_bist_fail_group_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_drf_mode:1;
        RBus_UInt32  dexcxl_rdat2_drf_mode:1;
        RBus_UInt32  dexcxl_rdat1_drf_mode:1;
        RBus_UInt32  dexcxl_winfo_drf_mode:1;
        RBus_UInt32  dexcxl_wdat_drf_mode:1;
        RBus_UInt32  mvf_rdat_drf_mode:1;
        RBus_UInt32  mvf_rinfo_drf_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_drf_bist_mode:1;
        RBus_UInt32  tchdr_plut_drf_bist_mode:1;
        RBus_UInt32  tchdr_silut_drf_bist_mode:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_drf_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_drf_resume:1;
        RBus_UInt32  dexcxl_rdat2_drf_resume:1;
        RBus_UInt32  dexcxl_rdat1_drf_resume:1;
        RBus_UInt32  dexcxl_winfo_drf_resume:1;
        RBus_UInt32  dexcxl_wdat_drf_resume:1;
        RBus_UInt32  mvf_rdat_drf_resume:1;
        RBus_UInt32  mvf_rinfo_drf_resume:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_drf_test_resume:1;
        RBus_UInt32  tchdr_plut_drf_test_resume:1;
        RBus_UInt32  tchdr_silut_drf_test_resume:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_drf_resume_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_drf_done:1;
        RBus_UInt32  dexcxl_rdat2_drf_done:1;
        RBus_UInt32  dexcxl_rdat1_drf_done:1;
        RBus_UInt32  dexcxl_winfo_drf_done:1;
        RBus_UInt32  dexcxl_wdat_drf_done:1;
        RBus_UInt32  mvf_rdat_drf_done:1;
        RBus_UInt32  mvf_rinfo_drf_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_drf_bist_done:1;
        RBus_UInt32  tchdr_plut_drf_bist_done:1;
        RBus_UInt32  tchdr_silut_drf_bist_done:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_drf_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_drf_pause:1;
        RBus_UInt32  dexcxl_rdat2_drf_pause:1;
        RBus_UInt32  dexcxl_rdat1_drf_pause:1;
        RBus_UInt32  dexcxl_winfo_drf_pause:1;
        RBus_UInt32  dexcxl_wdat_drf_pause:1;
        RBus_UInt32  mvf_rdat_drf_pause:1;
        RBus_UInt32  mvf_rinfo_drf_pause:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_drf_start_pause:1;
        RBus_UInt32  tchdr_plut_drf_start_pause:1;
        RBus_UInt32  tchdr_silut_drf_start_pause:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_drf_pause_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dexcxl_rinfo_drf_fail_group:1;
        RBus_UInt32  dexcxl_rdat2_drf_fail_group:1;
        RBus_UInt32  dexcxl_rdat1_drf_fail_group:1;
        RBus_UInt32  dexcxl_winfo_drf_fail_group:1;
        RBus_UInt32  dexcxl_wdat_drf_fail_group:1;
        RBus_UInt32  mvf_rdat_drf_fail_group:1;
        RBus_UInt32  mvf_rinfo_drf_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tchdr_cdlut_drf_bist_fail_group:1;
        RBus_UInt32  tchdr_plut_drf_bist_fail_group:1;
        RBus_UInt32  tchdr_silut_drf_bist_fail_group:1;
        RBus_UInt32  res2:21;
    };
}i_bist_bisr_dispi_drf_fail_group_1_RBUS;




#endif 


#endif 
