/**
* @file Merlin4-DesignSpec-I-Domain-Decontour
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_IPQ_DECONTOUR_REG_H_
#define _RBUS_IPQ_DECONTOUR_REG_H_

#include "rbus_types.h"



//  IPQ_DECONTOUR Register Address
#define  IPQ_DECONTOUR_De_Contour_CTRL                                           0x18025700
#define  IPQ_DECONTOUR_De_Contour_CTRL_reg_addr                                  "0xB8025700"
#define  IPQ_DECONTOUR_De_Contour_CTRL_reg                                       0xB8025700
#define  IPQ_DECONTOUR_De_Contour_CTRL_inst_addr                                 "0x0000"
#define  set_IPQ_DECONTOUR_De_Contour_CTRL_reg(data)                             (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_CTRL_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_CTRL_reg                                   (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_CTRL_reg))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_en_shift                           (31)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_neighbor_far_shift                 (30)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_debug_en_shift                     (29)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_debug_mode_shift                   (28)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_filter_mode_shift                  (27)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_yc_mode_shift                      (25)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_line_mode_shift                    (24)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_bottleneck_en_shift                (23)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_weight_lpf_en_shift          (22)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_lowbd_shift                  (8)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_step_shift                   (4)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_snr_blend_mode_shift               (0)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_en_mask                            (0x80000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_neighbor_far_mask                  (0x40000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_debug_en_mask                      (0x20000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_debug_mode_mask                    (0x10000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_filter_mode_mask                   (0x08000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_yc_mode_mask                       (0x06000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_line_mode_mask                     (0x01000000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_bottleneck_en_mask                 (0x00800000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_weight_lpf_en_mask           (0x00400000)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_lowbd_mask                   (0x0000FF00)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_step_mask                    (0x00000030)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_snr_blend_mode_mask                (0x00000003)
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_en(data)                           (0x80000000&((data)<<31))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_neighbor_far(data)                 (0x40000000&((data)<<30))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_debug_en(data)                     (0x20000000&((data)<<29))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_debug_mode(data)                   (0x10000000&((data)<<28))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_filter_mode(data)                  (0x08000000&((data)<<27))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_yc_mode(data)                      (0x06000000&((data)<<25))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_line_mode(data)                    (0x01000000&((data)<<24))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_bottleneck_en(data)                (0x00800000&((data)<<23))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_weight_lpf_en(data)          (0x00400000&((data)<<22))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_lowbd(data)                  (0x0000FF00&((data)<<8))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_blend_step(data)                   (0x00000030&((data)<<4))
#define  IPQ_DECONTOUR_De_Contour_CTRL_decont_snr_blend_mode(data)               (0x00000003&(data))
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_en(data)                       ((0x80000000&(data))>>31)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_neighbor_far(data)             ((0x40000000&(data))>>30)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_debug_en(data)                 ((0x20000000&(data))>>29)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_debug_mode(data)               ((0x10000000&(data))>>28)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_filter_mode(data)              ((0x08000000&(data))>>27)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_yc_mode(data)                  ((0x06000000&(data))>>25)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_line_mode(data)                ((0x01000000&(data))>>24)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_bottleneck_en(data)            ((0x00800000&(data))>>23)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_blend_weight_lpf_en(data)      ((0x00400000&(data))>>22)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_blend_lowbd(data)              ((0x0000FF00&(data))>>8)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_blend_step(data)               ((0x00000030&(data))>>4)
#define  IPQ_DECONTOUR_De_Contour_CTRL_get_decont_snr_blend_mode(data)           (0x00000003&(data))

#define  IPQ_DECONTOUR_De_Contour_Contrast                                       0x18025704
#define  IPQ_DECONTOUR_De_Contour_Contrast_reg_addr                              "0xB8025704"
#define  IPQ_DECONTOUR_De_Contour_Contrast_reg                                   0xB8025704
#define  IPQ_DECONTOUR_De_Contour_Contrast_inst_addr                             "0x0001"
#define  set_IPQ_DECONTOUR_De_Contour_Contrast_reg(data)                         (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Contrast_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Contrast_reg                               (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Contrast_reg))
#define  IPQ_DECONTOUR_De_Contour_Contrast_decont_contrast_th_y_shift            (16)
#define  IPQ_DECONTOUR_De_Contour_Contrast_decont_contrast_th_c_shift            (0)
#define  IPQ_DECONTOUR_De_Contour_Contrast_decont_contrast_th_y_mask             (0x00FF0000)
#define  IPQ_DECONTOUR_De_Contour_Contrast_decont_contrast_th_c_mask             (0x000001FF)
#define  IPQ_DECONTOUR_De_Contour_Contrast_decont_contrast_th_y(data)            (0x00FF0000&((data)<<16))
#define  IPQ_DECONTOUR_De_Contour_Contrast_decont_contrast_th_c(data)            (0x000001FF&(data))
#define  IPQ_DECONTOUR_De_Contour_Contrast_get_decont_contrast_th_y(data)        ((0x00FF0000&(data))>>16)
#define  IPQ_DECONTOUR_De_Contour_Contrast_get_decont_contrast_th_c(data)        (0x000001FF&(data))

#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff                                  0x18025708
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_reg_addr                         "0xB8025708"
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_reg                              0xB8025708
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_inst_addr                        "0x0002"
#define  set_IPQ_DECONTOUR_De_Contour_Neighbor_Diff_reg(data)                    (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Neighbor_Diff_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Neighbor_Diff_reg                          (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Neighbor_Diff_reg))
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th2_y_shift (24)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th_y_shift  (16)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th2_c_shift (8)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th_c_shift  (0)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th2_y_mask  (0x3F000000)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th_y_mask   (0x003F0000)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th2_c_mask  (0x00003F00)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th_c_mask   (0x0000003F)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th2_y(data) (0x3F000000&((data)<<24))
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th_y(data)  (0x003F0000&((data)<<16))
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th2_c(data) (0x00003F00&((data)<<8))
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_decont_neighbor_diff_th_c(data)  (0x0000003F&(data))
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_get_decont_neighbor_diff_th2_y(data) ((0x3F000000&(data))>>24)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_get_decont_neighbor_diff_th_y(data) ((0x003F0000&(data))>>16)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_get_decont_neighbor_diff_th2_c(data) ((0x00003F00&(data))>>8)
#define  IPQ_DECONTOUR_De_Contour_Neighbor_Diff_get_decont_neighbor_diff_th_c(data) (0x0000003F&(data))

#define  IPQ_DECONTOUR_De_Contour_Threshold                                      0x1802570C
#define  IPQ_DECONTOUR_De_Contour_Threshold_reg_addr                             "0xB802570C"
#define  IPQ_DECONTOUR_De_Contour_Threshold_reg                                  0xB802570C
#define  IPQ_DECONTOUR_De_Contour_Threshold_inst_addr                            "0x0003"
#define  set_IPQ_DECONTOUR_De_Contour_Threshold_reg(data)                        (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Threshold_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Threshold_reg                              (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Threshold_reg))
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_gradation_th_y_shift          (26)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_dark_th_shift                 (16)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_gradation_th_c_shift          (8)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_dark_contrast_th_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_gradation_th_y_mask           (0x7C000000)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_dark_th_mask                  (0x03FF0000)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_gradation_th_c_mask           (0x00001F00)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_dark_contrast_th_mask         (0x000000FF)
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_gradation_th_y(data)          (0x7C000000&((data)<<26))
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_dark_th(data)                 (0x03FF0000&((data)<<16))
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_gradation_th_c(data)          (0x00001F00&((data)<<8))
#define  IPQ_DECONTOUR_De_Contour_Threshold_decont_dark_contrast_th(data)        (0x000000FF&(data))
#define  IPQ_DECONTOUR_De_Contour_Threshold_get_decont_gradation_th_y(data)      ((0x7C000000&(data))>>26)
#define  IPQ_DECONTOUR_De_Contour_Threshold_get_decont_dark_th(data)             ((0x03FF0000&(data))>>16)
#define  IPQ_DECONTOUR_De_Contour_Threshold_get_decont_gradation_th_c(data)      ((0x00001F00&(data))>>8)
#define  IPQ_DECONTOUR_De_Contour_Threshold_get_decont_dark_contrast_th(data)    (0x000000FF&(data))

#define  IPQ_DECONTOUR_De_Contour_Diff_th                                        0x18025710
#define  IPQ_DECONTOUR_De_Contour_Diff_th_reg_addr                               "0xB8025710"
#define  IPQ_DECONTOUR_De_Contour_Diff_th_reg                                    0xB8025710
#define  IPQ_DECONTOUR_De_Contour_Diff_th_inst_addr                              "0x0004"
#define  set_IPQ_DECONTOUR_De_Contour_Diff_th_reg(data)                          (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Diff_th_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Diff_th_reg                                (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Diff_th_reg))
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_blend_lv1_gain_shift            (16)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_maxmindiff_th_c_shift           (8)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_maxmindiff_th_y_shift           (0)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_blend_lv1_gain_mask             (0x00070000)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_maxmindiff_th_c_mask            (0x0000FF00)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_maxmindiff_th_y_mask            (0x000000FF)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_blend_lv1_gain(data)            (0x00070000&((data)<<16))
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_maxmindiff_th_c(data)           (0x0000FF00&((data)<<8))
#define  IPQ_DECONTOUR_De_Contour_Diff_th_decont_maxmindiff_th_y(data)           (0x000000FF&(data))
#define  IPQ_DECONTOUR_De_Contour_Diff_th_get_decont_blend_lv1_gain(data)        ((0x00070000&(data))>>16)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_get_decont_maxmindiff_th_c(data)       ((0x0000FF00&(data))>>8)
#define  IPQ_DECONTOUR_De_Contour_Diff_th_get_decont_maxmindiff_th_y(data)       (0x000000FF&(data))

#define  IPQ_DECONTOUR_De_Contour_Counter                                        0x18025714
#define  IPQ_DECONTOUR_De_Contour_Counter_reg_addr                               "0xB8025714"
#define  IPQ_DECONTOUR_De_Contour_Counter_reg                                    0xB8025714
#define  IPQ_DECONTOUR_De_Contour_Counter_inst_addr                              "0x0005"
#define  set_IPQ_DECONTOUR_De_Contour_Counter_reg(data)                          (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Counter_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Counter_reg                                (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Counter_reg))
#define  IPQ_DECONTOUR_De_Contour_Counter_decont_contour_cnt_shift               (0)
#define  IPQ_DECONTOUR_De_Contour_Counter_decont_contour_cnt_mask                (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Counter_decont_contour_cnt(data)               (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Counter_get_decont_contour_cnt(data)           (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter                               0x18025718
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_reg_addr                      "0xB8025718"
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_reg                           0xB8025718
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_inst_addr                     "0x0006"
#define  set_IPQ_DECONTOUR_De_Contour_Avfilter_Counter_reg(data)                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Avfilter_Counter_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Avfilter_Counter_reg                       (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Avfilter_Counter_reg))
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_decont_avfilter_cnt_shift     (0)
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_decont_avfilter_cnt_mask      (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_decont_avfilter_cnt(data)     (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Avfilter_Counter_get_decont_avfilter_cnt(data) (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist0                                          0x1802571C
#define  IPQ_DECONTOUR_De_Contour_Hist0_reg_addr                                 "0xB802571C"
#define  IPQ_DECONTOUR_De_Contour_Hist0_reg                                      0xB802571C
#define  IPQ_DECONTOUR_De_Contour_Hist0_inst_addr                                "0x0007"
#define  set_IPQ_DECONTOUR_De_Contour_Hist0_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist0_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist0_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist0_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist0_decont_filter_range_hist0_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist0_decont_filter_range_hist0_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist0_decont_filter_range_hist0(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist0_get_decont_filter_range_hist0(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist1                                          0x18025720
#define  IPQ_DECONTOUR_De_Contour_Hist1_reg_addr                                 "0xB8025720"
#define  IPQ_DECONTOUR_De_Contour_Hist1_reg                                      0xB8025720
#define  IPQ_DECONTOUR_De_Contour_Hist1_inst_addr                                "0x0008"
#define  set_IPQ_DECONTOUR_De_Contour_Hist1_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist1_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist1_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist1_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist1_decont_filter_range_hist1_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist1_decont_filter_range_hist1_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist1_decont_filter_range_hist1(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist1_get_decont_filter_range_hist1(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist2                                          0x18025724
#define  IPQ_DECONTOUR_De_Contour_Hist2_reg_addr                                 "0xB8025724"
#define  IPQ_DECONTOUR_De_Contour_Hist2_reg                                      0xB8025724
#define  IPQ_DECONTOUR_De_Contour_Hist2_inst_addr                                "0x0009"
#define  set_IPQ_DECONTOUR_De_Contour_Hist2_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist2_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist2_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist2_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist2_decont_filter_range_hist2_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist2_decont_filter_range_hist2_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist2_decont_filter_range_hist2(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist2_get_decont_filter_range_hist2(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist3                                          0x18025728
#define  IPQ_DECONTOUR_De_Contour_Hist3_reg_addr                                 "0xB8025728"
#define  IPQ_DECONTOUR_De_Contour_Hist3_reg                                      0xB8025728
#define  IPQ_DECONTOUR_De_Contour_Hist3_inst_addr                                "0x000A"
#define  set_IPQ_DECONTOUR_De_Contour_Hist3_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist3_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist3_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist3_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist3_decont_filter_range_hist3_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist3_decont_filter_range_hist3_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist3_decont_filter_range_hist3(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist3_get_decont_filter_range_hist3(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist4                                          0x1802572C
#define  IPQ_DECONTOUR_De_Contour_Hist4_reg_addr                                 "0xB802572C"
#define  IPQ_DECONTOUR_De_Contour_Hist4_reg                                      0xB802572C
#define  IPQ_DECONTOUR_De_Contour_Hist4_inst_addr                                "0x000B"
#define  set_IPQ_DECONTOUR_De_Contour_Hist4_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist4_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist4_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist4_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist4_decont_filter_range_hist4_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist4_decont_filter_range_hist4_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist4_decont_filter_range_hist4(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist4_get_decont_filter_range_hist4(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist5                                          0x18025730
#define  IPQ_DECONTOUR_De_Contour_Hist5_reg_addr                                 "0xB8025730"
#define  IPQ_DECONTOUR_De_Contour_Hist5_reg                                      0xB8025730
#define  IPQ_DECONTOUR_De_Contour_Hist5_inst_addr                                "0x000C"
#define  set_IPQ_DECONTOUR_De_Contour_Hist5_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist5_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist5_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist5_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist5_decont_filter_range_hist5_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist5_decont_filter_range_hist5_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist5_decont_filter_range_hist5(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist5_get_decont_filter_range_hist5(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist6                                          0x18025734
#define  IPQ_DECONTOUR_De_Contour_Hist6_reg_addr                                 "0xB8025734"
#define  IPQ_DECONTOUR_De_Contour_Hist6_reg                                      0xB8025734
#define  IPQ_DECONTOUR_De_Contour_Hist6_inst_addr                                "0x000D"
#define  set_IPQ_DECONTOUR_De_Contour_Hist6_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist6_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist6_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist6_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist6_decont_filter_range_hist6_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist6_decont_filter_range_hist6_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist6_decont_filter_range_hist6(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist6_get_decont_filter_range_hist6(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist7                                          0x18025738
#define  IPQ_DECONTOUR_De_Contour_Hist7_reg_addr                                 "0xB8025738"
#define  IPQ_DECONTOUR_De_Contour_Hist7_reg                                      0xB8025738
#define  IPQ_DECONTOUR_De_Contour_Hist7_inst_addr                                "0x000E"
#define  set_IPQ_DECONTOUR_De_Contour_Hist7_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist7_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist7_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist7_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist7_decont_filter_range_hist7_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist7_decont_filter_range_hist7_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist7_decont_filter_range_hist7(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist7_get_decont_filter_range_hist7(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist8                                          0x1802573C
#define  IPQ_DECONTOUR_De_Contour_Hist8_reg_addr                                 "0xB802573C"
#define  IPQ_DECONTOUR_De_Contour_Hist8_reg                                      0xB802573C
#define  IPQ_DECONTOUR_De_Contour_Hist8_inst_addr                                "0x000F"
#define  set_IPQ_DECONTOUR_De_Contour_Hist8_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist8_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist8_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist8_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist8_decont_filter_range_hist8_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist8_decont_filter_range_hist8_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist8_decont_filter_range_hist8(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist8_get_decont_filter_range_hist8(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist9                                          0x18025740
#define  IPQ_DECONTOUR_De_Contour_Hist9_reg_addr                                 "0xB8025740"
#define  IPQ_DECONTOUR_De_Contour_Hist9_reg                                      0xB8025740
#define  IPQ_DECONTOUR_De_Contour_Hist9_inst_addr                                "0x0010"
#define  set_IPQ_DECONTOUR_De_Contour_Hist9_reg(data)                            (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist9_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist9_reg                                  (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist9_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist9_decont_filter_range_hist9_shift          (0)
#define  IPQ_DECONTOUR_De_Contour_Hist9_decont_filter_range_hist9_mask           (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist9_decont_filter_range_hist9(data)          (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist9_get_decont_filter_range_hist9(data)      (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist10                                         0x18025744
#define  IPQ_DECONTOUR_De_Contour_Hist10_reg_addr                                "0xB8025744"
#define  IPQ_DECONTOUR_De_Contour_Hist10_reg                                     0xB8025744
#define  IPQ_DECONTOUR_De_Contour_Hist10_inst_addr                               "0x0011"
#define  set_IPQ_DECONTOUR_De_Contour_Hist10_reg(data)                           (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist10_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist10_reg                                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist10_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist10_decont_filter_range_hist10_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Hist10_decont_filter_range_hist10_mask         (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist10_decont_filter_range_hist10(data)        (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist10_get_decont_filter_range_hist10(data)    (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist11                                         0x18025748
#define  IPQ_DECONTOUR_De_Contour_Hist11_reg_addr                                "0xB8025748"
#define  IPQ_DECONTOUR_De_Contour_Hist11_reg                                     0xB8025748
#define  IPQ_DECONTOUR_De_Contour_Hist11_inst_addr                               "0x0012"
#define  set_IPQ_DECONTOUR_De_Contour_Hist11_reg(data)                           (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist11_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist11_reg                                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist11_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist11_decont_filter_range_hist11_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Hist11_decont_filter_range_hist11_mask         (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist11_decont_filter_range_hist11(data)        (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist11_get_decont_filter_range_hist11(data)    (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist12                                         0x1802574C
#define  IPQ_DECONTOUR_De_Contour_Hist12_reg_addr                                "0xB802574C"
#define  IPQ_DECONTOUR_De_Contour_Hist12_reg                                     0xB802574C
#define  IPQ_DECONTOUR_De_Contour_Hist12_inst_addr                               "0x0013"
#define  set_IPQ_DECONTOUR_De_Contour_Hist12_reg(data)                           (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist12_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist12_reg                                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist12_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist12_decont_filter_range_hist12_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Hist12_decont_filter_range_hist12_mask         (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist12_decont_filter_range_hist12(data)        (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist12_get_decont_filter_range_hist12(data)    (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist13                                         0x18025750
#define  IPQ_DECONTOUR_De_Contour_Hist13_reg_addr                                "0xB8025750"
#define  IPQ_DECONTOUR_De_Contour_Hist13_reg                                     0xB8025750
#define  IPQ_DECONTOUR_De_Contour_Hist13_inst_addr                               "0x0014"
#define  set_IPQ_DECONTOUR_De_Contour_Hist13_reg(data)                           (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist13_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist13_reg                                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist13_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist13_decont_filter_range_hist13_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Hist13_decont_filter_range_hist13_mask         (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist13_decont_filter_range_hist13(data)        (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist13_get_decont_filter_range_hist13(data)    (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist14                                         0x18025754
#define  IPQ_DECONTOUR_De_Contour_Hist14_reg_addr                                "0xB8025754"
#define  IPQ_DECONTOUR_De_Contour_Hist14_reg                                     0xB8025754
#define  IPQ_DECONTOUR_De_Contour_Hist14_inst_addr                               "0x0015"
#define  set_IPQ_DECONTOUR_De_Contour_Hist14_reg(data)                           (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist14_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist14_reg                                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist14_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist14_decont_filter_range_hist14_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Hist14_decont_filter_range_hist14_mask         (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist14_decont_filter_range_hist14(data)        (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist14_get_decont_filter_range_hist14(data)    (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_Hist15                                         0x18025758
#define  IPQ_DECONTOUR_De_Contour_Hist15_reg_addr                                "0xB8025758"
#define  IPQ_DECONTOUR_De_Contour_Hist15_reg                                     0xB8025758
#define  IPQ_DECONTOUR_De_Contour_Hist15_inst_addr                               "0x0016"
#define  set_IPQ_DECONTOUR_De_Contour_Hist15_reg(data)                           (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist15_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Hist15_reg                                 (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Hist15_reg))
#define  IPQ_DECONTOUR_De_Contour_Hist15_decont_filter_range_hist15_shift        (0)
#define  IPQ_DECONTOUR_De_Contour_Hist15_decont_filter_range_hist15_mask         (0x00FFFFFF)
#define  IPQ_DECONTOUR_De_Contour_Hist15_decont_filter_range_hist15(data)        (0x00FFFFFF&(data))
#define  IPQ_DECONTOUR_De_Contour_Hist15_get_decont_filter_range_hist15(data)    (0x00FFFFFF&(data))

#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl                                     0x1802575C
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_reg_addr                            "0xB802575C"
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_reg                                 0xB802575C
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_inst_addr                           "0x0017"
#define  set_IPQ_DECONTOUR_De_Contour_db_reg_ctl_reg(data)                       (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_db_reg_ctl_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_db_reg_ctl_reg                             (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_db_reg_ctl_reg))
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_read_shift                       (2)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_en_shift                         (1)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_apply_shift                      (0)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_read_mask                        (0x00000004)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_en_mask                          (0x00000002)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_apply_mask                       (0x00000001)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_read(data)                       (0x00000004&((data)<<2))
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_en(data)                         (0x00000002&((data)<<1))
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_db_apply(data)                      (0x00000001&(data))
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_get_db_read(data)                   ((0x00000004&(data))>>2)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_get_db_en(data)                     ((0x00000002&(data))>>1)
#define  IPQ_DECONTOUR_De_Contour_db_reg_ctl_get_db_apply(data)                  (0x00000001&(data))

#define  IPQ_DECONTOUR_De_Contour_Bottleneck                                     0x18025760
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_reg_addr                            "0xB8025760"
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_reg                                 0xB8025760
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_inst_addr                           "0x0018"
#define  set_IPQ_DECONTOUR_De_Contour_Bottleneck_reg(data)                       (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Bottleneck_reg)=data)
#define  get_IPQ_DECONTOUR_De_Contour_Bottleneck_reg                             (*((volatile unsigned int*)IPQ_DECONTOUR_De_Contour_Bottleneck_reg))
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range4_shift      (16)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range3_shift      (12)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range2_shift      (8)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range1_shift      (4)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range0_shift      (0)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range4_mask       (0x000F0000)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range3_mask       (0x0000F000)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range2_mask       (0x00000F00)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range1_mask       (0x000000F0)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range0_mask       (0x0000000F)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range4(data)      (0x000F0000&((data)<<16))
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range3(data)      (0x0000F000&((data)<<12))
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range2(data)      (0x00000F00&((data)<<8))
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range1(data)      (0x000000F0&((data)<<4))
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_decont_bottleneck_range0(data)      (0x0000000F&(data))
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_get_decont_bottleneck_range4(data)  ((0x000F0000&(data))>>16)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_get_decont_bottleneck_range3(data)  ((0x0000F000&(data))>>12)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_get_decont_bottleneck_range2(data)  ((0x00000F00&(data))>>8)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_get_decont_bottleneck_range1(data)  ((0x000000F0&(data))>>4)
#define  IPQ_DECONTOUR_De_Contour_Bottleneck_get_decont_bottleneck_range0(data)  (0x0000000F&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======IPQ_DECONTOUR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_en:1;
        RBus_UInt32  decont_neighbor_far:1;
        RBus_UInt32  decont_debug_en:1;
        RBus_UInt32  decont_debug_mode:1;
        RBus_UInt32  decont_filter_mode:1;
        RBus_UInt32  decont_yc_mode:2;
        RBus_UInt32  decont_line_mode:1;
        RBus_UInt32  decont_bottleneck_en:1;
        RBus_UInt32  decont_blend_weight_lpf_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_blend_lowbd:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_blend_step:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  decont_snr_blend_mode:2;
    };
}ipq_decontour_de_contour_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_contrast_th_y:8;
        RBus_UInt32  res2:7;
        RBus_UInt32  decont_contrast_th_c:9;
    };
}ipq_decontour_de_contour_contrast_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_neighbor_diff_th2_y:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_neighbor_diff_th_y:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  decont_neighbor_diff_th2_c:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  decont_neighbor_diff_th_c:6;
    };
}ipq_decontour_de_contour_neighbor_diff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  decont_gradation_th_y:5;
        RBus_UInt32  decont_dark_th:10;
        RBus_UInt32  res2:3;
        RBus_UInt32  decont_gradation_th_c:5;
        RBus_UInt32  decont_dark_contrast_th:8;
    };
}ipq_decontour_de_contour_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  decont_blend_lv1_gain:3;
        RBus_UInt32  decont_maxmindiff_th_c:8;
        RBus_UInt32  decont_maxmindiff_th_y:8;
    };
}ipq_decontour_de_contour_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_contour_cnt:24;
    };
}ipq_decontour_de_contour_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_avfilter_cnt:24;
    };
}ipq_decontour_de_contour_avfilter_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist0:24;
    };
}ipq_decontour_de_contour_hist0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist1:24;
    };
}ipq_decontour_de_contour_hist1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist2:24;
    };
}ipq_decontour_de_contour_hist2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist3:24;
    };
}ipq_decontour_de_contour_hist3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist4:24;
    };
}ipq_decontour_de_contour_hist4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist5:24;
    };
}ipq_decontour_de_contour_hist5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist6:24;
    };
}ipq_decontour_de_contour_hist6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist7:24;
    };
}ipq_decontour_de_contour_hist7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist8:24;
    };
}ipq_decontour_de_contour_hist8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist9:24;
    };
}ipq_decontour_de_contour_hist9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist10:24;
    };
}ipq_decontour_de_contour_hist10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist11:24;
    };
}ipq_decontour_de_contour_hist11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist12:24;
    };
}ipq_decontour_de_contour_hist12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist13:24;
    };
}ipq_decontour_de_contour_hist13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist14:24;
    };
}ipq_decontour_de_contour_hist14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist15:24;
    };
}ipq_decontour_de_contour_hist15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_apply:1;
    };
}ipq_decontour_de_contour_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  decont_bottleneck_range4:4;
        RBus_UInt32  decont_bottleneck_range3:4;
        RBus_UInt32  decont_bottleneck_range2:4;
        RBus_UInt32  decont_bottleneck_range1:4;
        RBus_UInt32  decont_bottleneck_range0:4;
    };
}ipq_decontour_de_contour_bottleneck_RBUS;

#else //apply LITTLE_ENDIAN

//======IPQ_DECONTOUR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_snr_blend_mode:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_blend_step:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_blend_lowbd:8;
        RBus_UInt32  res3:6;
        RBus_UInt32  decont_blend_weight_lpf_en:1;
        RBus_UInt32  decont_bottleneck_en:1;
        RBus_UInt32  decont_line_mode:1;
        RBus_UInt32  decont_yc_mode:2;
        RBus_UInt32  decont_filter_mode:1;
        RBus_UInt32  decont_debug_mode:1;
        RBus_UInt32  decont_debug_en:1;
        RBus_UInt32  decont_neighbor_far:1;
        RBus_UInt32  decont_en:1;
    };
}ipq_decontour_de_contour_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contrast_th_c:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  decont_contrast_th_y:8;
        RBus_UInt32  res2:8;
    };
}ipq_decontour_de_contour_contrast_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_neighbor_diff_th_c:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_neighbor_diff_th2_c:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_neighbor_diff_th_y:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  decont_neighbor_diff_th2_y:6;
        RBus_UInt32  res4:2;
    };
}ipq_decontour_de_contour_neighbor_diff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_dark_contrast_th:8;
        RBus_UInt32  decont_gradation_th_c:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  decont_dark_th:10;
        RBus_UInt32  decont_gradation_th_y:5;
        RBus_UInt32  res2:1;
    };
}ipq_decontour_de_contour_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_maxmindiff_th_y:8;
        RBus_UInt32  decont_maxmindiff_th_c:8;
        RBus_UInt32  decont_blend_lv1_gain:3;
        RBus_UInt32  res1:13;
    };
}ipq_decontour_de_contour_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contour_cnt:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_avfilter_cnt:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_avfilter_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist0:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist1:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist2:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist3:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist4:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist5:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist6:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist7:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist8:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist9:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist10:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist11:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist12:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist13:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist14:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist15:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read:1;
        RBus_UInt32  res1:29;
    };
}ipq_decontour_de_contour_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_bottleneck_range0:4;
        RBus_UInt32  decont_bottleneck_range1:4;
        RBus_UInt32  decont_bottleneck_range2:4;
        RBus_UInt32  decont_bottleneck_range3:4;
        RBus_UInt32  decont_bottleneck_range4:4;
        RBus_UInt32  res1:12;
    };
}ipq_decontour_de_contour_bottleneck_RBUS;




#endif 


#endif 
