#ifndef READ_DEF_H
#define READ_DEF_H


#define RBUS_PATCH 0

#if RBUS_PATCH

#ifdef rtd_inl
#undef rtd_inl
#endif


#define rtd_inl(addr)  rtd_r3_inl(addr)
#define rtk_getl(a)          (*(volatile unsigned int *)(a))


#define RBUS_BASE_VIRT_1          0x18000000
#define RBUS_BASE_VIRT_OLD_1      0xb8000000
#define RBUS_BASE_SIZE_1          0x00200000
#define SPI_FLASH_BASE_VIRT_1         0x18200000
#define SPI_FLASH_BASE_VIRT_OLD_1     0xb8200000
#define SPI_FLASH_BASE_SIZE_1     0x02000000


static inline unsigned int rtd_r3_inl(unsigned int addr)
{
	unsigned int pre2,cur;
	 if (addr < (RBUS_BASE_VIRT_OLD_1+RBUS_BASE_SIZE_1) && addr >= RBUS_BASE_VIRT_OLD_1) {
        	rtk_getl(addr-RBUS_BASE_VIRT_OLD_1+RBUS_BASE_VIRT_1);
		pre2 = rtk_getl(addr-RBUS_BASE_VIRT_OLD_1+RBUS_BASE_VIRT_1);
		cur = rtk_getl(addr-RBUS_BASE_VIRT_OLD_1+RBUS_BASE_VIRT_1);
	 }
    else if (addr < (SPI_FLASH_BASE_VIRT_OLD_1+SPI_FLASH_BASE_SIZE_1) && addr >= SPI_FLASH_BASE_VIRT_OLD_1) {
		rtk_getl(addr-SPI_FLASH_BASE_VIRT_OLD_1+SPI_FLASH_BASE_VIRT_1);
		pre2 = rtk_getl(addr-SPI_FLASH_BASE_VIRT_OLD_1+SPI_FLASH_BASE_VIRT_1);
        	cur = rtk_getl(addr-SPI_FLASH_BASE_VIRT_OLD_1+SPI_FLASH_BASE_VIRT_1);
    }
    else {
		rtk_getl(addr);
		pre2 = rtk_getl(addr);
        	cur = rtk_getl(addr);
    }

     if (cur != pre2) {
		printk("RBUS Read error\n");
     }

     return cur;
	
}


#endif

#endif
