#include <qc_verify.h>

extern unsigned long strtoul(	const char *str, char **endptr, int base);
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);
extern void GetLine(char * buffer, const unsigned int size, int EchoFlag);
extern int GetArgc(const char* string);
extern char** GetArgv(const char* string);
extern char* StrUpr( char* string );
#define SW_BIN_REG 0xb801bd24
UINT8 bFirst_fail_no = 100;
/*

	QC VERIFY AUTO RUN FUNCTION

*/
QC_IP_VERIFY_ENTRY_T  qc_ip_verify_run_list[] = {
/*#####	BIST : qc_verify/BIST #####*/
#if CONFIG_QC_BIST
	{"BIST_QC",QC_Verifier_BIST,100},
#endif

/*#####	BISR : qc_verify/BISR #####*/
#if CONFIG_QC_BISR
	{"BISR_QC",QC_Verifier_BISR,100},
#endif

/*#####	SCPU : qc_verify/SCPU #####*/
#if CONFIG_QC_SCPU
	{"SCPU_QC",QC_Verifier_SCPU,1},
#endif

/*#####	ACPU : qc_verify/ACPU #####*/
#if CONFIG_QC_ACPU
	{"ACPU_QC",QC_Verifier_ACPU,2},
#endif

/*#####	GPU : qc_verify/GPU #####*/
#if CONFIG_QC_GPU
	{"GPU_QC",QC_Verifier_GPU,3},
#endif

/*#####	VE : qc_verify/VE #####*/
#if CONFIG_QC_VE
	{"VE_QC",QC_Verifier_VE,4},
#endif

/*#####	VE_Encode : qc_verify/VE_Encode #####*/
#if CONFIG_QC_VE_Encode
	{"VE_Encode_QC",QC_Verifier_VE_Encode,5},
#endif

/*#####	VDE : qc_verify/VDE #####*/
#if CONFIG_QC_VDE
	{"VDE_QC",QC_Verifier_VDE,6},
#endif

/*#####	SE : qc_verify/SE #####*/
#if CONFIG_QC_SE
	{"SE_QC",QC_Verifier_SE,7},
#endif

/*#####	MD : qc_verify/MD #####*/
#if CONFIG_QC_MD
	{"MD_QC",QC_Verifier_MD,8},
#endif

/*#####	CP : qc_verify/CP #####*/
#if CONFIG_QC_CP
	{"CP_QC",QC_Verifier_CP,9},
#endif

/*#####	8051 : qc_verify/8051 #####*/
#if CONFIG_QC_8051
	{"8051_QC",QC_Verifier_8051,10},
#endif

/*#####	AUDIO : qc_verify/Audio #####*/
#if CONFIG_QC_AUDIO
	{"AUDIO_QC",QC_Verifier_AUDIO,100},
#endif

/*#####	CEC : qc_verify/CEC #####*/
#if CONFIG_QC_CEC
	{"CEC_QC",QC_Verifier_CEC,100},
#endif

/*#####	HDMI : qc_verify/HDMI #####*/
#if CONFIG_QC_HDMI
	{"HDMI_QC",QC_Verifier_HDMI,100},
#endif

/*#####	HDMI_TX : qc_verify/HDMI_TX #####*/
#if CONFIG_QC_HDMI_TX
	{"HDMI_TX_QC",QC_Verifier_HDMI_TX,100},
#endif

/*#####	USB : qc_verify/USB #####*/
#if CONFIG_QC_USB
	{"USB_QC",QC_Verifier_USB,11},
#endif

/*#####	ETN : qc_verify/ETN #####*/
#if CONFIG_QC_ETN
	{"ETN_QC",QC_Verifier_ETN,12},
#endif

/*#####	VDC_TOP : qc_verify/VDC_Top #####*/
#if CONFIG_QC_VDC_TOP
	{"VDC_TOP_QC",QC_Verifier_VDC_Top,100},
#endif

/*#####	VDC_PQ : qc_verify/VDC_PQ #####*/
#if CONFIG_QC_VDC_PQ
	{"VDC_PQ_QC",QC_Verifier_VDC_PQ,13},
#endif

/*#####	VBI : qc_verify/VBI #####*/
#if CONFIG_QC_VBI
	{"VBI_QC",QC_Verifier_VBI,100},
#endif

/*#####	IFD : qc_verify/IFD #####*/
#if CONFIG_QC_IFD
	{"IFD_QC",QC_Verifier_IFD,22},
#endif

/*#####	EMMC : qc_verify/EMMC #####*/
#if CONFIG_QC_EMMC
	{"EMMC_QC",QC_Verifier_EMMC,14},
#endif

/*#####	NAND : qc_verify/NAND #####*/
#if CONFIG_QC_NAND
	{"NAND_QC",QC_Verifier_NAND,15},
#endif

/*#####	SPI : qc_verify/SPI_Flash #####*/
#if CONFIG_QC_SPI
	{"SPI_QC",QC_Verifier_SPI,16},
#endif

/*#####	SPI_NAND : qc_verify/SPI_NAND #####*/
#if CONFIG_QC_SPI_NAND
	{"SPI_NAND_QC",QC_Verifier_SPI_Nand,17},
#endif

/*#####	I3DDMA : qc_verify/I3DDMA #####*/
#if CONFIG_QC_I3DDMA
	{"I3DDMA_QC",QC_Verifier_I3DDMA,100},
#endif

/*#####	PERIPHERAL : qc_verify/Peripheral #####*/
#if CONFIG_QC_PERIPHERAL
	{"PERIPHERAL_QC",QC_Verifier_PERIPHERAL,100},
#endif

/*#####	MD_DOMAIN : qc_verify/MD_Domain #####*/
#if CONFIG_QC_MD_DOMAIN
	{"MD_DOMAIN_QC",QC_Verifier_MD_Domain,18},
#endif

/*#####	VIP : qc_verify/VIP #####*/
#if CONFIG_QC_VIP
	{"VIP_QC",QC_Verifier_VIP,19},
#endif

/*#####	MEMC : qc_verify/MEMC #####*/
#if CONFIG_QC_MEMC
	{"MEMC_QC",QC_Verifier_MEMC,20},
#endif

/*#####	LZMA : qc_verify/LZMA #####*/
#if CONFIG_QC_LZMA
	{"LZMA_QC",QC_Verifier_LZMA,21},
#endif

/*##### I_DOMAIN : qc_verify/I_Domain #####*/
#if CONFIG_QC_I_DOMAIN
        {"I_DOMAIN_QC",QC_Verifier_I_Domain,100},
#endif




//#if CONFIG_FT
/*#####	Multi_Core_test : qc_verify/Multi_Core_test #####*/
#if CONFIG_QC_MULTI_CORE_TEST
	{"MULTI_CORE_TEST_QC",QC_Verifier_Multi_Core,100},
#endif
//#endif

/*#####	VP9 : qc_verify/VP9 #####*/
#if CONFIG_QC_VP9
	{"VP9_QC",QC_Verifier_VP9,100},
#endif

/*#####	eCBUS_TX_Test : qc_verify/eCBUS_TX_Test #####*/
#if CONFIG_QC_eCBUS_TX_Test
	{"eCBUS_TX_Test_QC",QC_Verifier_eCBUS_TX_Test,100},
#endif

/*#####	TVE_TV : qc_verify/TVE_TV #####*/
#if CONFIG_QC_TVE
	{"TVE_QC",QC_Verifier_TVE,100},
#endif

/*#####	Dolby_HDR : qc_verify/Dolby_HDR #####*/
#if CONFIG_QC_Dolby_HDR
	{"Dolby_HDR_QC",QC_Verifier_Dolby_HDR,100},
#endif

/*#####	CARDREADER : qc_verify/CardReader #####*/
#if CONFIG_QC_CARDREADER
	{"CardReader_QC",QC_Verifier_CardReader,100},
#endif

/*#####	MHL : qc_verify/MHL #####*/
#if CONFIG_QC_MHL
	{"MHL_QC",QC_Verifier_MHL,100},
#endif

//#if CONFIG_EQC
/*#####	Multi_Core_test :	qc_verify/Multi_Core_test #####*/
//#if CONFIG_QC_MULTI_CORE_TEST
//	{"MULTI_CORE_TEST_QC",QC_Verifier_Multi_Core},
//#endif
//#endif

/*#####	DDR	:	qc_verify/DDR #####*/
#if CONFIG_QC_DDR
	{"DDR_QC",QC_Verifier_DDR,100},
#endif

/*#####	Standby :	qc_verify/Standby #####*/
#if CONFIG_QC_STANDBY
	{"Standby_QC",QC_Verifier_Standby,100},
#endif

/*#####	CBUS_RX :	qc_verify/CBUS_RX #####*/
#if CONFIG_QC_CBUS_RX
	{"CBUS_RX_QC",QC_Verifier_CBUS_RX,100},
#endif

/*#####	I2Rnd :	qc_verify/I2Rnd #####*/
#if CONFIG_QC_I2RND
	{"I2RND_QC",QC_Verifier_I2Rnd,100},
#endif

/*#####	CONFIG_QC_MHL_TX_CBUS  :	qc_verify/MHL_TX_CBUS  #####*/
#if CONFIG_QC_MHL_TX_CBUS
	{"MHL_TX_CBUS_QC",QC_Verifier_MHL_TX_CBUS,100},
#endif

/*#####	OTP :	qc_verify/OTP #####*/
#if CONFIG_QC_OTP
	{"OTP_QC",QC_Verifier_OTP,100},
#endif

/*#####	OTP_SW_key :	qc_verify/OTP_SW_key #####*/
#if CONFIG_QC_OTP_SW_KEY
	{"OTP_SW_key_QC",QC_Verifier_OTP_SW_key,100},
#endif

	{ "", NULL}
};

/* Timer Reset */
void timer_7_reset(void)
{
	rtd_outl(TC7CR, 0x00000000);
	rtd_outl(TC7TVR, 0xffffffff);   //xz-159s;
	rtd_outl(TCICR, 0x00000101);   //enable
	rtd_outl(TC7CR, 0x80000000);  //timer7 enable
}
//extern void enable_clock(uint reg_reset, uint mask_reset, uint reg_clock, uint mask_clock);

void SW_bin_result(int item_no) //for first fail item
{	
	if((rtd_inl(SW_BIN_REG)&(0x7C000000))== 0x0) //[30:26]
	{						
		if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "SCPU_QC") == 0)
		{//=0x1, b'00001
            rtd_outl(SW_BIN_REG, 0x04000001); //[30:26]=0x1,[0]write_en	
            
			printk(" == SW bin1 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "ACPU_QC") == 0)
		{//=0x2, b'00010
            rtd_outl(SW_BIN_REG, 0x08000001); //[30:26]=0x2,[0]write_en	
            
			printk(" == SW bin2 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "GPU_QC") == 0)
		{//=0x3, b'00011
            rtd_outl(SW_BIN_REG, 0x0C000001); //[30:26]=0x3,[0]write_en	

			printk(" == SW bin3 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "VE_QC") == 0)
		{//=0x4, b'00100
            rtd_outl(SW_BIN_REG, 0x10000001); //[30:26]=0x4,[0]write_en	

			printk(" == SW bin4 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "VE_Encode_QC") == 0)
		{//=0x5, b'00101
            rtd_outl(SW_BIN_REG, 0x14000001); //[30:26]=0x5,[0]write_en	

			printk(" == SW bin5 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "VDE_QC") == 0)
		{//=0x6, b'00110
            rtd_outl(SW_BIN_REG, 0x18000001); //[30:26]=0x6,[0]write_en	

			printk(" == SW bin6 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "SE_QC") == 0)
		{//=0x7, b'00111
            rtd_outl(SW_BIN_REG, 0x1C000001); //[30:26]=0x7,[0]write_en	

			printk(" == SW bin7 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "MD_QC") == 0)
		{//=0x8, b'01000
            rtd_outl(SW_BIN_REG, 0x20000001); //[30:26]=0x8,[0]write_en	

			printk(" == SW bin8 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "CP_QC") == 0)
		{//=0x9, b'01001
            rtd_outl(SW_BIN_REG, 0x24000001); //[30:26]=0x9,[0]write_en	

			printk(" == SW bin9 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "8051_QC") == 0)
		{//=0xA, b'01010
            rtd_outl(SW_BIN_REG, 0x28000001); //[30:26]=0xA,[0]write_en	

			printk(" == SW bin10 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "USB_QC") == 0)
		{//=0xB, b'01011
            rtd_outl(SW_BIN_REG, 0x2C000001); //[30:26]=0xB,[0]write_en	

			printk(" == SW bin11 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "ETN_QC") == 0)
		{//=0xC, b'01100
            rtd_outl(SW_BIN_REG, 0x30000001); //[230:26]=0xC,[0]write_en	

			printk(" == SW bin12 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "VDC_PQ_QC") == 0)
		{//=0xD, b'01101
            rtd_outl(SW_BIN_REG, 0x34000001); //[30:26]=0xD,[0]write_en	

			printk(" == SW bin13 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "EMMC_QC") == 0)	
		{//=0xE, b'01110
            rtd_outl(SW_BIN_REG, 0x38000001); //[30:26]=0xE,[0]write_en	

			printk(" == SW bin14 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "NAND_QC") == 0)
		{//=0xF, b'01111
            rtd_outl(SW_BIN_REG, 0x3C000001); //[30:26]=0xF,[0]write_en	

			printk(" == SW bin15 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "SPI_QC") == 0)
		{//=0x10, b'10000
            rtd_outl(SW_BIN_REG, 0x40000001); //[30:26]=0x10,[0]write_en	

			printk(" == SW bin16 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "SPI_NAND_QC") == 0)
		{//=0x11, b'10001
            rtd_outl(SW_BIN_REG, 0x44000001); //[30:26]=0x11,[0]write_en

			printk(" == SW bin17 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "MD_Domain_QC") == 0)
		{//=0x12, b'10010
            rtd_outl(SW_BIN_REG, 0x48000001); //[30:26]=0x12,[0]write_en

			printk(" == SW bin18 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "VIP_QC") == 0)
		{//=0x13, b'10011
            rtd_outl(SW_BIN_REG, 0x4C000001); //[30:26]=0x13,[0]write_en

			printk(" == SW bin19 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "MEMC_QC") == 0)
		{//=0x14, b'10100
            rtd_outl(SW_BIN_REG, 0x50000001); //[30:26]=0x14,[0]write_en

			printk(" == SW bin20 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "LZMA_QC") == 0)
		{//=0x15, b'10101
            rtd_outl(SW_BIN_REG, 0x54080001); //[30:26]=0x15,[0]write_en

			printk(" == SW bin21 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "IFD_QC") == 0)
		{//=0x16, b'10110
            rtd_outl(SW_BIN_REG, 0x58000001); //[30:26]=0x16,[0]write_en

			printk(" == SW bin22 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "I2RUN_QC") == 0)
		{//=0x17, b'10111
            rtd_outl(SW_BIN_REG, 0x5C000001); //[30:26]=0x17,[0]write_en

			printk(" == SW bin23 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "OTP_QC") == 0)
		{//=0x18, b'11000
            rtd_outl(SW_BIN_REG, 0x60000001); //[30:26]=0x18,[0]write_en

			printk(" == SW bin24 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "OTP_SW_key_QC") == 0)
		{//=0x19, b'11001
            rtd_outl(SW_BIN_REG, 0x64000001); //[30:26]=0x19,[0]write_en

			printk(" == SW bin25 ==\n");
		}
		else if(strcmp(qc_ip_verify_run_list[item_no].entry_name, "TVE_QC") == 0)
		{//=0x20, b'11010
            rtd_outl(SW_BIN_REG, 0x68000001); //[30:26]=0x1A,[0]write_en

			printk(" == SW bin26 ==\n");
		}

		bFirst_fail_no = item_no;
	}	
}


inline void print_menu(void)
{
	int i =0;
	while(qc_ip_verify_run_list[i].entry_function != 0)
	{
		printk("  %d).%s\n", i, qc_ip_verify_run_list[i].entry_name);
		i++;
	}
	printk("  %d).ALL (not support now)\n", i);
	i++;
	//printk("  %d).ALL LOOPS [Shift+A to break loops]\n",total);
	printk("  %d).ALL LOOPS (not support now)\n", i);
	i++;
	printk("  %d).ESC\n", i);
	printk("\r\n");

}

void Set_FTFW_GPIO(void)
{
	//GPIO106->start/end
	//GPIO108->pass/fail
	//GPIO13, 14, 15->code version
	//GPIO118, 119, 120, 121, 122->SW bin
	rtd_maskl(0xb800080c, 0xFF0F0F0F, 0x00F0F0F0); //pinshare to GPIO13~15,[23:20][15:12][7:4]
	rtd_maskl(0xb8000880, 0xFFFFFF0F, 0x000000F0); //pinshare to GPIO106,[7:4]
	rtd_maskl(0xb8000884, 0xFF0FFFFF, 0x00F00000); //pinshare to GPIO108,[23:20]
	rtd_maskl(0xb800088c, 0xFFFFFF0F, 0x000000F0); //pinshare to GPIO118,[7:4]
	rtd_maskl(0xb8000890, 0x0F0F0F0F, 0xF0F0F0F0); //pinshare to GPIO119~122,[31:28][23:20][15:12][7:4]	

	rtd_outl(0xb801bd00, 0x0001C001); //GPIO13~15 set to GPO [16:14],[0]write_en	
	rtd_outl(0xb801bd0c, 0x7C014001); //GPIO106,108,118~122 set to GPO [14][16][26:30],[0]write_en	
	
	rtd_outl(0xb801bd24, 0x00004000); //GPIO106[14] set low, start/end,[0]write_en
	rtd_outl(0xb801bd24, 0x00010001); //GPIO108[16] set high, pass/fail,[0]write_en

//    rtd_outl(SW_BIN_REG, 0x7C000000); //GPIO118~122[30:26] set low, SW bin,[0]write_en
	rtd_outl(SW_BIN_REG, 0x00000001); //GPIO118~122[30:26] set low, SW bin,[0]write_en
		
	#if defined(CONFIG_RTK_B22_QC)
	//BGA22 //version 2, init value =b'101
		rtd_outl(0xb801bd18, 0x00004001); //GPIO13[14],[0]write_en
		rtd_outl(0xb801bd18, 0x00008000); //GPIO14[15],[0]write_en
		rtd_outl(0xb801bd18, 0x00010001); //GPIO15[16],[0]write_en
//	#elif defined(CONFIG_RTD288O_B22_B2B_QC)
//	//BGA22 B2B //version 1, init value =b'110
//		rtd_outl(0xb801bd18, 0x00004000); //GPIO13[14],[0]write_en
//		rtd_outl(0xb801bd18, 0x00008001); //GPIO14[15],[0]write_en
//		rtd_outl(0xb801bd18, 0x00010001); //GPIO15[16],[0]write_en
	#elif defined(CONFIG_RTK_B27_QC)	//BGA27 
		#if defined(Config_Flash_Type_is_NAND)
		//Roku version 1, init value =b'110
		rtd_outl(0xb801bd18, 0x00004000); //GPIO13[14],[0]write_en
		rtd_outl(0xb801bd18, 0x00008001); //GPIO14[15],[0]write_en
		rtd_outl(0xb801bd18, 0x00010001); //GPIO15[16],[0]write_en
		#else
		//LG version 1, init value =b'110
		rtd_outl(0xb801bd18, 0x00004000); //GPIO13[14],[0]write_en
		rtd_outl(0xb801bd18, 0x00008001); //GPIO14[15],[0]write_en
		rtd_outl(0xb801bd18, 0x00010001); //GPIO15[16],[0]write_en
		#endif
	#endif
	
	#if defined(CONFIG_RTK_B22_QC)			//BGA22
	printk("---- Merlin6 BGA22/BGA23 FT FW Ver2 ----\n");
//	#elif defined(CONFIG_RTD288O_B22_B2B_QC)	//BGA22 B2B
//		printk("---- Merlin6 BGA22 B2B FT FW Ver1 ----\n");
	#elif defined(CONFIG_RTK_B27_QC)		//BGA27
		#if defined(Config_Flash_Type_is_NAND)
		printk("---- Merlin6 BGA27 Roku FT FW Ver1 ----\n");
		#else
		printk("---- Merlin6 BGA27 LGE FT FW Ver1 ----\n");
		#endif
	#endif
}

/* U-boot qc command entry */
void qc_verify(int option)
{
	#define	CONSOLE_MODE_QC_PROMPT	"EnterNumber :"
	#define	QCINFO_CMD_BUFFER_SIZE	128
	#define	ESTIME 1

	INT32	argc = 0;
  	INT8	**argv = NULL;

	int	total, fail, pass,i;
	int	tNum;
	char tResl[64];
	unsigned int	rst=0;
	unsigned int	totcnt = 0;
	UINT8	abyCommandBuffer[QCINFO_CMD_BUFFER_SIZE];
	UINT32	loops;
	UINT32	item;
	UINT32	tMs;
	UINT32	FailCnt = 0;


	total = 0;
	fail   = 0;
	pass = 0;
	loops = 0;
	
	#if (CONFIG_EQC||CONFIG_OLT)
	//LED light on (GPO set low), QC:ST_GP_09; OLT:ST_GP_08

	rtd_part_outl(0xb8060210,23,20,0xf); //pinshare to ST_GP_09
	rtd_outl(0xb8061100,0x00000401); //ST_GP_09[10] set to GPO
	rtd_outl(0xb8061108,0x00000400); //ST_GP_09[10] set to low

	rtd_part_outl(0xb8060210,31,28,0xf); //pinshare to ST_ST_GP_08
	rtd_outl(0xb8061100,0x00000201); //ST_GP_08[9] set to GPO
	rtd_outl(0xb8061108,0x00000200); //ST_GP_08[9] set to low
	#endif
		
	#if CONFIG_FT	
	Set_FTFW_GPIO();	
	#endif //FT

	item = sizeof(qc_ip_verify_run_list)/sizeof( QC_IP_VERIFY_ENTRY_T) -1; //sub 1, last dummy case.
	total = item +2; //2 extra automatic loops.
	printk("totoal cases: %d \n", total );

	while(TRUE)
	{
		#if CONFIG_QC_VERIFY_ATO

		if (GETCHAR_ESC)
			break;

		tNum = (total-2);

		if(option==1)
		{
			print_menu();
			printk("%s", CONSOLE_MODE_QC_PROMPT);
			while (!tstc());

			memset(abyCommandBuffer, 0, QCINFO_CMD_BUFFER_SIZE);
			GetLine(abyCommandBuffer, QCINFO_CMD_BUFFER_SIZE, 1);
  			printk("\n");

			//Parse Argument Count by Input Data
  			argc = GetArgc((const INT8 *) abyCommandBuffer);

  			//Parse Argument String by Input Data
  			argv = (INT8 **) GetArgv((const INT8 *) abyCommandBuffer);

  			if(argc < 1)
  			{
  			  	continue;
  			}

  			//Convert Argument String to Upper Case
  			StrUpr(argv[0]);
			tNum = strtoul((const INT8 *) (argv[0]), (INT8 **) NULL, 10);
		}
		#else
		if(option==2)
		{
	        printk(" == QC CODE TEST LIST ==\n");
			print_menu();

			tNum = (total-2);	//for once auto run
		}
		else
		{
			print_menu();
			printk("%s", CONSOLE_MODE_QC_PROMPT);
			while (!tstc());
			memset(abyCommandBuffer, 0, QCINFO_CMD_BUFFER_SIZE);
			GetLine((char *)abyCommandBuffer, QCINFO_CMD_BUFFER_SIZE, 1);
			printk("\n");

			//Parse Argument Count by Input Data
  			argc = GetArgc((const char *) abyCommandBuffer);
	      	//Parse Argument String by Input Data
  			argv = (INT8 **) GetArgv((const char *) abyCommandBuffer);
	      	if(argc < 1)
	      	{
	      	  	continue;
	      	}

	      	//Convert Argument String to Upper Case
	      	StrUpr((char *)argv[0]);
			tNum = strtoul((const char *) (argv[0]), (char **) NULL, 10);
		}
		#endif

		if (tNum > total)
		{
			printk("\n\t\t you died. don't play me ! \n\n");
		}
		else if (tNum==total)
		{	//ESC
			break;
		}
		else if (tNum==(total-2))
		{
			for (i=0;i<(item);i++)
			{
				if(GETCHAR_ESC)
					break;

				#if defined(ESTIME)
				timer_7_reset();
				#endif

				//reset modules
				//enable_clock(SYS_SRST1, 0x00FFFFFF, SYS_CLKEN1, 0x00FFFFFF);
				//enable_clock(SYS_SRST2, 0x0E000800, SYS_CLKEN2, 0x0E000800);
				
				if (qc_ip_verify_run_list[i].entry_function())
				{
					SW_bin_result(i); //GPIO high for fail item
					fail++;
					tResl[i] = 'F';
					FailCnt++;

					#if defined(ESTIME)
					tMs = rtd_inl(TC7CVR); //Timer7
					tMs = tMs/27000;
					printk("  %d).%s IP test Fail time=%d ms\n\n", i,qc_ip_verify_run_list[i].entry_name,tMs);
					#endif

					#if CONFIG_EQC
					//LED light off if test fail, ST_GP_09
					rtd_outl(0xb8061108,0x00000401); //ST_GP_09[10] set to high
					#endif
				}
				else
				{
					pass++;
					tResl[i] = 'S';

					#if defined(ESTIME)
					tMs = rtd_inl(TC7CVR);
					tMs = tMs/27000;
					printk("  %d).%s IP test Pass time=%d ms\n\n",i,qc_ip_verify_run_list[i].entry_name,tMs);
					#endif
				}
				printk("========== tot err count ======================>> %d \n",FailCnt);
			}
			//local_uart1_enable();

			//Succ IP
			#if CONFIG_FT
				#if defined(CONFIG_RTK_B22_QC)
				//BGA22 //version 2, init value =b'010
					rtd_outl(0xb801bd18, 0x00004000); //GPIO13[14],[0]write_en
					rtd_outl(0xb801bd18, 0x00008001); //GPIO14[15],[0]write_en
					rtd_outl(0xb801bd18, 0x00010000); //GPIO15[16],[0]write_en
//				#elif defined(CONFIG_RTD288O_B22_B2B_QC)
//				//BGA22 B2B //version 1, init value =b'001
//					rtd_outl(0xb801bd18, 0x00004001); //GPIO13[14],[0]write_en
//					rtd_outl(0xb801bd18, 0x00008000); //GPIO14[15],[0]write_en
//					rtd_outl(0xb801bd18, 0x00010000); //GPIO15[16],[0]write_en
				#elif defined(CONFIG_RTK_B27_QC)	//BGA27 
					#if defined(Config_Flash_Type_is_NAND)
					//Roku version 1, init value =b'001
					rtd_outl(0xb801bd18, 0x00004001); //GPIO13[14],[0]write_en
					rtd_outl(0xb801bd18, 0x00008000); //GPIO14[15],[0]write_en
					rtd_outl(0xb801bd18, 0x00010000); //GPIO15[16],[0]write_en
					#else
					//LG version 1, init value =b'001
					rtd_outl(0xb801bd18, 0x00004001); //GPIO13[14],[0]write_en
					rtd_outl(0xb801bd18, 0x00008000); //GPIO14[15],[0]write_en
					rtd_outl(0xb801bd18, 0x00010000); //GPIO15[16],[0]write_en
					#endif
				#endif
				

				rtd_outl(0xb801bd24, 0x00004001); //GPIO106[14] set high, end,[0]write_en
			
				if(fail==0)//  pass
					rtd_outl(0xb801bd24, 0x00010000); //GPIO108[16] set low, pass,[0]write_en
				else// fail
					rtd_outl(0xb801bd24, 0x00010001); //GPIO108[16] set high, fail,[0]write_en
				if (bFirst_fail_no != 100)
					printk("First fail item is %s\n", qc_ip_verify_run_list[bFirst_fail_no].entry_name);
			#endif


			//Fail IP
			if (FailCnt > 0)
				printk("\r\n *** FAIL IP ***\n");
			for (i=0;i<(item);i++)
			{
				if (FailCnt==0)
				{
					printk("\r\n");
					printk("\n+++++++++++++++++\n");
					printk("+++ No Fail IP ++");
					printk("\n+++++++++++++++++\n");
					printk("\r\n");
					printk("\r\n");
					break;
				}

				if (tResl[i]=='F')
					printk("  %d).%s\n\n",i ,qc_ip_verify_run_list[i].entry_name);
			}

			#if CONFIG_QC_ONCE_ALL //start/end
				//LED light off (GPO set high), OLT:ST_GP_08[9]
				#if CONFIG_OLT	
				    rtd_part_outl(0xb8061108,9,9,0x1); //ST_GP_08[9] set to high					
				#endif
				break;
			#endif
		}
		else if (tNum==(total-1))
		{	//ALL LOOPS
			//printk("ALL LOOPS =>%d\n",tNum);
			loops = 0;
			fail = 0;
			while(TRUE)
			{
				if (GETCHAR_ESC)
				break;

				for (i=0;i<(item);i++)
				{
					//local_uart1_disable();
					if (qc_ip_verify_run_list[i].entry_function())
					{
						//local_uart1_enable();
						fail++;
						tResl[i] = 'F';
					}
					else
					{
						//local_uart1_enable();
						pass++;
						tResl[i] = 'S';
					}
				}

				loops++;
				printk("\r\n =========== QC VERIFY LOOPS [%d] ============ \n",loops);
				//Succ IP
				printk("\r\n *** SUCCESS IP ***\n");
				for (i=0;i<(item);i++)
				{
					if (tResl[i]=='S')
						printk("  %d).%s\n",i, qc_ip_verify_run_list[i].entry_name);
				}

				//Fail IP
				printk("\r\n *** FAIL IP ***\n");
				for (i=0;i<(item);i++)
				{
					if (tResl[i]=='F')
						printk("  %d).%s\n",i ,qc_ip_verify_run_list[i].entry_name);
				}

				if (fail>0)
				break;
			}
		}
		else
		{
			printk("\r\n *** RESULT ***\n");

			//reset modules
			//enable_clock(SYS_SRST1, 0x00FFFFFF, SYS_CLKEN1, 0x00FFFFFF);
			//enable_clock(SYS_SRST2, 0x0E000800, SYS_CLKEN2, 0x0E000800);

			#if defined(ESTIME)
			timer_7_reset();
			#endif

			if (qc_ip_verify_run_list[tNum].entry_function())
			{
				#if defined(ESTIME)
				tMs = rtd_inl(TC7CVR);
				tMs = tMs/27000;
				printk("  %d).%s IP test Fail time=%d ms\n\n", tNum,qc_ip_verify_run_list[tNum].entry_name,tMs);
				#else
				printk("  %d).%s IP test Fail\n\n", tNum,qc_ip_verify_run_list[tNum].entry_name);
				#endif
			}
			else
			{
				#if defined(ESTIME)
				tMs = rtd_inl(TC7CVR);
				tMs = tMs/27000;
				printk("  %d).%s IP test Pass time=%d ms\n\n",tNum,qc_ip_verify_run_list[tNum].entry_name,tMs);
				#else
				printk("  %d).%s IP test Pass\n\n",tNum,qc_ip_verify_run_list[tNum].entry_name);
				#endif
			}
		}

		#if CONFIG_QC_VERIFY_ATO

		//if (fail>0)
			//break;

		if (GETCHAR_ESC)	/* stop loop */
			break;

		#if CONFIG_OLT
		//LED light off, OLT:GPIO57
		rtd_part_outl(0xb806110c,27,27,0x1); //GPIO57 set to high
		#endif

		if(option==2)
		{
			totcnt = rtd_inl(0xb8060120); //SCPU Context register value (NMI exception)
			totcnt = totcnt+1;
			rtd_outl(0xb8060120,totcnt);

			//watch dog reset
			//rtd_outl(TCWOV,	0x080BEFC0); //overflow time: 5s
			rtd_outl(TCWOV,	0x080BEFC0); //overflow time: 5s
			rtd_outl(TCWCR,	0x00000f00); //watch enable

			printk("WatchDog Reset CNT = %d\n",rtd_inl(0xb8060120));

			while(1)
			{
				if((rst%32768)==0)
					rst++;
			}
		}
		#endif
	}
}
