#include <linux/string.h>
//#include <platform_lib/board/pcb_mgr.h>
//#include <platform_lib/board/pcb.h>
#include <common.h>
#include <command.h>
#include <malloc.h>
#include <linux/compiler.h>
#include <asm/io.h>
#include "ad82010.h"
#include <drivers/i2c/rtk_i2c_lib.h>

//*************************************************************
// PUBLIC FUNCTIONS
//*************************************************************
#define END_FLAG 	(0xff)
#define AMP_DEBUG 	(0)

typedef struct
{
    unsigned char bAddr;
    unsigned char bArray;
}AD82010_REG;

static AD82010_REG AD82010_InitTbl[] = 
{
    //init
    {AD82010_SCTL2,0x81},//Status control2(FS=48KHz/MCLK=64xFS)
    {AD82010_SCTL4,0x36},//Mixing-off/DRC-on/Power-clipping-on.
    {AD82010_MVOL,0x18},//Master Vol default=mute.
    {AD82010_C1VOL,0x18},//CH1 Vol default=2dB
    {AD82010_C2VOL,0x18},//CH2 Vol default=2dB
    {AD82010_SCTL3,0x11},//unmute,default power-on is mute.
    {END_FLAG ,0x00},//END
};

void ad82010_func(int bus_id, unsigned short addr)
{
    unsigned char data[2];
    unsigned char regaddr;
    unsigned char index;
    for(index = 0; ; index ++)
    {
        regaddr = AD82010_InitTbl[index].bAddr;
        data[0] = AD82010_InitTbl[index].bAddr;
        data[1] = AD82010_InitTbl[index].bArray;
        if(regaddr == END_FLAG)
        {
            break;
        }

#if AMP_DEBUG
        printf("\nwrite addr:0x%x----data=0x%x\n",regaddr,data);
#endif
        if (I2C_Write_EX(AMP_I2C, addr ,  2, data ) < 0)
            printf("program AD82010 failed\n");

#if AMP_DEBUG
        unsigned char readArray[2] = {0,0};
        if (I2C_Read_EX(AMP_I2C, addr , 1,  &regaddr, 2, readArray)!= S_OK)
        {
            printf("\n i2c read fail \n"  );
        }
        printf("\nread addr:0x%x----data[0]=0x%x----data[1]=0x%x\n",regaddr,readArray[0],readArray[1]);
#endif

    }
}

