#include <common.h>
#include <io.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <drivers/i2c/rtk_i2c-api.h>
#include <sys_reg_reg.h>
#include <stb_reg.h>
#include <rbus/dc_sys_reg.h>

unsigned char i2c_init_rdy = 0;
unsigned int  spd;

#define FIFO_THRESHOLD                   4
#define DEFAULT_SPEED                    100    //must use 400KHz, then NETWORK ping ok, and AMP, YAMAHA will ok too, gene@20110714
#define MAX_I2C_PORT_NUM                 (sizeof(g_i2c_port_cfg)/sizeof(unsigned long long))

//#define i2c_print(fmt,args...)            printf(fmt,## args)
//#define i2c_pprint(fmt,args...)           printf(fmt,## args)
#define i2c_print(fmt,args...)      //printf(fmt,## args)
#define i2c_pprint(fmt,args...)     //printf(fmt,## args)
#define i2c_ppprint(fmt,args...)     //printf(fmt,## args)

unsigned long long g_i2c_port_cfg[] =
{ I2C_PORT_0, I2C_PORT_1, I2C_PORT_2,I2C_PORT_3, I2C_PORT_4, I2C_PORT_5};
rtk_i2c_device_addr i2c_dev_addr[MAX_I2C_PORT_NUM] = {0};

extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);

void i2c_power(void)
{
    //I2C0
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c0_off(1));
    rtd_outl(STB_ST_SRST0_reg, STB_ST_SRST0_rstn_i2c0_off(1));
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c0_off(1) | 1);
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c0_off(1));
    rtd_outl(STB_ST_SRST0_reg, STB_ST_SRST0_rstn_i2c0_off(1) | 1);
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c0_off(1) | 1);

    //I2C1
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c1(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c1(1));
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c1(1) | 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c1(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c1(1) | 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c1(1) | 1);

    //I2C2
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c2(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c2(1));
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c2(1) | 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c2(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c2(1) | 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c2(1) | 1);

    //I2C3
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c3(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c3(1));
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c3(1)| 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c3(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c3(1)| 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c3(1)| 1);

    //I2C4
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c4(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c4(1));
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c4(1)| 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c4(1));
    rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_i2c4(1)| 1);
    rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_i2c4(1)| 1);

    //I2C5
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c5_off(1));
    rtd_outl(STB_ST_SRST0_reg, STB_ST_SRST0_rstn_i2c5_off(1));
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c5_off(1)| 1);
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c5_off(1));
    rtd_outl(STB_ST_SRST0_reg, STB_ST_SRST0_rstn_i2c5_off(1)| 1);
    rtd_outl(STB_ST_CLKEN0_reg, STB_ST_CLKEN0_clken_i2c5_off(1)| 1);

}


/*======================================================================
 * Func : get_i2c_port_phy_id
 *
 * Desc : get phy id from logical id
 *
 * Parm : port_id (logical id)
 *
 * Retn : phy_id
 *======================================================================*/
unsigned int get_i2c_port_phy_id(unsigned char port_id)
{
    if (port_id >= MAX_I2C_PORT_NUM)
        return PCB_I2C_PHY_UNUSED;

    if (GET_I2C_TYPE(g_i2c_port_cfg[port_id]) == PCB_I2C_TYPE_GPIO_I2C)
        return PCB_I2C_PHY_UNUSED;      // GPIO I2C, no real PHY

    return GET_HW_I2C_PHY(g_i2c_port_cfg[port_id]);      // HW I2C PHY ID
}

/*======================================================================
 * Func : I2C_Init
 *
 * Desc : Init I2C
 *
 * Parm : N/A
 *
 * Retn : N/A
 *======================================================================*/
void I2C_Init(void)
{
    int port_id;
    unsigned int phy_id = 0;

//    unsigned char rx_fifo_depth;
    i2c_pprint("%s %d\n", __FUNCTION__, __LINE__);
    if (i2c_init_rdy == 0) {
        i2c_power();

#if defined(Config_Board_TV006_BGA_EMMC)|| defined(Config_Board_TV006_BGA_EMMC_27x27)
        rtd_setbits(0xb8000104, 0x800U); // RSTN_APLL_ADC
        rtd_setbits(0xb8000114, 0x800U); // CLKEN_APLL_ADC
        rtd_part_outl(0xb800086c, 1, 0, 0x3); // GPI_EN
        rtd_part_outl(0xb8020064, 12, 11, 0x2); //VSYNC_PD
#endif

        printf("I2C power on.%d\n", __LINE__);
        for (port_id = 0; port_id < MAX_I2C_PORT_NUM; port_id++) {
            phy_id = get_i2c_port_phy_id(port_id);

            if(phy_id == PCB_I2C_PHY_UNUSED) {
                printf("%s:port id = %d not used !!\n", __FUNCTION__, port_id);
                continue;
            }
//          rx_fifo_depth = ((GET_IC_COMP_PARAM_1(i) >>  8) & 0xFF)+1;
            SET_IC_ENABLE(phy_id, 0);
            SET_IC_INTR_MASK(phy_id, 0);               // disable all interrupt
            SET_IC_CON(phy_id, IC_SLAVE_DISABLE | IC_RESTART_EN | SPEED_SS | IC_MASTER_MODE);
            //SET_IC_TX_TL(i, FIFO_THRESHOLD);
            //SET_IC_RX_TL(i, rx_fifo_depth - FIFO_THRESHOLD);
            I2C_SetSpeed(port_id, DEFAULT_SPEED);
        }
        i2c_init_rdy = 1;
    }
}



/*======================================================================
 * Func : I2C_UnInit
 *
 * Desc : Uninit I2C
 *
 * Parm : N/A
 *
 * Retn : N/A
 *======================================================================*/
void I2C_UnInit(void)
{
    int port_id;
    unsigned int phy_id = 0;

    if (i2c_init_rdy) {
        for (port_id = 0; port_id < MAX_I2C_PORT_NUM; port_id++) {
            phy_id = get_i2c_port_phy_id(port_id);

            if(phy_id == PCB_I2C_PHY_UNUSED)
                continue;

            SET_IC_ENABLE(phy_id, 0);
            SET_IC_INTR_MASK(phy_id, 0);
        }
        i2c_init_rdy = 0;
    }
}

/*======================================================================
 * Func : I2C_Write_EX
 *
 * Desc : Single I2C Write Function (Extended Version)
 *
 * Parm : Id        : logical id
 *        Addr      : target address (7bits)
 *        nData     : number of bytes to write
 *        pData     : data to write
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
int I2C_Write_EX(
    unsigned char           PortId,
    unsigned short          Addr,
    unsigned short          nData,
    unsigned char*          pData
)
{
    return I2C_StartXfer(PortId, Addr, nData, pData, 0, NULL);
}



/*======================================================================
 * Func : I2C_Read_EX
 *
 * Desc : Single I2C Read Function
 *
 * Parm : id           : logical id
 *        Addr         : Target Address (7bits)
 *        nSubAddr     : number of bytes of sub address
 *        pSubAddr     : sub address
 *        nData        : numver of bytes to read
 *        pData        : data to read
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
int I2C_Read_EX(
    unsigned char           PortId,
    unsigned short          Addr,
    unsigned short          nSubAddr,
    unsigned char*          pSubAddr,
    unsigned short          nData,
    unsigned char*          pData
)
{
    return I2C_StartXfer(PortId, Addr, nSubAddr, pSubAddr, nData, pData);
}


/*======================================================================
 * Func : I2C_GetClkSel
 *
 * Desc : this function is used to get the clock selection
 *
 * Parm : PortId           : logical id
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
static CLKSEL_MODE I2C_GetClkSel(unsigned char PortId)
{
    unsigned char phy_id = 0;
    phy_id = get_i2c_port_phy_id(PortId);

    if(phy_id == PCB_I2C_PHY_UNUSED) {
        printf("%s:port id = %d not used !!\n", __FUNCTION__, PortId);
        return S_FALSE;
    }

    return CLKSEL_MODE_27MHZ;
}


/*======================================================================
 * Func : I2C_SetSpeed
 *
 * Desc : this function is used to change the operation speed of i2c adapter
 *
 * Parm : Id           : logical id
 *        KHz          : operation speed
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
int I2C_SetSpeed(unsigned char PortId, int KHz)
{
    /*100Hz*/
    unsigned int div_h = 0x84;
    unsigned int div_l = 0x84;
    unsigned char phy_id = 0;
    int ret = 0;
    CLKSEL_MODE clksel_mode = CLKSEL_MODE_27MHZ;

    if (KHz < 10 || KHz > 1200) {
        return -1;
    }

    phy_id = get_i2c_port_phy_id(PortId);

    if(phy_id == PCB_I2C_PHY_UNUSED) {
        printf("port id = %d not used !!\n", PortId);
        return S_FALSE;
    }

    ret = I2C_GetClkSel(PortId);
    if(ret != S_FALSE)
        clksel_mode = (CLKSEL_MODE)ret;

    if(clksel_mode == CLKSEL_MODE_62_5MHZ) {
        if (KHz >= 1000) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x0D);
            SET_IC_SS_SCL_LCNT(phy_id, 0x12);
        } else if (KHz >= 600) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x17);
            SET_IC_SS_SCL_LCNT(phy_id, 0x37);
        } else if (KHz >= 400) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x32);
            SET_IC_SS_SCL_LCNT(phy_id, 0x56);
        } else if (KHz == 50) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x273);
            SET_IC_SS_SCL_LCNT(phy_id, 0x273);
        } else {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            div_h = div_h * 625 / 27;
            div_l = div_l * 625 / 27;
            SET_IC_SS_SCL_HCNT(phy_id, div_h);
            SET_IC_SS_SCL_LCNT(phy_id, div_l);
        }
    } else {
        if (KHz >= 1000) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x06);
            SET_IC_SS_SCL_LCNT(phy_id, 0x08);
        } else if (KHz >= 600) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x0a);
            SET_IC_SS_SCL_LCNT(phy_id, 0x18);
        } else if (KHz >= 400) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x16);
            SET_IC_SS_SCL_LCNT(phy_id, 0x25);
        } else if (KHz == 50) {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, 0x10F);
            SET_IC_SS_SCL_LCNT(phy_id, 0x10F);
        } else {
            SET_IC_CON(phy_id, (GET_IC_CON(phy_id) & (~IC_SPEED)) | SPEED_SS);
            SET_IC_SS_SCL_HCNT(phy_id, div_h);
            SET_IC_SS_SCL_LCNT(phy_id, div_l);
        }
    }

    return 0;
}



/*======================================================================
 * Func : I2C_Transfer_EX
 *
 * Desc : this function supports atomic multiple messages read/write
 *        via i2c message data structure
 *
 * Parm : Id           : logical id
 *        pMsgs       : messages
 *        nMsg        : number of messages
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
int I2C_StartXfer(
    unsigned char           PortId,
    unsigned short          Addr,
    unsigned short          nSubAddr,
    unsigned char*          pSubAddr,
    unsigned short          nData,
    unsigned char*          pData
)
{
    int phy_id = 0;
    int tx_len = 0;
    int rx_len = 0;
    int ret = S_FALSE;
    int delay_loop = 0;
    int event;
    unsigned long Command;
    //int retry_count = 0;
    //int max_retry_times = 2;

//gotoretry:

    phy_id = get_i2c_port_phy_id(PortId);

    if(phy_id == PCB_I2C_PHY_UNUSED) {
        printf("%s:port id = %d not used !!\n", __FUNCTION__, PortId);
        return S_FALSE;
    }

    I2C_Init();

    SET_IC_TAR(phy_id, Addr & 0x7F);
    SET_IC_CON(phy_id, GET_IC_CON(phy_id) & (~IC_10BITADDR_MASTER));
    CLR_IC_INTR(phy_id);
    SET_IC_ENABLE(phy_id, 1);

    tx_len = 0;
    rx_len = 0;
    ret = S_FALSE;
    delay_loop = 0;

#define TxComplete()        (tx_len >= nData + nSubAddr)    // it should add the same number of read command to tx fifo
#define RxComplete()        (rx_len >= nData)

    i2c_pprint("s");

    while(1) {

        // check status
        event = GET_IC_INTR_STAT(phy_id);

        if (event & TX_ABRT_BIT) {
            i2c_ppprint("tx abort!!!!\n");
            break;
        }

        if ((event & STOP_DET_BIT) || (nData && RxComplete())) {
            if (RxComplete()) {
                i2c_pprint("Complete!!!!\n");
                ret = S_OK;
            } else {
                i2c_ppprint("Xmit not Complete!!!!\n");
            }
            break;
        }

        // TX Thread
        while(!TxComplete() && NOT_TXFULL(phy_id)) {
            if (tx_len < nSubAddr)
                Command = pSubAddr[tx_len];
            else
                Command = READ_CMD;

            tx_len++;

            if (TxComplete())
                Command |= (0x1 << 9);

            SET_IC_DATA_CMD(phy_id, Command);  // send read command to rx fifo
        }


        i2c_pprint("w");
        // RX Thread
        while(!RxComplete() && NOT_RXEMPTY(phy_id)) {
            pData[rx_len++] = (unsigned char)(GET_IC_DATA_CMD(phy_id) & 0xFF);
            i2c_pprint("r");
        }

        // //delay for a while, if u want that error but still go. however, in my project. I2C must ok. so skip this protection.  gene@20110714
        // udelay(40);
        if(delay_loop++ >= 10000) {
            i2c_pprint("o");
            break;
        }
    }

    i2c_pprint("e");

    if (ret != S_OK) {
        i2c_ppprint("[I2C%d] timeout\n", phy_id);
    }

    //printf("[i2c] txabort =%x %x \n",event,GET_IC_TX_ABRT_SOURCE(i));

    CLR_IC_INTR(phy_id);
    SET_IC_ENABLE(phy_id, 0);

    return ret;

#undef TxComplete
#undef RxComplete
}


unsigned char I2C_GetBusCount(void)
{
    return MAX_I2C_PORT_NUM;
}

#if 0
void  i2chandcraft()
{
    char tmp[4] = {0};
    int event;
    rtd_outl(MIS_IC1_ENABLE_reg,       0x00000000); // Diable MISC I2C0
    rtd_outl(MIS_IC1_INTR_MASK_reg,    0x00000000); // MASK all the interrupts
    rtd_outl(MIS_IC1_TAR_reg,          0x00000060); // Target address, & Set 7 bit address mode
    rtd_outl(MIS_IC1_CON_reg,          0x00000065); // 7 bit address mode, slave_en, full speed mode, restart_en
    //rtd_outl(IC1_SAR_reg,          0x00000055); // Slave address
    //rtd_outl(IC1_HS_MADDR_reg,     0x00000002); // HS Master Mode Code Address

    rtd_outl(MIS_IC1_SS_SCL_HCNT_reg,  0x0000003C); // Standard Speed I2C Clock SCL High Count
    rtd_outl(MIS_IC1_SS_SCL_LCNT_reg,  0x00000060); // Standard Speed I2C Clock SCL Low Count
    //rtd_outl(IC0_FS_SCL_HCNT_reg,  0x0000000f); // Full Speed I2C Clock SCL High Count
    //rtd_outl(IC0_FS_SCL_LCNT_reg,  0x00000021); // Full Speed I2C Clock SCL Low Count
    //rtd_outl(IC0_HS_SCL_HCNT_reg,  0x00000006); // High Speed I2C Clock SCL High Count
    //rtd_outl(IC0_HS_SCL_LCNT_reg,  0x00000008); // High Speed I2C Clock SCL Low Count
    rtd_outl(MIS_IC1_RX_TL_reg,        0x00000008); // TX FIFO threshold level
    rtd_outl(MIS_IC1_TX_TL_reg,        0x00000008); // TX FIFO threshold level


    rtd_inl(MIS_IC1_CLR_INTR_reg);
    rtd_outl(MIS_IC1_ENABLE_reg,       0x00000001); // Enable MISC I2C0
    rtd_outl(MIS_IC1_DATA_CMD_reg, 0x0 ); // DATA_CMD send addr 0
    udelay(20);
    rtd_outl(MIS_IC1_DATA_CMD_reg, 0x0 ); // DATA_CMD send addr 1
    udelay(20);
    rtd_outl(MIS_IC1_DATA_CMD_reg, 0x0 | 0x1 << 8 );   // DATA_CMD read data
    udelay(20);
    rtd_outl(MIS_IC1_DATA_CMD_reg, 0x0 | 0x1 << 8 );   // DATA_CMD read data
    udelay(20);
    rtd_outl(MIS_IC1_DATA_CMD_reg, 0x0 | 0x1 << 8 );   // DATA_CMD read data
    udelay(20);
    rtd_outl(MIS_IC1_DATA_CMD_reg, 0x0 | 0x1 << 8 | 0x1 << 9);   // DATA_CMD read data & Send Stop
    udelay(20);

    tmp[0] = rtd_inl(MIS_IC1_DATA_CMD_reg);
    udelay(20);
    tmp[1] = rtd_inl(MIS_IC1_DATA_CMD_reg);
    udelay(20);
    tmp[2] = rtd_inl(MIS_IC1_DATA_CMD_reg);
    udelay(20);
    tmp[3] = rtd_inl(MIS_IC1_DATA_CMD_reg);
    udelay(20);


    event = rtd_inl(MIS_IC1_RAW_INTR_STAT_reg);
    rtd_inl(MIS_IC1_CLR_INTR_reg);
    rtd_outl(MIS_IC1_ENABLE_reg,       0x00000000); // Diable MISC I2C0

    printf("baker do i2c handcraft data = [%02x, %02x, %02x, %02x], interrupt = %08x\n", tmp[0], tmp[1], tmp[2], tmp[3], event);


}
#endif

