#ifndef _UTIL_H_
#define _UTIL_H_

/* print more debug msg */
#define DEBUG
#ifdef DEBUG
#define DEBUG_MSG 1
#else
#define DEBUG_MSG 0
#endif

#define debug_print(fmt, ...) \
	do { if (DEBUG_MSG) printf(fmt, __VA_ARGS__); } while (0)

int get_2state_OTP(unsigned int value);
int get_3state_OTP_progressive(unsigned int value);
int get_3state_OTP_split(unsigned int value);
int get_4state_OTP_split(unsigned int value);
unsigned int encode_2state_OTP(int value);
unsigned int encode_3state_OTP_progressive(int value);
unsigned int encode_3state_OTP_split(int value);
unsigned int encode_4state_OTP_split(int value);

#endif /* _UTIL_H_ */

