#ifndef RT_GPIO_USERSPACE_ACCESS_LIBRARY
#define RT_GPIO_USERSPACE_ACCESS_LIBRARY

#include "gpio_reg.h"
#include <platform_lib/board/pcb_mgr.h>

#define GPIO_DIR_IN                 0
#define GPIO_DIR_OUT                1

#ifdef GPIO_DEBUG_PRINTF
#define gpioDebug(fmt,args...)      printf("[GPIO]DBG "fmt,##args)
#else
#define gpioDebug(fmt,args...)
#endif
#define gpioErr(fmt,args...)       printf("[GPIO]ERR "fmt,##args)

#define rtk_gpio_id(group, idx)     (((group & 0x7) << 8) | (idx & 0xFF))
#define gpio_group(id)              ((id >> 8) & 0x7)
#define gpio_idx(id)                (id & 0xFF)

#define RTK_GPIO_ID         unsigned int

typedef enum rt_gpio_type{
    ISO_GPIO  = 0,
    MISC_GPIO,
    ISO_GPI,
    ISO_GPO,
    MISC_GPI,
    MISC_GPO,
}RT_GPIO_TYPE;

typedef enum _tagGPIOPOTENTIAL {
    GPIO_PIN_LOW  = 0,
    GPIO_PIN_HIGH = 1,
} GPIOPOT;

typedef struct gpio_reginfo {
    volatile unsigned int gpioDir;
    volatile unsigned int gpioDatI;
    volatile unsigned int gpioDatO;
}RT_GPIO_REGINFO;

int rt_gpio_get(int gpioNum, RT_GPIO_TYPE rtGpioType);
int rt_gpio_set(int gpioNum, int value, RT_GPIO_TYPE rtGpioType);

int rt_gpo_set(int gpoNum, int value, RT_GPIO_TYPE rtGpioType);
int rt_gpo_get(int gpoNum, RT_GPIO_TYPE rtGpioType);

int rt_gpi_get(int gpiNum, RT_GPIO_TYPE rtGpioType);

RTK_GPIO_ID rtk_gpio_get_gid_by_pintype(PCB_PIN_TYPE_T pin_type, unsigned char pin_index);
#endif
