#ifndef __RTK_RCP_DEFINES_H__
#define __RTK_RCP_DEFINES_H__

#define MAX_CW_ENTRY       128
#define RCP_B4TL(b1, b2, b3, b4)        (((b1) << 24) + ((b2) << 16) + ((b3) << 8) + (b4))
#define RCP_BS4TL(array)                ((*(array) << 24) + (*(array + 1) << 16) +  \
                                            (*(array + 2) << 8) + *(array + 3))

#define RCP_LTB4(b1, b2, b3, b4, L)     { b1 = ((L>>24)); b2 = ((L>>16)); \
                                            b3 = ((L>> 8)); b4 = ( L); }
#define RCP_LTBS4(array, L)             { *(array)  = ((L>>24)); *(array + 1) = ((L>>16)); \
                                            *(array + 2) = ((L>> 8)); *(array + 3) = ( L); }


#define RCP_DEV_NAME        "rcp_core"

#define RCP_MODE(x)             ((x) & 0x1F)

#define RCP_ALGO_AES                        0x0
#define RCP_ALGO_TDES                      0x1
#define RCP_ALGO_DES                        0x2
#define RCP_ALGO_SHA_256                0x3
#define RCP_ALGO_AES_192                0x4
#define RCP_ALGO_AES_256                0x7
#define RCP_ALGO_CAM                       0x8
#define RCP_ALGO_CAM_192                0x9
#define RCP_ALGO_CAM_256                0xa
#define RCP_ALGO_CW_LOGIC             0xF
#define RCP_ALGO_CW_OPSEL             0x10



#define RCP_ENDE(x)                           (((x) >> 5) & 0x1)
#define RCP_ENC                                 1
#define RCP_DEC                                 0

#define RCP_CW_OPSEL(x)                  (((x) >> 5) & 0x1)
#define GET_CW                          0x1
#define SET_CW                           0x0


#define RCP_BCM(x)                            (((x) >> 6) & 0x3)
#define RCP_BCM_ECB                         0x0
#define RCP_BCM_CBC                         0x1
#define RCP_BCM_CTR                         0x2

#define RCP_CW_LOGIC(x)                 (((x) >> 6) & 0x3)
#define RCP_CW_LOGIC_AND                0x0
#define RCP_CW_LOGIC_OR                 0x1
#define RCP_CW_LOGIC_XOR                0x2

#define RCP_KEY_FROM(x)                 (((x) >> 20) & 0x3)
#define RCP_KEY_FROM_OTP                0x0
#define RCP_KEY_FROM_CW                 0x1
#define RCP_KEY_FROM_DDR                0x2

#define RCP_IV_FROM(x)                 (((x) >> 22) & 0x3)
#define RCP_IV_FROM_OTP                0x0
#define RCP_IV_FROM_CW                 0x1
#define RCP_IV_FROM_DDR                0x2

#define RCP_IV_POST_CRYPT(x)                 (((x) >> 24) & 0x1)
#define RCP_IV_NO_UPDATE                0x0
#define RCP_IV_NEED_UPDATE                 0x1

/*Only for AES Ctr algorithm*/
#define RCP_CHECK_ADDR_ALIGN(x)         (((x) >> 25) & 0x1)
#define RCP_NO_CHECK_ADDR_ALIGN                0
#define RCP_NEED_CHECK_ADDR_ALIGN              1

/****************Use for TA******************************/
#define U_RCP_MODE(x)             ((x) & 0x1F)

#define U_RCP_ALGO_AES                        U_RCP_MODE(0x0)
#define U_RCP_ALGO_TDES                      U_RCP_MODE(0x1)
#define U_RCP_ALGO_DES                        U_RCP_MODE(0x2)
#define U_RCP_ALGO_SHA_256                U_RCP_MODE(0x3)
#define U_RCP_ALGO_AES_192                U_RCP_MODE(0x4)
#define U_RCP_ALGO_AES_256                U_RCP_MODE(0x7)
#define U_RCP_ALGO_CAM                       U_RCP_MODE(0x8)
#define U_RCP_ALGO_CAM_192                U_RCP_MODE(0x9)
#define U_RCP_ALGO_CAM_256                U_RCP_MODE(0xa)
#define U_RCP_ALGO_CW_LOGIC             U_RCP_MODE(0xF)
#define U_RCP_ALGO_CW_OPSEL             U_RCP_MODE(0x10)



#define U_RCP_ENDE(x)                           (((x) & 0x1) << 5)
#define U_RCP_ENC                                 U_RCP_ENDE(1)
#define U_RCP_DEC                                 U_RCP_ENDE(0)

#define U_RCP_CW_OPSEL(x)                  (((x) & 0x1) << 5)
#define U_GET_CW                                  U_RCP_CW_OPSEL(0x1)
#define U_SET_CW                                  U_RCP_CW_OPSEL(0x0)


#define U_RCP_BCM(x)                            (((x) & 0x3) << 6)
#define U_RCP_BCM_ECB                         U_RCP_BCM(0x0)
#define U_RCP_BCM_CBC                         U_RCP_BCM(0x1)
#define U_RCP_BCM_CTR                         U_RCP_BCM(0x2)

#define U_RCP_CW_LOGIC(x)                 (((x) & 0x3) << 6)
#define U_RCP_CW_LOGIC_AND                U_RCP_CW_LOGIC(0x0)
#define U_RCP_CW_LOGIC_OR                 U_RCP_CW_LOGIC(0x1)
#define U_RCP_CW_LOGIC_XOR                U_RCP_CW_LOGIC(0x2)

#define U_RCP_KEY_FROM(x)                 (((x) & 0x3) << 20)
#define U_RCP_KEY_FROM_OTP                U_RCP_KEY_FROM(0x0)
#define U_RCP_KEY_FROM_CW                 U_RCP_KEY_FROM(0x1)
#define U_RCP_KEY_FROM_DDR                U_RCP_KEY_FROM(0x2)

#define U_RCP_IV_FROM(x)                 (((x) & 0x3) << 22)
#define U_RCP_IV_FROM_OTP                U_RCP_IV_FROM(0x0)
#define U_RCP_IV_FROM_CW                 U_RCP_IV_FROM(0x1)
#define U_RCP_IV_FROM_DDR                U_RCP_IV_FROM(0x2)

#define U_RCP_IV_POST_CRYPT(x)                 (((x) & 0x1) << 24)
#define U_RCP_IV_NO_UPDATE                U_RCP_IV_POST_CRYPT(0x0)
#define U_RCP_IV_NEED_UPDATE           U_RCP_IV_POST_CRYPT(0x1)

/*Only for AES Ctr algorithm*/
#define U_RCP_CHECK_ADDR_ALIGN(x)         (((x) & 0x1) << 25)
#define U_RCP_NO_CHECK_ADDR_ALIGN                U_RCP_CHECK_ADDR_ALIGN(0x0)
#define U_RCP_NEED_CHECK_ADDR_ALIGN              U_RCP_CHECK_ADDR_ALIGN(0x1)



typedef enum _RCP_REG_TYPE{
    RCP_REG_TYPE_KEY,
    RCP_REG_TYPE_KEY1,
    RCP_REG_TYPE_DATAIN,
    RCP_REG_TYPE_DATAOUT,
    RCP_REG_TYPE_IV,
}RCP_REG_TYPE;

typedef enum _RCP_MODE_TYPE{
    KEY_MODE,
    IV_MODE,
    INPUT_MODE,
    OUTPUT_MODE,
    INPUT_ENTRY,
    OUTPUT_ENTRY,
}RCP_MODE_TYPE;

typedef enum _RCP_CW_LOGIC_MODE_TYPE{
    CW_LOGIC_MODE_AND,
    CW_LOGIC_MODE_OR,
    CW_LOGIC_MODE_XOR,
}RCP_CW_LOGIC_MODE_TYPE;

typedef struct {
    unsigned char *key;
    unsigned char *iv;
    unsigned int flags;
    unsigned int    len;
    unsigned char *data_in;
    unsigned char *data_out;
    unsigned int out_len;
} RCP_DESC;

#endif
