/**
* @file Merlin6-DesignSpec-D-Domain_LineOD
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_PCID_REG_H_
#define _RBUS_PCID_REG_H_

#include "rbus_types.h"



//  PCID Register Address
#define  PCID_PCID_CTRL                                                         0x1802EF00
#define  PCID_PCID_CTRL_reg_addr                                                 "0xB802EF00"
#define  PCID_PCID_CTRL_reg                                                      0xB802EF00
#define  PCID_PCID_CTRL_inst_addr                                                "0x0000"
#define  set_PCID_PCID_CTRL_reg(data)                                            (*((volatile unsigned int*)PCID_PCID_CTRL_reg)=data)
#define  get_PCID_PCID_CTRL_reg                                                  (*((volatile unsigned int*)PCID_PCID_CTRL_reg))
#define  PCID_PCID_CTRL_dummy_31_30_shift                                        (30)
#define  PCID_PCID_CTRL_first_line_cfg_shift                                     (18)
#define  PCID_PCID_CTRL_first_line_boundary_mode_shift                           (16)
#define  PCID_PCID_CTRL_dummy_15_14_shift                                        (14)
#define  PCID_PCID_CTRL_general_cfg_shift                                        (2)
#define  PCID_PCID_CTRL_general_boundary_mode_shift                              (0)
#define  PCID_PCID_CTRL_dummy_31_30_mask                                         (0xC0000000)
#define  PCID_PCID_CTRL_first_line_cfg_mask                                      (0x3FFC0000)
#define  PCID_PCID_CTRL_first_line_boundary_mode_mask                            (0x00030000)
#define  PCID_PCID_CTRL_dummy_15_14_mask                                         (0x0000C000)
#define  PCID_PCID_CTRL_general_cfg_mask                                         (0x00003FFC)
#define  PCID_PCID_CTRL_general_boundary_mode_mask                               (0x00000003)
#define  PCID_PCID_CTRL_dummy_31_30(data)                                        (0xC0000000&((data)<<30))
#define  PCID_PCID_CTRL_first_line_cfg(data)                                     (0x3FFC0000&((data)<<18))
#define  PCID_PCID_CTRL_first_line_boundary_mode(data)                           (0x00030000&((data)<<16))
#define  PCID_PCID_CTRL_dummy_15_14(data)                                        (0x0000C000&((data)<<14))
#define  PCID_PCID_CTRL_general_cfg(data)                                        (0x00003FFC&((data)<<2))
#define  PCID_PCID_CTRL_general_boundary_mode(data)                              (0x00000003&(data))
#define  PCID_PCID_CTRL_get_dummy_31_30(data)                                    ((0xC0000000&(data))>>30)
#define  PCID_PCID_CTRL_get_first_line_cfg(data)                                 ((0x3FFC0000&(data))>>18)
#define  PCID_PCID_CTRL_get_first_line_boundary_mode(data)                       ((0x00030000&(data))>>16)
#define  PCID_PCID_CTRL_get_dummy_15_14(data)                                    ((0x0000C000&(data))>>14)
#define  PCID_PCID_CTRL_get_general_cfg(data)                                    ((0x00003FFC&(data))>>2)
#define  PCID_PCID_CTRL_get_general_boundary_mode(data)                          (0x00000003&(data))

#define  PCID_PCID_CTRL_2                                                       0x1802EF04
#define  PCID_PCID_CTRL_2_reg_addr                                               "0xB802EF04"
#define  PCID_PCID_CTRL_2_reg                                                    0xB802EF04
#define  PCID_PCID_CTRL_2_inst_addr                                              "0x0001"
#define  set_PCID_PCID_CTRL_2_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_CTRL_2_reg)=data)
#define  get_PCID_PCID_CTRL_2_reg                                                (*((volatile unsigned int*)PCID_PCID_CTRL_2_reg))
#define  PCID_PCID_CTRL_2_pcid_tab1_xtr_en_shift                                 (30)
#define  PCID_PCID_CTRL_2_pcid_thd_mode_shift                                    (29)
#define  PCID_PCID_CTRL_2_pcid_thd_en_shift                                      (28)
#define  PCID_PCID_CTRL_2_pcid_tab1_b_thd_shift                                  (16)
#define  PCID_PCID_CTRL_2_pcid_tab1_g_thd_shift                                  (8)
#define  PCID_PCID_CTRL_2_pcid_tab1_r_thd_shift                                  (0)
#define  PCID_PCID_CTRL_2_pcid_tab1_xtr_en_mask                                  (0x40000000)
#define  PCID_PCID_CTRL_2_pcid_thd_mode_mask                                     (0x20000000)
#define  PCID_PCID_CTRL_2_pcid_thd_en_mask                                       (0x10000000)
#define  PCID_PCID_CTRL_2_pcid_tab1_b_thd_mask                                   (0x00FF0000)
#define  PCID_PCID_CTRL_2_pcid_tab1_g_thd_mask                                   (0x0000FF00)
#define  PCID_PCID_CTRL_2_pcid_tab1_r_thd_mask                                   (0x000000FF)
#define  PCID_PCID_CTRL_2_pcid_tab1_xtr_en(data)                                 (0x40000000&((data)<<30))
#define  PCID_PCID_CTRL_2_pcid_thd_mode(data)                                    (0x20000000&((data)<<29))
#define  PCID_PCID_CTRL_2_pcid_thd_en(data)                                      (0x10000000&((data)<<28))
#define  PCID_PCID_CTRL_2_pcid_tab1_b_thd(data)                                  (0x00FF0000&((data)<<16))
#define  PCID_PCID_CTRL_2_pcid_tab1_g_thd(data)                                  (0x0000FF00&((data)<<8))
#define  PCID_PCID_CTRL_2_pcid_tab1_r_thd(data)                                  (0x000000FF&(data))
#define  PCID_PCID_CTRL_2_get_pcid_tab1_xtr_en(data)                             ((0x40000000&(data))>>30)
#define  PCID_PCID_CTRL_2_get_pcid_thd_mode(data)                                ((0x20000000&(data))>>29)
#define  PCID_PCID_CTRL_2_get_pcid_thd_en(data)                                  ((0x10000000&(data))>>28)
#define  PCID_PCID_CTRL_2_get_pcid_tab1_b_thd(data)                              ((0x00FF0000&(data))>>16)
#define  PCID_PCID_CTRL_2_get_pcid_tab1_g_thd(data)                              ((0x0000FF00&(data))>>8)
#define  PCID_PCID_CTRL_2_get_pcid_tab1_r_thd(data)                              (0x000000FF&(data))

#define  PCID_PCID_CTRL_3                                                       0x1802EF08
#define  PCID_PCID_CTRL_3_reg_addr                                               "0xB802EF08"
#define  PCID_PCID_CTRL_3_reg                                                    0xB802EF08
#define  PCID_PCID_CTRL_3_inst_addr                                              "0x0002"
#define  set_PCID_PCID_CTRL_3_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_CTRL_3_reg)=data)
#define  get_PCID_PCID_CTRL_3_reg                                                (*((volatile unsigned int*)PCID_PCID_CTRL_3_reg))
#define  PCID_PCID_CTRL_3_dummy_31_0_shift                                       (0)
#define  PCID_PCID_CTRL_3_dummy_31_0_mask                                        (0xFFFFFFFF)
#define  PCID_PCID_CTRL_3_dummy_31_0(data)                                       (0xFFFFFFFF&(data))
#define  PCID_PCID_CTRL_3_get_dummy_31_0(data)                                   (0xFFFFFFFF&(data))

#define  PCID_PCID_LINE_1                                                       0x1802EF10
#define  PCID_PCID_LINE_1_reg_addr                                               "0xB802EF10"
#define  PCID_PCID_LINE_1_reg                                                    0xB802EF10
#define  PCID_PCID_LINE_1_inst_addr                                              "0x0003"
#define  set_PCID_PCID_LINE_1_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_LINE_1_reg)=data)
#define  get_PCID_PCID_LINE_1_reg                                                (*((volatile unsigned int*)PCID_PCID_LINE_1_reg))
#define  PCID_PCID_LINE_1_line1_odd_b_color_select_shift                         (30)
#define  PCID_PCID_LINE_1_line1_odd_g_color_select_shift                         (28)
#define  PCID_PCID_LINE_1_line1_odd_r_color_select_shift                         (26)
#define  PCID_PCID_LINE_1_line1_odd_b_point_select_shift                         (24)
#define  PCID_PCID_LINE_1_line1_odd_g_point_select_shift                         (22)
#define  PCID_PCID_LINE_1_line1_odd_r_point_select_shift                         (20)
#define  PCID_PCID_LINE_1_line1_odd_b_line_select_shift                          (18)
#define  PCID_PCID_LINE_1_line1_odd_g_line_select_shift                          (17)
#define  PCID_PCID_LINE_1_line1_odd_r_line_select_shift                          (16)
#define  PCID_PCID_LINE_1_line1_even_b_color_select_shift                        (14)
#define  PCID_PCID_LINE_1_line1_even_g_color_select_shift                        (12)
#define  PCID_PCID_LINE_1_line1_even_r_color_select_shift                        (10)
#define  PCID_PCID_LINE_1_line1_even_b_point_select_shift                        (8)
#define  PCID_PCID_LINE_1_line1_even_g_point_select_shift                        (6)
#define  PCID_PCID_LINE_1_line1_even_r_point_select_shift                        (4)
#define  PCID_PCID_LINE_1_line1_even_b_line_select_shift                         (2)
#define  PCID_PCID_LINE_1_line1_even_g_line_select_shift                         (1)
#define  PCID_PCID_LINE_1_line1_even_r_line_select_shift                         (0)
#define  PCID_PCID_LINE_1_line1_odd_b_color_select_mask                          (0xC0000000)
#define  PCID_PCID_LINE_1_line1_odd_g_color_select_mask                          (0x30000000)
#define  PCID_PCID_LINE_1_line1_odd_r_color_select_mask                          (0x0C000000)
#define  PCID_PCID_LINE_1_line1_odd_b_point_select_mask                          (0x03000000)
#define  PCID_PCID_LINE_1_line1_odd_g_point_select_mask                          (0x00C00000)
#define  PCID_PCID_LINE_1_line1_odd_r_point_select_mask                          (0x00300000)
#define  PCID_PCID_LINE_1_line1_odd_b_line_select_mask                           (0x00040000)
#define  PCID_PCID_LINE_1_line1_odd_g_line_select_mask                           (0x00020000)
#define  PCID_PCID_LINE_1_line1_odd_r_line_select_mask                           (0x00010000)
#define  PCID_PCID_LINE_1_line1_even_b_color_select_mask                         (0x0000C000)
#define  PCID_PCID_LINE_1_line1_even_g_color_select_mask                         (0x00003000)
#define  PCID_PCID_LINE_1_line1_even_r_color_select_mask                         (0x00000C00)
#define  PCID_PCID_LINE_1_line1_even_b_point_select_mask                         (0x00000300)
#define  PCID_PCID_LINE_1_line1_even_g_point_select_mask                         (0x000000C0)
#define  PCID_PCID_LINE_1_line1_even_r_point_select_mask                         (0x00000030)
#define  PCID_PCID_LINE_1_line1_even_b_line_select_mask                          (0x00000004)
#define  PCID_PCID_LINE_1_line1_even_g_line_select_mask                          (0x00000002)
#define  PCID_PCID_LINE_1_line1_even_r_line_select_mask                          (0x00000001)
#define  PCID_PCID_LINE_1_line1_odd_b_color_select(data)                         (0xC0000000&((data)<<30))
#define  PCID_PCID_LINE_1_line1_odd_g_color_select(data)                         (0x30000000&((data)<<28))
#define  PCID_PCID_LINE_1_line1_odd_r_color_select(data)                         (0x0C000000&((data)<<26))
#define  PCID_PCID_LINE_1_line1_odd_b_point_select(data)                         (0x03000000&((data)<<24))
#define  PCID_PCID_LINE_1_line1_odd_g_point_select(data)                         (0x00C00000&((data)<<22))
#define  PCID_PCID_LINE_1_line1_odd_r_point_select(data)                         (0x00300000&((data)<<20))
#define  PCID_PCID_LINE_1_line1_odd_b_line_select(data)                          (0x00040000&((data)<<18))
#define  PCID_PCID_LINE_1_line1_odd_g_line_select(data)                          (0x00020000&((data)<<17))
#define  PCID_PCID_LINE_1_line1_odd_r_line_select(data)                          (0x00010000&((data)<<16))
#define  PCID_PCID_LINE_1_line1_even_b_color_select(data)                        (0x0000C000&((data)<<14))
#define  PCID_PCID_LINE_1_line1_even_g_color_select(data)                        (0x00003000&((data)<<12))
#define  PCID_PCID_LINE_1_line1_even_r_color_select(data)                        (0x00000C00&((data)<<10))
#define  PCID_PCID_LINE_1_line1_even_b_point_select(data)                        (0x00000300&((data)<<8))
#define  PCID_PCID_LINE_1_line1_even_g_point_select(data)                        (0x000000C0&((data)<<6))
#define  PCID_PCID_LINE_1_line1_even_r_point_select(data)                        (0x00000030&((data)<<4))
#define  PCID_PCID_LINE_1_line1_even_b_line_select(data)                         (0x00000004&((data)<<2))
#define  PCID_PCID_LINE_1_line1_even_g_line_select(data)                         (0x00000002&((data)<<1))
#define  PCID_PCID_LINE_1_line1_even_r_line_select(data)                         (0x00000001&(data))
#define  PCID_PCID_LINE_1_get_line1_odd_b_color_select(data)                     ((0xC0000000&(data))>>30)
#define  PCID_PCID_LINE_1_get_line1_odd_g_color_select(data)                     ((0x30000000&(data))>>28)
#define  PCID_PCID_LINE_1_get_line1_odd_r_color_select(data)                     ((0x0C000000&(data))>>26)
#define  PCID_PCID_LINE_1_get_line1_odd_b_point_select(data)                     ((0x03000000&(data))>>24)
#define  PCID_PCID_LINE_1_get_line1_odd_g_point_select(data)                     ((0x00C00000&(data))>>22)
#define  PCID_PCID_LINE_1_get_line1_odd_r_point_select(data)                     ((0x00300000&(data))>>20)
#define  PCID_PCID_LINE_1_get_line1_odd_b_line_select(data)                      ((0x00040000&(data))>>18)
#define  PCID_PCID_LINE_1_get_line1_odd_g_line_select(data)                      ((0x00020000&(data))>>17)
#define  PCID_PCID_LINE_1_get_line1_odd_r_line_select(data)                      ((0x00010000&(data))>>16)
#define  PCID_PCID_LINE_1_get_line1_even_b_color_select(data)                    ((0x0000C000&(data))>>14)
#define  PCID_PCID_LINE_1_get_line1_even_g_color_select(data)                    ((0x00003000&(data))>>12)
#define  PCID_PCID_LINE_1_get_line1_even_r_color_select(data)                    ((0x00000C00&(data))>>10)
#define  PCID_PCID_LINE_1_get_line1_even_b_point_select(data)                    ((0x00000300&(data))>>8)
#define  PCID_PCID_LINE_1_get_line1_even_g_point_select(data)                    ((0x000000C0&(data))>>6)
#define  PCID_PCID_LINE_1_get_line1_even_r_point_select(data)                    ((0x00000030&(data))>>4)
#define  PCID_PCID_LINE_1_get_line1_even_b_line_select(data)                     ((0x00000004&(data))>>2)
#define  PCID_PCID_LINE_1_get_line1_even_g_line_select(data)                     ((0x00000002&(data))>>1)
#define  PCID_PCID_LINE_1_get_line1_even_r_line_select(data)                     (0x00000001&(data))

#define  PCID_PCID_LINE_2                                                       0x1802EF14
#define  PCID_PCID_LINE_2_reg_addr                                               "0xB802EF14"
#define  PCID_PCID_LINE_2_reg                                                    0xB802EF14
#define  PCID_PCID_LINE_2_inst_addr                                              "0x0004"
#define  set_PCID_PCID_LINE_2_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_LINE_2_reg)=data)
#define  get_PCID_PCID_LINE_2_reg                                                (*((volatile unsigned int*)PCID_PCID_LINE_2_reg))
#define  PCID_PCID_LINE_2_line2_odd_b_color_select_shift                         (30)
#define  PCID_PCID_LINE_2_line2_odd_g_color_select_shift                         (28)
#define  PCID_PCID_LINE_2_line2_odd_r_color_select_shift                         (26)
#define  PCID_PCID_LINE_2_line2_odd_b_point_select_shift                         (24)
#define  PCID_PCID_LINE_2_line2_odd_g_point_select_shift                         (22)
#define  PCID_PCID_LINE_2_line2_odd_r_point_select_shift                         (20)
#define  PCID_PCID_LINE_2_line2_odd_b_line_select_shift                          (18)
#define  PCID_PCID_LINE_2_line2_odd_g_line_select_shift                          (17)
#define  PCID_PCID_LINE_2_line2_odd_r_line_select_shift                          (16)
#define  PCID_PCID_LINE_2_line2_even_b_color_select_shift                        (14)
#define  PCID_PCID_LINE_2_line2_even_g_color_select_shift                        (12)
#define  PCID_PCID_LINE_2_line2_even_r_color_select_shift                        (10)
#define  PCID_PCID_LINE_2_line2_even_b_point_select_shift                        (8)
#define  PCID_PCID_LINE_2_line2_even_g_point_select_shift                        (6)
#define  PCID_PCID_LINE_2_line2_even_r_point_select_shift                        (4)
#define  PCID_PCID_LINE_2_line2_even_b_line_select_shift                         (2)
#define  PCID_PCID_LINE_2_line2_even_g_line_select_shift                         (1)
#define  PCID_PCID_LINE_2_line2_even_r_line_select_shift                         (0)
#define  PCID_PCID_LINE_2_line2_odd_b_color_select_mask                          (0xC0000000)
#define  PCID_PCID_LINE_2_line2_odd_g_color_select_mask                          (0x30000000)
#define  PCID_PCID_LINE_2_line2_odd_r_color_select_mask                          (0x0C000000)
#define  PCID_PCID_LINE_2_line2_odd_b_point_select_mask                          (0x03000000)
#define  PCID_PCID_LINE_2_line2_odd_g_point_select_mask                          (0x00C00000)
#define  PCID_PCID_LINE_2_line2_odd_r_point_select_mask                          (0x00300000)
#define  PCID_PCID_LINE_2_line2_odd_b_line_select_mask                           (0x00040000)
#define  PCID_PCID_LINE_2_line2_odd_g_line_select_mask                           (0x00020000)
#define  PCID_PCID_LINE_2_line2_odd_r_line_select_mask                           (0x00010000)
#define  PCID_PCID_LINE_2_line2_even_b_color_select_mask                         (0x0000C000)
#define  PCID_PCID_LINE_2_line2_even_g_color_select_mask                         (0x00003000)
#define  PCID_PCID_LINE_2_line2_even_r_color_select_mask                         (0x00000C00)
#define  PCID_PCID_LINE_2_line2_even_b_point_select_mask                         (0x00000300)
#define  PCID_PCID_LINE_2_line2_even_g_point_select_mask                         (0x000000C0)
#define  PCID_PCID_LINE_2_line2_even_r_point_select_mask                         (0x00000030)
#define  PCID_PCID_LINE_2_line2_even_b_line_select_mask                          (0x00000004)
#define  PCID_PCID_LINE_2_line2_even_g_line_select_mask                          (0x00000002)
#define  PCID_PCID_LINE_2_line2_even_r_line_select_mask                          (0x00000001)
#define  PCID_PCID_LINE_2_line2_odd_b_color_select(data)                         (0xC0000000&((data)<<30))
#define  PCID_PCID_LINE_2_line2_odd_g_color_select(data)                         (0x30000000&((data)<<28))
#define  PCID_PCID_LINE_2_line2_odd_r_color_select(data)                         (0x0C000000&((data)<<26))
#define  PCID_PCID_LINE_2_line2_odd_b_point_select(data)                         (0x03000000&((data)<<24))
#define  PCID_PCID_LINE_2_line2_odd_g_point_select(data)                         (0x00C00000&((data)<<22))
#define  PCID_PCID_LINE_2_line2_odd_r_point_select(data)                         (0x00300000&((data)<<20))
#define  PCID_PCID_LINE_2_line2_odd_b_line_select(data)                          (0x00040000&((data)<<18))
#define  PCID_PCID_LINE_2_line2_odd_g_line_select(data)                          (0x00020000&((data)<<17))
#define  PCID_PCID_LINE_2_line2_odd_r_line_select(data)                          (0x00010000&((data)<<16))
#define  PCID_PCID_LINE_2_line2_even_b_color_select(data)                        (0x0000C000&((data)<<14))
#define  PCID_PCID_LINE_2_line2_even_g_color_select(data)                        (0x00003000&((data)<<12))
#define  PCID_PCID_LINE_2_line2_even_r_color_select(data)                        (0x00000C00&((data)<<10))
#define  PCID_PCID_LINE_2_line2_even_b_point_select(data)                        (0x00000300&((data)<<8))
#define  PCID_PCID_LINE_2_line2_even_g_point_select(data)                        (0x000000C0&((data)<<6))
#define  PCID_PCID_LINE_2_line2_even_r_point_select(data)                        (0x00000030&((data)<<4))
#define  PCID_PCID_LINE_2_line2_even_b_line_select(data)                         (0x00000004&((data)<<2))
#define  PCID_PCID_LINE_2_line2_even_g_line_select(data)                         (0x00000002&((data)<<1))
#define  PCID_PCID_LINE_2_line2_even_r_line_select(data)                         (0x00000001&(data))
#define  PCID_PCID_LINE_2_get_line2_odd_b_color_select(data)                     ((0xC0000000&(data))>>30)
#define  PCID_PCID_LINE_2_get_line2_odd_g_color_select(data)                     ((0x30000000&(data))>>28)
#define  PCID_PCID_LINE_2_get_line2_odd_r_color_select(data)                     ((0x0C000000&(data))>>26)
#define  PCID_PCID_LINE_2_get_line2_odd_b_point_select(data)                     ((0x03000000&(data))>>24)
#define  PCID_PCID_LINE_2_get_line2_odd_g_point_select(data)                     ((0x00C00000&(data))>>22)
#define  PCID_PCID_LINE_2_get_line2_odd_r_point_select(data)                     ((0x00300000&(data))>>20)
#define  PCID_PCID_LINE_2_get_line2_odd_b_line_select(data)                      ((0x00040000&(data))>>18)
#define  PCID_PCID_LINE_2_get_line2_odd_g_line_select(data)                      ((0x00020000&(data))>>17)
#define  PCID_PCID_LINE_2_get_line2_odd_r_line_select(data)                      ((0x00010000&(data))>>16)
#define  PCID_PCID_LINE_2_get_line2_even_b_color_select(data)                    ((0x0000C000&(data))>>14)
#define  PCID_PCID_LINE_2_get_line2_even_g_color_select(data)                    ((0x00003000&(data))>>12)
#define  PCID_PCID_LINE_2_get_line2_even_r_color_select(data)                    ((0x00000C00&(data))>>10)
#define  PCID_PCID_LINE_2_get_line2_even_b_point_select(data)                    ((0x00000300&(data))>>8)
#define  PCID_PCID_LINE_2_get_line2_even_g_point_select(data)                    ((0x000000C0&(data))>>6)
#define  PCID_PCID_LINE_2_get_line2_even_r_point_select(data)                    ((0x00000030&(data))>>4)
#define  PCID_PCID_LINE_2_get_line2_even_b_line_select(data)                     ((0x00000004&(data))>>2)
#define  PCID_PCID_LINE_2_get_line2_even_g_line_select(data)                     ((0x00000002&(data))>>1)
#define  PCID_PCID_LINE_2_get_line2_even_r_line_select(data)                     (0x00000001&(data))

#define  PCID_PCID_LINE_3                                                       0x1802EF18
#define  PCID_PCID_LINE_3_reg_addr                                               "0xB802EF18"
#define  PCID_PCID_LINE_3_reg                                                    0xB802EF18
#define  PCID_PCID_LINE_3_inst_addr                                              "0x0005"
#define  set_PCID_PCID_LINE_3_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_LINE_3_reg)=data)
#define  get_PCID_PCID_LINE_3_reg                                                (*((volatile unsigned int*)PCID_PCID_LINE_3_reg))
#define  PCID_PCID_LINE_3_line3_odd_b_color_select_shift                         (30)
#define  PCID_PCID_LINE_3_line3_odd_g_color_select_shift                         (28)
#define  PCID_PCID_LINE_3_line3_odd_r_color_select_shift                         (26)
#define  PCID_PCID_LINE_3_line3_odd_b_point_select_shift                         (24)
#define  PCID_PCID_LINE_3_line3_odd_g_point_select_shift                         (22)
#define  PCID_PCID_LINE_3_line3_odd_r_point_select_shift                         (20)
#define  PCID_PCID_LINE_3_line3_odd_b_line_select_shift                          (18)
#define  PCID_PCID_LINE_3_line3_odd_g_line_select_shift                          (17)
#define  PCID_PCID_LINE_3_line3_odd_r_line_select_shift                          (16)
#define  PCID_PCID_LINE_3_line3_even_b_color_select_shift                        (14)
#define  PCID_PCID_LINE_3_line3_even_g_color_select_shift                        (12)
#define  PCID_PCID_LINE_3_line3_even_r_color_select_shift                        (10)
#define  PCID_PCID_LINE_3_line3_even_b_point_select_shift                        (8)
#define  PCID_PCID_LINE_3_line3_even_g_point_select_shift                        (6)
#define  PCID_PCID_LINE_3_line3_even_r_point_select_shift                        (4)
#define  PCID_PCID_LINE_3_line3_even_b_line_select_shift                         (2)
#define  PCID_PCID_LINE_3_line3_even_g_line_select_shift                         (1)
#define  PCID_PCID_LINE_3_line3_even_r_line_select_shift                         (0)
#define  PCID_PCID_LINE_3_line3_odd_b_color_select_mask                          (0xC0000000)
#define  PCID_PCID_LINE_3_line3_odd_g_color_select_mask                          (0x30000000)
#define  PCID_PCID_LINE_3_line3_odd_r_color_select_mask                          (0x0C000000)
#define  PCID_PCID_LINE_3_line3_odd_b_point_select_mask                          (0x03000000)
#define  PCID_PCID_LINE_3_line3_odd_g_point_select_mask                          (0x00C00000)
#define  PCID_PCID_LINE_3_line3_odd_r_point_select_mask                          (0x00300000)
#define  PCID_PCID_LINE_3_line3_odd_b_line_select_mask                           (0x00040000)
#define  PCID_PCID_LINE_3_line3_odd_g_line_select_mask                           (0x00020000)
#define  PCID_PCID_LINE_3_line3_odd_r_line_select_mask                           (0x00010000)
#define  PCID_PCID_LINE_3_line3_even_b_color_select_mask                         (0x0000C000)
#define  PCID_PCID_LINE_3_line3_even_g_color_select_mask                         (0x00003000)
#define  PCID_PCID_LINE_3_line3_even_r_color_select_mask                         (0x00000C00)
#define  PCID_PCID_LINE_3_line3_even_b_point_select_mask                         (0x00000300)
#define  PCID_PCID_LINE_3_line3_even_g_point_select_mask                         (0x000000C0)
#define  PCID_PCID_LINE_3_line3_even_r_point_select_mask                         (0x00000030)
#define  PCID_PCID_LINE_3_line3_even_b_line_select_mask                          (0x00000004)
#define  PCID_PCID_LINE_3_line3_even_g_line_select_mask                          (0x00000002)
#define  PCID_PCID_LINE_3_line3_even_r_line_select_mask                          (0x00000001)
#define  PCID_PCID_LINE_3_line3_odd_b_color_select(data)                         (0xC0000000&((data)<<30))
#define  PCID_PCID_LINE_3_line3_odd_g_color_select(data)                         (0x30000000&((data)<<28))
#define  PCID_PCID_LINE_3_line3_odd_r_color_select(data)                         (0x0C000000&((data)<<26))
#define  PCID_PCID_LINE_3_line3_odd_b_point_select(data)                         (0x03000000&((data)<<24))
#define  PCID_PCID_LINE_3_line3_odd_g_point_select(data)                         (0x00C00000&((data)<<22))
#define  PCID_PCID_LINE_3_line3_odd_r_point_select(data)                         (0x00300000&((data)<<20))
#define  PCID_PCID_LINE_3_line3_odd_b_line_select(data)                          (0x00040000&((data)<<18))
#define  PCID_PCID_LINE_3_line3_odd_g_line_select(data)                          (0x00020000&((data)<<17))
#define  PCID_PCID_LINE_3_line3_odd_r_line_select(data)                          (0x00010000&((data)<<16))
#define  PCID_PCID_LINE_3_line3_even_b_color_select(data)                        (0x0000C000&((data)<<14))
#define  PCID_PCID_LINE_3_line3_even_g_color_select(data)                        (0x00003000&((data)<<12))
#define  PCID_PCID_LINE_3_line3_even_r_color_select(data)                        (0x00000C00&((data)<<10))
#define  PCID_PCID_LINE_3_line3_even_b_point_select(data)                        (0x00000300&((data)<<8))
#define  PCID_PCID_LINE_3_line3_even_g_point_select(data)                        (0x000000C0&((data)<<6))
#define  PCID_PCID_LINE_3_line3_even_r_point_select(data)                        (0x00000030&((data)<<4))
#define  PCID_PCID_LINE_3_line3_even_b_line_select(data)                         (0x00000004&((data)<<2))
#define  PCID_PCID_LINE_3_line3_even_g_line_select(data)                         (0x00000002&((data)<<1))
#define  PCID_PCID_LINE_3_line3_even_r_line_select(data)                         (0x00000001&(data))
#define  PCID_PCID_LINE_3_get_line3_odd_b_color_select(data)                     ((0xC0000000&(data))>>30)
#define  PCID_PCID_LINE_3_get_line3_odd_g_color_select(data)                     ((0x30000000&(data))>>28)
#define  PCID_PCID_LINE_3_get_line3_odd_r_color_select(data)                     ((0x0C000000&(data))>>26)
#define  PCID_PCID_LINE_3_get_line3_odd_b_point_select(data)                     ((0x03000000&(data))>>24)
#define  PCID_PCID_LINE_3_get_line3_odd_g_point_select(data)                     ((0x00C00000&(data))>>22)
#define  PCID_PCID_LINE_3_get_line3_odd_r_point_select(data)                     ((0x00300000&(data))>>20)
#define  PCID_PCID_LINE_3_get_line3_odd_b_line_select(data)                      ((0x00040000&(data))>>18)
#define  PCID_PCID_LINE_3_get_line3_odd_g_line_select(data)                      ((0x00020000&(data))>>17)
#define  PCID_PCID_LINE_3_get_line3_odd_r_line_select(data)                      ((0x00010000&(data))>>16)
#define  PCID_PCID_LINE_3_get_line3_even_b_color_select(data)                    ((0x0000C000&(data))>>14)
#define  PCID_PCID_LINE_3_get_line3_even_g_color_select(data)                    ((0x00003000&(data))>>12)
#define  PCID_PCID_LINE_3_get_line3_even_r_color_select(data)                    ((0x00000C00&(data))>>10)
#define  PCID_PCID_LINE_3_get_line3_even_b_point_select(data)                    ((0x00000300&(data))>>8)
#define  PCID_PCID_LINE_3_get_line3_even_g_point_select(data)                    ((0x000000C0&(data))>>6)
#define  PCID_PCID_LINE_3_get_line3_even_r_point_select(data)                    ((0x00000030&(data))>>4)
#define  PCID_PCID_LINE_3_get_line3_even_b_line_select(data)                     ((0x00000004&(data))>>2)
#define  PCID_PCID_LINE_3_get_line3_even_g_line_select(data)                     ((0x00000002&(data))>>1)
#define  PCID_PCID_LINE_3_get_line3_even_r_line_select(data)                     (0x00000001&(data))

#define  PCID_PCID_LINE_4                                                       0x1802EF1C
#define  PCID_PCID_LINE_4_reg_addr                                               "0xB802EF1C"
#define  PCID_PCID_LINE_4_reg                                                    0xB802EF1C
#define  PCID_PCID_LINE_4_inst_addr                                              "0x0006"
#define  set_PCID_PCID_LINE_4_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_LINE_4_reg)=data)
#define  get_PCID_PCID_LINE_4_reg                                                (*((volatile unsigned int*)PCID_PCID_LINE_4_reg))
#define  PCID_PCID_LINE_4_line4_odd_b_color_select_shift                         (30)
#define  PCID_PCID_LINE_4_line4_odd_g_color_select_shift                         (28)
#define  PCID_PCID_LINE_4_line4_odd_r_color_select_shift                         (26)
#define  PCID_PCID_LINE_4_line4_odd_b_point_select_shift                         (24)
#define  PCID_PCID_LINE_4_line4_odd_g_point_select_shift                         (22)
#define  PCID_PCID_LINE_4_line4_odd_r_point_select_shift                         (20)
#define  PCID_PCID_LINE_4_line4_odd_b_line_select_shift                          (18)
#define  PCID_PCID_LINE_4_line4_odd_g_line_select_shift                          (17)
#define  PCID_PCID_LINE_4_line4_odd_r_line_select_shift                          (16)
#define  PCID_PCID_LINE_4_line4_even_b_color_select_shift                        (14)
#define  PCID_PCID_LINE_4_line4_even_g_color_select_shift                        (12)
#define  PCID_PCID_LINE_4_line4_even_r_color_select_shift                        (10)
#define  PCID_PCID_LINE_4_line4_even_b_point_select_shift                        (8)
#define  PCID_PCID_LINE_4_line4_even_g_point_select_shift                        (6)
#define  PCID_PCID_LINE_4_line4_even_r_point_select_shift                        (4)
#define  PCID_PCID_LINE_4_line4_even_b_line_select_shift                         (2)
#define  PCID_PCID_LINE_4_line4_even_g_line_select_shift                         (1)
#define  PCID_PCID_LINE_4_line4_even_r_line_select_shift                         (0)
#define  PCID_PCID_LINE_4_line4_odd_b_color_select_mask                          (0xC0000000)
#define  PCID_PCID_LINE_4_line4_odd_g_color_select_mask                          (0x30000000)
#define  PCID_PCID_LINE_4_line4_odd_r_color_select_mask                          (0x0C000000)
#define  PCID_PCID_LINE_4_line4_odd_b_point_select_mask                          (0x03000000)
#define  PCID_PCID_LINE_4_line4_odd_g_point_select_mask                          (0x00C00000)
#define  PCID_PCID_LINE_4_line4_odd_r_point_select_mask                          (0x00300000)
#define  PCID_PCID_LINE_4_line4_odd_b_line_select_mask                           (0x00040000)
#define  PCID_PCID_LINE_4_line4_odd_g_line_select_mask                           (0x00020000)
#define  PCID_PCID_LINE_4_line4_odd_r_line_select_mask                           (0x00010000)
#define  PCID_PCID_LINE_4_line4_even_b_color_select_mask                         (0x0000C000)
#define  PCID_PCID_LINE_4_line4_even_g_color_select_mask                         (0x00003000)
#define  PCID_PCID_LINE_4_line4_even_r_color_select_mask                         (0x00000C00)
#define  PCID_PCID_LINE_4_line4_even_b_point_select_mask                         (0x00000300)
#define  PCID_PCID_LINE_4_line4_even_g_point_select_mask                         (0x000000C0)
#define  PCID_PCID_LINE_4_line4_even_r_point_select_mask                         (0x00000030)
#define  PCID_PCID_LINE_4_line4_even_b_line_select_mask                          (0x00000004)
#define  PCID_PCID_LINE_4_line4_even_g_line_select_mask                          (0x00000002)
#define  PCID_PCID_LINE_4_line4_even_r_line_select_mask                          (0x00000001)
#define  PCID_PCID_LINE_4_line4_odd_b_color_select(data)                         (0xC0000000&((data)<<30))
#define  PCID_PCID_LINE_4_line4_odd_g_color_select(data)                         (0x30000000&((data)<<28))
#define  PCID_PCID_LINE_4_line4_odd_r_color_select(data)                         (0x0C000000&((data)<<26))
#define  PCID_PCID_LINE_4_line4_odd_b_point_select(data)                         (0x03000000&((data)<<24))
#define  PCID_PCID_LINE_4_line4_odd_g_point_select(data)                         (0x00C00000&((data)<<22))
#define  PCID_PCID_LINE_4_line4_odd_r_point_select(data)                         (0x00300000&((data)<<20))
#define  PCID_PCID_LINE_4_line4_odd_b_line_select(data)                          (0x00040000&((data)<<18))
#define  PCID_PCID_LINE_4_line4_odd_g_line_select(data)                          (0x00020000&((data)<<17))
#define  PCID_PCID_LINE_4_line4_odd_r_line_select(data)                          (0x00010000&((data)<<16))
#define  PCID_PCID_LINE_4_line4_even_b_color_select(data)                        (0x0000C000&((data)<<14))
#define  PCID_PCID_LINE_4_line4_even_g_color_select(data)                        (0x00003000&((data)<<12))
#define  PCID_PCID_LINE_4_line4_even_r_color_select(data)                        (0x00000C00&((data)<<10))
#define  PCID_PCID_LINE_4_line4_even_b_point_select(data)                        (0x00000300&((data)<<8))
#define  PCID_PCID_LINE_4_line4_even_g_point_select(data)                        (0x000000C0&((data)<<6))
#define  PCID_PCID_LINE_4_line4_even_r_point_select(data)                        (0x00000030&((data)<<4))
#define  PCID_PCID_LINE_4_line4_even_b_line_select(data)                         (0x00000004&((data)<<2))
#define  PCID_PCID_LINE_4_line4_even_g_line_select(data)                         (0x00000002&((data)<<1))
#define  PCID_PCID_LINE_4_line4_even_r_line_select(data)                         (0x00000001&(data))
#define  PCID_PCID_LINE_4_get_line4_odd_b_color_select(data)                     ((0xC0000000&(data))>>30)
#define  PCID_PCID_LINE_4_get_line4_odd_g_color_select(data)                     ((0x30000000&(data))>>28)
#define  PCID_PCID_LINE_4_get_line4_odd_r_color_select(data)                     ((0x0C000000&(data))>>26)
#define  PCID_PCID_LINE_4_get_line4_odd_b_point_select(data)                     ((0x03000000&(data))>>24)
#define  PCID_PCID_LINE_4_get_line4_odd_g_point_select(data)                     ((0x00C00000&(data))>>22)
#define  PCID_PCID_LINE_4_get_line4_odd_r_point_select(data)                     ((0x00300000&(data))>>20)
#define  PCID_PCID_LINE_4_get_line4_odd_b_line_select(data)                      ((0x00040000&(data))>>18)
#define  PCID_PCID_LINE_4_get_line4_odd_g_line_select(data)                      ((0x00020000&(data))>>17)
#define  PCID_PCID_LINE_4_get_line4_odd_r_line_select(data)                      ((0x00010000&(data))>>16)
#define  PCID_PCID_LINE_4_get_line4_even_b_color_select(data)                    ((0x0000C000&(data))>>14)
#define  PCID_PCID_LINE_4_get_line4_even_g_color_select(data)                    ((0x00003000&(data))>>12)
#define  PCID_PCID_LINE_4_get_line4_even_r_color_select(data)                    ((0x00000C00&(data))>>10)
#define  PCID_PCID_LINE_4_get_line4_even_b_point_select(data)                    ((0x00000300&(data))>>8)
#define  PCID_PCID_LINE_4_get_line4_even_g_point_select(data)                    ((0x000000C0&(data))>>6)
#define  PCID_PCID_LINE_4_get_line4_even_r_point_select(data)                    ((0x00000030&(data))>>4)
#define  PCID_PCID_LINE_4_get_line4_even_b_line_select(data)                     ((0x00000004&(data))>>2)
#define  PCID_PCID_LINE_4_get_line4_even_g_line_select(data)                     ((0x00000002&(data))>>1)
#define  PCID_PCID_LINE_4_get_line4_even_r_line_select(data)                     (0x00000001&(data))

#define  PCID_PCID_RM                                                           0x1802EFA0
#define  PCID_PCID_RM_reg_addr                                                   "0xB802EFA0"
#define  PCID_PCID_RM_reg                                                        0xB802EFA0
#define  PCID_PCID_RM_inst_addr                                                  "0x0007"
#define  set_PCID_PCID_RM_reg(data)                                              (*((volatile unsigned int*)PCID_PCID_RM_reg)=data)
#define  get_PCID_PCID_RM_reg                                                    (*((volatile unsigned int*)PCID_PCID_RM_reg))
#define  PCID_PCID_RM_pcid_lb_rm_1_shift                                         (4)
#define  PCID_PCID_RM_pcid_lb_rm_0_shift                                         (0)
#define  PCID_PCID_RM_pcid_lb_rm_1_mask                                          (0x000000F0)
#define  PCID_PCID_RM_pcid_lb_rm_0_mask                                          (0x0000000F)
#define  PCID_PCID_RM_pcid_lb_rm_1(data)                                         (0x000000F0&((data)<<4))
#define  PCID_PCID_RM_pcid_lb_rm_0(data)                                         (0x0000000F&(data))
#define  PCID_PCID_RM_get_pcid_lb_rm_1(data)                                     ((0x000000F0&(data))>>4)
#define  PCID_PCID_RM_get_pcid_lb_rm_0(data)                                     (0x0000000F&(data))

#define  PCID_PCID_RME_LS                                                       0x1802EFA4
#define  PCID_PCID_RME_LS_reg_addr                                               "0xB802EFA4"
#define  PCID_PCID_RME_LS_reg                                                    0xB802EFA4
#define  PCID_PCID_RME_LS_inst_addr                                              "0x0008"
#define  set_PCID_PCID_RME_LS_reg(data)                                          (*((volatile unsigned int*)PCID_PCID_RME_LS_reg)=data)
#define  get_PCID_PCID_RME_LS_reg                                                (*((volatile unsigned int*)PCID_PCID_RME_LS_reg))
#define  PCID_PCID_RME_LS_pcid_lb_ls_1_shift                                     (17)
#define  PCID_PCID_RME_LS_pcid_lb_ls_0_shift                                     (16)
#define  PCID_PCID_RME_LS_pcid_lb_rme_1_shift                                    (1)
#define  PCID_PCID_RME_LS_pcid_lb_rme_0_shift                                    (0)
#define  PCID_PCID_RME_LS_pcid_lb_ls_1_mask                                      (0x00020000)
#define  PCID_PCID_RME_LS_pcid_lb_ls_0_mask                                      (0x00010000)
#define  PCID_PCID_RME_LS_pcid_lb_rme_1_mask                                     (0x00000002)
#define  PCID_PCID_RME_LS_pcid_lb_rme_0_mask                                     (0x00000001)
#define  PCID_PCID_RME_LS_pcid_lb_ls_1(data)                                     (0x00020000&((data)<<17))
#define  PCID_PCID_RME_LS_pcid_lb_ls_0(data)                                     (0x00010000&((data)<<16))
#define  PCID_PCID_RME_LS_pcid_lb_rme_1(data)                                    (0x00000002&((data)<<1))
#define  PCID_PCID_RME_LS_pcid_lb_rme_0(data)                                    (0x00000001&(data))
#define  PCID_PCID_RME_LS_get_pcid_lb_ls_1(data)                                 ((0x00020000&(data))>>17)
#define  PCID_PCID_RME_LS_get_pcid_lb_ls_0(data)                                 ((0x00010000&(data))>>16)
#define  PCID_PCID_RME_LS_get_pcid_lb_rme_1(data)                                ((0x00000002&(data))>>1)
#define  PCID_PCID_RME_LS_get_pcid_lb_rme_0(data)                                (0x00000001&(data))

#define  PCID_PCID_FAIL                                                         0x1802EFA8
#define  PCID_PCID_FAIL_reg_addr                                                 "0xB802EFA8"
#define  PCID_PCID_FAIL_reg                                                      0xB802EFA8
#define  PCID_PCID_FAIL_inst_addr                                                "0x0009"
#define  set_PCID_PCID_FAIL_reg(data)                                            (*((volatile unsigned int*)PCID_PCID_FAIL_reg)=data)
#define  get_PCID_PCID_FAIL_reg                                                  (*((volatile unsigned int*)PCID_PCID_FAIL_reg))
#define  PCID_PCID_FAIL_pcid_lb_drf_fail_1_shift                                 (17)
#define  PCID_PCID_FAIL_pcid_lb_drf_fail_0_shift                                 (16)
#define  PCID_PCID_FAIL_pcid_lb_bist_fail_1_shift                                (1)
#define  PCID_PCID_FAIL_pcid_lb_bist_fail_0_shift                                (0)
#define  PCID_PCID_FAIL_pcid_lb_drf_fail_1_mask                                  (0x00020000)
#define  PCID_PCID_FAIL_pcid_lb_drf_fail_0_mask                                  (0x00010000)
#define  PCID_PCID_FAIL_pcid_lb_bist_fail_1_mask                                 (0x00000002)
#define  PCID_PCID_FAIL_pcid_lb_bist_fail_0_mask                                 (0x00000001)
#define  PCID_PCID_FAIL_pcid_lb_drf_fail_1(data)                                 (0x00020000&((data)<<17))
#define  PCID_PCID_FAIL_pcid_lb_drf_fail_0(data)                                 (0x00010000&((data)<<16))
#define  PCID_PCID_FAIL_pcid_lb_bist_fail_1(data)                                (0x00000002&((data)<<1))
#define  PCID_PCID_FAIL_pcid_lb_bist_fail_0(data)                                (0x00000001&(data))
#define  PCID_PCID_FAIL_get_pcid_lb_drf_fail_1(data)                             ((0x00020000&(data))>>17)
#define  PCID_PCID_FAIL_get_pcid_lb_drf_fail_0(data)                             ((0x00010000&(data))>>16)
#define  PCID_PCID_FAIL_get_pcid_lb_bist_fail_1(data)                            ((0x00000002&(data))>>1)
#define  PCID_PCID_FAIL_get_pcid_lb_bist_fail_0(data)                            (0x00000001&(data))

#define  PCID_PCID_TESTRWM                                                      0x1802EFAC
#define  PCID_PCID_TESTRWM_reg_addr                                              "0xB802EFAC"
#define  PCID_PCID_TESTRWM_reg                                                   0xB802EFAC
#define  PCID_PCID_TESTRWM_inst_addr                                             "0x000A"
#define  set_PCID_PCID_TESTRWM_reg(data)                                         (*((volatile unsigned int*)PCID_PCID_TESTRWM_reg)=data)
#define  get_PCID_PCID_TESTRWM_reg                                               (*((volatile unsigned int*)PCID_PCID_TESTRWM_reg))
#define  PCID_PCID_TESTRWM_pcid_lb_testrwm_1_shift                               (1)
#define  PCID_PCID_TESTRWM_pcid_lb_testrwm_0_shift                               (0)
#define  PCID_PCID_TESTRWM_pcid_lb_testrwm_1_mask                                (0x00000002)
#define  PCID_PCID_TESTRWM_pcid_lb_testrwm_0_mask                                (0x00000001)
#define  PCID_PCID_TESTRWM_pcid_lb_testrwm_1(data)                               (0x00000002&((data)<<1))
#define  PCID_PCID_TESTRWM_pcid_lb_testrwm_0(data)                               (0x00000001&(data))
#define  PCID_PCID_TESTRWM_get_pcid_lb_testrwm_1(data)                           ((0x00000002&(data))>>1)
#define  PCID_PCID_TESTRWM_get_pcid_lb_testrwm_0(data)                           (0x00000001&(data))

#define  PCID_PCID_LUT_ADDR                                                     0x1802EF20
#define  PCID_PCID_LUT_ADDR_reg_addr                                             "0xB802EF20"
#define  PCID_PCID_LUT_ADDR_reg                                                  0xB802EF20
#define  PCID_PCID_LUT_ADDR_inst_addr                                            "0x000B"
#define  set_PCID_PCID_LUT_ADDR_reg(data)                                        (*((volatile unsigned int*)PCID_PCID_LUT_ADDR_reg)=data)
#define  get_PCID_PCID_LUT_ADDR_reg                                              (*((volatile unsigned int*)PCID_PCID_LUT_ADDR_reg))
#define  PCID_PCID_LUT_ADDR_pcid_regional_lut_ax_en_shift                        (21)
#define  PCID_PCID_LUT_ADDR_pcid_regional_lut_sel_shift                          (17)
#define  PCID_PCID_LUT_ADDR_pcid_lut_sel_shift                                   (12)
#define  PCID_PCID_LUT_ADDR_pcid_regional_lut_ax_en_mask                         (0x00200000)
#define  PCID_PCID_LUT_ADDR_pcid_regional_lut_sel_mask                           (0x001E0000)
#define  PCID_PCID_LUT_ADDR_pcid_lut_sel_mask                                    (0x00003000)
#define  PCID_PCID_LUT_ADDR_pcid_regional_lut_ax_en(data)                        (0x00200000&((data)<<21))
#define  PCID_PCID_LUT_ADDR_pcid_regional_lut_sel(data)                          (0x001E0000&((data)<<17))
#define  PCID_PCID_LUT_ADDR_pcid_lut_sel(data)                                   (0x00003000&((data)<<12))
#define  PCID_PCID_LUT_ADDR_get_pcid_regional_lut_ax_en(data)                    ((0x00200000&(data))>>21)
#define  PCID_PCID_LUT_ADDR_get_pcid_regional_lut_sel(data)                      ((0x001E0000&(data))>>17)
#define  PCID_PCID_LUT_ADDR_get_pcid_lut_sel(data)                               ((0x00003000&(data))>>12)

#define  PCID_PCID_LUT_DATA                                                     0x1802EF24
#define  PCID_PCID_LUT_DATA_reg_addr                                             "0xB802EF24"
#define  PCID_PCID_LUT_DATA_reg                                                  0xB802EF24
#define  PCID_PCID_LUT_DATA_inst_addr                                            "0x000C"
#define  set_PCID_PCID_LUT_DATA_reg(data)                                        (*((volatile unsigned int*)PCID_PCID_LUT_DATA_reg)=data)
#define  get_PCID_PCID_LUT_DATA_reg                                              (*((volatile unsigned int*)PCID_PCID_LUT_DATA_reg))
#define  PCID_PCID_LUT_DATA_pcid_lut_data_shift                                  (0)
#define  PCID_PCID_LUT_DATA_pcid_lut_data_mask                                   (0xFFFFFFFF)
#define  PCID_PCID_LUT_DATA_pcid_lut_data(data)                                  (0xFFFFFFFF&(data))
#define  PCID_PCID_LUT_DATA_get_pcid_lut_data(data)                              (0xFFFFFFFF&(data))

#define  PCID_PCID_RegionalTable_Ctrl                                           0x1802EF30
#define  PCID_PCID_RegionalTable_Ctrl_reg_addr                                   "0xB802EF30"
#define  PCID_PCID_RegionalTable_Ctrl_reg                                        0xB802EF30
#define  PCID_PCID_RegionalTable_Ctrl_inst_addr                                  "0x000D"
#define  set_PCID_PCID_RegionalTable_Ctrl_reg(data)                              (*((volatile unsigned int*)PCID_PCID_RegionalTable_Ctrl_reg)=data)
#define  get_PCID_PCID_RegionalTable_Ctrl_reg                                    (*((volatile unsigned int*)PCID_PCID_RegionalTable_Ctrl_reg))
#define  PCID_PCID_RegionalTable_Ctrl_pcid_regional_10x1_en_shift                (2)
#define  PCID_PCID_RegionalTable_Ctrl_pcid_regional_19x19tab_en_shift            (1)
#define  PCID_PCID_RegionalTable_Ctrl_regional_table_en_shift                    (0)
#define  PCID_PCID_RegionalTable_Ctrl_pcid_regional_10x1_en_mask                 (0x00000004)
#define  PCID_PCID_RegionalTable_Ctrl_pcid_regional_19x19tab_en_mask             (0x00000002)
#define  PCID_PCID_RegionalTable_Ctrl_regional_table_en_mask                     (0x00000001)
#define  PCID_PCID_RegionalTable_Ctrl_pcid_regional_10x1_en(data)                (0x00000004&((data)<<2))
#define  PCID_PCID_RegionalTable_Ctrl_pcid_regional_19x19tab_en(data)            (0x00000002&((data)<<1))
#define  PCID_PCID_RegionalTable_Ctrl_regional_table_en(data)                    (0x00000001&(data))
#define  PCID_PCID_RegionalTable_Ctrl_get_pcid_regional_10x1_en(data)            ((0x00000004&(data))>>2)
#define  PCID_PCID_RegionalTable_Ctrl_get_pcid_regional_19x19tab_en(data)        ((0x00000002&(data))>>1)
#define  PCID_PCID_RegionalTable_Ctrl_get_regional_table_en(data)                (0x00000001&(data))

#define  PCID_PCID_RegionalTable_Index_H                                        0x1802EF34
#define  PCID_PCID_RegionalTable_Index_H_reg_addr                                "0xB802EF34"
#define  PCID_PCID_RegionalTable_Index_H_reg                                     0xB802EF34
#define  PCID_PCID_RegionalTable_Index_H_inst_addr                               "0x000E"
#define  set_PCID_PCID_RegionalTable_Index_H_reg(data)                           (*((volatile unsigned int*)PCID_PCID_RegionalTable_Index_H_reg)=data)
#define  get_PCID_PCID_RegionalTable_Index_H_reg                                 (*((volatile unsigned int*)PCID_PCID_RegionalTable_Index_H_reg))
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index2_shift                     (20)
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index1_shift                     (10)
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index0_shift                     (0)
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index2_mask                      (0x3FF00000)
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index1_mask                      (0x000FFC00)
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index0_mask                      (0x000003FF)
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index2(data)                     (0x3FF00000&((data)<<20))
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index1(data)                     (0x000FFC00&((data)<<10))
#define  PCID_PCID_RegionalTable_Index_H_rt_hor_index0(data)                     (0x000003FF&(data))
#define  PCID_PCID_RegionalTable_Index_H_get_rt_hor_index2(data)                 ((0x3FF00000&(data))>>20)
#define  PCID_PCID_RegionalTable_Index_H_get_rt_hor_index1(data)                 ((0x000FFC00&(data))>>10)
#define  PCID_PCID_RegionalTable_Index_H_get_rt_hor_index0(data)                 (0x000003FF&(data))

#define  PCID_PCID_RegionalTable_Index_V                                        0x1802EF38
#define  PCID_PCID_RegionalTable_Index_V_reg_addr                                "0xB802EF38"
#define  PCID_PCID_RegionalTable_Index_V_reg                                     0xB802EF38
#define  PCID_PCID_RegionalTable_Index_V_inst_addr                               "0x000F"
#define  set_PCID_PCID_RegionalTable_Index_V_reg(data)                           (*((volatile unsigned int*)PCID_PCID_RegionalTable_Index_V_reg)=data)
#define  get_PCID_PCID_RegionalTable_Index_V_reg                                 (*((volatile unsigned int*)PCID_PCID_RegionalTable_Index_V_reg))
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index2_shift                     (20)
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index1_shift                     (10)
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index0_shift                     (0)
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index2_mask                      (0x3FF00000)
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index1_mask                      (0x000FFC00)
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index0_mask                      (0x000003FF)
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index2(data)                     (0x3FF00000&((data)<<20))
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index1(data)                     (0x000FFC00&((data)<<10))
#define  PCID_PCID_RegionalTable_Index_V_rt_ver_index0(data)                     (0x000003FF&(data))
#define  PCID_PCID_RegionalTable_Index_V_get_rt_ver_index2(data)                 ((0x3FF00000&(data))>>20)
#define  PCID_PCID_RegionalTable_Index_V_get_rt_ver_index1(data)                 ((0x000FFC00&(data))>>10)
#define  PCID_PCID_RegionalTable_Index_V_get_rt_ver_index0(data)                 (0x000003FF&(data))

#define  PCID_PCID_RegionalTable_Step                                           0x1802EF3C
#define  PCID_PCID_RegionalTable_Step_reg_addr                                   "0xB802EF3C"
#define  PCID_PCID_RegionalTable_Step_reg                                        0xB802EF3C
#define  PCID_PCID_RegionalTable_Step_inst_addr                                  "0x0010"
#define  set_PCID_PCID_RegionalTable_Step_reg(data)                              (*((volatile unsigned int*)PCID_PCID_RegionalTable_Step_reg)=data)
#define  get_PCID_PCID_RegionalTable_Step_reg                                    (*((volatile unsigned int*)PCID_PCID_RegionalTable_Step_reg))
#define  PCID_PCID_RegionalTable_Step_rt_hor_step_mode_shift                     (28)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step_mode_shift                     (16)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step2_shift                         (12)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step1_shift                         (10)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step0_shift                         (8)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step2_shift                         (4)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step1_shift                         (2)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step0_shift                         (0)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step_mode_mask                      (0x70000000)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step_mode_mask                      (0x01FF0000)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step2_mask                          (0x00003000)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step1_mask                          (0x00000C00)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step0_mask                          (0x00000300)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step2_mask                          (0x00000030)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step1_mask                          (0x0000000C)
#define  PCID_PCID_RegionalTable_Step_rt_ver_step0_mask                          (0x00000003)
#define  PCID_PCID_RegionalTable_Step_rt_hor_step_mode(data)                     (0x70000000&((data)<<28))
#define  PCID_PCID_RegionalTable_Step_rt_ver_step_mode(data)                     (0x01FF0000&((data)<<16))
#define  PCID_PCID_RegionalTable_Step_rt_hor_step2(data)                         (0x00003000&((data)<<12))
#define  PCID_PCID_RegionalTable_Step_rt_hor_step1(data)                         (0x00000C00&((data)<<10))
#define  PCID_PCID_RegionalTable_Step_rt_hor_step0(data)                         (0x00000300&((data)<<8))
#define  PCID_PCID_RegionalTable_Step_rt_ver_step2(data)                         (0x00000030&((data)<<4))
#define  PCID_PCID_RegionalTable_Step_rt_ver_step1(data)                         (0x0000000C&((data)<<2))
#define  PCID_PCID_RegionalTable_Step_rt_ver_step0(data)                         (0x00000003&(data))
#define  PCID_PCID_RegionalTable_Step_get_rt_hor_step_mode(data)                 ((0x70000000&(data))>>28)
#define  PCID_PCID_RegionalTable_Step_get_rt_ver_step_mode(data)                 ((0x01FF0000&(data))>>16)
#define  PCID_PCID_RegionalTable_Step_get_rt_hor_step2(data)                     ((0x00003000&(data))>>12)
#define  PCID_PCID_RegionalTable_Step_get_rt_hor_step1(data)                     ((0x00000C00&(data))>>10)
#define  PCID_PCID_RegionalTable_Step_get_rt_hor_step0(data)                     ((0x00000300&(data))>>8)
#define  PCID_PCID_RegionalTable_Step_get_rt_ver_step2(data)                     ((0x00000030&(data))>>4)
#define  PCID_PCID_RegionalTable_Step_get_rt_ver_step1(data)                     ((0x0000000C&(data))>>2)
#define  PCID_PCID_RegionalTable_Step_get_rt_ver_step0(data)                     (0x00000003&(data))

#define  PCID_PCID_10x1_RegionalTable_Index_V_0                                 0x1802EF40
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_reg_addr                         "0xB802EF40"
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_reg                              0xB802EF40
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_inst_addr                        "0x0011"
#define  set_PCID_PCID_10x1_RegionalTable_Index_V_0_reg(data)                    (*((volatile unsigned int*)PCID_PCID_10x1_RegionalTable_Index_V_0_reg)=data)
#define  get_PCID_PCID_10x1_RegionalTable_Index_V_0_reg                          (*((volatile unsigned int*)PCID_PCID_10x1_RegionalTable_Index_V_0_reg))
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index5_shift              (20)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index4_shift              (10)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index3_shift              (0)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index5_mask               (0x3FF00000)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index4_mask               (0x000FFC00)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index3_mask               (0x000003FF)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index5(data)              (0x3FF00000&((data)<<20))
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index4(data)              (0x000FFC00&((data)<<10))
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_rt_ver_index3(data)              (0x000003FF&(data))
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_get_rt_ver_index5(data)          ((0x3FF00000&(data))>>20)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_get_rt_ver_index4(data)          ((0x000FFC00&(data))>>10)
#define  PCID_PCID_10x1_RegionalTable_Index_V_0_get_rt_ver_index3(data)          (0x000003FF&(data))

#define  PCID_PCID_10x1_RegionalTable_Index_V_1                                 0x1802EF44
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_reg_addr                         "0xB802EF44"
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_reg                              0xB802EF44
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_inst_addr                        "0x0012"
#define  set_PCID_PCID_10x1_RegionalTable_Index_V_1_reg(data)                    (*((volatile unsigned int*)PCID_PCID_10x1_RegionalTable_Index_V_1_reg)=data)
#define  get_PCID_PCID_10x1_RegionalTable_Index_V_1_reg                          (*((volatile unsigned int*)PCID_PCID_10x1_RegionalTable_Index_V_1_reg))
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index8_shift              (20)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index7_shift              (10)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index6_shift              (0)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index8_mask               (0x3FF00000)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index7_mask               (0x000FFC00)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index6_mask               (0x000003FF)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index8(data)              (0x3FF00000&((data)<<20))
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index7(data)              (0x000FFC00&((data)<<10))
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_rt_ver_index6(data)              (0x000003FF&(data))
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_get_rt_ver_index8(data)          ((0x3FF00000&(data))>>20)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_get_rt_ver_index7(data)          ((0x000FFC00&(data))>>10)
#define  PCID_PCID_10x1_RegionalTable_Index_V_1_get_rt_ver_index6(data)          (0x000003FF&(data))

#define  PCID_PCID_10x1_RegionalTable_Step                                      0x1802EF48
#define  PCID_PCID_10x1_RegionalTable_Step_reg_addr                              "0xB802EF48"
#define  PCID_PCID_10x1_RegionalTable_Step_reg                                   0xB802EF48
#define  PCID_PCID_10x1_RegionalTable_Step_inst_addr                             "0x0013"
#define  set_PCID_PCID_10x1_RegionalTable_Step_reg(data)                         (*((volatile unsigned int*)PCID_PCID_10x1_RegionalTable_Step_reg)=data)
#define  get_PCID_PCID_10x1_RegionalTable_Step_reg                               (*((volatile unsigned int*)PCID_PCID_10x1_RegionalTable_Step_reg))
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step8_shift                    (10)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step7_shift                    (8)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step6_shift                    (6)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step5_shift                    (4)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step4_shift                    (2)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step3_shift                    (0)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step8_mask                     (0x00000C00)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step7_mask                     (0x00000300)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step6_mask                     (0x000000C0)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step5_mask                     (0x00000030)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step4_mask                     (0x0000000C)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step3_mask                     (0x00000003)
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step8(data)                    (0x00000C00&((data)<<10))
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step7(data)                    (0x00000300&((data)<<8))
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step6(data)                    (0x000000C0&((data)<<6))
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step5(data)                    (0x00000030&((data)<<4))
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step4(data)                    (0x0000000C&((data)<<2))
#define  PCID_PCID_10x1_RegionalTable_Step_rt_ver_step3(data)                    (0x00000003&(data))
#define  PCID_PCID_10x1_RegionalTable_Step_get_rt_ver_step8(data)                ((0x00000C00&(data))>>10)
#define  PCID_PCID_10x1_RegionalTable_Step_get_rt_ver_step7(data)                ((0x00000300&(data))>>8)
#define  PCID_PCID_10x1_RegionalTable_Step_get_rt_ver_step6(data)                ((0x000000C0&(data))>>6)
#define  PCID_PCID_10x1_RegionalTable_Step_get_rt_ver_step5(data)                ((0x00000030&(data))>>4)
#define  PCID_PCID_10x1_RegionalTable_Step_get_rt_ver_step4(data)                ((0x0000000C&(data))>>2)
#define  PCID_PCID_10x1_RegionalTable_Step_get_rt_ver_step3(data)                (0x00000003&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_0                           0x1802EF50
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_reg_addr                   "0xB802EF50"
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_reg                        0xB802EF50
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_inst_addr                  "0x0014"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_0_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_0_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_0_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_0_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_col_bound2_shift           (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_col_bound1_shift           (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_col_bound2_mask            (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_col_bound1_mask            (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_col_bound2(data)           (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_col_bound1(data)           (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_get_col_bound2(data)       ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_0_get_col_bound1(data)       (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_1                           0x1802EF54
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_reg_addr                   "0xB802EF54"
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_reg                        0xB802EF54
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_inst_addr                  "0x0015"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_1_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_1_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_1_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_1_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_col_bound4_shift           (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_col_bound3_shift           (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_col_bound4_mask            (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_col_bound3_mask            (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_col_bound4(data)           (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_col_bound3(data)           (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_get_col_bound4(data)       ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_1_get_col_bound3(data)       (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_2                           0x1802EF58
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_reg_addr                   "0xB802EF58"
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_reg                        0xB802EF58
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_inst_addr                  "0x0016"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_2_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_2_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_2_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_2_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_col_bound6_shift           (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_col_bound5_shift           (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_col_bound6_mask            (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_col_bound5_mask            (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_col_bound6(data)           (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_col_bound5(data)           (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_get_col_bound6(data)       ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_2_get_col_bound5(data)       (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_3                           0x1802EF5C
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_reg_addr                   "0xB802EF5C"
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_reg                        0xB802EF5C
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_inst_addr                  "0x0017"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_3_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_3_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_3_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_3_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_col_bound8_shift           (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_col_bound7_shift           (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_col_bound8_mask            (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_col_bound7_mask            (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_col_bound8(data)           (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_col_bound7(data)           (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_get_col_bound8(data)       ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_3_get_col_bound7(data)       (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_4                           0x1802EF60
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_reg_addr                   "0xB802EF60"
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_reg                        0xB802EF60
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_inst_addr                  "0x0018"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_4_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_4_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_4_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_4_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_col_bound10_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_col_bound9_shift           (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_col_bound10_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_col_bound9_mask            (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_col_bound10(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_col_bound9(data)           (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_get_col_bound10(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_4_get_col_bound9(data)       (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_5                           0x1802EF64
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_reg_addr                   "0xB802EF64"
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_reg                        0xB802EF64
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_inst_addr                  "0x0019"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_5_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_5_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_5_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_5_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_col_bound12_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_col_bound11_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_col_bound12_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_col_bound11_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_col_bound12(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_col_bound11(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_get_col_bound12(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_5_get_col_bound11(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_6                           0x1802EF68
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_reg_addr                   "0xB802EF68"
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_reg                        0xB802EF68
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_inst_addr                  "0x001A"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_6_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_6_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_6_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_6_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_col_bound14_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_col_bound13_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_col_bound14_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_col_bound13_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_col_bound14(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_col_bound13(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_get_col_bound14(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_6_get_col_bound13(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_7                           0x1802EF6C
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_reg_addr                   "0xB802EF6C"
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_reg                        0xB802EF6C
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_inst_addr                  "0x001B"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_7_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_7_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_7_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_7_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_col_bound16_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_col_bound15_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_col_bound16_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_col_bound15_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_col_bound16(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_col_bound15(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_get_col_bound16(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_7_get_col_bound15(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_8                           0x1802EF70
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_reg_addr                   "0xB802EF70"
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_reg                        0xB802EF70
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_inst_addr                  "0x001C"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_8_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_8_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_8_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_8_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_col_bound17_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_col_bound17_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_col_bound17(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_8_get_col_bound17(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_9                           0x1802EF74
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_reg_addr                   "0xB802EF74"
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_reg                        0xB802EF74
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_inst_addr                  "0x001D"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_9_reg(data)              (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_9_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_9_reg                    (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_9_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_row_bound2_shift           (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_row_bound1_shift           (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_row_bound2_mask            (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_row_bound1_mask            (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_row_bound2(data)           (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_row_bound1(data)           (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_get_row_bound2(data)       ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_9_get_row_bound1(data)       (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_10                          0x1802EF78
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_reg_addr                  "0xB802EF78"
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_reg                       0xB802EF78
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_inst_addr                 "0x001E"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_10_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_10_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_10_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_10_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_row_bound4_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_row_bound3_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_row_bound4_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_row_bound3_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_row_bound4(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_row_bound3(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_get_row_bound4(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_10_get_row_bound3(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_11                          0x1802EF7C
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_reg_addr                  "0xB802EF7C"
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_reg                       0xB802EF7C
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_inst_addr                 "0x001F"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_11_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_11_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_11_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_11_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_row_bound6_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_row_bound5_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_row_bound6_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_row_bound5_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_row_bound6(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_row_bound5(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_get_row_bound6(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_11_get_row_bound5(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_12                          0x1802EF80
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_reg_addr                  "0xB802EF80"
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_reg                       0xB802EF80
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_inst_addr                 "0x0020"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_12_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_12_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_12_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_12_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_row_bound8_shift          (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_row_bound7_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_row_bound8_mask           (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_row_bound7_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_row_bound8(data)          (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_row_bound7(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_get_row_bound8(data)      ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_12_get_row_bound7(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_13                          0x1802EF84
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_reg_addr                  "0xB802EF84"
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_reg                       0xB802EF84
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_inst_addr                 "0x0021"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_13_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_13_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_13_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_13_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_row_bound10_shift         (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_row_bound9_shift          (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_row_bound10_mask          (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_row_bound9_mask           (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_row_bound10(data)         (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_row_bound9(data)          (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_get_row_bound10(data)     ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_13_get_row_bound9(data)      (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_14                          0x1802EF88
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_reg_addr                  "0xB802EF88"
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_reg                       0xB802EF88
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_inst_addr                 "0x0022"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_14_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_14_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_14_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_14_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_row_bound12_shift         (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_row_bound11_shift         (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_row_bound12_mask          (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_row_bound11_mask          (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_row_bound12(data)         (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_row_bound11(data)         (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_get_row_bound12(data)     ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_14_get_row_bound11(data)     (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_15                          0x1802EF8C
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_reg_addr                  "0xB802EF8C"
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_reg                       0xB802EF8C
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_inst_addr                 "0x0023"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_15_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_15_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_15_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_15_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_row_bound14_shift         (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_row_bound13_shift         (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_row_bound14_mask          (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_row_bound13_mask          (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_row_bound14(data)         (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_row_bound13(data)         (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_get_row_bound14(data)     ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_15_get_row_bound13(data)     (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_16                          0x1802EF90
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_reg_addr                  "0xB802EF90"
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_reg                       0xB802EF90
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_inst_addr                 "0x0024"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_16_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_16_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_16_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_16_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_row_bound16_shift         (12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_row_bound15_shift         (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_row_bound16_mask          (0x00FFF000)
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_row_bound15_mask          (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_row_bound16(data)         (0x00FFF000&((data)<<12))
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_row_bound15(data)         (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_get_row_bound16(data)     ((0x00FFF000&(data))>>12)
#define  PCID_PCID_Regional_19x19_Table_index_bound_16_get_row_bound15(data)     (0x00000FFF&(data))

#define  PCID_PCID_Regional_19x19_Table_index_bound_17                          0x1802EF94
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_reg_addr                  "0xB802EF94"
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_reg                       0xB802EF94
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_inst_addr                 "0x0025"
#define  set_PCID_PCID_Regional_19x19_Table_index_bound_17_reg(data)             (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_17_reg)=data)
#define  get_PCID_PCID_Regional_19x19_Table_index_bound_17_reg                   (*((volatile unsigned int*)PCID_PCID_Regional_19x19_Table_index_bound_17_reg))
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_row_bound17_shift         (0)
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_row_bound17_mask          (0x00000FFF)
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_row_bound17(data)         (0x00000FFF&(data))
#define  PCID_PCID_Regional_19x19_Table_index_bound_17_get_row_bound17(data)     (0x00000FFF&(data))

#define  PCID_PCID_AccessData_CTRL                                              0x1802EFE0
#define  PCID_PCID_AccessData_CTRL_reg_addr                                      "0xB802EFE0"
#define  PCID_PCID_AccessData_CTRL_reg                                           0xB802EFE0
#define  PCID_PCID_AccessData_CTRL_inst_addr                                     "0x0026"
#define  set_PCID_PCID_AccessData_CTRL_reg(data)                                 (*((volatile unsigned int*)PCID_PCID_AccessData_CTRL_reg)=data)
#define  get_PCID_PCID_AccessData_CTRL_reg                                       (*((volatile unsigned int*)PCID_PCID_AccessData_CTRL_reg))
#define  PCID_PCID_AccessData_CTRL_access_location_sel_shift                     (3)
#define  PCID_PCID_AccessData_CTRL_access_cross_bar_en_shift                     (2)
#define  PCID_PCID_AccessData_CTRL_access_write_en_shift                         (1)
#define  PCID_PCID_AccessData_CTRL_access_read_en_shift                          (0)
#define  PCID_PCID_AccessData_CTRL_access_location_sel_mask                      (0x00000008)
#define  PCID_PCID_AccessData_CTRL_access_cross_bar_en_mask                      (0x00000004)
#define  PCID_PCID_AccessData_CTRL_access_write_en_mask                          (0x00000002)
#define  PCID_PCID_AccessData_CTRL_access_read_en_mask                           (0x00000001)
#define  PCID_PCID_AccessData_CTRL_access_location_sel(data)                     (0x00000008&((data)<<3))
#define  PCID_PCID_AccessData_CTRL_access_cross_bar_en(data)                     (0x00000004&((data)<<2))
#define  PCID_PCID_AccessData_CTRL_access_write_en(data)                         (0x00000002&((data)<<1))
#define  PCID_PCID_AccessData_CTRL_access_read_en(data)                          (0x00000001&(data))
#define  PCID_PCID_AccessData_CTRL_get_access_location_sel(data)                 ((0x00000008&(data))>>3)
#define  PCID_PCID_AccessData_CTRL_get_access_cross_bar_en(data)                 ((0x00000004&(data))>>2)
#define  PCID_PCID_AccessData_CTRL_get_access_write_en(data)                     ((0x00000002&(data))>>1)
#define  PCID_PCID_AccessData_CTRL_get_access_read_en(data)                      (0x00000001&(data))

#define  PCID_PCID_AccessData_PosCtrl                                           0x1802EFE4
#define  PCID_PCID_AccessData_PosCtrl_reg_addr                                   "0xB802EFE4"
#define  PCID_PCID_AccessData_PosCtrl_reg                                        0xB802EFE4
#define  PCID_PCID_AccessData_PosCtrl_inst_addr                                  "0x0027"
#define  set_PCID_PCID_AccessData_PosCtrl_reg(data)                              (*((volatile unsigned int*)PCID_PCID_AccessData_PosCtrl_reg)=data)
#define  get_PCID_PCID_AccessData_PosCtrl_reg                                    (*((volatile unsigned int*)PCID_PCID_AccessData_PosCtrl_reg))
#define  PCID_PCID_AccessData_PosCtrl_access_starty_shift                        (16)
#define  PCID_PCID_AccessData_PosCtrl_access_startx_shift                        (0)
#define  PCID_PCID_AccessData_PosCtrl_access_starty_mask                         (0x0FFF0000)
#define  PCID_PCID_AccessData_PosCtrl_access_startx_mask                         (0x00000FFF)
#define  PCID_PCID_AccessData_PosCtrl_access_starty(data)                        (0x0FFF0000&((data)<<16))
#define  PCID_PCID_AccessData_PosCtrl_access_startx(data)                        (0x00000FFF&(data))
#define  PCID_PCID_AccessData_PosCtrl_get_access_starty(data)                    ((0x0FFF0000&(data))>>16)
#define  PCID_PCID_AccessData_PosCtrl_get_access_startx(data)                    (0x00000FFF&(data))

#define  PCID_PCID_AccessData_R                                                 0x1802EFE8
#define  PCID_PCID_AccessData_R_reg_addr                                         "0xB802EFE8"
#define  PCID_PCID_AccessData_R_reg                                              0xB802EFE8
#define  PCID_PCID_AccessData_R_inst_addr                                        "0x0028"
#define  set_PCID_PCID_AccessData_R_reg(data)                                    (*((volatile unsigned int*)PCID_PCID_AccessData_R_reg)=data)
#define  get_PCID_PCID_AccessData_R_reg                                          (*((volatile unsigned int*)PCID_PCID_AccessData_R_reg))
#define  PCID_PCID_AccessData_R_access_read_r_shift                              (16)
#define  PCID_PCID_AccessData_R_access_write_r_shift                             (0)
#define  PCID_PCID_AccessData_R_access_read_r_mask                               (0x0FFF0000)
#define  PCID_PCID_AccessData_R_access_write_r_mask                              (0x00000FFF)
#define  PCID_PCID_AccessData_R_access_read_r(data)                              (0x0FFF0000&((data)<<16))
#define  PCID_PCID_AccessData_R_access_write_r(data)                             (0x00000FFF&(data))
#define  PCID_PCID_AccessData_R_get_access_read_r(data)                          ((0x0FFF0000&(data))>>16)
#define  PCID_PCID_AccessData_R_get_access_write_r(data)                         (0x00000FFF&(data))

#define  PCID_PCID_AccessData_G                                                 0x1802EFEC
#define  PCID_PCID_AccessData_G_reg_addr                                         "0xB802EFEC"
#define  PCID_PCID_AccessData_G_reg                                              0xB802EFEC
#define  PCID_PCID_AccessData_G_inst_addr                                        "0x0029"
#define  set_PCID_PCID_AccessData_G_reg(data)                                    (*((volatile unsigned int*)PCID_PCID_AccessData_G_reg)=data)
#define  get_PCID_PCID_AccessData_G_reg                                          (*((volatile unsigned int*)PCID_PCID_AccessData_G_reg))
#define  PCID_PCID_AccessData_G_access_read_g_shift                              (16)
#define  PCID_PCID_AccessData_G_access_write_g_shift                             (0)
#define  PCID_PCID_AccessData_G_access_read_g_mask                               (0x0FFF0000)
#define  PCID_PCID_AccessData_G_access_write_g_mask                              (0x00000FFF)
#define  PCID_PCID_AccessData_G_access_read_g(data)                              (0x0FFF0000&((data)<<16))
#define  PCID_PCID_AccessData_G_access_write_g(data)                             (0x00000FFF&(data))
#define  PCID_PCID_AccessData_G_get_access_read_g(data)                          ((0x0FFF0000&(data))>>16)
#define  PCID_PCID_AccessData_G_get_access_write_g(data)                         (0x00000FFF&(data))

#define  PCID_PCID_AccessData_B                                                 0x1802EFF0
#define  PCID_PCID_AccessData_B_reg_addr                                         "0xB802EFF0"
#define  PCID_PCID_AccessData_B_reg                                              0xB802EFF0
#define  PCID_PCID_AccessData_B_inst_addr                                        "0x002A"
#define  set_PCID_PCID_AccessData_B_reg(data)                                    (*((volatile unsigned int*)PCID_PCID_AccessData_B_reg)=data)
#define  get_PCID_PCID_AccessData_B_reg                                          (*((volatile unsigned int*)PCID_PCID_AccessData_B_reg))
#define  PCID_PCID_AccessData_B_access_read_b_shift                              (16)
#define  PCID_PCID_AccessData_B_access_write_b_shift                             (0)
#define  PCID_PCID_AccessData_B_access_read_b_mask                               (0x0FFF0000)
#define  PCID_PCID_AccessData_B_access_write_b_mask                              (0x00000FFF)
#define  PCID_PCID_AccessData_B_access_read_b(data)                              (0x0FFF0000&((data)<<16))
#define  PCID_PCID_AccessData_B_access_write_b(data)                             (0x00000FFF&(data))
#define  PCID_PCID_AccessData_B_get_access_read_b(data)                          ((0x0FFF0000&(data))>>16)
#define  PCID_PCID_AccessData_B_get_access_write_b(data)                         (0x00000FFF&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======PCID register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef00_31_30:2;
        RBus_UInt32  first_line_cfg:12;
        RBus_UInt32  first_line_boundary_mode:2;
        RBus_UInt32  dummy1802ef00_15_14:2;
        RBus_UInt32  general_cfg:12;
        RBus_UInt32  general_boundary_mode:2;
    };
}pcid_pcid_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  pcid_tab1_xtr_en:1;
        RBus_UInt32  pcid_thd_mode:1;
        RBus_UInt32  pcid_thd_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pcid_tab1_b_thd:8;
        RBus_UInt32  pcid_tab1_g_thd:8;
        RBus_UInt32  pcid_tab1_r_thd:8;
    };
}pcid_pcid_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef08_31_0:32;
    };
}pcid_pcid_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line1_odd_b_color_select:2;
        RBus_UInt32  line1_odd_g_color_select:2;
        RBus_UInt32  line1_odd_r_color_select:2;
        RBus_UInt32  line1_odd_b_point_select:2;
        RBus_UInt32  line1_odd_g_point_select:2;
        RBus_UInt32  line1_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line1_odd_b_line_select:1;
        RBus_UInt32  line1_odd_g_line_select:1;
        RBus_UInt32  line1_odd_r_line_select:1;
        RBus_UInt32  line1_even_b_color_select:2;
        RBus_UInt32  line1_even_g_color_select:2;
        RBus_UInt32  line1_even_r_color_select:2;
        RBus_UInt32  line1_even_b_point_select:2;
        RBus_UInt32  line1_even_g_point_select:2;
        RBus_UInt32  line1_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line1_even_b_line_select:1;
        RBus_UInt32  line1_even_g_line_select:1;
        RBus_UInt32  line1_even_r_line_select:1;
    };
}pcid_pcid_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line2_odd_b_color_select:2;
        RBus_UInt32  line2_odd_g_color_select:2;
        RBus_UInt32  line2_odd_r_color_select:2;
        RBus_UInt32  line2_odd_b_point_select:2;
        RBus_UInt32  line2_odd_g_point_select:2;
        RBus_UInt32  line2_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line2_odd_b_line_select:1;
        RBus_UInt32  line2_odd_g_line_select:1;
        RBus_UInt32  line2_odd_r_line_select:1;
        RBus_UInt32  line2_even_b_color_select:2;
        RBus_UInt32  line2_even_g_color_select:2;
        RBus_UInt32  line2_even_r_color_select:2;
        RBus_UInt32  line2_even_b_point_select:2;
        RBus_UInt32  line2_even_g_point_select:2;
        RBus_UInt32  line2_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line2_even_b_line_select:1;
        RBus_UInt32  line2_even_g_line_select:1;
        RBus_UInt32  line2_even_r_line_select:1;
    };
}pcid_pcid_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line3_odd_b_color_select:2;
        RBus_UInt32  line3_odd_g_color_select:2;
        RBus_UInt32  line3_odd_r_color_select:2;
        RBus_UInt32  line3_odd_b_point_select:2;
        RBus_UInt32  line3_odd_g_point_select:2;
        RBus_UInt32  line3_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line3_odd_b_line_select:1;
        RBus_UInt32  line3_odd_g_line_select:1;
        RBus_UInt32  line3_odd_r_line_select:1;
        RBus_UInt32  line3_even_b_color_select:2;
        RBus_UInt32  line3_even_g_color_select:2;
        RBus_UInt32  line3_even_r_color_select:2;
        RBus_UInt32  line3_even_b_point_select:2;
        RBus_UInt32  line3_even_g_point_select:2;
        RBus_UInt32  line3_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line3_even_b_line_select:1;
        RBus_UInt32  line3_even_g_line_select:1;
        RBus_UInt32  line3_even_r_line_select:1;
    };
}pcid_pcid_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line4_odd_b_color_select:2;
        RBus_UInt32  line4_odd_g_color_select:2;
        RBus_UInt32  line4_odd_r_color_select:2;
        RBus_UInt32  line4_odd_b_point_select:2;
        RBus_UInt32  line4_odd_g_point_select:2;
        RBus_UInt32  line4_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line4_odd_b_line_select:1;
        RBus_UInt32  line4_odd_g_line_select:1;
        RBus_UInt32  line4_odd_r_line_select:1;
        RBus_UInt32  line4_even_b_color_select:2;
        RBus_UInt32  line4_even_g_color_select:2;
        RBus_UInt32  line4_even_r_color_select:2;
        RBus_UInt32  line4_even_b_point_select:2;
        RBus_UInt32  line4_even_g_point_select:2;
        RBus_UInt32  line4_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line4_even_b_line_select:1;
        RBus_UInt32  line4_even_g_line_select:1;
        RBus_UInt32  line4_even_r_line_select:1;
    };
}pcid_pcid_line_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pcid_lb_rm_1:4;
        RBus_UInt32  pcid_lb_rm_0:4;
    };
}pcid_pcid_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  pcid_lb_ls_1:1;
        RBus_UInt32  pcid_lb_ls_0:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  pcid_lb_rme_1:1;
        RBus_UInt32  pcid_lb_rme_0:1;
    };
}pcid_pcid_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  pcid_lb_drf_fail_1:1;
        RBus_UInt32  pcid_lb_drf_fail_0:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  pcid_lb_bist_fail_1:1;
        RBus_UInt32  pcid_lb_bist_fail_0:1;
    };
}pcid_pcid_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pcid_lb_testrwm_1:1;
        RBus_UInt32  pcid_lb_testrwm_0:1;
    };
}pcid_pcid_testrwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  pcid_regional_lut_ax_en:1;
        RBus_UInt32  pcid_regional_lut_sel:4;
        RBus_UInt32  res2:3;
        RBus_UInt32  pcid_lut_sel:2;
        RBus_UInt32  res3:12;
    };
}pcid_pcid_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_data:32;
    };
}pcid_pcid_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  pcid_regional_10x1_en:1;
        RBus_UInt32  pcid_regional_19x19tab_en:1;
        RBus_UInt32  regional_table_en:1;
    };
}pcid_pcid_regionaltable_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  rt_hor_index2:10;
        RBus_UInt32  rt_hor_index1:10;
        RBus_UInt32  rt_hor_index0:10;
    };
}pcid_pcid_regionaltable_index_h_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  rt_ver_index2:10;
        RBus_UInt32  rt_ver_index1:10;
        RBus_UInt32  rt_ver_index0:10;
    };
}pcid_pcid_regionaltable_index_v_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  rt_hor_step_mode:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  rt_ver_step_mode:9;
        RBus_UInt32  res3:2;
        RBus_UInt32  rt_hor_step2:2;
        RBus_UInt32  rt_hor_step1:2;
        RBus_UInt32  rt_hor_step0:2;
        RBus_UInt32  res4:2;
        RBus_UInt32  rt_ver_step2:2;
        RBus_UInt32  rt_ver_step1:2;
        RBus_UInt32  rt_ver_step0:2;
    };
}pcid_pcid_regionaltable_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  rt_ver_index5:10;
        RBus_UInt32  rt_ver_index4:10;
        RBus_UInt32  rt_ver_index3:10;
    };
}pcid_pcid_10x1_regionaltable_index_v_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  rt_ver_index8:10;
        RBus_UInt32  rt_ver_index7:10;
        RBus_UInt32  rt_ver_index6:10;
    };
}pcid_pcid_10x1_regionaltable_index_v_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  rt_ver_step8:2;
        RBus_UInt32  rt_ver_step7:2;
        RBus_UInt32  rt_ver_step6:2;
        RBus_UInt32  rt_ver_step5:2;
        RBus_UInt32  rt_ver_step4:2;
        RBus_UInt32  rt_ver_step3:2;
    };
}pcid_pcid_10x1_regionaltable_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound2:12;
        RBus_UInt32  col_bound1:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound4:12;
        RBus_UInt32  col_bound3:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound6:12;
        RBus_UInt32  col_bound5:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound8:12;
        RBus_UInt32  col_bound7:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound10:12;
        RBus_UInt32  col_bound9:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound12:12;
        RBus_UInt32  col_bound11:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound14:12;
        RBus_UInt32  col_bound13:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  col_bound16:12;
        RBus_UInt32  col_bound15:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  col_bound17:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound2:12;
        RBus_UInt32  row_bound1:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound4:12;
        RBus_UInt32  row_bound3:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound6:12;
        RBus_UInt32  row_bound5:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound8:12;
        RBus_UInt32  row_bound7:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound10:12;
        RBus_UInt32  row_bound9:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound12:12;
        RBus_UInt32  row_bound11:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound14:12;
        RBus_UInt32  row_bound13:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  row_bound16:12;
        RBus_UInt32  row_bound15:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  row_bound17:12;
    };
}pcid_pcid_regional_19x19_table_index_bound_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  access_location_sel:1;
        RBus_UInt32  access_cross_bar_en:1;
        RBus_UInt32  access_write_en:1;
        RBus_UInt32  access_read_en:1;
    };
}pcid_pcid_accessdata_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_starty:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_startx:12;
    };
}pcid_pcid_accessdata_posctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_r:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_write_r:12;
    };
}pcid_pcid_accessdata_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_g:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_write_g:12;
    };
}pcid_pcid_accessdata_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_b:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_write_b:12;
    };
}pcid_pcid_accessdata_b_RBUS;

#else //apply LITTLE_ENDIAN

//======PCID register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  general_boundary_mode:2;
        RBus_UInt32  general_cfg:12;
        RBus_UInt32  dummy1802ef00_15_14:2;
        RBus_UInt32  first_line_boundary_mode:2;
        RBus_UInt32  first_line_cfg:12;
        RBus_UInt32  dummy1802ef00_31_30:2;
    };
}pcid_pcid_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab1_r_thd:8;
        RBus_UInt32  pcid_tab1_g_thd:8;
        RBus_UInt32  pcid_tab1_b_thd:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  pcid_thd_en:1;
        RBus_UInt32  pcid_thd_mode:1;
        RBus_UInt32  pcid_tab1_xtr_en:1;
        RBus_UInt32  res2:1;
    };
}pcid_pcid_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef08_31_0:32;
    };
}pcid_pcid_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line1_even_r_line_select:1;
        RBus_UInt32  line1_even_g_line_select:1;
        RBus_UInt32  line1_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line1_even_r_point_select:2;
        RBus_UInt32  line1_even_g_point_select:2;
        RBus_UInt32  line1_even_b_point_select:2;
        RBus_UInt32  line1_even_r_color_select:2;
        RBus_UInt32  line1_even_g_color_select:2;
        RBus_UInt32  line1_even_b_color_select:2;
        RBus_UInt32  line1_odd_r_line_select:1;
        RBus_UInt32  line1_odd_g_line_select:1;
        RBus_UInt32  line1_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line1_odd_r_point_select:2;
        RBus_UInt32  line1_odd_g_point_select:2;
        RBus_UInt32  line1_odd_b_point_select:2;
        RBus_UInt32  line1_odd_r_color_select:2;
        RBus_UInt32  line1_odd_g_color_select:2;
        RBus_UInt32  line1_odd_b_color_select:2;
    };
}pcid_pcid_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line2_even_r_line_select:1;
        RBus_UInt32  line2_even_g_line_select:1;
        RBus_UInt32  line2_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line2_even_r_point_select:2;
        RBus_UInt32  line2_even_g_point_select:2;
        RBus_UInt32  line2_even_b_point_select:2;
        RBus_UInt32  line2_even_r_color_select:2;
        RBus_UInt32  line2_even_g_color_select:2;
        RBus_UInt32  line2_even_b_color_select:2;
        RBus_UInt32  line2_odd_r_line_select:1;
        RBus_UInt32  line2_odd_g_line_select:1;
        RBus_UInt32  line2_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line2_odd_r_point_select:2;
        RBus_UInt32  line2_odd_g_point_select:2;
        RBus_UInt32  line2_odd_b_point_select:2;
        RBus_UInt32  line2_odd_r_color_select:2;
        RBus_UInt32  line2_odd_g_color_select:2;
        RBus_UInt32  line2_odd_b_color_select:2;
    };
}pcid_pcid_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line3_even_r_line_select:1;
        RBus_UInt32  line3_even_g_line_select:1;
        RBus_UInt32  line3_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line3_even_r_point_select:2;
        RBus_UInt32  line3_even_g_point_select:2;
        RBus_UInt32  line3_even_b_point_select:2;
        RBus_UInt32  line3_even_r_color_select:2;
        RBus_UInt32  line3_even_g_color_select:2;
        RBus_UInt32  line3_even_b_color_select:2;
        RBus_UInt32  line3_odd_r_line_select:1;
        RBus_UInt32  line3_odd_g_line_select:1;
        RBus_UInt32  line3_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line3_odd_r_point_select:2;
        RBus_UInt32  line3_odd_g_point_select:2;
        RBus_UInt32  line3_odd_b_point_select:2;
        RBus_UInt32  line3_odd_r_color_select:2;
        RBus_UInt32  line3_odd_g_color_select:2;
        RBus_UInt32  line3_odd_b_color_select:2;
    };
}pcid_pcid_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line4_even_r_line_select:1;
        RBus_UInt32  line4_even_g_line_select:1;
        RBus_UInt32  line4_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line4_even_r_point_select:2;
        RBus_UInt32  line4_even_g_point_select:2;
        RBus_UInt32  line4_even_b_point_select:2;
        RBus_UInt32  line4_even_r_color_select:2;
        RBus_UInt32  line4_even_g_color_select:2;
        RBus_UInt32  line4_even_b_color_select:2;
        RBus_UInt32  line4_odd_r_line_select:1;
        RBus_UInt32  line4_odd_g_line_select:1;
        RBus_UInt32  line4_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line4_odd_r_point_select:2;
        RBus_UInt32  line4_odd_g_point_select:2;
        RBus_UInt32  line4_odd_b_point_select:2;
        RBus_UInt32  line4_odd_r_color_select:2;
        RBus_UInt32  line4_odd_g_color_select:2;
        RBus_UInt32  line4_odd_b_color_select:2;
    };
}pcid_pcid_line_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_rm_0:4;
        RBus_UInt32  pcid_lb_rm_1:4;
        RBus_UInt32  res1:24;
    };
}pcid_pcid_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_rme_0:1;
        RBus_UInt32  pcid_lb_rme_1:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  pcid_lb_ls_0:1;
        RBus_UInt32  pcid_lb_ls_1:1;
        RBus_UInt32  res2:14;
    };
}pcid_pcid_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_bist_fail_0:1;
        RBus_UInt32  pcid_lb_bist_fail_1:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  pcid_lb_drf_fail_0:1;
        RBus_UInt32  pcid_lb_drf_fail_1:1;
        RBus_UInt32  res2:14;
    };
}pcid_pcid_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_testrwm_0:1;
        RBus_UInt32  pcid_lb_testrwm_1:1;
        RBus_UInt32  res1:30;
    };
}pcid_pcid_testrwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  pcid_lut_sel:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  pcid_regional_lut_sel:4;
        RBus_UInt32  pcid_regional_lut_ax_en:1;
        RBus_UInt32  res3:10;
    };
}pcid_pcid_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_data:32;
    };
}pcid_pcid_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  regional_table_en:1;
        RBus_UInt32  pcid_regional_19x19tab_en:1;
        RBus_UInt32  pcid_regional_10x1_en:1;
        RBus_UInt32  res1:29;
    };
}pcid_pcid_regionaltable_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rt_hor_index0:10;
        RBus_UInt32  rt_hor_index1:10;
        RBus_UInt32  rt_hor_index2:10;
        RBus_UInt32  res1:2;
    };
}pcid_pcid_regionaltable_index_h_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rt_ver_index0:10;
        RBus_UInt32  rt_ver_index1:10;
        RBus_UInt32  rt_ver_index2:10;
        RBus_UInt32  res1:2;
    };
}pcid_pcid_regionaltable_index_v_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rt_ver_step0:2;
        RBus_UInt32  rt_ver_step1:2;
        RBus_UInt32  rt_ver_step2:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  rt_hor_step0:2;
        RBus_UInt32  rt_hor_step1:2;
        RBus_UInt32  rt_hor_step2:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  rt_ver_step_mode:9;
        RBus_UInt32  res3:3;
        RBus_UInt32  rt_hor_step_mode:3;
        RBus_UInt32  res4:1;
    };
}pcid_pcid_regionaltable_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rt_ver_index3:10;
        RBus_UInt32  rt_ver_index4:10;
        RBus_UInt32  rt_ver_index5:10;
        RBus_UInt32  res1:2;
    };
}pcid_pcid_10x1_regionaltable_index_v_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rt_ver_index6:10;
        RBus_UInt32  rt_ver_index7:10;
        RBus_UInt32  rt_ver_index8:10;
        RBus_UInt32  res1:2;
    };
}pcid_pcid_10x1_regionaltable_index_v_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rt_ver_step3:2;
        RBus_UInt32  rt_ver_step4:2;
        RBus_UInt32  rt_ver_step5:2;
        RBus_UInt32  rt_ver_step6:2;
        RBus_UInt32  rt_ver_step7:2;
        RBus_UInt32  rt_ver_step8:2;
        RBus_UInt32  res1:20;
    };
}pcid_pcid_10x1_regionaltable_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound1:12;
        RBus_UInt32  col_bound2:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound3:12;
        RBus_UInt32  col_bound4:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound5:12;
        RBus_UInt32  col_bound6:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound7:12;
        RBus_UInt32  col_bound8:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound9:12;
        RBus_UInt32  col_bound10:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound11:12;
        RBus_UInt32  col_bound12:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound13:12;
        RBus_UInt32  col_bound14:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound15:12;
        RBus_UInt32  col_bound16:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  col_bound17:12;
        RBus_UInt32  res1:20;
    };
}pcid_pcid_regional_19x19_table_index_bound_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound1:12;
        RBus_UInt32  row_bound2:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound3:12;
        RBus_UInt32  row_bound4:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound5:12;
        RBus_UInt32  row_bound6:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound7:12;
        RBus_UInt32  row_bound8:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound9:12;
        RBus_UInt32  row_bound10:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound11:12;
        RBus_UInt32  row_bound12:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound13:12;
        RBus_UInt32  row_bound14:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound15:12;
        RBus_UInt32  row_bound16:12;
        RBus_UInt32  res1:8;
    };
}pcid_pcid_regional_19x19_table_index_bound_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  row_bound17:12;
        RBus_UInt32  res1:20;
    };
}pcid_pcid_regional_19x19_table_index_bound_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_read_en:1;
        RBus_UInt32  access_write_en:1;
        RBus_UInt32  access_cross_bar_en:1;
        RBus_UInt32  access_location_sel:1;
        RBus_UInt32  res1:28;
    };
}pcid_pcid_accessdata_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_startx:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_starty:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_posctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_write_r:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_r:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_write_g:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_g:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_write_b:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_b:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_b_RBUS;




#endif 


#endif 
