/**
* @file Merlin6-DesignSpec-D-Domain_SSRS
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SSRS_REG_H_
#define _RBUS_SSRS_REG_H_

#include "rbus_types.h"



//  SSRS Register Address
#define  SSRS_SSRS_CTRL                                                         0x181C0000
#define  SSRS_SSRS_CTRL_reg_addr                                                 "0xB81C0000"
#define  SSRS_SSRS_CTRL_reg                                                      0xB81C0000
#define  SSRS_SSRS_CTRL_inst_addr                                                "0x0000"
#define  set_SSRS_SSRS_CTRL_reg(data)                                            (*((volatile unsigned int*)SSRS_SSRS_CTRL_reg)=data)
#define  get_SSRS_SSRS_CTRL_reg                                                  (*((volatile unsigned int*)SSRS_SSRS_CTRL_reg))
#define  SSRS_SSRS_CTRL_table_pre_load_sel_shift                                 (15)
#define  SSRS_SSRS_CTRL_ssrs_main_large_sub_shift                                (14)
#define  SSRS_SSRS_CTRL_ssrs_dw_inv_shift                                        (13)
#define  SSRS_SSRS_CTRL_ssrs_dw_en_shift                                         (12)
#define  SSRS_SSRS_CTRL_mask_win_sel_shift                                       (8)
#define  SSRS_SSRS_CTRL_mask_win_switch_shift                                    (4)
#define  SSRS_SSRS_CTRL_arb_en_1_shift                                           (3)
#define  SSRS_SSRS_CTRL_arb_en_0_shift                                           (2)
#define  SSRS_SSRS_CTRL_ssrs_disable_shift                                       (0)
#define  SSRS_SSRS_CTRL_table_pre_load_sel_mask                                  (0x000F8000)
#define  SSRS_SSRS_CTRL_ssrs_main_large_sub_mask                                 (0x00004000)
#define  SSRS_SSRS_CTRL_ssrs_dw_inv_mask                                         (0x00002000)
#define  SSRS_SSRS_CTRL_ssrs_dw_en_mask                                          (0x00001000)
#define  SSRS_SSRS_CTRL_mask_win_sel_mask                                        (0x00000F00)
#define  SSRS_SSRS_CTRL_mask_win_switch_mask                                     (0x00000030)
#define  SSRS_SSRS_CTRL_arb_en_1_mask                                            (0x00000008)
#define  SSRS_SSRS_CTRL_arb_en_0_mask                                            (0x00000004)
#define  SSRS_SSRS_CTRL_ssrs_disable_mask                                        (0x00000001)
#define  SSRS_SSRS_CTRL_table_pre_load_sel(data)                                 (0x000F8000&((data)<<15))
#define  SSRS_SSRS_CTRL_ssrs_main_large_sub(data)                                (0x00004000&((data)<<14))
#define  SSRS_SSRS_CTRL_ssrs_dw_inv(data)                                        (0x00002000&((data)<<13))
#define  SSRS_SSRS_CTRL_ssrs_dw_en(data)                                         (0x00001000&((data)<<12))
#define  SSRS_SSRS_CTRL_mask_win_sel(data)                                       (0x00000F00&((data)<<8))
#define  SSRS_SSRS_CTRL_mask_win_switch(data)                                    (0x00000030&((data)<<4))
#define  SSRS_SSRS_CTRL_arb_en_1(data)                                           (0x00000008&((data)<<3))
#define  SSRS_SSRS_CTRL_arb_en_0(data)                                           (0x00000004&((data)<<2))
#define  SSRS_SSRS_CTRL_ssrs_disable(data)                                       (0x00000001&(data))
#define  SSRS_SSRS_CTRL_get_table_pre_load_sel(data)                             ((0x000F8000&(data))>>15)
#define  SSRS_SSRS_CTRL_get_ssrs_main_large_sub(data)                            ((0x00004000&(data))>>14)
#define  SSRS_SSRS_CTRL_get_ssrs_dw_inv(data)                                    ((0x00002000&(data))>>13)
#define  SSRS_SSRS_CTRL_get_ssrs_dw_en(data)                                     ((0x00001000&(data))>>12)
#define  SSRS_SSRS_CTRL_get_mask_win_sel(data)                                   ((0x00000F00&(data))>>8)
#define  SSRS_SSRS_CTRL_get_mask_win_switch(data)                                ((0x00000030&(data))>>4)
#define  SSRS_SSRS_CTRL_get_arb_en_1(data)                                       ((0x00000008&(data))>>3)
#define  SSRS_SSRS_CTRL_get_arb_en_0(data)                                       ((0x00000004&(data))>>2)
#define  SSRS_SSRS_CTRL_get_ssrs_disable(data)                                   (0x00000001&(data))

#define  SSRS_SSRS_DEMO_WINDOW_STA                                              0x181C0004
#define  SSRS_SSRS_DEMO_WINDOW_STA_reg_addr                                      "0xB81C0004"
#define  SSRS_SSRS_DEMO_WINDOW_STA_reg                                           0xB81C0004
#define  SSRS_SSRS_DEMO_WINDOW_STA_inst_addr                                     "0x0001"
#define  set_SSRS_SSRS_DEMO_WINDOW_STA_reg(data)                                 (*((volatile unsigned int*)SSRS_SSRS_DEMO_WINDOW_STA_reg)=data)
#define  get_SSRS_SSRS_DEMO_WINDOW_STA_reg                                       (*((volatile unsigned int*)SSRS_SSRS_DEMO_WINDOW_STA_reg))
#define  SSRS_SSRS_DEMO_WINDOW_STA_ssrs_dw_x_sta_shift                           (16)
#define  SSRS_SSRS_DEMO_WINDOW_STA_ssrs_dw_y_sta_shift                           (0)
#define  SSRS_SSRS_DEMO_WINDOW_STA_ssrs_dw_x_sta_mask                            (0x0FFF0000)
#define  SSRS_SSRS_DEMO_WINDOW_STA_ssrs_dw_y_sta_mask                            (0x00000FFF)
#define  SSRS_SSRS_DEMO_WINDOW_STA_ssrs_dw_x_sta(data)                           (0x0FFF0000&((data)<<16))
#define  SSRS_SSRS_DEMO_WINDOW_STA_ssrs_dw_y_sta(data)                           (0x00000FFF&(data))
#define  SSRS_SSRS_DEMO_WINDOW_STA_get_ssrs_dw_x_sta(data)                       ((0x0FFF0000&(data))>>16)
#define  SSRS_SSRS_DEMO_WINDOW_STA_get_ssrs_dw_y_sta(data)                       (0x00000FFF&(data))

#define  SSRS_SSRS_DEMO_WINDOW_END                                              0x181C0008
#define  SSRS_SSRS_DEMO_WINDOW_END_reg_addr                                      "0xB81C0008"
#define  SSRS_SSRS_DEMO_WINDOW_END_reg                                           0xB81C0008
#define  SSRS_SSRS_DEMO_WINDOW_END_inst_addr                                     "0x0002"
#define  set_SSRS_SSRS_DEMO_WINDOW_END_reg(data)                                 (*((volatile unsigned int*)SSRS_SSRS_DEMO_WINDOW_END_reg)=data)
#define  get_SSRS_SSRS_DEMO_WINDOW_END_reg                                       (*((volatile unsigned int*)SSRS_SSRS_DEMO_WINDOW_END_reg))
#define  SSRS_SSRS_DEMO_WINDOW_END_ssrs_dw_x_end_shift                           (16)
#define  SSRS_SSRS_DEMO_WINDOW_END_ssrs_dw_y_end_shift                           (0)
#define  SSRS_SSRS_DEMO_WINDOW_END_ssrs_dw_x_end_mask                            (0x0FFF0000)
#define  SSRS_SSRS_DEMO_WINDOW_END_ssrs_dw_y_end_mask                            (0x00000FFF)
#define  SSRS_SSRS_DEMO_WINDOW_END_ssrs_dw_x_end(data)                           (0x0FFF0000&((data)<<16))
#define  SSRS_SSRS_DEMO_WINDOW_END_ssrs_dw_y_end(data)                           (0x00000FFF&(data))
#define  SSRS_SSRS_DEMO_WINDOW_END_get_ssrs_dw_x_end(data)                       ((0x0FFF0000&(data))>>16)
#define  SSRS_SSRS_DEMO_WINDOW_END_get_ssrs_dw_y_end(data)                       (0x00000FFF&(data))

#define  SSRS_SSRS_TIMING_CTL                                                   0x181C000C
#define  SSRS_SSRS_TIMING_CTL_reg_addr                                           "0xB81C000C"
#define  SSRS_SSRS_TIMING_CTL_reg                                                0xB81C000C
#define  SSRS_SSRS_TIMING_CTL_inst_addr                                          "0x0003"
#define  set_SSRS_SSRS_TIMING_CTL_reg(data)                                      (*((volatile unsigned int*)SSRS_SSRS_TIMING_CTL_reg)=data)
#define  get_SSRS_SSRS_TIMING_CTL_reg                                            (*((volatile unsigned int*)SSRS_SSRS_TIMING_CTL_reg))
#define  SSRS_SSRS_TIMING_CTL_hsync_cntr_shift                                   (0)
#define  SSRS_SSRS_TIMING_CTL_hsync_cntr_mask                                    (0x0000001F)
#define  SSRS_SSRS_TIMING_CTL_hsync_cntr(data)                                   (0x0000001F&(data))
#define  SSRS_SSRS_TIMING_CTL_get_hsync_cntr(data)                               (0x0000001F&(data))

#define  SSRS_SSRS_TIMING_SEL                                                   0x181C0010
#define  SSRS_SSRS_TIMING_SEL_reg_addr                                           "0xB81C0010"
#define  SSRS_SSRS_TIMING_SEL_reg                                                0xB81C0010
#define  SSRS_SSRS_TIMING_SEL_inst_addr                                          "0x0004"
#define  set_SSRS_SSRS_TIMING_SEL_reg(data)                                      (*((volatile unsigned int*)SSRS_SSRS_TIMING_SEL_reg)=data)
#define  get_SSRS_SSRS_TIMING_SEL_reg                                            (*((volatile unsigned int*)SSRS_SSRS_TIMING_SEL_reg))
#define  SSRS_SSRS_TIMING_SEL_ssrs_user_timing_sel_shift                         (2)
#define  SSRS_SSRS_TIMING_SEL_ssrs_auto_detect_result_shift                      (1)
#define  SSRS_SSRS_TIMING_SEL_ssrs_auto_detect_en_shift                          (0)
#define  SSRS_SSRS_TIMING_SEL_ssrs_user_timing_sel_mask                          (0x00000004)
#define  SSRS_SSRS_TIMING_SEL_ssrs_auto_detect_result_mask                       (0x00000002)
#define  SSRS_SSRS_TIMING_SEL_ssrs_auto_detect_en_mask                           (0x00000001)
#define  SSRS_SSRS_TIMING_SEL_ssrs_user_timing_sel(data)                         (0x00000004&((data)<<2))
#define  SSRS_SSRS_TIMING_SEL_ssrs_auto_detect_result(data)                      (0x00000002&((data)<<1))
#define  SSRS_SSRS_TIMING_SEL_ssrs_auto_detect_en(data)                          (0x00000001&(data))
#define  SSRS_SSRS_TIMING_SEL_get_ssrs_user_timing_sel(data)                     ((0x00000004&(data))>>2)
#define  SSRS_SSRS_TIMING_SEL_get_ssrs_auto_detect_result(data)                  ((0x00000002&(data))>>1)
#define  SSRS_SSRS_TIMING_SEL_get_ssrs_auto_detect_en(data)                      (0x00000001&(data))

#define  SSRS_SSRS_INTERRUPT                                                    0x181C0014
#define  SSRS_SSRS_INTERRUPT_reg_addr                                            "0xB81C0014"
#define  SSRS_SSRS_INTERRUPT_reg                                                 0xB81C0014
#define  SSRS_SSRS_INTERRUPT_inst_addr                                           "0x0005"
#define  set_SSRS_SSRS_INTERRUPT_reg(data)                                       (*((volatile unsigned int*)SSRS_SSRS_INTERRUPT_reg)=data)
#define  get_SSRS_SSRS_INTERRUPT_reg                                             (*((volatile unsigned int*)SSRS_SSRS_INTERRUPT_reg))
#define  SSRS_SSRS_INTERRUPT_ssrs_dummy_shift                                    (8)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_cpu_gp_1_en_shift                          (7)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_cpu_gp_0_en_shift                          (6)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_1_shift                                    (5)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_0_shift                                    (4)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_1_en_shift                                 (1)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_0_en_shift                                 (0)
#define  SSRS_SSRS_INTERRUPT_ssrs_dummy_mask                                     (0xFFFFFF00)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_cpu_gp_1_en_mask                           (0x00000080)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_cpu_gp_0_en_mask                           (0x00000040)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_1_mask                                     (0x00000020)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_0_mask                                     (0x00000010)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_1_en_mask                                  (0x00000002)
#define  SSRS_SSRS_INTERRUPT_ssrs_int_0_en_mask                                  (0x00000001)
#define  SSRS_SSRS_INTERRUPT_ssrs_dummy(data)                                    (0xFFFFFF00&((data)<<8))
#define  SSRS_SSRS_INTERRUPT_ssrs_int_cpu_gp_1_en(data)                          (0x00000080&((data)<<7))
#define  SSRS_SSRS_INTERRUPT_ssrs_int_cpu_gp_0_en(data)                          (0x00000040&((data)<<6))
#define  SSRS_SSRS_INTERRUPT_ssrs_int_1(data)                                    (0x00000020&((data)<<5))
#define  SSRS_SSRS_INTERRUPT_ssrs_int_0(data)                                    (0x00000010&((data)<<4))
#define  SSRS_SSRS_INTERRUPT_ssrs_int_1_en(data)                                 (0x00000002&((data)<<1))
#define  SSRS_SSRS_INTERRUPT_ssrs_int_0_en(data)                                 (0x00000001&(data))
#define  SSRS_SSRS_INTERRUPT_get_ssrs_dummy(data)                                ((0xFFFFFF00&(data))>>8)
#define  SSRS_SSRS_INTERRUPT_get_ssrs_int_cpu_gp_1_en(data)                      ((0x00000080&(data))>>7)
#define  SSRS_SSRS_INTERRUPT_get_ssrs_int_cpu_gp_0_en(data)                      ((0x00000040&(data))>>6)
#define  SSRS_SSRS_INTERRUPT_get_ssrs_int_1(data)                                ((0x00000020&(data))>>5)
#define  SSRS_SSRS_INTERRUPT_get_ssrs_int_0(data)                                ((0x00000010&(data))>>4)
#define  SSRS_SSRS_INTERRUPT_get_ssrs_int_1_en(data)                             ((0x00000002&(data))>>1)
#define  SSRS_SSRS_INTERRUPT_get_ssrs_int_0_en(data)                             (0x00000001&(data))

#define  SSRS_SSRS_MASK_COLOR                                                   0x181C0030
#define  SSRS_SSRS_MASK_COLOR_reg_addr                                           "0xB81C0030"
#define  SSRS_SSRS_MASK_COLOR_reg                                                0xB81C0030
#define  SSRS_SSRS_MASK_COLOR_inst_addr                                          "0x0006"
#define  set_SSRS_SSRS_MASK_COLOR_reg(data)                                      (*((volatile unsigned int*)SSRS_SSRS_MASK_COLOR_reg)=data)
#define  get_SSRS_SSRS_MASK_COLOR_reg                                            (*((volatile unsigned int*)SSRS_SSRS_MASK_COLOR_reg))
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_color_en_shift                           (30)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_v_fill_shift                             (20)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_u_fill_shift                             (10)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_y_fill_shift                             (0)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_color_en_mask                            (0x40000000)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_v_fill_mask                              (0x3FF00000)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_u_fill_mask                              (0x000FFC00)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_y_fill_mask                              (0x000003FF)
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_color_en(data)                           (0x40000000&((data)<<30))
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_v_fill(data)                             (0x3FF00000&((data)<<20))
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_u_fill(data)                             (0x000FFC00&((data)<<10))
#define  SSRS_SSRS_MASK_COLOR_ssrs_mask_y_fill(data)                             (0x000003FF&(data))
#define  SSRS_SSRS_MASK_COLOR_get_ssrs_mask_color_en(data)                       ((0x40000000&(data))>>30)
#define  SSRS_SSRS_MASK_COLOR_get_ssrs_mask_v_fill(data)                         ((0x3FF00000&(data))>>20)
#define  SSRS_SSRS_MASK_COLOR_get_ssrs_mask_u_fill(data)                         ((0x000FFC00&(data))>>10)
#define  SSRS_SSRS_MASK_COLOR_get_ssrs_mask_y_fill(data)                         (0x000003FF&(data))

#define  SSRS_SSRS_DB_CTL                                                       0x181C0034
#define  SSRS_SSRS_DB_CTL_reg_addr                                               "0xB81C0034"
#define  SSRS_SSRS_DB_CTL_reg                                                    0xB81C0034
#define  SSRS_SSRS_DB_CTL_inst_addr                                              "0x0007"
#define  set_SSRS_SSRS_DB_CTL_reg(data)                                          (*((volatile unsigned int*)SSRS_SSRS_DB_CTL_reg)=data)
#define  get_SSRS_SSRS_DB_CTL_reg                                                (*((volatile unsigned int*)SSRS_SSRS_DB_CTL_reg))
#define  SSRS_SSRS_DB_CTL_ssrs_db_read_level_shift                               (2)
#define  SSRS_SSRS_DB_CTL_ssrs_db_en_shift                                       (1)
#define  SSRS_SSRS_DB_CTL_ssrs_db_apply_shift                                    (0)
#define  SSRS_SSRS_DB_CTL_ssrs_db_read_level_mask                                (0x00000004)
#define  SSRS_SSRS_DB_CTL_ssrs_db_en_mask                                        (0x00000002)
#define  SSRS_SSRS_DB_CTL_ssrs_db_apply_mask                                     (0x00000001)
#define  SSRS_SSRS_DB_CTL_ssrs_db_read_level(data)                               (0x00000004&((data)<<2))
#define  SSRS_SSRS_DB_CTL_ssrs_db_en(data)                                       (0x00000002&((data)<<1))
#define  SSRS_SSRS_DB_CTL_ssrs_db_apply(data)                                    (0x00000001&(data))
#define  SSRS_SSRS_DB_CTL_get_ssrs_db_read_level(data)                           ((0x00000004&(data))>>2)
#define  SSRS_SSRS_DB_CTL_get_ssrs_db_en(data)                                   ((0x00000002&(data))>>1)
#define  SSRS_SSRS_DB_CTL_get_ssrs_db_apply(data)                                (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SSRS register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  table_pre_load_sel:5;
        RBus_UInt32  ssrs_main_large_sub:1;
        RBus_UInt32  ssrs_dw_inv:1;
        RBus_UInt32  ssrs_dw_en:1;
        RBus_UInt32  mask_win_sel:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  mask_win_switch:2;
        RBus_UInt32  arb_en_1:1;
        RBus_UInt32  arb_en_0:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  ssrs_disable:1;
    };
}ssrs_ssrs_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ssrs_dw_x_sta:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ssrs_dw_y_sta:12;
    };
}ssrs_ssrs_demo_window_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ssrs_dw_x_end:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ssrs_dw_y_end:12;
    };
}ssrs_ssrs_demo_window_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  hsync_cntr:5;
    };
}ssrs_ssrs_timing_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ssrs_user_timing_sel:1;
        RBus_UInt32  ssrs_auto_detect_result:1;
        RBus_UInt32  ssrs_auto_detect_en:1;
    };
}ssrs_ssrs_timing_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_dummy:24;
        RBus_UInt32  ssrs_int_cpu_gp_1_en:1;
        RBus_UInt32  ssrs_int_cpu_gp_0_en:1;
        RBus_UInt32  ssrs_int_1:1;
        RBus_UInt32  ssrs_int_0:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ssrs_int_1_en:1;
        RBus_UInt32  ssrs_int_0_en:1;
    };
}ssrs_ssrs_interrupt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  ssrs_mask_color_en:1;
        RBus_UInt32  ssrs_mask_v_fill:10;
        RBus_UInt32  ssrs_mask_u_fill:10;
        RBus_UInt32  ssrs_mask_y_fill:10;
    };
}ssrs_ssrs_mask_color_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ssrs_db_read_level:1;
        RBus_UInt32  ssrs_db_en:1;
        RBus_UInt32  ssrs_db_apply:1;
    };
}ssrs_ssrs_db_ctl_RBUS;

#else //apply LITTLE_ENDIAN

//======SSRS register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_disable:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  arb_en_0:1;
        RBus_UInt32  arb_en_1:1;
        RBus_UInt32  mask_win_switch:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  mask_win_sel:4;
        RBus_UInt32  ssrs_dw_en:1;
        RBus_UInt32  ssrs_dw_inv:1;
        RBus_UInt32  ssrs_main_large_sub:1;
        RBus_UInt32  table_pre_load_sel:5;
        RBus_UInt32  res3:12;
    };
}ssrs_ssrs_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_dw_y_sta:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ssrs_dw_x_sta:12;
        RBus_UInt32  res2:4;
    };
}ssrs_ssrs_demo_window_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_dw_y_end:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ssrs_dw_x_end:12;
        RBus_UInt32  res2:4;
    };
}ssrs_ssrs_demo_window_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hsync_cntr:5;
        RBus_UInt32  res1:27;
    };
}ssrs_ssrs_timing_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_auto_detect_en:1;
        RBus_UInt32  ssrs_auto_detect_result:1;
        RBus_UInt32  ssrs_user_timing_sel:1;
        RBus_UInt32  res1:29;
    };
}ssrs_ssrs_timing_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_int_0_en:1;
        RBus_UInt32  ssrs_int_1_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ssrs_int_0:1;
        RBus_UInt32  ssrs_int_1:1;
        RBus_UInt32  ssrs_int_cpu_gp_0_en:1;
        RBus_UInt32  ssrs_int_cpu_gp_1_en:1;
        RBus_UInt32  ssrs_dummy:24;
    };
}ssrs_ssrs_interrupt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_mask_y_fill:10;
        RBus_UInt32  ssrs_mask_u_fill:10;
        RBus_UInt32  ssrs_mask_v_fill:10;
        RBus_UInt32  ssrs_mask_color_en:1;
        RBus_UInt32  res1:1;
    };
}ssrs_ssrs_mask_color_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_db_apply:1;
        RBus_UInt32  ssrs_db_en:1;
        RBus_UInt32  ssrs_db_read_level:1;
        RBus_UInt32  res1:29;
    };
}ssrs_ssrs_db_ctl_RBUS;




#endif 


#endif 
